{---------------------------------------------------------------------

 (c) Copyleft or copyright under terms of GNU General Public License
 2003  Jordi March i Nogu   jmarch@comg.es
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version

----------------------------------------------------------------------}

unit CtrlPS0;

interface

uses
  Controls, Classes, Forms;

type
  TPosSize = class (TObject)
    X, Y, W, H: Integer;
  private
    FControl: TControl;
  public
    property Control: TControl read FControl write FControl;
    procedure GetPosSize; virtual;
    function  SetPosSize: Boolean; virtual;
    function  HasValues: Boolean;
  end;

  TPosSizeCH = class (TPosSize)
  private
    CH: Integer;
    FControlH: TControl;
  public
    property ControlH: TControl read FControlH write FControlH;
    procedure GetPosSize; override;
    function  SetPosSize: Boolean; override;
  end;

  TAliWidth = class(TObject)
    Alignment: TAlignment;
    Width: Integer;
  end;

  TPosSizeGridW0 = class(TPosSize)
  protected
    GridCols: TStringList;
    procedure FreeGridColsObjects;
  public
    constructor Create;
    destructor Destroy; override;
  end;

implementation

uses
  Math;

{--------------------------------------}
{-PUBLIC-----------}

procedure TPosSize.GetPosSize;
begin
  if  not Assigned (Control)
  then  Exit;
  with FControl do  begin
    X := Left;
    Y := Top;
    W := Width;
    H := Height;
  end;
end {GetPosSize};

function TPosSize.HasValues: Boolean;
begin
  Result := W <> 0;
end;

function TPosSize.SetPosSize: Boolean;
begin
  Result := False;
  if  not Assigned (Control)
  then  Exit;
  with FControl do  begin
    if  not HasValues
    then  Exit;
    if  FControl is TForm
    then  TForm(FControl).Position := poDesigned;
    Result := True;
    Left := Max (0, X);
    Top := Max (0, Y);
    Width := W;
    Height := H;
  end;
end {SetPosSize};

{--------------------------------------}
{-PUBLIC-----------}

procedure TPosSizeCH.GetPosSize;
begin
  inherited;
  CH := FControlH.Height;
end;

function TPosSizeCH.SetPosSize: Boolean;
var
  Ok: Boolean;
begin
  Ok := inherited SetPosSize;
  if Ok then
    if  CH > 5
    then  FControlH.Height := CH;
  Result := Ok;
end;

{--------------------------------------}
{-PRIVATE----------}

procedure TPosSizeGridW0.FreeGridColsObjects;
var
  I: Byte;
begin
  if GridCols.Count > 0
  then
    for  I := 0 to GridCols.Count-1  do
      TAliWidth(GridCols.Objects[I]).Free;
end {FreeGridColsObjects};

{-PUBLIC-----------}

constructor TPosSizeGridW0.Create;
begin
  inherited;
  GridCols := TStringList.Create;
end {Create};

destructor TPosSizeGridW0.Destroy;
begin
  inherited;
  FreeGridColsObjects;
  GridCols.Free;
end {Destroy};

{--------------------------------------}

end.
