{---------------------------------------------------------------------

 Date and Time consts and funtions

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version
 12/10/2006 version:
   DaysPerYear -> MeanDaysPerYear
   DaysPerMonth -> MeanDaysPerMonth

----------------------------------------------------------------------}

unit DateTime00;

interface

uses
  GrTypFun, DateTimeA0;

const
  DTPosYear = 1;
  DTPosMonth = 2;
  DTPosWeek = 3;
  DTPosDay = 4;
type
  TVDate = record
    Valid: Boolean;
    Num: LongInt;
  end;
  TInterVDate = array [1..2] of TVDate;

const
  MonthsPerYear = 12;

type
  TVTime = TVReal;
type
  TWeekDaySearch = (wdsPast, wdsAround, wdsFuture);
  TSetOfWeekValidNumbers = set of 1..7;

const
  TimeGroupNumber = 5; {a,m,s,d,h}
type
  TDateRelationWithToday = (drwtPast, drwtAround, drwtFuture);
  TimeGroupsSR = 0..TimeGroupNumber-1;  {SR=Subrange}
  TTimeGroupBoolArr = array [TimeGroupsSR] of Boolean;
  TTimeGroupConvFactArr = array [TimeGroupsSR] of Real;

var
  DaysPer4Years: Integer;
  MeanDaysPerYear, MeanDaysPerMonth: Real;
  TGCFArrToDays: TTimeGroupConvFactArr;
  TGCFArrToNext: TTimeGroupConvFactArr;

implementation

begin
  DaysPer4Years := (365 * 3) + 366;
  MeanDaysPerYear := DaysPer4Years / 4; {365.25 days}
  MeanDaysPerMonth := DaysPer4Years / (MonthsPerYear * 4); {30.44 days}
  TGCFArrToNext [0] := MonthsPerYear; {12 months in 1 year}
  TGCFArrToNext [1] := MeanDaysPerYear/(MonthsPerYear*7); {4.35 weeks in 1 month}
  TGCFArrToNext [2] := 7; {7 days in 1 week}
  TGCFArrToNext [3] := 24; {24 hours in 1 day}
  TGCFArrToNext [4] := 1; {hour}
  TGCFArrToDays [0] := MeanDaysPerYear; {365.25 days in 1 year}
  TGCFArrToDays [1] := MeanDaysPerMonth; {30.44 days in 1 moth}
  TGCFArrToDays [2] := 7; {7 days in 1 week}
  TGCFArrToDays [3] := 1;
  TGCFArrToDays [4] := 1/24 {0.042 days in 1 hour};
end.
