{---------------------------------------------------------------------

 Several General Types and Functions

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version
 08/16/2006 version
   rename Func/Proc FileName for Str
   add TProcFrom2Str

----------------------------------------------------------------------}

unit GrTypFun;

interface

type
  TXProcedure = procedure of object;
  TBoolFunction = function: Boolean of object;
  TBoolFunctFromStr = function (const S: string): Boolean of object;
  TProcFromStr = procedure (const S: string) of object;
  TProcFrom2Str = procedure (const S1, S2: string) of object;
  TBoolFunctFromStrW = function (const S: WideString): Boolean of object;
  TProcFromStrW = procedure (const S: WideString) of object;
  TStrFunction = function: string of object;
  TByteSet = set of Byte;

  Str1  = string [1];
  Str2  = string [2];
  Str3  = string [3];
  Str4  = string [4];
  Str5  = string [5];
  Str8  = string [8];
  Str12 = string [12];
  Str20 = string [20];
  Str30 = string [30];
  Str40 = string [40];

  TPropertyPresent = (ppIgnore, ppYes, ppNo);
  PBoolean = ^Boolean;
  PByte = ^Byte;

  TVLongint = record
    Valid: Boolean;
    Num: Longint;
  end;

  TVInteger = record
    Valid: Boolean;
    Num: Integer;
  end;

  TVByte = record
    Valid: Boolean;
    Num: Byte;
  end;

  TVReal = record
    Valid: Boolean;
    Num: Real;
  end;

  TVExtended = record
    Valid: Boolean;
    Num: Extended;
  end;

procedure ChangeBool (var Bool: Boolean);
function  StrLenNum (N: Longint): Byte;
function  StrLenReal (N: Extended;  D: Byte): Byte;
function  StrLenNums (NMin, NMax: Longint): Byte;
function  StrLenReals (NMin, NMax: Extended;  D: Byte): Byte;
function  GetFromVLongint (VL: TVLongint): Longint;
procedure SetToVLongint (var VL: TVLongint;  ANum: Longint);
function  GetFromVReal (VR: TVReal): Real;
procedure SetToVReal (var VR: TVReal;  ANum: Real);
function  VLongintValidRange (Min, Max: TVLongint): Boolean;
function  VRealValidRange (Min, Max: TVReal): Boolean;

implementation

uses
  SysUtils, Math,
  StrNumU;

procedure ChangeBool (var Bool: Boolean);
begin
  if  Bool = True
  then  Bool := False
  else  Bool := True;
end {ChangeBool};

{--------------------------------------}

{ Obtain a numbers string length from a numbers }

function StrLenNum (N: Longint): Byte;
begin
  StrLenNum := Length (IntToStr(N));
end {StrLenNum};

function StrLenReal (N: Extended;  D: Byte): Byte;
begin
  StrLenReal := Length (Format ('%*.*f', [0, D, N]));
end {StrLenReal};

function StrLenNums (NMin, NMax: Longint): Byte;
begin
  StrLenNums := Max (StrLenNum(NMin), StrLenNum(NMax));
end {StrLenNums};

function StrLenReals (NMin, NMax: Extended;  D: Byte): Byte;
var
  Espai: Byte;
begin
  Espai := Max (StrLenNum(Trunc(NMin)), StrLenNum(Trunc(NMax)));
  if  D > 0  then  Inc (Espai, D+1);
  StrLenReals := Espai;
end {StrLenReals};

{--------------------------------------}

function GetFromVLongint (VL: TVLongint): Longint;
begin
  if  VL.Valid
  then  Result := VL.Num
  else  Result := 0;
end {GetFromVLongint};

procedure SetToVLongint (var VL: TVLongint;  ANum: Longint);
begin
  VL.Valid := True;
  VL.Num := ANum;
end {SetToVLongint};

function GetFromVReal (VR: TVReal): Real;
begin
  if  VR.Valid
  then  Result := VR.Num
  else  Result := 0;
end {GetFromVReal};

procedure SetToVReal (var VR: TVReal;  ANum: Real);
begin
  VR.Valid := True;
  VR.Num := ANum;
end {SetToVReal};

function VLongintValidRange (Min, Max: TVLongint): Boolean;
begin
  if  Min.Valid and Max.Valid
  then  Result := not (Min.Num > Max.Num)
  else  Result := True;
end {VLongintValidRange};

function VRealValidRange (Min, Max: TVReal): Boolean;
begin
  if  Min.Valid and Max.Valid
  then  Result := not (Min.Num > Max.Num)
  else  Result := True;
end {VRealValidRange};

{--------------------------------------}

end {GrTypFun}.
