{---------------------------------------------------------------------

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version
 27/05/2006 version
   Add  Align left or rigth to controls array (AlignLeftCtrls and AlignRightCtrls)
   Add  Moving to controls array: HorzMoveCtrls (CA: array of TControl;  Delta: Integer);
 07/01/2006 version
   rename  horitz (horizontal) -> horz
     MirrorBitmap to MirrorBitmapHorz
     Horitz -> Horz
 08/016/2006 version
   SetGBColor is moved from (Tnt)Several unit

----------------------------------------------------------------------}

unit VCtrls;

interface

uses
  Classes, Controls, Forms, Windows, Graphics, StdCtrls;

function ControlBottom (C: TControl): Integer;
function ControlHCenter (C: TControl): Integer;
function ControlRight (C: TControl): Integer;
function ControlVCenter (C: TControl): Integer;
function CenterForm (F: TForm): Boolean;
function HorzCenterForm (F: TForm): Boolean;
function VertCenterForm (F: TForm): Boolean;
procedure CenterControlInParent (C: TControl);
procedure HorzCenterControlInParent (C: TControl);
procedure HorzCenterControlRefOther (C, Other: TControl);
procedure HorzLeftDControlRefOther (C, Other: TControl);
procedure HorzRightControlRefOther (C, Other: TControl);
procedure HorzRightDControlRefOther (C, Other: TControl);
procedure VertBottomControlRefOther (C, Other: TControl);
procedure VertCenterControlInParent (C: TControl);
procedure VertCenterControlRefOther (C, Other: TControl);
procedure AtBeginRight (C: TControl);
procedure AtLeft (C1, C2: TControl);
procedure AtNext (C1, C2: TControl);
procedure AtNextSep (C1, C2: TControl);
procedure AtPriorSep (C1, C2: TControl);
procedure AlignLeftCtrls (CA: array of TControl;  Left: Integer);
procedure AlignRightCtrls (CA: array of TControl;  Right: Integer);
procedure HorzMoveCtrls (CA: array of TControl;  Delta: Integer);

procedure MirrorBitmapHorz (B: TBitmap);
procedure SetFormOpaque (F: TForm);
procedure SetFormTransparent (F: TForm);
procedure SetGBColor (GB: TGroupBox;  Enabled: Boolean);

implementation

function ControlBottom (C: TControl): Integer;
begin
  Result := C.Top + C.Height;
end;

function ControlHCenter (C: TControl): Integer;
begin
  Result := C.Left + (C.Width div 2);
end;

function ControlRight (C: TControl): Integer;
begin
  Result := C.Left + C.Width;
end;

function ControlVCenter (C: TControl): Integer;
begin
  Result := C.Top + (C.Height div 2);
end;

function CenterForm (F: TForm): Boolean;
begin
  Result := HorzCenterForm (F) and VertCenterForm (F);
end;

function HorzCenterForm (F: TForm): Boolean;
var
  Res: Boolean;
begin
  Res := Screen.Width > F.Width;
  F.Left := (Screen.Width - F.Width) div 2;
  Result := Res;
end {HorzCenterForm};

function VertCenterForm (F: TForm): Boolean;
var
  Res: Boolean;
begin
  Res := Screen.Height > F.Height;
  if  Res
  then  F.Top := (Screen.Height - F.Height) div 2
  else  F.Top := 0;
  Result := Res;
end {VertCenterForm};

procedure CenterControlInParent (C: TControl);
begin
  HorzCenterControlInParent (C);
  VertCenterControlInParent (C);
end {CenterControlInParent};

procedure HorzCenterControlInParent (C: TControl);
begin
  C.Left := (C.Parent.Width - C.Width) div 2;
end;

procedure HorzCenterControlRefOther (C, Other: TControl);
begin
  C.Left := Other.Left + (Other.Width - C.Width) div 2;
end;

procedure HorzLeftDControlRefOther (C, Other: TControl);
begin
  if  Application.BiDiMode = bdLeftToRight
  then  C.Left := Other.Left
  else  HorzRightControlRefOther (C, Other);
end {HorzLeftDControlRefOther};

procedure HorzRightControlRefOther (C, Other: TControl);
begin
  C.Left := ControlRight (Other) - C.Width;
end;

procedure HorzRightDControlRefOther (C, Other: TControl);
begin
  if  Application.BiDiMode = bdLeftToRight
  then  HorzRightControlRefOther (C, Other)
  else  C.Left := Other.Left;
end {HorzRightDControlRefOther};

procedure VertBottomControlRefOther (C, Other: TControl);
begin
  C.Top := ControlBottom (Other) - C.Height;
end;

procedure VertCenterControlInParent (C: TControl);
begin
  C.Top := (C.Parent.Height - C.Height) div 2;
end;

procedure VertCenterControlRefOther (C, Other: TControl);
begin
  C.Top := Other.Top + (Other.Height - C.Height) div 2;
end;

procedure AtBeginRight (C: TControl);
begin
  C.Left := C.Parent.Width - (C.Width + 4)
end;

procedure AtLeft (C1, C2: TControl);
begin
  C1.Left := C2.Left - (C1.Width + 4);
end;

procedure AtNext (C1, C2: TControl);
begin
  C2.Left := ControlRight (C1);
end;

procedure AtNextSep (C1, C2: TControl);
begin
  C2.Left := ControlRight (C1) + 4;
end;

procedure AtPriorSep (C1, C2: TControl);
begin
  C1.Left := C2.Left - (4 + C1.Width);
end;


procedure AlignLeftCtrls (CA: array of TControl;  Left: Integer);
var
  I: Integer;
begin
  for  I := Low(CA) to High(CA)  do
    CA[I].Left := Left;
end;

procedure AlignRightCtrls (CA: array of TControl;  Right: Integer);
var
  I: Integer;
begin
  for  I := Low(CA) to High(CA)  do
    CA[I].Left := Right - CA[I].Width;
end;

procedure HorzMoveCtrls (CA: array of TControl;  Delta: Integer);
var
  I: Integer;
begin
  for  I := Low(CA) to High(CA)  do
    CA[I].Left := CA[I].Left + Delta;
end;


procedure MirrorBitmapHorz (B: TBitmap);
var
  B2: Graphics.TBitmap;
  i, j: Integer;
begin
  B2 := TBitmap.Create;
  B2.Height := B.Height;
  B2.Width := B.Width;
  for  i := 0 to B.Width-1  do
    for  j := 0 to B.Height-1  do
      B2.Canvas.Pixels[B2.Width-(i+1), j] := B.Canvas.Pixels[i,j];
  B.Assign (B2);
  B2.Free;
end {MirrorBitmapHorz};

procedure SetFormOpaque (F: TForm);
var
  ClientRgn: THandle;
begin
  ClientRgn := CreateRectRgn
    (0, 0, MaxInt, MaxInt);
  SetWindowRgn(F.Handle, ClientRgn, True);
end {SetFormOpaque};

procedure SetFormTransparent (F: TForm);
var
  FullRgn: THandle;
  InicX, InicY: Integer;
procedure AddH (WC: TControl;  Mode: Byte);
var
  ButtonRgn: THandle;
  X, Y: Integer;
begin
  X := InicX + WC.Left;
  Y := InicY + WC.Top;
  ButtonRgn := CreateRectRgn
    (X, Y, X + WC.Width, Y + WC.Height);
  CombineRgn(FullRgn, FullRgn, ButtonRgn, Mode);
end {AddH};
var
  I: Integer;
  Margin: Integer;
  ClientRgn: THandle;
begin
  Margin := (F.Width - F.ClientWidth) div 2;
  FullRgn := CreateRectRgn(0, 0, F.Width, F.Height);
  InicX := Margin;
  InicY := F.Height - F.ClientHeight - Margin;
  ClientRgn := CreateRectRgn
    (InicX, InicY, InicX + F.ClientWidth, InicY + F.ClientHeight);
  CombineRgn(FullRgn, FullRgn, ClientRgn, RGN_DIFF);
  for  I := 0 to F.ControlCount-1 do
    if  F.Controls[I].Visible
    then  AddH (F.Controls[I], RGN_OR);
  SetWindowRgn(F.Handle, FullRgn, True);
end {SetFormTransparent};

procedure SetGBColor (GB: TGroupBox;  Enabled: Boolean);
begin
  if Enabled
  then GB.Font.Color := clBlack
  else GB.Font.Color := clGray;
end {SetGBColor};

end.
