unit TntdnPxReg;

(*****************************************************************************
Copyright  1997-99 Dieter Nth
version    : 2.1
date       : 10.08.1999
description:

  Registers all Paradox-mask enabled components
******************************************************************************)

interface

{$I JVCL.inc}

procedure Register;

implementation

uses
  WinTypes, SysUtils, Classes,
  Forms, Dialogs, Controls,
 {$IFDEF DELPHI6_UP} RTLConsts, DesignIntf, DesignEditors, VCLEditors, {$ELSE} DsgnIntf, {$ENDIF}
  TntdnPxCnst, TntdnGlobal, TntdnPxMask, TntdnPxProp,
  TntVer, TntNewAbout;

type
  TTntPxMaskProperty = class(TClassProperty)
  public
    function  GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

  TAboutPxM = class(TAboutH2)
  protected
    function AuthorMess: string; override;
  end;

{--------------------------------------}

function TTntPxMaskProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paSubProperties, paDialog, paReadOnly];
end;

procedure TTntPxMaskProperty.Edit;
begin
  with TdlgPxMaskEditor.Create(application) do
  try
    PxMask := TTntPxMask(GetOrdValue);
    if ShowModal = idOK then
      SetOrdValue(LongInt(PxMask));
  finally
    Free;
  end;
end;

{--------------------------------------}
{-PROTECTED--------}

function TAboutPxM.AuthorMess: string;
begin
  Result := 'Dieter Nth';
end;

{--------------------------------------}

procedure Register;
const
  PacknamePx = 'Tnt JMN Edits';
begin
  RegisterComponents(PacknamePx, [
    TTntPxMaskEdit]);
  RegisterComponents(PacknamePx, [   {New}
    TTntPxMaskEditR]);
 (**
  RegisterComponents(PacknamePx, [
    TTntPxMaskEdit,
    TTntPxComboBox,
    TTntPxGrid]);
  RegisterComponents(PacknamePx, [   {New}
    TTntPxMaskEditR,
    TTntPxComboBoxR,
    TTntPxComboBoxRWLI]);
  **)
  RegisterPropertyEditor(TypeInfo(TAboutInfo), TTntPxMaskEdit, 'About', TAboutPxM);
  RegisterPropertyEditor(TypeInfo(TTntPxMask), nil, 'PxMask', TTntPxMaskProperty);
{$IFDEF UseDD}
  {$IFDEF DELPHI3_UP} //Hide published properties in Object Inspector by undefining the property editor
  //RegisterPropertyEditor(TypeInfo(TTntPxMask), TTntPxGrid, 'PxMask', nil);
  {$ENDIF}
{$ENDIF}
end;

end.
