unit TntBtnResizeDemoU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TntForms, StdCtrls, Buttons, TntButtons, TntButtons2,
  TntStdCtrls, TntExtCtrls, Mask, TntJvExMask, TntJvSpin, TntSeveral;

type
  TFResizeTntBtnDemo = class(TTntForm)
    B_Resize: TTntButton;
    BB_Cancel1: TTntBitBtn2;
    BB_Cancel2: TTntBitBtn2;
    BB_Close1: TTntBitBtn2;
    BB_Close2: TTntBitBtn2;
    BB_Ok1: TTntButton;
    BB_Ok2: TTntButton;
    CB_FitToMaxWidth: TTntCheckBox;
    L_MinWidth: TTntLabel;
    RG_Justify: TTntRadioGroup;
    SE_MinWidth: TTntJvSpinEdit;
    L_GlobalWidthEnun: TLabel;
    L_GlobalWidth: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure B_ResizeClick(Sender: TObject);
  private
    ResizeBtnArray: TTntResizeBtnArray;
  end;


var
  FResizeTntBtnDemo: TFResizeTntBtnDemo;

implementation

{$R *.dfm}

uses
  VCtrls;

{--------------------------------------}

procedure TFResizeTntBtnDemo.FormCreate(Sender: TObject);
begin
  ResizeBtnArray := TTntResizeBtnArray.Create;
end;

procedure TFResizeTntBtnDemo.FormDestroy(Sender: TObject);
begin
  ResizeBtnArray.Free;
end;

procedure TFResizeTntBtnDemo.B_ResizeClick(Sender: TObject);
var
  GW, Delta: Word;
begin
  ResizeBtnArray.VertResizeR ([B_Resize]);
  ResizeBtnArray.MinWidth := Trunc (SE_MinWidth.Value);
  if  RG_Justify.ItemIndex = 0
  then  ResizeBtnArray.Alignment := taLeftJustify
  else  ResizeBtnArray.Alignment := taRightJustify;
  ResizeBtnArray.FitToMaxWidth := CB_FitToMaxWidth.Checked;
  if  RG_Justify.ItemIndex = 0
  then  ResizeBtnArray.HoritzResize ([BB_Ok2, BB_Cancel2, BB_Close2])
  else  ResizeBtnArray.HoritzResize ([BB_Close2, BB_Cancel2, BB_Ok2]);
  GW := ResizeBtnArray.HoritzSize ([BB_Ok2, BB_Cancel2, BB_Close2]);
  if  GW + 16 > ClientWidth  then  begin
    if  RG_Justify.ItemIndex = 1  then  begin
      Delta := (GW + 16) - ClientWidth;
      HoritzMoveCtrls ([BB_Ok2, BB_Cancel2, BB_Close2], Delta);
    end;
    ClientWidth := GW + 16;
  end;
  L_GlobalWidth.Caption := IntToStr (GW);
  ResizeBtnArray.VertResize ([BB_Ok1, BB_Cancel1, BB_Close1]);
  RG_Justify.Enabled := False;
end {B_ResizeClick};

{--------------------------------------}

end.
