unit TntCopyMoveDelDemoU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, TntControls, 
  Forms, TntForms, Dialogs, StdCtrls, TntStdCtrls, Mask, ExtCtrls, TntExtCtrls,
  TntCCopyDlg, ComCtrls, TntJvExMask, TntJvToolEdit, TntComCtrls,
  xTntFFilesSC;

type
  TFCMDFilesDemo = class(TTntForm)
    B_CopyMove: TTntButton;
    B_CopyMovePreview: TTntButton;
    B_Delete: TTntButton;
    B_DeletePreview: TTntButton;
    CB_CopyMoveToSingleDir: TTntCheckBox;
    CB_DeleteEmptyDirs: TTntCheckBox;
    CB_IncludeSubFolders: TTntCheckBox;
    CB_OverwriteNewerPrompt: TTntCheckBox;
    CB_PromptOnDelReadOnlyFiles: TTntCheckBox;
    CB_SendToTrash: TTntCheckBox;
    CB_SetFilesToNoReadOnly: TTntCheckBox;
    CCopyMoveBoxDlg: TTntCCopyMoveBoxDlg;
    CDelBoxDlg: TTntCDelBoxDlg;
    DE_Directory: TTntJvDirectoryEdit;
    DE_Source: TTntJvDirectoryEdit;
    DE_Target: TTntJvDirectoryEdit;
    FrFilesSC: TTntFrFilesSC;
    GB_CopyMove: TTntGroupBox;
    L_Directory: TTntLabel;
    L_SourceDir: TTntLabel;
    L_TargetDir: TTntLabel;
    L_Warning: TTntLabel;
    Memo: TTntMemo;
    MemoFiles: TTntMemo;
    PageControl: TTntPageControl;
    RG_DeleteOptions: TTntGroupBox;
    RG_FileAction: TTntRadioGroup;
    TntPageControl1: TTntPageControl;
    TS_Action: TTntTabSheet;
    TS_CMDOptions: TTntTabSheet;
    TS_FilesSC: TTntTabSheet;
    TS_Preview: TTntTabSheet;
    procedure B_CopyMoveClick (Sender: TObject);
    procedure B_CopyMovePreviewClick(Sender: TObject);
    procedure B_DeleteClick (Sender: TObject);
    procedure B_DeletePreviewClick(Sender: TObject);
    procedure CB_SetFilesToNoReadOnlyClick (Sender: TObject);
    procedure CCopyMoveBoxDlgNotifyCopyMoveMade(const SrceFN,
      DestFN: WideString; FileAction: TFileAction; Made: Boolean);
    procedure CDelBoxDlgNotifyDelMade(const FN: WideString; Made: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FilesSC: TTntFilesSCIncExc;
    procedure PresActionMade (const FN: WideString;  Made: Boolean);
    function  Previous (T: TTntCCMDBoxDlg): Boolean;
    function  PromptExecute (T: TTntCCMDBoxDlg;  Sender: TObject): Boolean;
  end;

var
  FCMDFilesDemo: TFCMDFilesDemo;

implementation

{$R *.DFM}

uses
  TntSystem, TntMessUsual;

{--------------------------------------}
{-EVENTS-----------}

procedure TFCMDFilesDemo.B_CopyMoveClick(Sender: TObject);
begin
  if  not Previous (CCopyMoveBoxDlg)
  then  Exit;
  with CCopyMoveBoxDlg do  begin
    StrSourceDir := DE_Source.Text;
    StrTargetDir := DE_Target.Text;
    OverwriteNewerPrompt := CB_OverwriteNewerPrompt.Checked;
    CopyMoveToSingleDir := CB_CopyMoveToSingleDir.Checked;
    if  RG_FileAction.ItemIndex = 0
    then  FileAction := faCopy
    else  FileAction := faMove;
    {next line must be after FileAction Assignment:}
    FilesSCIncExc := FilesSC;
    AddFilesFromDir ('');
    if  PromptExecute (CCopyMoveBoxDlg, Sender)
    then  Execute;
  end;
end;

procedure TFCMDFilesDemo.B_CopyMovePreviewClick(Sender: TObject);
begin
  if  not Previous (CCopyMoveBoxDlg)
  then  Exit;
  with CCopyMoveBoxDlg do  begin
    StrSourceDir := DE_Source.Text;
    StrTargetDir := DE_Target.Text;
    OverwriteNewerPrompt := CB_OverwriteNewerPrompt.Checked;
    CopyMoveToSingleDir := CB_CopyMoveToSingleDir.Checked;
    if  RG_FileAction.ItemIndex = 0
    then  FileAction := faCopy
    else  FileAction := faMove;
    {next line must be after FileAction Assignment:}
    FilesSCIncExc := FilesSC;
    AddFilesFromDir ('');
  end;
  MemoFiles.Lines.Clear;
  MemoFiles.Lines.AddStrings(CCopyMoveBoxDlg.List);
end;

procedure TFCMDFilesDemo.B_DeleteClick(Sender: TObject);
begin
  if  not Previous (CDelBoxDlg)
  then  Exit;
  with CDelBoxDlg do  begin
    Directory := DE_Directory.Text;
    FilesSCIncExc := FilesSC;
    AddFilesFromDir ('');
    SendToTrash := CB_SendToTrash.Checked;
    if  PromptExecute (CDelBoxDlg, Sender)
    then  Execute;
  end;
end;

procedure TFCMDFilesDemo.B_DeletePreviewClick(Sender: TObject);
begin
  if  not Previous (CDelBoxDlg)
  then  Exit;
  with CDelBoxDlg do  begin
    Directory := DE_Directory.Text;
    FilesSCIncExc := FilesSC;
    AddFilesFromDir ('');
  end;
  MemoFiles.Lines.Clear;
  MemoFiles.Lines.AddStrings(CDelBoxDlg.List);
end;

procedure TFCMDFilesDemo.CCopyMoveBoxDlgNotifyCopyMoveMade(const SrceFN,
  DestFN: WideString; FileAction: TFileAction; Made: Boolean);
begin
  PresActionMade (SrceFN+' -> '+DestFN, Made);
end;

procedure TFCMDFilesDemo.CDelBoxDlgNotifyDelMade(const FN: WideString;
  Made: Boolean);
begin
  PresActionMade (FN, Made);
end;

procedure TFCMDFilesDemo.CB_SetFilesToNoReadOnlyClick(Sender: TObject);
begin
  if  CB_SetFilesToNoReadOnly.Checked
  then  CB_PromptOnDelReadOnlyFiles.Checked := False;
end;

procedure TFCMDFilesDemo.FormCreate(Sender: TObject);
var
  Path: WideString;
begin
  FilesSC := TTntFilesSCIncExc.Create;
  FrFilesSC.FrameCreate;
  FrFilesSC.SetFilesSCIncExc (FilesSC);
  Path := ExtractFilePath (WideParamStr(0));
  Path := Copy (Path, 1, Length(Path)-1);
  DE_Source.Text := Path;
  DE_Directory.Text := Path;
end;

procedure TFCMDFilesDemo.FormDestroy(Sender: TObject);
begin
  FilesSC.Free;
end;

{-PRIVATE----------}

procedure TFCMDFilesDemo.PresActionMade (const FN: WideString;  Made: Boolean);
var
  S: WideString;
begin
  if  Made
  then  S := 'X '
  else  S := '  ';
  Memo.Lines.Add (Concat (S, FN));
end {PresActionMade};

function TFCMDFilesDemo.Previous (T: TTntCCMDBoxDlg): Boolean;
begin
  Result := False;
  if  FrFilesSC.IsOk
  then  FrFilesSC.GetFilesSCIncExc (FilesSC)
  else  Exit;
  FilesSC.Enabled := True;
  T.List.Clear;
  T.DeleteEmptyDirs := CB_DeleteEmptyDirs.Checked;
  T.IncSubFolders := CB_IncludeSubFolders.Checked;
  T.PromptOnDelReadOnlyFiles := CB_PromptOnDelReadOnlyFiles.Checked;
  Result := True;
end {Previous};

function TFCMDFilesDemo.PromptExecute (T: TTntCCMDBoxDlg;  Sender: TObject): Boolean;
begin
  Memo.Lines.Clear;
  T.List.Sort;
  Memo.Lines.AddStrings (T.List);
  Memo.Lines.Add ('------');
  T.DirList.Sort;
  Memo.Lines.AddStrings (T.DirList);
  Memo.Lines.Add ('------');
  Result := WideUserSayYes (WideFormat ('Make %s?', [TTntButton(Sender).Caption]));
end {PromptExecute};

{--------------------------------------}

end.
