unit xTntFFilesSC;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, TntForms, Dialogs,
  StdCtrls, TntStdCtrls, ExtCtrls, TntExtCtrls, Mask, Buttons, TntButtons,
  TntJvExMask, TntJvToolEdit,
  GrTypFun, TntCCopyDlg, TntRZNE0, TntRZNEdit2;

resourcestring
  RSFSetMasks_LimDateNotStored = 'No hi ha cap marge de dates assignat';
  RSFSetMasks_InvalidSizes = 'La mida major no pot ser ms petita que la menor';

type
  TTntFrFilesSC = class(TTntFrame)
    CB_Date: TTntCheckBox;
    CB_ExcMask: TTntComboBox;
    CB_fArchive: TTntCheckBox;
    CB_fHidden: TTntCheckBox;
    CB_fReadOnly: TTntCheckBox;
    CB_fSystem: TTntCheckBox;
    CB_IncMask: TTntComboBox;
    CB_Length: TTntCheckBox;
    DEL_AS_Max: TTntJvDateEdit;
    DEL_AS_Min: TTntJvDateEdit;
    EVC_Max: TTntEditVCardinal;
    EVC_Min: TTntEditVCardinal;
    GB_FilesAttr: TTntGroupBox;
    GB_IncConditions: TTntGroupBox;
    L_Bytes: TTntLabel;
    L_ExcMask: TTntLabel;
    L_IncMask: TTntLabel;
    L_Separator1: TTntLabel;
    L_Separator2: TTntLabel;
    SB_ClearAttribs: TTntSpeedButton;
    SB_ClearDateFile: TTntSpeedButton;
    SB_ClearExcMask: TTntSpeedButton;
    SB_ClearIncMask: TTntSpeedButton;
    SB_ClearLengthFile: TTntSpeedButton;
    procedure CB_MaskExit(Sender: TObject);
    procedure RG_AS_DataTypeOptionsClick(Sender: TObject);
    procedure SB_ClearExcMaskClick(Sender: TObject);
    procedure SB_ClearIncMaskClick(Sender: TObject);
    procedure SB_ClearAttribsClick(Sender: TObject);
    procedure CB_LengthClick(Sender: TObject);
    procedure SB_ClearLengthFileClick(Sender: TObject);
    procedure CB_DateClick(Sender: TObject);
    procedure SB_ClearDateFileClick(Sender: TObject);
  private
    procedure WhenDataTypeOptionsChange;
    procedure WhenLengthOptionsChange;
  public
    procedure FrameCreate;
    procedure CB_Mask_AddNewItem (Sender: TObject);
    function  IsOk: Boolean;
    procedure GetFilesSCIncExc (F: TTntFilesSCIncExc);
    procedure SetFilesSCIncExc (F: TTntFilesSCIncExc);
  end;

implementation

{$R *.DFM}

uses
  TntMessUsual;

{--------------------------------------}
{-EVENTS-----------}

procedure TTntFrFilesSC.CB_LengthClick(Sender: TObject);
begin
  WhenLengthOptionsChange;
end;

procedure TTntFrFilesSC.CB_DateClick(Sender: TObject);
begin
  WhenDataTypeOptionsChange;
end;

procedure TTntFrFilesSC.CB_MaskExit(Sender: TObject);
begin
  CB_Mask_AddNewItem (Sender);
end;

procedure TTntFrFilesSC.RG_AS_DataTypeOptionsClick (Sender: TObject);
begin
  WhenDataTypeOptionsChange;
end;

procedure TTntFrFilesSC.SB_ClearAttribsClick(Sender: TObject);
begin
  CB_fArchive.State := cbGrayed;
  CB_fHidden.State := cbGrayed;
  CB_fReadOnly.State := cbGrayed;
  CB_fSystem.State := cbGrayed;
end {SB_ClearAttribsClick};

procedure TTntFrFilesSC.SB_ClearDateFileClick(Sender: TObject);
begin
  DEL_AS_Min.Clear;
  DEL_AS_Max.Clear;
end;

procedure TTntFrFilesSC.SB_ClearExcMaskClick (Sender: TObject);
begin
  CB_ExcMask.Text := '';
end;

procedure TTntFrFilesSC.SB_ClearIncMaskClick(Sender: TObject);
begin
  CB_IncMask.Text := '*.*';
end;

procedure TTntFrFilesSC.SB_ClearLengthFileClick(Sender: TObject);
begin
  EVC_Min.Clear;
  EVC_Max.Clear;
end;

{-PRIVATE----------}

procedure TTntFrFilesSC.GetFilesSCIncExc (F: TTntFilesSCIncExc);
function GetFTProperty (CB: TTntCheckBox): TPropertyPresent;
begin
  case CB.State of
  cbUnchecked: Result := ppYes;
  cbChecked:   Result := ppNo;
  else {cbGrayed:} Result := ppIgnore;
  end;
end {GetFTProperty};
function GetLength (EC: TTntEditVCardinal): Integer;
begin
  if  EC.TextStored and CB_Length.Checked
  then  Result := EC.Value
  else  Result := -1;
end {GetLength};
begin
  F.MaskInc := CB_IncMask.Text;
  F.MaskExc := CB_ExcMask.Text;
  F.ftReadOnly := GetFTProperty (CB_fReadOnly);
  F.ftSystem   := GetFTProperty (CB_fSystem);
  F.ftHidden   := GetFTProperty (CB_fHidden);
  F.ftArchive  := GetFTProperty (CB_fArchive);
  F.DateMax := DEL_AS_Max.Date;
  F.DateMin := DEL_AS_Min.Date;
  if  CB_Date.Checked
  then  F.DataTypeOptions := dtoDateRange
  else  F.DataTypeOptions := dtoDatesNoSet;
  F.SizeMax := GetLength (EVC_Max);
  F.SizeMin := GetLength (EVC_Min);
end {GetFilesSCIncExc};

procedure TTntFrFilesSC.SetFilesSCIncExc (F: TTntFilesSCIncExc);
procedure SetFTProperty (CB: TTntCheckBox;  PP: TPropertyPresent);
begin
  case PP of
  ppYes    : CB.State := cbUnchecked;
  ppNo     : CB.State := cbChecked;
  ppIgnore : CB.State := cbGrayed;
  end;
end {SetFTProperty};
procedure SetLength (L: Integer;  EC: TTntEditVCardinal);
begin
  if  L = -1
  then  EC.Text := ''
  else  EC.Value := L;
end {SetLength};
begin
  CB_IncMask.Text := F.MaskInc;
  CB_ExcMask.Text := F.MaskExc;
  SetFTProperty (CB_fReadOnly, F.ftReadOnly);
  SetFTProperty (CB_fSystem,   F.ftSystem);
  SetFTProperty (CB_fHidden,   F.ftHidden);
  SetFTProperty (CB_fArchive,  F.ftArchive);
  DEL_AS_Max.Date := F.DateMax;
  DEL_AS_Min.Date := F.DateMin;
  CB_Date.Checked := F.DataTypeOptions = dtoDateRange;
  WhenDataTypeOptionsChange;
  SetLength (F.SizeMax, EVC_Max);
  SetLength (F.SizeMin, EVC_Min);
  CB_Length.Checked := EVC_Max.TextStored or EVC_Min.TextStored; 
  WhenLengthOptionsChange;
end {SetFilesSCIncExc};

procedure TTntFrFilesSC.WhenDataTypeOptionsChange;
procedure SetVisible (Vis: Boolean);
begin
  DEL_AS_Min.Visible := Vis;
  L_Separator2.Visible := Vis;
  DEL_AS_Max.Visible := Vis;
  SB_ClearDateFile.Visible := Vis;
end {SetVisible};
begin
  SetVisible (CB_Length.Checked);
end {WhenDataTypeOptionsChange};

procedure TTntFrFilesSC.WhenLengthOptionsChange;
procedure SetVisible (Vis: Boolean);
begin
  EVC_Min.Visible := Vis;
  L_Separator1.Visible := Vis;
  EVC_Max.Visible := Vis;
  SB_ClearLengthFile.Visible := Vis;
end {SetVisible};
begin
  SetVisible (CB_Date.Checked);
end {WhenLengthOptionsChange};

{-PUBLIC-----------}

procedure TTntFrFilesSC.FrameCreate;
begin
  DEL_AS_Max.MaxDate := Date;
  DEL_AS_Min.MaxDate := Date;
end;

procedure TTntFrFilesSC.CB_Mask_AddNewItem (Sender: TObject);
begin
  with TTntComboBox (Sender) do
    if  (Items.IndexOf (Text) = -1) and (Text <> '')
    then  Items.Insert (0, Text);
end {CBR_Mask_AddNewItem};

function TTntFrFilesSC.IsOk: Boolean;
begin
  Result := True;
  if  CB_IncMask.Text = ''
  then  CB_IncMask.Text := '*.*';
  if CB_Date.Checked and
   (not (DEL_AS_Min.TextStored or DEL_AS_Max.TextStored))
  then  begin
    WideMessageBoxError (RSFSetMasks_LimDateNotStored);
    DEL_AS_Min.SetFocus;
    Result := False;
  end;
  if  not VLongintValidRange (EVC_Min.VValue, EVC_Max.VValue)  then  begin
    WideMessageBoxError (RSFSetMasks_InvalidSizes);
    EVC_Min.SetFocus;
    Result := False;
  end;
end {IsOk};

{--------------------------------------}

end.
