unit TntMessDemoU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, TntControls, Forms, TntForms, Dialogs,
  StdCtrls, TntStdCtrls, TntExtCtrls, ExtCtrls, Mask, TntJvExMask,
  TntJvSpin;

type
  TFTntMessDemo = class(TTntForm)
    B_PresMessage: TTntButton;
    B_ShowMessage: TTntButton;
    B_SimpleMessage: TTntButton;
    BB_ChangeFont: TTntButton;
    CB_AutoClose: TTntCheckBox;
    CB_WithIcon: TTntCheckBox;
    E_Cancel: TTntEdit;
    E_No: TTntEdit;
    E_Question: TTntEdit;
    E_Yes: TTntEdit;
    FontDialog: TFontDialog;
    GB_WithChangeableFont: TTntGroupBox;
    L_ButtonWidth: TTntLabel;
    L_Cancel: TTntLabel;
    L_No: TTntLabel;
    L_Question: TTntLabel;
    L_TextToShow: TTntLabel;
    L_TimePerChar: TTntLabel;
    L_Yes: TTntLabel;
    M_TextToShow: TTntMemo;
    P_Separator: TPanel;
    SE_ButtonWidth: TTntJvSpinEdit;
    SE_TimePerChar: TTntJvSpinEdit;
    procedure B_PresMessageClick(Sender: TObject);
    procedure B_ShowMessageClick(Sender: TObject);
    procedure B_SimpleMessageClick(Sender: TObject);
    procedure BB_ChangeFontClick(Sender: TObject);
    procedure CB_AutoCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SE_TimePerCharChange(Sender: TObject);
  end;

var
  FTntMessDemo: TFTntMessDemo;

implementation

{$R *.DFM}

uses
  TntMessFont, TntMessUsual, TntMessOther;

procedure TFTntMessDemo.B_ShowMessageClick(Sender: TObject);
begin
  if  CB_AutoClose.Checked
  then  WideMessageFBoxInfoTimer (M_TextToShow.Text, FontDialog.Font, CB_WithIcon.Checked)
  else  WideMessageFBoxInfo (M_TextToShow.Text, FontDialog.Font, CB_WithIcon.Checked);
end;

procedure TFTntMessDemo.BB_ChangeFontClick(Sender: TObject);
begin
  FontDialog.Execute;
end;

procedure TFTntMessDemo.B_PresMessageClick(Sender: TObject);
function MkStr(const S: WideString;  E: TTntEdit): WideString;
begin
  if  E.Text = ''
  then  Result := S
  else  Result := Concat (S, ' ', E.Text);
end {MkStr};
begin
  mcButtonWidth := Trunc (SE_ButtonWidth.Value);
  WideMessageXDlg
  (E_Question.Text,
    mtConfirmation, [
      MkStr ('Yes', E_Yes),
      MkStr ('No', E_No),
      MkStr ('Cancel', E_Cancel)],
    0);
end {B_PresMessageClick};

procedure TFTntMessDemo.B_SimpleMessageClick(Sender: TObject);
begin
  if  CB_AutoClose.Checked
  then  WideMessageBoxInfoTimer (M_TextToShow.Text)
  else  WideMessageBoxInfo (M_TextToShow.Text);
end;

procedure TFTntMessDemo.CB_AutoCloseClick(Sender: TObject);
begin
  L_TimePerChar.Visible := CB_AutoClose.Checked;
  SE_TimePerChar.Visible := CB_AutoClose.Checked;
end;

procedure TFTntMessDemo.FormCreate(Sender: TObject);
begin
  inherited;
  SE_TimePerCharChange (nil);
end;

procedure TFTntMessDemo.SE_TimePerCharChange(Sender: TObject);
begin
  TimeForChar := Trunc(SE_TimePerChar.Value);
end;

end.
