unit TntMkLinkDemoU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, TntForms,
  Dialogs, StdCtrls, Buttons, TntButtons, TntStdCtrls, TntExtCtrls,
  TntStdCtrls2, TntEdiTAmp;

resourcestring
  RS_FMakeLink0_RG_PresetDirs_Item1 = '&Programs menu';
  RS_FMakeLink0_RG_PresetDirs_Item2 = '&Start menu';
  RS_FMakeLink0_RG_PresetDirs_Item3 = '&Desktop';

type
  TFMakeLinkDemo = class(TTntForm)
    L_Link: TTntLabel;
    EOFN_Link: TTntEditOnlyFileName;
    L_Description: TTntLabel;
    M_Description: TTntMemo;
    RG_PresetDirs: TTntRadioGroup;
    CB_ForAllUsers: TTntCheckBox;
    BB_Ok: TTntBitBtn;
    BB_Close: TTntBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure BB_OkClick(Sender: TObject);
  end;

var
  FMakeLinkDemo: TFMakeLinkDemo;

implementation

{$R *.dfm}

uses
  ShlObj, TntFileUtil2,
  TntMessUsual, TntInst0, TntInstU;

procedure TFMakeLinkDemo.BB_OkClick(Sender: TObject);
var
  InstApp: TTntInstApp;
  SF: Integer;
  Path: WideString;
begin
  ModalResult := mrNone;
  if  not EOFN_Link.Valid
  then  Exit;
  if  CB_ForAllUsers.Checked  then  begin
    case RG_PresetDirs.ItemIndex of
    0: SF := CSIDL_COMMON_PROGRAMS;
    1: SF := CSIDL_COMMON_STARTMENU;
    else {2:} SF := CSIDL_COMMON_DESKTOPDIRECTORY;
    end;
  end
  else  begin
    case RG_PresetDirs.ItemIndex of
    0: SF := CSIDL_PROGRAMS;
    1: SF := CSIDL_STARTMENU;
    else {2:} SF := CSIDL_DESKTOPDIRECTORY;
    end;
  end;
  InstApp := TTntInstApp.Create;
  InstApp.GetSpecialFolder (SF, Path);
  if  InstApp.MakeLink (ExpandFileName(ParamStr(0)),
    '', Concat (AddSlashW(Path), EOFN_Link.Text, ExtLnk), M_Description.Text)
  then  WideMessageBoxInfo ('Link has been made');
  InstApp.Free;
end {BB_OkClick};

procedure TFMakeLinkDemo.FormCreate(Sender: TObject);
begin
  EOFN_Link.Text := ExtractFileOnlyNameW (ApplicationNameW);
  with  RG_PresetDirs  do  begin
    with Items do  begin
      Add (RS_FMakeLink0_RG_PresetDirs_Item1);
      Add (RS_FMakeLink0_RG_PresetDirs_Item2);
      Add (RS_FMakeLink0_RG_PresetDirs_Item3);
    end;
    ItemIndex := 2;
  end;
  M_Description.Text := Concat (M_Description.Text, 'Location: ', DelSlashW(ApplicationPathW));
end {FormCreate};

end.
