unit TntRZNEditDemoU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, TntForms, Dialogs,
  StdCtrls, TntStdCtrls, Buttons, TntButtons, ComCtrls, TntComCtrls,
  TntRZNEdit2, TntRZNEdit, TntRZNE0;

type
  TFTntRZNEditDemo = class(TTntForm)
    BB_Cancel: TTntBitBtn;
    BB_Ok: TTntBitBtn;
    CB_DecimalsAccept: TTntCheckBox;
    CB_LimMax: TTntCheckBox;
    CB_LimMin: TTntCheckBox;
    CB_PromptOnExit: TTntCheckBox;
    CB_RequiredValue: TTntCheckBox;
    CB_Validate: TTntCheckBox;
    EditCardinal: TTntEditCardinal;
    EditInteger: TTntEditInteger;
    EditReal: TTntEditReal;
    EditVCardinal: TTntEditVCardinal;
    EditVInteger: TTntEditVInteger;
    EditVReal: TTntEditVReal;
    EI_DecimalPlaces: TTntEditInteger;
    EI_LimMax: TTntEditInteger;
    EI_LimMin: TTntEditInteger;
    GB_Limits: TTntGroupBox;
    L_DecimalPlaces: TTntLabel;
    L_EditCardinal: TTntLabel;
    L_EditInteger: TTntLabel;
    L_EditReal: TTntLabel;
    L_EditVCardinal: TTntLabel;
    L_EditVInteger: TTntLabel;
    L_EditVReal: TTntLabel;
    procedure BB_CancelClick(Sender: TObject);
    procedure BB_OkClick(Sender: TObject);
    procedure CB_DecimalsAcceptClick(Sender: TObject);
    procedure CB_LimMaxClick(Sender: TObject);
    procedure CB_LimMinClick(Sender: TObject);
    procedure CB_PromptOnExitClick(Sender: TObject);
    procedure CB_RequiredValueClick(Sender: TObject);
    procedure CB_ValidateClick(Sender: TObject);
    procedure EI_DecimalPlacesChange(Sender: TObject);
    procedure EI_LimMaxChange(Sender: TObject);
    procedure EI_LimMinChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure SetLimsMax;
    procedure SetLimsMin;
  end;

var
  FTntRZNEditDemo: TFTntRZNEditDemo;

implementation

{$R *.DFM}

{--------------------------------------}
{-EVENTS-----------}

procedure TFTntRZNEditDemo.BB_CancelClick(Sender: TObject);
begin
  Close;
end;

procedure TFTntRZNEditDemo.BB_OkClick(Sender: TObject);
var
  IsOk: Boolean;
begin
  IsOk :=
    EditReal.Valid and
    EditInteger.Valid and
    EditCardinal.Valid and
    EditVReal.Valid and
    EditVInteger.Valid and
    EditVCardinal.Valid;
  if IsOk
  then  Close;
end;

procedure TFTntRZNEditDemo.CB_DecimalsAcceptClick(Sender: TObject);
begin
  EditInteger.DecimalsAccept := CB_DecimalsAccept.Checked;
  EditCardinal.DecimalsAccept := CB_DecimalsAccept.Checked;
  EditVInteger.DecimalsAccept := CB_DecimalsAccept.Checked;
  EditVCardinal.DecimalsAccept := CB_DecimalsAccept.Checked;
end;

procedure TFTntRZNEditDemo.CB_LimMinClick(Sender: TObject);
begin
  EI_LimMin.Visible := CB_LimMin.Checked;
  if  CB_LimMin.Checked
  then  EI_LimMin.SetFocus;
  SetLimsMin;
end;

procedure TFTntRZNEditDemo.CB_LimMaxClick(Sender: TObject);
begin
  EI_LimMax.Visible := CB_LimMax.Checked;
  if  CB_LimMax.Checked
  then  EI_LimMax.SetFocus;
  SetLimsMax;
end;

procedure TFTntRZNEditDemo.CB_PromptOnExitClick(Sender: TObject);
begin
  EditReal.PromptOnExit := CB_PromptOnExit.Checked;
  EditInteger.PromptOnExit := CB_PromptOnExit.Checked;
  EditCardinal.PromptOnExit := CB_PromptOnExit.Checked;
  EditVReal.PromptOnExit := CB_PromptOnExit.Checked;
  EditVInteger.PromptOnExit := CB_PromptOnExit.Checked;
  EditVCardinal.PromptOnExit := CB_PromptOnExit.Checked;
end;

procedure TFTntRZNEditDemo.CB_RequiredValueClick(Sender: TObject);
begin
  EditVReal.Required := CB_RequiredValue.Checked;
  EditVInteger.Required := CB_RequiredValue.Checked;
  EditVCardinal.Required := CB_RequiredValue.Checked;
end;

procedure TFTntRZNEditDemo.CB_ValidateClick(Sender: TObject);
begin
  EditReal.Validate := CB_Validate.Checked;
  EditInteger.Validate := CB_Validate.Checked;
  EditCardinal.Validate := CB_Validate.Checked;
  EditVReal.Validate := CB_Validate.Checked;
  EditVInteger.Validate := CB_Validate.Checked;
  EditVCardinal.Validate := CB_Validate.Checked;
end;

procedure TFTntRZNEditDemo.FormCreate(Sender: TObject);
begin
  EditReal.EditNameFromLabel (L_EditReal);
  EditInteger.EditNameFromLabel (L_EditInteger);
  EditCardinal.EditNameFromLabel (L_EditCardinal);
  EditVReal.EditNameFromLabel (L_EditVReal);
  EditVInteger.EditNameFromLabel (L_EditVInteger);
  EditVCardinal.EditNameFromLabel (L_EditVCardinal);
end;

procedure TFTntRZNEditDemo.EI_DecimalPlacesChange(Sender: TObject);
begin
  EditReal.DecimalPlaces := EI_DecimalPlaces.Value;
  EditVReal.DecimalPlaces := EI_DecimalPlaces.Value;
end;

procedure TFTntRZNEditDemo.EI_LimMaxChange(Sender: TObject);
begin
  SetLimsMax;
end;

procedure TFTntRZNEditDemo.EI_LimMinChange(Sender: TObject);
begin
  SetLimsMin;
end;

{-PRIVATE----------}

procedure TFTntRZNEditDemo.SetLimsMax;
begin
  if CB_LimMax.Checked then  begin
    EditReal.NMax := EI_LimMax.Value;
    EditInteger.NMax := EI_LimMax.Value;
    EditCardinal.NMax := Abs (EI_LimMax.Value);
    EditVReal.NMax := EI_LimMax.Value;
    EditVInteger.NMax := EI_LimMax.Value;
    EditVCardinal.NMax := Abs (EI_LimMax.Value);
  end
  else  begin
    EditReal.ClearMaxValue;
    EditInteger.ClearMaxValue;
    EditCardinal.ClearMaxValue;
    EditVReal.ClearMaxValue;
    EditVInteger.ClearMaxValue;
    EditVCardinal.ClearMaxValue;
  end;
end {SetLimsMax};

procedure TFTntRZNEditDemo.SetLimsMin;
begin
  if CB_LimMin.Checked then  begin
    EditReal.NMin := EI_LimMin.Value;
    EditInteger.NMin := EI_LimMin.Value;
    EditCardinal.NMin := Abs (EI_LimMin.Value);
    EditVReal.NMin := EI_LimMin.Value;
    EditVInteger.NMin := EI_LimMin.Value;
    EditVCardinal.NMin := Abs (EI_LimMin.Value);
  end
  else  begin
    EditReal.ClearMinValue;
    EditInteger.ClearMinValue;
    EditCardinal.ClearMinValue;
    EditVReal.ClearMinValue;
    EditVInteger.ClearMinValue;
    EditVCardinal.ClearMinValue;
  end;
end {SetLimsMin};

{--------------------------------------}

end.
