{---------------------------------------------------------------------

 TTntBBFont enables on click self to select a Font from TFontDialog,
 then Caption := CaptionLabel + FontSize, where Font := FontDialog.Font

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version

----------------------------------------------------------------------}

unit TntBBFont;  

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, TntButtons, TntButtons2;

type
  TTntBBFont = class(TTntBitBtn2)
    procedure Click; override;
  private
    FCaptionLabel: WideString;
    FFontDialog: TFontDialog;
    procedure SetCaptionLabel(const Value: WideString);
    procedure SetFontDialog(const Value: TFontDialog);
  public
    constructor Create (AOwner: TComponent); override;
    procedure GetFontAll (NewFont: TFont);
    procedure SetFont;
    procedure SetFontAll (NewFont: TFont);
  published
    property CaptionLabel: WideString read FCaptionLabel write SetCaptionLabel;
    property FontDialog: TFontDialog read FFontDialog write SetFontDialog;
  end;

implementation

{$R TntBBFont}

{--------------------------------------}
{-EVENTS-----------}

procedure TTntBBFont.Click;
begin
  inherited Click;
  if  Assigned (FFontDialog)  then  begin
    if  FFontDialog.Execute
    then  SetFont;
  end
  else
    ShowMessage ('You must assign FFontDialog');
end {Click};

{-PRIVATE----------}

procedure TTntBBFont.SetCaptionLabel(const Value: WideString);
begin
  FCaptionLabel := Value;
  SetFont;
end;

procedure TTntBBFont.SetFontDialog(const Value: TFontDialog);
begin
  FFontDialog := Value;
  SetFont;
end;

{-PUBLIC-----------}

constructor TTntBBFont.Create (AOwner: TComponent);
begin
  inherited Create (AOwner);
  Caption := '';
  Glyph.LoadFromResourceName(HInstance, 'TNTFONT');
  NumGlyphs := 1;
end {Create};

procedure TTntBBFont.GetFontAll (NewFont: TFont);
begin
  NewFont.Assign (Font);
  NewFont.Size := StrToInt (Caption);
end {GetFontAll};

procedure TTntBBFont.SetFont;
var
  WS: WideString;
  PrevSize: Integer;
begin
  if  Assigned (FFontDialog)  then  begin
    PrevSize := Font.Size;
    Font.Assign (FFontDialog.Font);
    Font.Size := PrevSize;
    WS := CaptionLabel;
    if  WS <> ''
    then  WS := Concat (WS, ' ');
    Caption := Concat (WS, IntToStr (FFontDialog.Font.Size));
  end;
end {SetFont};

procedure TTntBBFont.SetFontAll (NewFont: TFont);
begin
  if  Assigned (FFontDialog)  then  begin
    FFontDialog.Font.Assign (NewFont);
    SetFont;
  end;
end {SetFontAll};

{--------------------------------------}

end.
