{---------------------------------------------------------------------

 Widthly modified from TntCCopyDlg unit Arnt Kern's

 (c) Copyleft or copyright under terms of GNU General Public License
 2003  Jordi March i Nogu jmarch@comg.es

----------------------------------------------------------------------}

unit TntCCopyDlg;
{$D+,L+}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, TntClasses, Graphics, Controls,
  Forms, Dialogs, Db, FileCtrl,
  TntIniFiles, TntJvComponentBase,
  GrTypFun, TntMabSave;

resourcestring
  RS_CCopyDlg_IdentInval = 'Disk identificator invalid';
  RS_CCopyDlg_NoFoundDir = 'Directory ''%s'' not found';
  RS_CCopyDlg_PleaseInsertDisq = 'Please, you must insert the diskette in the drive';
  RS_CCopyDlg_NoCanOpen = 'Cannot open: ''%s''';
  RS_CCopyDlg_NoCanOverwriteFiles = 'Files cannot be overwritten';
  RS_CCopyDlg_SpaceForCopy = 'to target (%s bytes) for the selected files (%s bytes)';
  RS_CCopyDlg_NoDiskSpace = 'There is not enough space';
  RS_CCopyDlg_NoDiskFreeSpace = 'There is not enough space free';
  RS_CCopyDlg_NoMakeDir = 'Cannot create the directory ''%s''';
  RS_CCopyDlg_Continue = ', would you like to continue?';
  RS_CCopyDlg_TryIfBreak = 'Are you sure to interrupt the %s process?';
  RS_CCopyDlg_OfCopy = 'copy';
  RS_CCopyDlg_OfDeletion = 'deletion';
  RS_CCopyDlg_TryIfOverwriteFile = 'Rewrite %s'#13#10'Size: %s bytes  Date: %s'#13#10#13#10+
                                     'with: %s'#13#10'Size: %s bytes  Date: %s';
  RS_CCopyDlg_NoCanCreate = 'Cannot create ''%s''';
  RS_CCopyDlg_NoHandleSpaceForCopy = 'There is not enough space for the target device for: %s''';
  RS_CCopyDlg_ToCopy = 'to copy';
  RS_CCopyDlg_ToDelete = 'to delete';
  RS_CCopyDlg_ToMove = 'to move';
  RS_CCopyDlg_NoFile = 'There is not any file for %s!';
  RS_CCopyDlg_NoCanDeleteFile = 'It has not been possible to erase ''%s''';
  RS_CCopyDlg_Copying = 'Copying... ';
  RS_CCopyDlg_Moving = 'Moving... ';  
  RS_CCopyDlg_NoSetTargetDir = 'The target directory is not assigned';
  RS_CCopyDlg_DuplicateName = 'There are files with the same name when attempting %s to oneself directory: ';
  RS_CCopyDlg_IsCDROM = 'CD-ROM cannot modify';
  RS_CCopyDlg_DelReadOnlyFile = 'Delete the protected file ''%s''?';
  RS_CCopyDlg_OverwriteReadOnlyFile = 'Overwrite the protected file ''%s''?';
  RS_CCopyDlg_PromptCopyStructure = 'There is not any selected file. Only copy the tree in the target?';
  RS_FF_FileAlreadyExist = '''%s'' already exists in the list%s';
  RS_FF_FileNotExist = '''%s'' not exists in the list%s';
  RS_FF_PresentIdMessages = ', present new similar messages?';

const
  IdentDataTypeOptions = 'DataTypeOptions';
  IdentDateMax = 'DateMax';
  IdentDateMin = 'DateMin';
  IdentEnabled = 'Enabled';
  IdentExc = 'Exc';
  IdentFtArchive = 'FtArchive';
  IdentFtHidden = 'FtHidden';
  IdentFtReadOnly = 'FtReadOnly';
  IdentFtSystem = 'FtSystem';
  IdentInc = 'Inc';
  IdentTime = 'Time';
  IdentMask = 'Mask';
  IdentSizeMax = 'SizeMax';
  IdentSizeMin = 'SizeMin';

type
  TDataTypeOptions = (dtoLastTime, dtoBeforeTime, dtoDateRange, dtoDatesNoSet);

  {TTntFilesSCIncExc = Files Conditions Search for Include Exclude
   TTntFilesSCIncExc would be easily converted to Component
   IdentLastNForIniFile is a number from 0 to 9,
     will add end of each ident (key name),
     used when TTntFilesSCIncExc is loaded or saveded from or to any INI File
   Time is a WideString what determines the last time,
     for example: '1d ' = 1 day, '2m 1d ' = 2 month and 2 days
   MaskInc and FMaskExc, contains the masks for searching files,
     they can contains several makks each one, ex: '*.pas;*.dpr'}
  TTntFilesSCIncExc = class (TObject)
  private
    FChN: Char;
    FDateMax: TDate;
    FDateMin: TDate;
    FDataTypeOptions: TDataTypeOptions;
    FftReadOnly, FftHidden, FftSystem, FftArchive: TPropertyPresent;  {file types}
    FSizeMax: Integer;
    FSizeMin: Integer;
    FTime: WideString;
    FMaskInc: WideString;
    FMaskExc: WideString;
    FEnabled: Boolean;
    function  GetDateMax: TDate;
    function  GetDateMin: TDate;
    function  GetIdentLastNForIniFile: Byte;
    procedure SetIdentLastNForIniFile (Value: Byte);
    function  GetTime: Integer;
  public
    function CanEnabled: Boolean;
    constructor Create;
    function  IsOkAttr (FileAttr: LongWord): Boolean;
    function  IsOkDate (const DT: TDateTime): Boolean;
    function  IsOkLength (Length: Integer): Boolean;
    procedure LoadFromIniF (IniFile: TTntNewIniFile;  const Section: WideString);
    procedure SaveToIniF (IniFile: TTntNewIniFile;  const Section: WideString);
    property DateMax: TDate read GetDateMax write FDateMax;
    property DateMin: TDate read GetDateMin write FDateMin;
    property ITime: Integer read GetTime;
 {published}
    property DataTypeOptions: TDataTypeOptions read FDataTypeOptions write FDataTypeOptions default dtoDatesNoSet;
    property Enabled: Boolean read FEnabled write FEnabled;
    property ftArchive: TPropertyPresent read FftArchive write FftArchive default ppYes;
    property ftHidden: TPropertyPresent read FftHidden write FftHidden;
    property ftReadOnly: TPropertyPresent read FftReadOnly write FftReadOnly;
    property ftSystem: TPropertyPresent read FftSystem write FftSystem;
    property IdentLastNForIniFile: Byte read GetIdentLastNForIniFile write SetIdentLastNForIniFile default 0;
    property SizeMax: Integer read FSizeMax write FSizeMax;
    property SizeMin: Integer read FSizeMin write FSizeMin;
    property Time: WideString read FTime write FTime;
    property MaskInc: WideString read FMaskInc write FMaskInc;
    property MaskExc: WideString read FMaskExc write FMaskExc;
  end;

  TTntDirList = class(TTntStringList)
  public
    procedure AddNotExistDir (Dir: WideString);
    procedure Sort; override;
  end;

  {Next procedures are would be used for show messages in Custom Form}
  TTntNotifyChangeDir = procedure (const Dir: WideString) of object;
  TTntNotifyAddRemoveF = procedure (N: Longword) of object;

  TTntOtherCorrectFile = function (const FN: WideString): Boolean of object;

  {TTntGenericFileList is TTntStringFileList and TTntDataSetFileList ancestor
    SS = List (of TTntStringFileList) or DataSet (of TTntDataSetFileList)
    AddFile (FN: WideString) = Add a file named FN to SS
    AddFilesFromDir (const Dir: WideString) =
      Add files with FilesSCIncExc and IncSubFolders properties to SS,
      begin in Dir
    RemoveFile (FN: WideString) = Remove a file named FN from SS
    RemoveFilesFromDir (const Dir: WideString)
      Add files with FilesSCIncExc and IncSubFolders properties from SS,
      begin in Dir
    CheckOnAdd = checks if a file exists before AddFile to SS

    Interrupted is called with Interrupted as @Interrupted,
    where Interrupted: Boolean
    and associated to
     procedure TXForm.FormKeyPress(Sender: TObject; var Key: WideChar);
     begin
       if  Key = Chr(VK_ESCAPE)
       then  Interrupted := True;
     end;
    and
      XForm.KeyPreview = True }

  TTntGenericFileList = class(TTntJvComponent)
  private
    FCheckOnAdd: Boolean;
    FCheckOnRemove: Boolean;
    FCompleteRecOnAdd: Boolean;
    function AddOnlyFile (FN: WideString): Boolean;
    function CorrectFile (Add: Boolean;  var FN: WideString): Boolean;
    procedure RemoveOnlyFile (FN: WideString);
  protected
    FAddDirectories: Boolean;
    FDirList: TTntDirList;
    FFilesSCIncExc: TTntFilesSCIncExc;
    FIncAllFilesFromSubFolders: Boolean;
    FIncSubFolders: Boolean;
    FMessOnNoAddOrNoRemove: Boolean;
    FOnAddRemoveFile: TTntNotifyAddRemoveF;
    FOnChangeDir: TTntNotifyChangeDir;
    FOnOtherCorrectFile: TTntOtherCorrectFile;
    FStrSourceDir: WideString;
    PresentNewMessage: Boolean;
    SeveralSourceDrivers: Boolean;
    procedure AddNow (const FN: WideString); virtual; abstract;
    function  AddOrCheckFilesFromDir
     (ActionAddOrRemove, Remove, RootOfSearchDir: Boolean;
      const Dir: WideString): Boolean;
    function  GetCount: LongWord; virtual; abstract;
    function  FoundFileName (const FN: WideString): Boolean; virtual; abstract;
    function  FindCommonDirForAllItems (L: TTntStringList;  Extract: Boolean;
      var Res: WideString): Boolean;
    procedure OtherWhenChangeSourceDir; virtual;
    procedure PresentMessNoAddOrNoRemove (Add: Boolean;  const FN: WideString);
    procedure RemoveNow (const FN: WideString); virtual; abstract;
    function  GetSlashStrSourceDir: WideString;
    procedure SetStrSourceDir (const SD: WideString); virtual;
    procedure WhenChangeSourceDir;
    property CommonDir: WideString read FStrSourceDir write SetStrSourceDir;
    property CompleteRecOnAdd: Boolean read FCompleteRecOnAdd write FCompleteRecOnAdd;
    property CheckOnAdd: Boolean read FCheckOnAdd write FCheckOnAdd;
    property CheckOnRemove: Boolean read FCheckOnRemove write FCheckOnRemove;
  public
    Interrupted: PBoolean;
    procedure AddFile (FN: WideString);
    function  AddFilesFromDir (const Dir: WideString): Boolean;
    function  AddFilesFromDirNoRoot (const Dir: WideString): Boolean;
    constructor Create (AOwner: TComponent); override;
    destructor Destroy; override;
    procedure RemoveFile (FN: WideString);
    function  RemoveFilesFromDir (const Dir: WideString): Boolean;
    property DirList: TTntDirList read FDirList;
  published
    property FilesSCIncExc: TTntFilesSCIncExc read FFilesSCIncExc write FFilesSCIncExc;
    property AddDirectories: Boolean read FAddDirectories write FAddDirectories default True;
    property IncAllFilesFromSubFolders: Boolean read FIncAllFilesFromSubFolders write FIncAllFilesFromSubFolders;
    property IncSubFolders: Boolean read FIncSubFolders write FIncSubFolders default True;
    property MessOnNoAddOrNoRemove: Boolean read FMessOnNoAddOrNoRemove write FMessOnNoAddOrNoRemove default True;
    property OnAddRemoveFile: TTntNotifyAddRemoveF read FOnAddRemoveFile write FOnAddRemoveFile;
    property OnChangeDir: TTntNotifyChangeDir read FOnChangeDir write FOnChangeDir;
    property OnOtherCorrectFile: TTntOtherCorrectFile read FOnOtherCorrectFile write FOnOtherCorrectFile;
  end;

  TTntStringFileList = class(TTntGenericFileList)
  protected
    FList: TTntStringList;
    ItemIndex: Integer; {uses for test a File in FoundFileName and Remove it}
    procedure AddNow (const FN: WideString); override;
    function  GetCount: LongWord; override;
    function  FoundFileName (const FN: WideString): Boolean; override;
    function  FindCommonDirForAllList (L: TTntStringList;  Extract: Boolean;
      var Res: WideString): Boolean;
    procedure OtherWhenChangeSourceDir; override;
    procedure RemoveNow (const FN: WideString); override;
  public
    constructor Create (AOwner: TComponent); override;
    destructor Destroy; override;
    function  ExistDirInList (const Dir: WideString): Boolean;
    function  ExistAnyFileInDir (const Dir: WideString): Boolean;
    procedure FindCommonDir (UpdateList: Boolean);
    property List: TTntStringList read FList;
  published
    property CheckOnAdd;
    property CheckOnRemove;
  end;

const {FN = FieldNumber}
  FNDir = 0;
  FNName = 1;
  FNExt = 2;
  FNMarkForDuplicate = 3;
  FNSize = 4;
  FNDateHour = 5;
  FNAttrib = 6;
  FNTypeDescr = 7;
  FNImageIndex = 8;
  FNSSize = 9;
  FNDate = 10;
  FNHour =11;
  FNSAttrib = 12;
  FNIsDir = 13;
  FNIsFile = 14;
  FNNSubDir = 15;
  FNInternType = 16;
  FNGraphImageIndex = 17;
  FNMark = 18;
  FNActionMade = 19;
  FNDeleted = 20;
  FNNameUp = 21; {used for comparations and Locate}
  FNExtUp = 22;  {used for comparations and Locate}

  {FNm = FieldName}
  FNmDir = 'Dir'; {0}
  FNmName = 'Name'; {1}
  FNmExt = 'Ext'; {2}
  FNmMarkForDuplicate = 'MarkForDuplicate'; {3}
  FNmSize = 'Size'; {4}
  FNmDateHour = 'DateHour'; {5}
  FNmAttrib = 'Attrib'; {6}
  FNmTypeDescr = 'TypeDescr'; {7}
  FNmImageIndex = 'ImageIndex'; {8}
  FNmSSize = 'SSize'; {9}
  FNmDate = 'Date'; {10}
  FNmHour = 'Hour'; {11}
  FNmSAttrib = 'SAttrib'; {12}
  FNmIsDir = 'IsDir'; {13}
  FNmIsFile = 'IsFile'; {14}
  FNmNSubDir = 'NSubDir'; {15}
  FNmInternType = 'InternType'; {16}
  FNmGraphImageIndex = 'GraphImageIndex'; {17}
  FNmMark = 'Mark'; {18}
  FNmActionMade = 'ActionMade'; {19}
  FNmDeleted = 'Deleted'; {20}
  FNmNameUp = 'NameUp'; {21}
  FNmExtUp = 'ExtUp'; {22}

type
  TTntDataSetFileList = class(TTntGenericFileList)
  private
    procedure SetDataSet(const Value: TDataSet);
  protected
    FDataSetWithShortRec: Boolean;
    FDataSet: TDataSet;
    FDSIntTypeExt: TDataSet;
    procedure AddNow (const FN: WideString); override;
    function  GetCompletFN: WideString;
    function  GetCount: LongWord; override;
    function  FoundFileName (const FN: WideString): Boolean; override;
    procedure OtherWhenChangeSourceDir; override;
    procedure RemoveNow (const FN: WideString); override;
  public
    procedure CompleteRecords;
    procedure DelDuplicates (PresMessage, OnAdd: Boolean); {On Sorted DataSet}
    function  ExistDirInDataSet (const Dir: WideString): Boolean;
    function  FindCommonDir: WideString;
    property CompleteRecOnAdd;
    property DataSet: TDataSet read FDataSet write SetDataSet;
    property DSIntTypeExt: TDataSet read FDSIntTypeExt write FDSIntTypeExt;
  published
    property CheckOnAdd;
    property CheckOnRemove;
  end;

  {custom type to hold file information}
  TFileInfo = record
    Date: Longint;
    Size: Longint;
  end;

  TTntCCMDBoxDlg = class(TTntStringFileList)
  private
    FDeleteEmptyDirs: Boolean;
    FInfoNotFilesOrDirsToCopy: Boolean;
    FPromptOnDelReadOnlyFiles: Boolean;
    FSetFilesToNoReadOnly: Boolean;
    function  GetDirsDeleted: Boolean;
    function  DiskInDrive (I: Byte): Word;
    function  IsDir (const sDrive: WideString;  Writeable: Boolean): Boolean;
    function  GetFilesWithActionMade: Boolean;
    procedure SetSetFilesToNoReadOnly (const Value: Boolean);
  protected
    EverDelROF: Boolean; {Ever Delete Read Only File}
    FNDirsDeleted: Word;
    FNFilesWithActionMade: Longword;
    NeedDel: Boolean;
    function  CheckDir (sDir: WideString;  var sDirResult: WideString;
      Writeable: Boolean): Boolean;
    function  DiskValid (var C: Char;  var DiskByte: Byte): Boolean;
    procedure PerhapsDeleteEmptyDirs;
    procedure SetStrSourceDir (const SD: WideString); override;
    function  SourceDirWriteable: Boolean; virtual; abstract;
    function  PreExecute (const S: WideString): Boolean;
    procedure PostExecute;
    procedure WhenAskDelROF (const FN, Mess: WideString);
  public
    constructor Create (AOwner: TComponent); override;
    property NDirsDeleted: Word read FNDirsDeleted;
    property DirsDeleted: Boolean read GetDirsDeleted;
    property NFilesWithActionMade: Longword read FNFilesWithActionMade;
    property FilesWithActionMade: Boolean read GetFilesWithActionMade;
  published
    property DeleteEmptyDirs: Boolean read FDeleteEmptyDirs write FDeleteEmptyDirs;
    property InfoNotFilesOrDirsToCopy: Boolean read FInfoNotFilesOrDirsToCopy write FInfoNotFilesOrDirsToCopy default False;
    property PromptOnDelReadOnlyFiles: Boolean read FPromptOnDelReadOnlyFiles write FPromptOnDelReadOnlyFiles default True;
    property SetFilesToNoReadOnly: Boolean read FSetFilesToNoReadOnly write SetSetFilesToNoReadOnly default False;
  end;

  TTntCMDBoxDlg = class(TTntDataSetFileList)
  private
    FDeleteEmptyDirs: Boolean;
    FInfoNotFilesOrDirsToCopy: Boolean;
    FPromptOnDelReadOnlyFiles: Boolean;
    FSetFilesToNoReadOnly: Boolean;
    function  GetDirsDeleted: Boolean;
    function  DiskInDrive (I: Byte): Word;
    function  IsDir (const sDrive: WideString;  Writeable: Boolean): Boolean;
    function  GetFilesWithActionMade: Boolean;
    procedure SetSetFilesToNoReadOnly (const Value: Boolean);
  protected
    EverDelROF: Boolean; {Ever Delete Read Only File}
    FNDirsDeleted: Word;
    FNFilesWithActionMade: Longword;
    NeedDel: Boolean;
    function  CheckDir (sDir: WideString;  var sDirResult: WideString;
      Writeable: Boolean): Boolean;
    function  DiskValid (var C: Char;  var DiskByte: Byte): Boolean;
    procedure PerhapsDeleteEmptyDirs;
    procedure SetStrSourceDir (const SD: WideString); override;
    function  SourceDirWriteable: Boolean; virtual; abstract;
    function  PreExecute (const S: WideString): Boolean;
    procedure PostExecute;
    procedure WhenAskDelROF (const FN, Mess: WideString);
  public
    constructor Create (AOwner: TComponent); override;
    property NDirsDeleted: Word read FNDirsDeleted;
    property DirsDeleted: Boolean read GetDirsDeleted;
    property NFilesWithActionMade: Longword read FNFilesWithActionMade;
    property FilesWithActionMade: Boolean read GetFilesWithActionMade;
  published
    property DeleteEmptyDirs: Boolean read FDeleteEmptyDirs write FDeleteEmptyDirs;
    property InfoNotFilesOrDirsToCopy: Boolean read FInfoNotFilesOrDirsToCopy write FInfoNotFilesOrDirsToCopy default False;
    property PromptOnDelReadOnlyFiles: Boolean read FPromptOnDelReadOnlyFiles write FPromptOnDelReadOnlyFiles default True;
    property SetFilesToNoReadOnly: Boolean read FSetFilesToNoReadOnly write SetSetFilesToNoReadOnly default False;
  end;

  TTntNotifyDelMade = procedure (const FN: WideString;  Made: Boolean) of object;

  TTntCDelBoxDlg = class(TTntCCMDBoxDlg)
  private
    FSendToTrash: Boolean;
    FOnNotifyDelMade: TTntNotifyDelMade;
  protected
    function  SourceDirWriteable: Boolean; override;
  public
    constructor Create (AOwner: TComponent); override;
    function  Execute: Boolean;
  published
    property Directory: WideString read FStrSourceDir write SetStrSourceDir;
    property SendToTrash: Boolean read FSendToTrash write FSendToTrash default True;
    property OnNotifyDelMade: TTntNotifyDelMade read FOnNotifyDelMade write FOnNotifyDelMade;
  end;

  TTntDelBoxDlg = class(TTntCMDBoxDlg)
  private
    FSendToTrash: Boolean;
    FOnNotifyDelMade: TTntNotifyDelMade;
  protected
    function  SourceDirWriteable: Boolean; override;
  public
    constructor Create (AOwner: TComponent); override;
    function  Execute: Boolean;
  published
    property Directory: WideString read FStrSourceDir write SetStrSourceDir;
    property SendToTrash: Boolean read FSendToTrash write FSendToTrash default True;
    property OnNotifyDelMade: TTntNotifyDelMade read FOnNotifyDelMade write FOnNotifyDelMade;
  end;

  TTntSingleStr = class(TObject)
    S: ShortString;
  end;
  TFileAction = (faCopy, faMove);
  TTntNotifyCopyMoveMade = procedure (const SrceFN, DestFN: WideString;
    FileAction: TFileAction;  Made: Boolean) of object;

  TTntCCopyMoveBoxDlg = class(TTntCCMDBoxDlg)
  private
    FCopyMoveToSingleDir: Boolean;
    FNDirsAdded: Word;
    FOkToAll: Boolean;
    FFileAction: TFileAction;
    FOverwritePrompt: Boolean;
    FOverwriteNewerPrompt: Boolean;
    FOverwriteReadOnlyFiles: Boolean;
    FPromptEmptyStructure: Boolean;
    FStrTargetDir: WideString;
    FOnNotifyCopyMoveMade: TTntNotifyCopyMoveMade;
    function  GetDirsAdded: Boolean;
    procedure SetFileAction (const Value: TFileAction);
    procedure SetOverwritePrompt (V: Boolean);
    procedure SetOverwriteNewerPrompt (V: Boolean);
    procedure SetStrTargetDir (const TD: WideString);
  protected
    function  SourceDirWriteable: Boolean; override;
  public
    constructor Create (AOwner: TComponent); override;
    function  Execute: Boolean;
    function  ExistDirInTargetList (const Dir: WideString): Boolean;
    property NDirsAdded: Word read FNDirsAdded;
    property DirsAdded: Boolean read GetDirsAdded;
  published
    property CopyMoveToSingleDir: Boolean read FCopyMoveToSingleDir write FCopyMoveToSingleDir default False;
    property FileAction: TFileAction read FFileAction write SetFileAction;
    property OverwritePrompt: Boolean read FOverwritePrompt write SetOverwritePrompt default False;
    property OverwriteNewerPrompt: Boolean read FOverwriteNewerPrompt write SetOverwriteNewerPrompt default True;
    property OverwriteReadOnlyFiles: Boolean read FOverwriteReadOnlyFiles write FOverwriteReadOnlyFiles;
    property PromptEmptyStructure: Boolean read FPromptEmptyStructure write FPromptEmptyStructure default False;
    property StrSourceDir: WideString read FStrSourceDir write SetStrSourceDir;
    property StrTargetDir: WideString read FStrTargetDir write SetStrTargetDir;
    property OnNotifyCopyMoveMade: TTntNotifyCopyMoveMade read FOnNotifyCopyMoveMade write FOnNotifyCopyMoveMade;
  end;

  TTntCopyMoveBoxDlg = class(TTntCMDBoxDlg)
  private
    FCopyMoveToSingleDir: Boolean;
    FNDirsAdded: Word;
    FOkToAll: Boolean;
    FFileAction: TFileAction;
    FOverwritePrompt: Boolean;
    FOverwriteNewerPrompt: Boolean;
    FOverwriteReadOnlyFiles: Boolean;
    FStrTargetDir: WideString;
    FOnNotifyCopyMoveMade: TTntNotifyCopyMoveMade;
    FPromptEmptyStructure: Boolean;
    function  GetDirsAdded: Boolean;
    procedure SetFileAction (const Value: TFileAction);
    procedure SetOverwritePrompt (V: Boolean);
    procedure SetOverwriteNewerPrompt (V: Boolean);
    procedure SetStrTargetDir (const TD: WideString);
  protected
    function  SourceDirWriteable: Boolean; override;
  public
    constructor Create (AOwner: TComponent); override;
    function  Execute: Boolean;
    function  ExistDirInTargetList (const Dir: WideString): Boolean;
    property NDirsAdded: Word read FNDirsAdded;
    property DirsAdded: Boolean read GetDirsAdded;
  published
    property CopyMoveToSingleDir: Boolean read FCopyMoveToSingleDir write FCopyMoveToSingleDir default False;
    property FileAction: TFileAction read FFileAction write SetFileAction;
    property OverwritePrompt: Boolean read FOverwritePrompt write SetOverwritePrompt default False;
    property OverwriteNewerPrompt: Boolean read FOverwriteNewerPrompt write SetOverwriteNewerPrompt default True;
    property OverwriteReadOnlyFiles: Boolean read FOverwriteReadOnlyFiles write FOverwriteReadOnlyFiles;
    property PromptEmptyStructure: Boolean read FPromptEmptyStructure write FPromptEmptyStructure;
    property StrSourceDir: WideString read FStrSourceDir write SetStrSourceDir;
    property StrTargetDir: WideString read FStrTargetDir write SetStrTargetDir;
    property OnNotifyCopyMoveMade: TTntNotifyCopyMoveMade read FOnNotifyCopyMoveMade write FOnNotifyCopyMoveMade;
  end;

function TntIntTypeFromExt (DSIntTypeExt: TDataSet;  const UpExt: WideString): Str1;
procedure TntAddOneShortRecord (DataSet: TDataSet;
  const PathWSlash, FN: WideString);
procedure TntAddOneRecord (DataSet, DSIntTypeExt: TDataSet;
  const PathWSlash, FN: WideString);
procedure TntCompleteOneShortRecord (DataSet: TDataSet;  const FN: WideString);
procedure TntCompleteOneRecord (DataSet, DSIntTypeExt: TDataSet;  const FN: WideString);
function TntFindCommonDirFromDirsSL (SL: TTntStringList;  var Res: WideString): Boolean;

var
  iErrorMode: Word;

implementation

uses
  ShellAPI, TntWindows, TntSysUtils, TntWideStrUtils, TntFileUtil,
  TntDateTime0, TntFileUtil2, StrUtil00, TntStrUtil0, TntStrAnal, StrNumU, TntMessUsual,
  TntFilesProgB, TntCopyFBP, TntDelFPB;

{--------------------------------------}

function TntIntTypeFromExt (DSIntTypeExt: TDataSet;  const UpExt: WideString): Str1;
begin
  Result := '';
  if  not Assigned (DSIntTypeExt)
  then  Exit;
  with DSIntTypeExt do  begin
    First;
    while not EOF do  begin
      if  Fields[0].Value = UpExt  then  begin
        Result := Fields[1].Value;
        Exit;
      end;
      Next;
    end;
  end;
end {TntIntTypeFromExt};

procedure TntAddOneShortRecord (DataSet: TDataSet;
  const PathWSlash, FN: WideString);
begin
  with DataSet do  begin
    Append;
    Fields[FNDir].Value  := DelSlashW (PathWSlash);
    Fields[FNName].Value := ExtractFileOnlyNameW (FN);
    Fields[FNExt].Value  := ExtractFileExtWithoutPointW (FN);
    TntCompleteOneShortRecord (DataSet, FN);
    Post;
  end;
end {TntAddOneShortRecord};

procedure TntAddOneRecord (DataSet, DSIntTypeExt: TDataSet;
  const PathWSlash, FN: WideString);
begin
  with DataSet do  begin
    Append;
    Fields[FNDir].Value  := DelSlashW (PathWSlash);
    Fields[FNName].Value := ExtractFileOnlyNameW (FN);
    Fields[FNExt].Value  := ExtractFileExtWithoutPointW (FN);
    TntCompleteOneRecord (DataSet, DSIntTypeExt, FN);
    Post;
  end;
end {TntAddOneRecord};

(****
procedure CompleteOneShortRecWithHandle (DataSet: TDataSet;
  const FN: WideString;  win32FD: TWin32FindDataW);
begin
  with DataSet do  begin
    Fields[FNSize].AsInteger  := (Win32FD.nFileSizeHigh * MAXDWORD) + Win32FD.nFileSizeLow;
    Fields[FNDateHour].AsDateTime := FileTimeToDateTime (Win32FD.ftLastWriteTime);
    TLargeintField(Fields[FNAttrib]).AsLargeInt := Win32FD.dwFileAttributes;
  end;
end {CompleteOneShortRecWithHandle};

procedure CompleteOneRecWithHandle (DataSet, DSIntTypeExt: TDataSet;
  const FN: WideString;  win32FD: TWin32FindDataW);
var
  DT: TDateTime;
  sfi: TSHFileInfoW;
  UpExt: WideString[5];
begin
  with DataSet do  begin
    Fields[FNSize].AsInteger  := (Win32FD.nFileSizeHigh * MAXDWORD) + Win32FD.nFileSizeLow;
    DT := FileTimeToDateTime (Win32FD.ftLastWriteTime);
    Fields[FNDateHour].AsDateTime := DT;
    TLargeintField(Fields[FNAttrib]).AsLargeInt := Win32FD.dwFileAttributes;
    {Rest}
    SHGetFileInfo (PWideChar(FN), 0, sfi, SizeOf(sfi), {SHGFI_TYPENAME or }SHGFI_SYSICONINDEX{ or SHGFI_DISPLAYNAME});
    Fields[FNImageIndex].AsInteger := sfi.iIcon;
    Fields[FNDate].AsDateTime := Trunc(DT);
    Fields[FNHour].AsDateTime := Frac(DT);
    if  Win32FD.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY = FILE_ATTRIBUTE_DIRECTORY  then  begin
      Fields[FNIsDir].AsBoolean := True;
      Fields[FNIsFile].AsBoolean := False;
    end
    else  begin
      Fields[FNIsDir].AsBoolean := False;
      Fields[FNIsFile].AsBoolean := True;
    end;
    Fields[FNNSubDir].AsInteger := PosChForward(FN, PathDelim)-1;
    Fields[FNMark].AsBoolean := False;
    Fields[FNDeleted].AsBoolean := False;
    Fields[FNNameUp].Value := WideUpperCase (Fields[FNName].Value);
    UpExt := WideUpperCase (Fields[FNExt].Value);
    Fields[FNExtUp].Value := UpExt;
    Fields[FNInternType].Value := TntIntTypeFromExt (DSIntTypeExt, UpExt);
  end;
end {CompleteOneRecWithHandle};
***)

procedure TntCompleteOneShortRecord (DataSet: TDataSet;  const FN: WideString);
var
  win32FD: TWin32FindDataW;
  hFindFile: THandle;
begin
  hFindFile := Tnt_FindFirstFileW (PWideChar(FN), Win32FD);
  if  hFindFile <> INVALID_HANDLE_VALUE  then  begin
    with DataSet do  begin
      Fields[FNSize].AsInteger  := (Win32FD.nFileSizeHigh * MAXDWORD) + Win32FD.nFileSizeLow;
      Fields[FNDateHour].AsDateTime := FileTimeToDateTime (Win32FD.ftLastWriteTime);
      TLargeintField(Fields[FNAttrib]).AsLargeInt := Win32FD.dwFileAttributes;
    end;
    FindClose (hFindFile);
  end;
end {TntCompleteOneRecord};

procedure TntCompleteOneRecord (DataSet, DSIntTypeExt: TDataSet;  const FN: WideString);
var
  win32FD: TWin32FindDataW;
  hFindFile: THandle;
  DT: TDateTime;
  sfi: TSHFileInfoW;
  UpExt: WideString;
begin
  hFindFile := Tnt_FindFirstFileW (PWideChar(FN), Win32FD);
  if  hFindFile <> INVALID_HANDLE_VALUE  then  begin
    with DataSet do  begin
      Fields[FNSize].AsInteger  := (Win32FD.nFileSizeHigh * MAXDWORD) + Win32FD.nFileSizeLow;
      DT := FileTimeToDateTime (Win32FD.ftLastWriteTime);
      Fields[FNDateHour].AsDateTime := DT;
      TLargeintField(Fields[FNAttrib]).AsLargeInt := Win32FD.dwFileAttributes;
      {Rest}
{ERROR} SHGetFileInfoW (PChar(FN), 0, sfi, SizeOf(sfi), {SHGFI_TYPENAME or }SHGFI_SYSICONINDEX{ or SHGFI_DISPLAYNAME});
      Fields[FNImageIndex].AsInteger := sfi.iIcon;
      Fields[FNDate].AsDateTime := Trunc(DT);
      Fields[FNHour].AsDateTime := Frac(DT);
      if  Win32FD.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY = FILE_ATTRIBUTE_DIRECTORY  then  begin
        Fields[FNIsDir].AsBoolean := True;
        Fields[FNIsFile].AsBoolean := False;
      end
      else  begin
        Fields[FNIsDir].AsBoolean := False;
        Fields[FNIsFile].AsBoolean := True;
      end;
      Fields[FNNSubDir].AsInteger := PosChForwardW (FN, PathDelim)-1;
      Fields[FNMark].AsBoolean := False;
      Fields[FNDeleted].AsBoolean := False;
      Fields[FNNameUp].Value := WideUpperCase (Fields[FNName].Value);
      UpExt := WideUpperCase (Fields[FNExt].Value);
      Fields[FNExtUp].Value := UpExt;
      Fields[FNInternType].Value := TntIntTypeFromExt (DSIntTypeExt, UpExt);
    end;
    //CompleteOneRecWithHandle (DataSet, DSIntTypeExt, FN, win32FD);
    FindClose (hFindFile);
  end;
end {TntCompleteOneRecord};

function TntFindCommonDirFromDirsSL (SL: TTntStringList;  var Res: WideString): Boolean;
var
  I, Position: Integer;
  S, S1: WideString;
  NoMore: Boolean;
begin
  S := '';
  Res := '';
  if  SL.Count = 0  then  begin
    Result := False;
    Exit;
  end
  else
    Result := True;
  if  SL.Count = 1
  then  Res := SL[0]
  else  begin
    NoMore := False;
    while not NoMore  do  begin
      for  I := 0 to SL.Count-1  do  begin
        Position := Pos(PathDelim, SL[I]);
        if  Position = 0
        then  S1 := AddSlashW (SL[I])
        else  S1 := System.Copy (SL[I], 1, Position);
        if  (I <> 0) and (S <> S1)  then  begin
          NoMore := True;
          Break;
        end;
        S := S1;
      end;
      if  not NoMore  then  begin
        Res := Concat (Res, S1);
        for  I := 0 to SL.Count-1  do   begin
          S := SL[I];
          Position := Pos(PathDelim, S);
          if  Position = 0
          then  Position := MaxInt;
          System.Delete (S, 1, Position);
          SL[I] := S;
        end;
      end;
    end;
  end;
end {TntFindCommonDirFromDirsSL};

{--------------------------------------}
{-PRIVATE----------}

function TTntFilesSCIncExc.GetDateMax: TDate;
begin
  case DataTypeOptions of
  dtoLastTime  : Result := 0; {=Date}
  dtoBeforeTime: Result := Date - ITime;
  dtoDateRange : Result := FDateMax;
  else {dtoDatesNoSet} Result := 0;
  end;
end {GetDateMax};

function TTntFilesSCIncExc.GetDateMin: TDate;
begin
  case DataTypeOptions of
  dtoLastTime  : Result := Date - ITime;
  dtoBeforeTime: Result := 0;
  dtoDateRange : Result := FDateMin;
  else {dtoDatesNoSet} Result := 0;
  end;
end {GetDateMin};

function TTntFilesSCIncExc.GetIdentLastNForIniFile: Byte;
begin
  Result := StrToInt (CharToStr1(FChN));
end {GetIdentLastNForIniFile};

procedure TTntFilesSCIncExc.SetIdentLastNForIniFile (Value: Byte);
begin
  FChN := IntToStr(Value)[1];
end {SetIdentLastNForIniFile};

function TTntFilesSCIncExc.GetTime: Integer;
var
  Res: Real;
begin
  if  StrToAbsTimeW (FTime, Res)
  then  Result := Round (Res)
  else  begin
    FTime := '';
    Result := 0;
  end;
end {GetTime};

{-PUBLIC-----------}

function TTntFilesSCIncExc.CanEnabled: Boolean;
begin
  Result := not
  ((FMaskInc = '*.*') and
   (FMaskExc = '') and
   (FftArchive = ppIgnore) and
   (FftHidden = ppIgnore) and
   (FftReadOnly = ppIgnore) and
   (FftSystem = ppIgnore) and
   (FDataTypeOptions = dtoDatesNoSet) and
   (FSizeMax = -1) and
   (FSizeMin = -1));
end {CanEnabled};

constructor TTntFilesSCIncExc.Create;
begin
  FEnabled := True;
  FMaskInc := '*.*';
  FftArchive := ppYes;
  FDataTypeOptions := dtoDatesNoSet;
  FSizeMax := -1;
  FSizeMin := -1;
end {Create};

function TTntFilesSCIncExc.IsOkAttr (FileAttr: LongWord): Boolean;
var
  Ok: Boolean;
function AttrOk (PP: TPropertyPresent;  Attr: LongWord): Boolean;
begin
  case PP of
  ppIgnore: Ok := True;
  ppYes:    Ok := FileAttr and Attr = Attr;
  ppNo:     Ok := not (FileAttr and Attr = Attr);
  end;
  Result := Ok;
end {AttrOk};
begin
  Ok := {(FileAttr >= 0) and} not (FileAttr and faDirectory = faDirectory);
  if  Ok and
    AttrOk (FftArchive,  SysUtils.faArchive)  and
    AttrOk (FftHidden,   SysUtils.faHidden)   and
    AttrOk (FftReadOnly, SysUtils.faReadOnly) and
    AttrOk (FtSystem,   SysUtils.faSysFile)  then;
  Result := Ok;
end {IsOkAttr};

function TTntFilesSCIncExc.IsOkDate (const DT: TDateTime): Boolean;
var
  Ok: Boolean;
begin
  Ok := True;
  if  DataTypeOptions <> dtoDatesNoSet  then  begin
    if  (FDateMin <> 0) and (DT < FDateMin)
    then  Ok := False;
    if  Ok and (FDateMax <> 0) and (DT > FDateMax)
    then  Ok := False;
  end;
  Result := Ok;
end {IsOkDate};

function TTntFilesSCIncExc.IsOkLength (Length: Integer): Boolean;
var
  Ok: Boolean;
begin
  Ok := True;
  if  FSizeMax <> -1
  then  Ok := Length <= FSizeMax;
  if  Ok and (FSizeMin <> -1)
  then  Ok := Length >= FSizeMin;
  Result := Ok;
end {IsOkLength};

procedure TTntFilesSCIncExc.LoadFromIniF (IniFile: TTntNewIniFile;  const Section: WideString);
var
  I: Integer;
procedure ReadPresentProperty (var PP: TPropertyPresent;  const Ident: WideString;
  Default: TPropertyPresent);
begin
  I := IniFile.ReadInteger
   (Section, Concat (Ident, FChN), Ord(Default));
  PP := TPropertyPresent (I);
end {ReadPresentProperty};
begin
  FEnabled := IniFile.ReadBool
   (Section, Concat (IdentEnabled, FChN), False);
  FMaskInc := IniFile.ReadString
   (Section, Concat (IdentMask, IdentInc, FChN), '*.*');
  FMaskExc := IniFile.ReadString
   (Section, Concat (IdentMask, IdentExc, FChN), '');
  ReadPresentProperty (FftReadOnly, IdentFtReadOnly, ppNo);
  ReadPresentProperty (FftHidden,   IdentFtHidden,   ppNo);
  ReadPresentProperty (FftSystem,   IdentFtSystem,   ppNo);
  ReadPresentProperty (FftArchive,  IdentFtArchive,  ppYes);
  I := IniFile.ReadInteger
   (Section, Concat (IdentDataTypeOptions, FChN), Ord(dtoDatesNoSet));
  FDataTypeOptions := TDataTypeOptions (I);
  FDateMax := IniFile.ReadDate
   (Section, Concat (IdentDateMax, FChN), 0);
  FDateMin := IniFile.ReadDate
   (Section, Concat (IdentDateMin, FChN), 0);
  FTime := IniFile.ReadString
   (Section, Concat (IdentTime, FChN), '');
  FSizeMax := IniFile.ReadInteger
   (Section, Concat (IdentSizeMax, FChN), -1);
  FSizeMin := IniFile.ReadInteger
   (Section, Concat (IdentSizeMin, FChN), -1);
end {LoadFromIniF};

procedure TTntFilesSCIncExc.SaveToIniF (IniFile: TTntNewIniFile;  const Section: WideString);
procedure WritePresentProperty (const Ident: WideString;  PP: TPropertyPresent);
begin
  IniFile.WriteInteger (Section, Concat (Ident, FChN), Ord(PP));
end {WritePresentProperty};
begin
  IniFile.WriteBool
   (Section, Concat (IdentEnabled, FChN), FEnabled);
  IniFile.WriteString
   (Section, Concat (IdentMask, IdentInc, FChN), FMaskInc);
  IniFile.WriteString
   (Section, Concat (IdentMask, IdentExc, FChN), FMaskExc);
  WritePresentProperty (IdentFtReadOnly, FftReadOnly);
  WritePresentProperty (IdentFtHidden,   FftHidden);
  WritePresentProperty (IdentFtSystem,   FftSystem);
  WritePresentProperty (IdentFtArchive,  FftArchive);
  IniFile.WriteInteger
   (Section, Concat (IdentDataTypeOptions, FChN), Ord(FDataTypeOptions));
  IniFile.WriteDate
   (Section, Concat (IdentDateMax, FChN), FDateMax);
  IniFile.WriteDate
   (Section, Concat (IdentDateMin, FChN), FDateMin);
  IniFile.WriteString
   (Section, Concat (IdentTime, FChN), FTime);
  IniFile.WriteInteger
   (Section, Concat (IdentSizeMax, FChN), FSizeMax);
  IniFile.WriteInteger
   (Section, Concat (IdentSizeMin, FChN), FSizeMin);
end {SaveToIniF};

{--------------------------------------}

function StringDirCompare (List: TTntStringList; Index1, Index2: Integer): Integer;
procedure FindL (var L: Byte;  const S: WideString);
var
  I: Integer;
begin
  L := 0;
  for  I := 1 to Length (S)  do
    if  S[I] = PathDelim
    then  Inc (L);
end {FindL};
var
  L1, L2: Byte;
begin
  FindL (L1, List[Index1]);
  FindL (L2, List[Index2]);
  if  L1 > L2
  then  Result := -1
  else if  L1 < L2
  then  Result := +1
  else  Result := WideCompareText (List[Index1], List[Index2]);
end {StringDirCompare};

procedure TTntDirList.AddNotExistDir (Dir: WideString);
begin
  Dir := DelSlashW (Dir);
  if  IndexOf (Dir) = -1
  then  Add (Dir);
end {AddNotExistDir};

procedure TTntDirList.Sort;
begin
  CustomSort(StringDirCompare);
end {Sort};

{--------------------------------------}
{-PRIVATE----------}

function TTntGenericFileList.AddOnlyFile (FN: WideString): Boolean;
begin
  if  CorrectFile (True{Add}, FN)  then  begin
    Result := True;
    AddNow (FN);
    if  Assigned (FOnAddRemoveFile)
    then  FOnAddRemoveFile (GetCount);
  end
  else
    Result := False;
end {AddOnlyFile};

function TTntGenericFileList.CorrectFile (Add: Boolean;  var FN: WideString): Boolean;
var
  CompletFN: Boolean;
  L: Byte;
  Exists: Boolean;
begin
  Result := False;
  CompletFN := Pos(DriveDelim,FN) = 2;
  if  (FN = '') or (SeveralSourceDrivers and not CompletFN)  then  begin
    {ErrorMessage?}
    Exit;
  end;
  if  CompletFN and not SeveralSourceDrivers  then  begin
    L := Length (FStrSourceDir)+1;
    if  Length (FN) <= L  then  begin
      {ErrorMessage?}
      Exit;
    end;
    Delete (FN, 1, L);
  end;
  if  Assigned (FOnOtherCorrectFile) and
    not FOnOtherCorrectFile (Concat (GetSlashStrSourceDir, FN))
  then  Exit;
  if (Add and FCheckOnAdd) or ((not Add) and FCheckOnRemove)
  then  Exists := FoundFileName (FN)
  else  Exists := False; {not check before Add}
  if  Exists then begin
    PresentMessNoAddOrNoRemove (Add, FN);
    Result := False;
  end
  else
    Result := True;
end {CorrectFile};

procedure TTntGenericFileList.RemoveOnlyFile (FN: WideString);
begin
  if  CorrectFile (False{not Add}, FN)  then  begin
    RemoveNow (FN);
    if  Assigned (FOnAddRemoveFile)
    then  FOnAddRemoveFile (GetCount);
  end;
end {RemoveOnlyFile};

function TTntGenericFileList.GetSlashStrSourceDir: WideString;
begin
  if  SeveralSourceDrivers
  then  Result := ''
  else  Result := AddSlashW (FStrSourceDir);
end {GetSlashStrSourceDir};

procedure TTntGenericFileList.SetStrSourceDir (const SD: WideString);
begin
  FStrSourceDir := SD;
  WhenChangeSourceDir;
end {SetStrSourceDir};

procedure TTntGenericFileList.WhenChangeSourceDir;
begin
  SeveralSourceDrivers := FStrSourceDir = '';
  OtherWhenChangeSourceDir;
end {WhenChangeSourceDir};

{-PROTECTED--------}

function TTntGenericFileList.AddOrCheckFilesFromDir
 (ActionAddOrRemove, Remove, RootOfSearchDir: Boolean;
  const Dir: WideString): Boolean;
var
  Ok: Boolean;
  FileAttr: Integer;
  L: Byte;
  S, S2: WideString;
  MasksToOperate, FoundMask, PathNameExt: WideString;
  Found: Integer;
  SearchRec: TSearchRecW;
  SL: TTntStringList;
procedure PerhapsSLFree;
begin
  if  FFilesSCIncExc.MaskExc <> ''
  then  SL.Free;
end {PerhapsSLFree};
begin
  Result := False;
  Application.ProcessMessages;
  if  Assigned (Interrupted) and Interrupted^  then  begin
    Exit;
  end;
  S := GetSlashStrSourceDir;
  if  Dir <> ''
  then  S := Concat (S, AddSlashW (Dir));
  if  Assigned (FOnChangeDir)
  then  FOnChangeDir (S);
  if  FStrSourceDir = ''
  then  L := 0
  else  L := Length (FStrSourceDir) + 1;
  if  S = ''  then  begin
    {ErrorMessage?}
    Exit;
  end;
  Result := True;
  if (Assigned (FFilesSCIncExc) and FFilesSCIncExc.Enabled) and
   (((not RootOfSearchDir) and (not FIncAllFilesFromSubFolders)) or
          RootOfSearchDir)
  then  begin
    if  FFilesSCIncExc.Enabled  then  begin
      if  FFilesSCIncExc.MaskExc <> ''  then  begin
        SL := TTntStringList.Create;
        MasksToOperate := FFilesSCIncExc.MaskExc;
        while  MasksToOperate <> ''  do  begin
          FoundMask := StrUntilDelimiterW (MasksToOperate, ';');
          Found := WideFindFirst (S+FoundMask, faArchive, SearchRec);
          while  Found = 0  do  begin
            SL.Add (SearchRec.Name);
            Found := WideFindNext (SearchRec);
          end;
        end;
        WideFindClose (SearchRec);
      end
      else
        SL := nil;
      MasksToOperate := FFilesSCIncExc.MaskInc;
      while  MasksToOperate <> ''  do  begin
        FoundMask := StrUntilDelimiterW (MasksToOperate, ';');
        Found := WideFindFirst (S+FoundMask, faAnyFile, SearchRec);
        while  Found = 0  do  begin
          if  (SL = nil) or (SL.IndexOf(SearchRec.Name) = -1)  then  begin
            PathNameExt := Concat (S,SearchRec.Name);
            FileAttr := WideFileGetAttr (PathNameExt);
            Ok := FFilesSCIncExc.IsOkAttr (FileAttr) and
                  FFilesSCIncExc.IsOkLength (GetFileSizeW(PathNameExt));
            if  Ok and (FFilesSCIncExc.DataTypeOptions <> dtoDatesNoSet)
            then  Ok := FFilesSCIncExc.IsOkDate (FileDateTimeW (PathNameExt));
            if Ok then begin
              if ActionAddOrRemove  then  begin
                if  Remove
                then  RemoveOnlyFile (PathNameExt)
                else  AddOnlyFile (PathNameExt);
              end
              else  begin
                Result := True;
                WideFindClose (SearchRec);
                PerhapsSLFree;
                Exit;
              end;
            end;
          end;
          Found := WideFindNext (SearchRec);
        end;
      end;
      WideFindClose (SearchRec);
      PerhapsSLFree;
    end;
  end
  else  begin
    Found := WideFindFirst (Concat(S,'*.*'), faAnyFile, SearchRec);
    while  Found = 0  do  begin
      if  not (SearchRec.Attr = faDirectory) then  begin
        PathNameExt := Concat (S,SearchRec.Name);
        if ActionAddOrRemove  then  begin
          if  Remove
          then  RemoveOnlyFile (PathNameExt)
          else  AddOnlyFile (PathNameExt);
           {usually is only used when FFilesSCIncExc is'nt assigned}
        end
        else  begin
          Result := True;
          WideFindClose (SearchRec);
          Exit;
        end;
      end;
      Found := WideFindNext (SearchRec);
    end;
    WideFindClose (SearchRec);
  end;
  if FAddDirectories then  begin
    Found := WideFindFirst (Concat(S,'*.*'), faDirectory, SearchRec);
    while  Found = 0  do  begin
      if  (SearchRec.Attr = faDirectory) and
        (not ((SearchRec.Name='.') or (SearchRec.Name='..')))
      then  begin
        PathNameExt := Concat (S, SearchRec.Name);
        AddOnlyFile (PathNameExt);
      end;
      Found := WideFindNext (SearchRec);
    end;
    WideFindClose (SearchRec);
  end;
  DirList.AddNotExistDir (S);
  if  FIncSubFolders  then  begin
    Found := WideFindFirst (Concat(S,'*.*'), faDirectory, SearchRec);
    while  Found = 0  do  begin
      if  (SearchRec.Attr = faDirectory) and
        (not ((SearchRec.Name='.') or (SearchRec.Name='..')))
      then  begin
        S2 := S;
        Delete (S2, 1, L);
        if  not AddOrCheckFilesFromDir
          (ActionAddOrRemove, Remove, False, Concat (S2,SearchRec.Name))
        then  Break;
        {Recursive}
      end;
      Found := WideFindNext (SearchRec);
    end;
    WideFindClose (SearchRec);
  end;

(****
var
  Ok: Boolean;
  FileAttr: Integer;
  L: Byte;
  S, S2: WideString;
  MasksToOperate, FoundMask, FName, PathNameExt: WideString;
  hFindFile: THandle;
  Win32FD: TWin32FindDataW;
  SL: TTntStringList;
procedure PerhapsSLFree;
begin
  if  FFilesSCIncExc.MaskExc <> ''
  then  SL.Free;
end {PerhapsSLFree};
begin
  Result := False;
  Application.ProcessMessages;
  if  Assigned (Interrupted) and Interrupted^  then  begin
    Exit;
  end;
  S := Concat (GetSlashStrSourceDir, AddSlashW (Dir));
  if  Assigned (FOnChangeDir)
  then  FOnChangeDir (S);
  if  FStrSourceDir = ''
  then  L := 0
  else  L := Length (FStrSourceDir) + 1;
  if  S = ''  then  begin
    {ErrorMessage?}
    Exit;
  end;
  Result := True;
  if Assigned (FFilesSCIncExc)  then  begin
    if  FFilesSCIncExc.Enabled  then  begin
      if  FFilesSCIncExc.MaskExc <> ''  then  begin
        SL := TTntStringList.Create;
        MasksToOperate := FFilesSCIncExc.MaskExc;
        while  MasksToOperate <> ''  do  begin
          FoundMask := StrUntilDelimiterW (MasksToOperate, ';');
          hFindFile := Tnt_FindFirstFileW (PWideChar(Concat(S,FoundMask)), Win32FD);
          if  hFindFile <> INVALID_HANDLE_VALUE  then
          try
            repeat
              with Win32FD do
                if (dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY <> FILE_ATTRIBUTE_DIRECTORY)
                then  SL.Add (StrPas(cFileName));
            until not FindNextFile (hFindFile, Win32FD);
          finally
            FindClose (hFindFile);
          end;
        end;
      end
      else
        SL := nil;
      MasksToOperate := FFilesSCIncExc.MaskInc;
      while  MasksToOperate <> ''  do  begin
        FoundMask := StrUntilDelimiterW (MasksToOperate, ';');
        hFindFile := Tnt_FindFirstFileW (PWideChar(Concat(S,FoundMask)), Win32FD);
        if  hFindFile <> INVALID_HANDLE_VALUE  then
        try
          repeat
            with Win32FD do
              if (dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY <> FILE_ATTRIBUTE_DIRECTORY)
              then  begin
                if  (SL = nil) or (SL.IndexOf(StrPas(cFileName)) = -1)  then  begin
                  PathNameExt := Concat (S, StrPas(cFileName));
                  FileAttr := WideFileGetAttr (PathNameExt);
                  Ok := FFilesSCIncExc.IsOkAttr (FileAttr) and
                        FFilesSCIncExc.IsOkLength (GetFileSizeW(PathNameExt));
                  if  Ok and (FFilesSCIncExc.DataTypeOptions <> dtoDatesNoSet)
                  then  Ok := FFilesSCIncExc.IsOkDate (FileDateTime (PathNameExt));
                  if Ok then begin
                    if ActionAddOrRemove  then  begin
                      if  Remove
                      then  RemoveOnlyFile (PathNameExt)
                      else  AddOnlyFile (PathNameExt);
                    end
                    else  begin
                      Result := True;
                      FindClose (hFindFile);
                      PerhapsSLFree;
                      Exit;
                    end;
                  end;
                end;
              end;
          until not FindNextFile (hFindFile, Win32FD);
        finally
          FindClose (hFindFile);
        end;
      end;
    end;
  end
  else  begin
    hFindFile := Tnt_FindFirstFileW (PWideChar(Concat(S,'*.*')), Win32FD);
    if  hFindFile <> INVALID_HANDLE_VALUE  then
    try
      repeat
        with Win32FD do  begin
          FName := StrPas (cFileName);
          PathNameExt := Concat (S, FName);
          if (dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY = FILE_ATTRIBUTE_DIRECTORY)
          then  begin
            if FAddDirectories then  begin
              if  (FName <> '.') and (FName <> '..')
              then  begin
                AddOnlyFile (PathNameExt);
              end;
            end;
          end
          else  begin
            if ActionAddOrRemove  then  begin
              if  Remove
              then  RemoveOnlyFile (PathNameExt)
              else  AddOnlyFile (PathNameExt);
               {usually is only used when FFilesSCIncExc is'nt assigned}
            end
            else  begin
              Result := True;
              FindClose (hFindFile);
              Exit;
            end;
          end;
        end;
      until not FindNextFile (hFindFile, Win32FD);
    finally
      FindClose (hFindFile);
    end;
  end;
  DirList.AddNotExistDir (S);
  if  FIncSubFolders  then  begin
    hFindFile := Tnt_FindFirstFileW(PWideChar(Concat(S,'*.*')), Win32FD);
    if  hFindFile <> INVALID_HANDLE_VALUE  then
    try
      repeat
        with Win32FD do  begin
          if (dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY = FILE_ATTRIBUTE_DIRECTORY)
          and (FName <> '.') and (FName <> '..')
          then  begin
            S2 := S;
            Delete (S2, 1, L);
            if  not AddOrCheckFilesFromDir
              (ActionAddOrRemove, Remove, Concat (S2,cFileName))
            then  Break;
            {Recursive}
          end;
        end;
      until not FindNextFile (hFindFile, Win32FD);
    finally
      FindClose (hFindFile);
    end;
  end;
***)
end {AddOrCheckFilesFromDir};

function TTntGenericFileList.FindCommonDirForAllItems (L: TTntStringList;  Extract: Boolean;
  var Res: WideString): Boolean;
var
  FDir, NewFDir: WideString;
  SL: TTntStringList;
  I: Integer;
begin
  Result := False;
  if  L.Count = 0  then  begin
    {Message?}
    Exit;
  end;
  L.Sort;
  SL := TTntStringList.Create;
  FDir := '';
  for  I := 0 to L.Count-1  do  begin
    if  Extract  then  begin
      NewFDir := WideExtractFileDir(L[I]);
      if  FDir = NewFDir  then  begin
      end
      else  begin
        FDir := NewFDir;
        SL.Add (FDir);
      end;
    end
    else  begin
      if  SL.IndexOf (L[I]) < 0
      then  SL.Add (L[I]); {only copies}
    end;
  end;
  TntFindCommonDirFromDirsSL (SL, Res);
  SL.Free;
  Result := True;
end {FindCommonDirForAllItems};

procedure TTntGenericFileList.OtherWhenChangeSourceDir;
begin
  FDirList.Clear;
end {OtherWhenChangeSourceDir};

procedure TTntGenericFileList.PresentMessNoAddOrNoRemove (Add: Boolean;
  const FN: WideString);
var
  M: WideString;
begin
  if  FMessOnNoAddOrNoRemove and PresentNewMessage then  begin
    if Add
    then  M := RS_FF_FileAlreadyExist
    else  M := RS_FF_FileNotExist;
    PresentNewMessage := WideUserSayYes
     (WideFormat (M, [FN, RS_FF_PresentIdMessages]));
  end;
end {PresentMessNoAddOrNoRemove};

{-PUBLIC-----------}

procedure TTntGenericFileList.AddFile (FN: WideString);
var
  win32FD: TWin32FindDataW;
  hFindFile: THandle;
begin
  hFindFile := Tnt_FindFirstFileW (PWideChar(FN), Win32FD);
  if  hFindFile <> INVALID_HANDLE_VALUE  then  begin
    if  AddOnlyFile (FN)
    then  DirList.AddNotExistDir (WideExtractFileDir (Concat (GetSlashStrSourceDir, FN)));
  end;
  FindClose (hFindFile);
end {AddFile};

function TTntGenericFileList.AddFilesFromDir (const Dir: WideString): Boolean;
begin
  Result := AddOrCheckFilesFromDir (True{ActionAddOrRemove}, False{not Remove},
    True{RootOfSearchDir}, Dir);
end {AddFilesFromDir};

function TTntGenericFileList.AddFilesFromDirNoRoot (const Dir: WideString): Boolean;
begin
  Result := AddOrCheckFilesFromDir (True{ActionAddOrRemove}, False{not Remove},
    False{RootOfSearchDir}, Dir);
end {AddFilesFromDirNoRoot};

constructor TTntGenericFileList.Create (AOwner: TComponent);
begin
  inherited Create (AOwner);
  FDirList := TTntDirList.Create;
  FIncSubFolders := True;
  PresentNewMessage := True;
  SeveralSourceDrivers := True;
end {Create};

destructor TTntGenericFileList.Destroy;
begin
  inherited;
  FDirList.Free;
end {Destroy};

procedure TTntGenericFileList.RemoveFile (FN: WideString);
begin
  RemoveOnlyFile (FN);
  //DirList.AddNotExistDir (WideExtractFileDir (Concat (GetSlashStrSourceDir, FN)));
end {RemoveFile};

function TTntGenericFileList.RemoveFilesFromDir (const Dir: WideString): Boolean;
begin
  Result := AddOrCheckFilesFromDir (True{ActionAddOrRemove}, True{Remove},
    True{RootOfSearchDir}, Dir);
end {RemoveFilesFromDir};

{--------------------------------------}
{-PROTECTED--------}

procedure TTntStringFileList.AddNow (const FN: WideString);
begin
  FList.Add (FN);
end {AddNow};

function TTntStringFileList.GetCount: LongWord;
begin
  Result := FList.Count;
end {GetCount};

function TTntStringFileList.FoundFileName (const FN: WideString): Boolean;
begin
  ItemIndex := FList.IndexOf (FN);
  FoundFileName := ItemIndex <> -1;
end {FoundFileName};

function TTntStringFileList.FindCommonDirForAllList (L: TTntStringList;  Extract: Boolean;
  var Res: WideString): Boolean;
begin
  Result := FindCommonDirForAllItems (L, Extract, Res);
end {FindCommonDirForAllList};

procedure TTntStringFileList.RemoveNow (const FN: WideString);
begin
  FList.Delete (ItemIndex);
end {RemoveNow};

procedure TTntStringFileList.OtherWhenChangeSourceDir;
begin
  inherited;
  FList.Clear;
end {OtherWhenChangeSourceDir};

{-PUBLIC-----------}

constructor TTntStringFileList.Create (AOwner: TComponent);
begin
  inherited Create (AOwner);
  FList := TTntStringList.Create;
end {Create};

destructor TTntStringFileList.Destroy;
begin
  inherited;
  FList.Free;
end {Destroy};

function TTntStringFileList.ExistDirInList (const Dir: WideString): Boolean;
{Dir must be with PathDelim}
var
  SLD: WideString;
  I: Integer;
begin
  if  FList.Count = 0  then  begin
    Result := False;
    Exit;
  end;
  SLD := GetSlashStrSourceDir;
  Result := False;
  for  I := 0 to FList.Count-1  do
    if  WideExtractFileDir (SLD+FList[I]) = Dir  then  begin
      Result := True;
      Exit;
    end;
end {ExistDirInList};

function TTntStringFileList.ExistAnyFileInDir (const Dir: WideString): Boolean;
begin
  Result := AddOrCheckFilesFromDir (False{not ActionAddOrRemove, only Check},
    False{not used = Remove}, True{RootOfSearchDir}, Dir);
end {ExistAnyFileInDir};

procedure TTntStringFileList.FindCommonDir (UpdateList: Boolean);
var
  I, Position: Integer;
  S, Res: WideString;
begin
  if  not FindCommonDirForAllList (FList, True, Res)
  then  Exit;
  FStrSourceDir := DelSlashW (Res);
  SeveralSourceDrivers := Res = '';
  if  UpdateList and (not SeveralSourceDrivers)  then  begin
    Position := Length (Res);
    for  I := 0 to FList.Count-1  do  begin
      S := FList[I];
      System.Delete (S, 1, Position);
      FList[I] := S;
    end;
  end;
end {FindCommonDir};

{--------------------------------------}
{-PRIVATE----------}

procedure TTntDataSetFileList.SetDataSet (const Value: TDataSet);
begin
  FDataSet := Value;
  FDataSetWithShortRec := FDataSet.FieldCount = FNAttrib+1;
end {SetDataSet};

{-PROTECTED--------}

procedure TTntDataSetFileList.AddNow (const FN: WideString);
begin
  with FDataSet do  begin
    Append;
    Fields[FNDir].Value  := DelSlashW (WideExtractFileDir (FN));
    Fields[FNName].Value := ExtractFileOnlyNameW (FN);
    Fields[FNExt].Value  := ExtractFileExtWithoutPointW (FN);
    if FCompleteRecOnAdd then  begin
      if FDataSetWithShortRec
      then  TntCompleteOneShortRecord (FDataSet, FN)
      else  TntCompleteOneRecord (FDataSet, FDSIntTypeExt, FN);
    end;
    Post;
  end;
end {AddNow};

function TTntDataSetFileList.GetCompletFN: WideString;
var
  S: WideString;
begin
  with FDataSet do  begin
    S := Concat (
      AddSlashW (Fields[FNDir].Value), Fields[FNName].Value);
    if  Fields[FNExt].Value = ''
    then  Result := S
    else  Result := Concat (S, '.', Fields[FNExt].Value);
  end;
end {GetCompletFN};

function TTntDataSetFileList.GetCount: LongWord;
begin
  Result := FDataSet.RecordCount;
end {GetCount};

function TTntDataSetFileList.FoundFileName (const FN: WideString): Boolean;
begin
  Result := False; {Not used}
end {FoundFileName};

procedure TTntDataSetFileList.OtherWhenChangeSourceDir;
begin
  inherited;
  {FDataSet.EmptyTable;}
end {OtherWhenChangeSourceDir};

procedure TTntDataSetFileList.RemoveNow (const FN: WideString);
begin
  FDataSet.Delete;
end {RemoveNow};

{-PUBLIC-----------}

procedure TTntDataSetFileList.CompleteRecords;
begin
  with FDataSet do  begin
    First;
    while not EOF  do  begin
      Edit;
      if FDataSetWithShortRec
      then  TntCompleteOneShortRecord (FDataSet, GetCompletFN)
      else  TntCompleteOneRecord (FDataSet, FDSIntTypeExt, GetCompletFN);
      Post;
      Next;
    end;
  end;
end {CompleteRecords};

procedure TTntDataSetFileList.DelDuplicates (PresMessage, OnAdd: Boolean);
var
  FDir, FName, FExt: WideString;
begin
  with FDataSet do  begin
    First;
    FDir := '';
    FName := '';
    FExt := '';
    while not EOF  do  begin
      if  (FDir = Fields[FNDir].Value) and
          (FName = Fields[FNName].Value) and
          (FExt = Fields[FNExt].Value)
      then  begin
        Edit;
        Fields[FNMarkForDuplicate].Value := 'F';
        Post;
      end
      else  begin
        FDir := Fields[FNDir].Value;
        FName := Fields[FNName].Value;
        FExt := Fields[FNExt].Value;
      end;
      Next;
    end;
    First;
    while not EOF  do  begin
      if  not Fields[FNMarkForDuplicate].IsNull  then  begin
        if PresMessage
        then  PresentMessNoAddOrNoRemove (OnAdd, GetCompletFN);
        Delete;
      end
      else  Next;
    end;
  end;
end {DelDuplicates};

function TTntDataSetFileList.ExistDirInDataSet (const Dir: WideString): Boolean;
{Dir must be without PathDelim}
begin
  if  FDataSet.RecordCount = 0  then  begin
    Result := False;
    Exit;
  end;
  Result := False;
  with FDataSet do  begin
    First;
    while not EOF  do  begin
      if  Fields[FNDir].Value = Dir  then  begin
        Result := True;
        Exit;
      end
      else  Next;
    end;
  end;
end {ExistDirInDataSet};

function TTntDataSetFileList.FindCommonDir: WideString;
var
  List: TTntStringList;
  Res: WideString;
  BM: TBookmarkStr;
begin
  List := TTntStringList.Create;
  Res := '';
  try
    Screen.Cursor := crHourGlass;
    with FDataSet do  begin
      DisableControls;
      BM := Bookmark;
      First;
      while not EOF  do  begin
        List.Add (FDataSet.Fields[FNDir].Value);
        Next;
      end;
      Bookmark := BM;
    end;
    if  FindCommonDirForAllItems (List, False, Res)  then  begin
      FStrSourceDir := DelSlashW (Res);
      SeveralSourceDrivers := Res = '';
    end;
  finally
    List.Free;
    FDataSet.EnableControls;
    Screen.Cursor := crDefault;
  end;
  Result := Res;
end {FindCommonDir};

{--------------------------------------}
{-PRIVATE----------}

function TTntCCMDBoxDlg.GetDirsDeleted: Boolean;
begin
  Result := FNDirsDeleted > 0;
end {GetDirsDeleted};

{check for floppy disk in drive}
function TTntCCMDBoxDlg.DiskInDrive (I: Byte): Word;
begin
  if  DiskSize(I) = -1
  then  Result := messageDlg (RS_CCopyDlg_PleaseInsertDisq,
          mtWarning, [mbOK, mbCancel],0)
  else  Result := mrYes;
end {DiskInDrive};

{check for directory, or drive}
function TTntCCMDBoxDlg.IsDir (const sDrive: WideString;  Writeable: Boolean): Boolean;

function IsOkDir: Boolean;
begin
  {first, if sDrive is less than 3 characters then the user is trying to copy to a
   root, in which case DirectoryExists will fail. If the routine has reached this stage
   we should be sure that the drive is legal so return True}
  if length(sDrive) <= 3 then
    Result := True
  else
  if  DirectoryExists(sDrive)  then
    Result := True
  else  begin
    WideMessageBoxError (WideFormat (RS_CCopyDlg_NoFoundDir, [sDrive]));
    Result := False;
  end;
end {IsOkDir};

var
  c: Char;
  DiskByte: Byte;
  S: WideString;
  A: array [0..2] of WideChar;
  W: Word;
  UI: UINT;
begin

 {get drive letter}
  c := Char (sDrive[1]);
 {check that drive letter is valid}
  if  not DiskValid (C, DiskByte)  then  begin
    Result := False;
    Exit; {New}
  end;

  S := Copy (sDrive, 1, 2);
  WStrPCopy (A, S);
  UI := GetDriveTypeW (A);
  case UI of
  DRIVE_REMOVABLE: begin {floppy, ZIP}
     {ensure floppy in drive}
      repeat
        W := DiskInDrive (DiskByte);
      until  W in [mrCancel, mrYes];
      if  W = mrYes  then  begin
       {floppy in drive, now check for directory}
        if (length(sDrive) > 3) then {where 3 would be the size of 'a:\'}  begin
         {check floppy for sub-dir}
          Result := DirectoryExists(sDrive);
        end
        else
         {user trying to copy to root of floppy drive}
          Result := True;
      end
      else
        Result := False;
    end;
  DRIVE_CDROM: begin
      if Writeable then  begin
        WideMessageBoxError (RS_CCopyDlg_IsCDROM);
        Result := False;
      end
      else
        Result := IsOkDir;
    end;
  else {hard disk} begin
    Result := IsOkDir;
  end;
  end;

  {finally, check that drive is a legal drive}
  if  DiskSize (DiskByte) = -1
  then  Result := False;
end {IsDir};

function TTntCCMDBoxDlg.GetFilesWithActionMade: Boolean;
begin
  Result := NFilesWithActionMade > 0;
end {GetFilesWithActionMade};

procedure TTntCCMDBoxDlg.SetSetFilesToNoReadOnly (const Value: Boolean);
begin
  FSetFilesToNoReadOnly := Value;
  if  FSetFilesToNoReadOnly
  then  FPromptOnDelReadOnlyFiles := False;
end {SetSetFilesToNoReadOnly};

{-PROTECTED--------}

{check directory - this routine amends the WideString passed so that all directory
 labels don't end in a backslash, then checks that the directory is valid by
 calling isDir}
function TTntCCMDBoxDlg.CheckDir (sDir: WideString;  var sDirResult: WideString;
  Writeable: Boolean): Boolean;
procedure InvalidResult;
begin
  sDirResult := '';
  CheckDir := False;
end;
begin
  CheckDir := True;
  case length(sDir) of
  0: InvalidResult;
 {case of sDir being just a drive letter, add DriveDelim}
  1:
     begin
       if  isDir (sDir, Writeable)
       then  sDirResult := sDir + DriveDelim
       else  InvalidResult;
     end;
  else
  begin
     sDir := DelSlashW (sDir);
     if  isDir (sDir, Writeable)
     then  sDirResult := sDir
     else  InvalidResult;
  end;
  end;
end {CheckDir};

function TTntCCMDBoxDlg.DiskValid (var C: Char;  var DiskByte: Byte): Boolean;
begin
  if C in ['a'..'z'] then Dec(C,($20));
  if not (C in ['A'..'Z']) then   begin
    WideMessageBoxError (RS_CCopyDlg_IdentInval);
    DiskValid := False;
  end
  else  begin
    DiskByte := DriveByteFromDriveChar (C);
    DiskValid := True;
  end;
end {DiskValid};

procedure TTntCCMDBoxDlg.PerhapsDeleteEmptyDirs;
var
  I: Integer;
begin
  if FDeleteEmptyDirs then  begin
    FDirList.Sort;
    for  I := 0 to FDirList.Count-1  do
      EraseEmptyDirW(FDirList[I], FNDirsDeleted);
  end;
end {PerhapsDeleteEmptyDirs};

procedure TTntCCMDBoxDlg.SetStrSourceDir (const SD: WideString);
begin
  CheckDir (SD, FStrSourceDir, SourceDirWriteable);
  WhenChangeSourceDir;
end {SetStrSourceDir};

procedure TTntCCMDBoxDlg.WhenAskDelROF (const FN, Mess: WideString);
begin
  NeedDel := True;
  if  FileIsReadOnly (FN) then  begin
    if  FSetFilesToNoReadOnly or EverDelROF
    then
      FileSetNotReadOnlyW (FN)

    else if  FileIsReadOnly (FN) and FPromptOnDelReadOnlyFiles  then  begin
      case MessageDlg(WideFormat (Mess, [FN]),
        mtConfirmation,[mbYes,mbAll,mbNo],0)
      of
      mrYes: FileSetNotReadOnlyW (FN);
      mrAll: begin
          EverDelROF := True;
          FileSetNotReadOnlyW (FN);
        end;
      mrNo: NeedDel := False;
      end;
    end;
  end;
end {WhenAskDelROF};

function TTntCCMDBoxDlg.PreExecute (const S: WideString): Boolean;
begin
  {turn off DOS error reporting}
  iErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
  {check for files}
  if  (FList.Count = 0) and (FDirList.Count = 0)  then  begin
    if  FInfoNotFilesOrDirsToCopy
    then  WideMessageBoxWarning (WideFormat (RS_CCopyDlg_NoFile, [S]));
    Result := False;
  end
  else  begin
    EverDelROF := FSetFilesToNoReadOnly or (not FPromptOnDelReadOnlyFiles);
    Result := True;
  end;
  FNDirsDeleted := 0;
  FNFilesWithActionMade := 0;
end {PreExecute};

procedure TTntCCMDBoxDlg.PostExecute;
begin
  SetErrorMode (iErrorMode); {reset system}
end {PostExecute};

{-PUBLIC-----------}

constructor TTntCCMDBoxDlg.Create (AOwner: TComponent);
begin
  inherited Create (AOwner);
  FPromptOnDelReadOnlyFiles := True;
end {Create};

{--------------------------------------}
{-PRIVATE----------}

function TTntCMDBoxDlg.GetDirsDeleted: Boolean;
begin
  Result := FNDirsDeleted > 0;
end {GetDirsDeleted};

{check for floppy disk in drive}
function TTntCMDBoxDlg.DiskInDrive (I: Byte): Word;
begin
  if  DiskSize(I) = -1
  then  Result := messageDlg (RS_CCopyDlg_PleaseInsertDisq,
          mtWarning, [mbOK, mbCancel],0)
  else  Result := mrYes;
end {DiskInDrive};

{check for directory, or drive}
function TTntCMDBoxDlg.IsDir (const sDrive: WideString;  Writeable: Boolean): Boolean;

function IsOkDir: Boolean;
begin
  {first, if sDrive is less than 3 characters then the user is trying to copy to a
   root, in which case DirectoryExists will fail. If the routine has reached this stage
   we should be sure that the drive is legal so return True}
  if length(sDrive) <= 3 then
    Result := True
  else
  if  DirectoryExists(sDrive)  then
    Result := True
  else  begin
    WideMessageBoxError (WideFormat (RS_CCopyDlg_NoFoundDir, [sDrive]));
    Result := False;
  end;
end {IsOkDir};

var
  c: Char;
  DiskByte: Byte;
  S: WideString;
  A: array [0..2] of WideChar;
  W: Word;
  UI: UINT;
begin

 {get drive letter}
  c := Char (sDrive[1]);
 {check that drive letter is valid}
  if  not DiskValid (C, DiskByte)  then  begin
    Result := False;
    Exit; {New}
  end;

  S := Copy (sDrive, 1, 2);
  WStrPCopy (A, S);
  UI := GetDriveTypeW (A);
  case UI of
  DRIVE_REMOVABLE: begin {floppy, ZIP}
     {ensure floppy in drive}
      repeat
        W := DiskInDrive (DiskByte);
      until  W in [mrCancel, mrYes];
      if  W = mrYes  then  begin
       {floppy in drive, now check for directory}
        if (length(sDrive) > 3) then {where 3 would be the size of 'a:\'}  begin
         {check floppy for sub-dir}
          Result := DirectoryExists(sDrive);
        end
        else
         {user trying to copy to root of floppy drive}
          Result := True;
      end
      else
        Result := False;
    end;
  DRIVE_CDROM: begin
      if Writeable then  begin
        WideMessageBoxError (RS_CCopyDlg_IsCDROM);
        Result := False;
      end
      else
        Result := IsOkDir;
    end;
  else {hard disk} begin
    Result := IsOkDir;
  end;
  end;

  {finally, check that drive is a legal drive}
  if  DiskSize (DiskByte) = -1
  then  Result := False;
end {IsDir};

function TTntCMDBoxDlg.GetFilesWithActionMade: Boolean;
begin
  Result := NFilesWithActionMade > 0;
end {GetFilesWithActionMade};

procedure TTntCMDBoxDlg.SetSetFilesToNoReadOnly (const Value: Boolean);
begin
  FSetFilesToNoReadOnly := Value;
  if  FSetFilesToNoReadOnly
  then  FPromptOnDelReadOnlyFiles := False;
end {SetSetFilesToNoReadOnly};

{-PROTECTED--------}

{check directory - this routine amends the WideString passed so that all directory
 labels don't end in a backslash, then checks that the directory is valid by
 calling isDir}
function TTntCMDBoxDlg.CheckDir (sDir: WideString;  var sDirResult: WideString;
  Writeable: Boolean): Boolean;
procedure InvalidResult;
begin
  sDirResult := '';
  CheckDir := False;
end;
begin
  CheckDir := True;
  case length(sDir) of
  0: InvalidResult;
 {case of sDir being just a drive letter, add DriveDelim}
  1:
     begin
       if  isDir (sDir, Writeable)
       then  sDirResult := sDir + DriveDelim
       else  InvalidResult;
     end;
  else
  begin
     sDir := DelSlashW (sDir);
     if  isDir (sDir, Writeable)
     then  sDirResult := sDir
     else  InvalidResult;
  end;
  end;
end {CheckDir};

function TTntCMDBoxDlg.DiskValid (var C: Char;  var DiskByte: Byte): Boolean;
begin
  if C in ['a'..'z'] then Dec(C,($20));
  if not (C in ['A'..'Z']) then   begin
    WideMessageBoxError (RS_CCopyDlg_IdentInval);
    DiskValid := False;
  end
  else  begin
    DiskByte := DriveByteFromDriveChar (C);
    DiskValid := True;
  end;
end {DiskValid};

procedure TTntCMDBoxDlg.PerhapsDeleteEmptyDirs;
var
  I: Integer;
begin
  if FDeleteEmptyDirs then  begin
    FDirList.Sort;
    for  I := 0 to FDirList.Count-1  do
      EraseEmptyDirW(FDirList[I], FNDirsDeleted);
  end;
end {PerhapsDeleteEmptyDirs};

procedure TTntCMDBoxDlg.SetStrSourceDir (const SD: WideString);
begin
  CheckDir (SD, FStrSourceDir, SourceDirWriteable);
  WhenChangeSourceDir;
end {SetStrSourceDir};

procedure TTntCMDBoxDlg.WhenAskDelROF (const FN, Mess: WideString);
begin
  NeedDel := True;
  if  TLargeintField(FDataSet.Fields[FNAttrib]).AsLargeInt and FILE_ATTRIBUTE_READONLY > 0 then  begin
    if  FSetFilesToNoReadOnly or EverDelROF
    then
      FileSetNotReadOnlyW (FN)

    else if  FileIsReadOnly (FN) and FPromptOnDelReadOnlyFiles  then  begin
      case MessageDlg(WideFormat (Mess, [FN]),
        mtConfirmation,[mbYes,mbAll,mbNo],0)
      of
      mrYes: FileSetNotReadOnlyW (FN);
      mrAll: begin
          EverDelROF := True;
          FileSetNotReadOnlyW (FN);
        end;
      mrNo: NeedDel := False;
      end;
    end;
  end;
end {WhenAskDelROF};

function TTntCMDBoxDlg.PreExecute (const S: WideString): Boolean;
begin
  {turn off DOS error reporting}
  iErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
  {check for files}
  if  FDataSet.RecordCount = 0  then  begin
    if  FInfoNotFilesOrDirsToCopy
    then  WideMessageBoxWarning (WideFormat (RS_CCopyDlg_NoFile, [S]));
    Result := False;
  end
  else  begin
    EverDelROF := FSetFilesToNoReadOnly or (not FPromptOnDelReadOnlyFiles);
    Result := True;
  end;
  FNDirsDeleted := 0;
  FNFilesWithActionMade := 0;
end {PreExecute};

procedure TTntCMDBoxDlg.PostExecute;
begin
  SetErrorMode (iErrorMode); {reset system}
end {PostExecute};

{-PUBLIC-----------}

constructor TTntCMDBoxDlg.Create (AOwner: TComponent);
begin
  inherited Create (AOwner);
  FPromptOnDelReadOnlyFiles := True;
end {Create};

{--------------------------------------}
{-PROTECTED--------}

function TTntCDelBoxDlg.SourceDirWriteable: Boolean;
begin
  Result := True;
end {SourceDirWriteable};

{-PUBLIC-----------}

constructor TTntCDelBoxDlg.Create (AOwner: TComponent);
begin
  inherited;
  FSendToTrash := True;
end {Create};

function TTntCDelBoxDlg.Execute: Boolean;
var
  I: integer;
  SLD, FN: WideString;
  SizeTotal, SizeDeleted: Longint;
  RxFileOperator: TTntJvFileOperator;
  Deleted: Boolean;
begin
  if  not PreExecute (RS_CCopyDlg_ToDelete)
  then  Result := False
  else  begin
    if  FList.Count > 0  then  begin
      FList.Sort;
      SLD := GetSlashStrSourceDir;
      SizeTotal := 0;
      for  I := 0 to FList.Count-1  do
        Inc (SizeTotal, FileSizeFromNotOpenFileW (SLD + FList[I]));
      TntDelFilesProgressBox := TTntDelFilesProgressBox.Create(Application);
      TntDelFilesProgressBox.Show;
      if  FSendToTrash
      then  RxFileOperator := TTntJvFileOperator.Create (nil)
      else  RxFileOperator := nil; {for no Warning compiler messages}
      SizeDeleted := 0;
      for  I := 0 to FList.Count-1  do  begin
        FN := SLD + FList[I];
        WhenAskDelROF (FN, RS_CCopyDlg_DelReadOnlyFile);
        TntDelFilesProgressBox.L_SourceFileOrFileToDel.Caption := FN;
        Inc (SizeDeleted, FileSizeFromNotOpenFileW(FN));
        if NeedDel then  begin
          if FSendToTrash then  begin
            with RxFileOperator do  begin
              Source := FN;
              Operation := foDelete;
              Options := [flAllowUndo,flNoConfirmation];
              Deleted := Execute and (not FileExists (FN));
            end;
          end
          else
            Deleted := SysUtils.DeleteFile (FN);
        end
        else
          Deleted := False;
        if  Assigned (FOnNotifyDelMade)
        then  FOnNotifyDelMade (FN, Deleted);
        if Deleted
        then  Inc (FNFilesWithActionMade);
        if  SizeTotal > 0
        then  TntDelFilesProgressBox.GaugeTotal.Progress := Round (SizeDeleted/SizeTotal * 100);
        if  NeedDel and (not Deleted)  then  begin
          WideMessageBoxError (WideFormat (RS_CCopyDlg_NoCanDeleteFile, [FN]));
          Break;
        end;
        Application.ProcessMessages;
        if  TntDelFilesProgressBox.bCancel = True  then  begin
          if  WideUserSayYes (WideFormat (RS_CCopyDlg_TryIfBreak, [RS_CCopyDlg_OfDeletion]))
          then  Break
          else  TntDelFilesProgressBox.bCancel := False;
        end
        else
          TntDelFilesProgressBox.bCancel := False;
      end;
      if  FSendToTrash
      then  RxFileOperator.Free;
      TntDelFilesProgressBox.Close;
      TntDelFilesProgressBox.Free;
    end;
    PerhapsDeleteEmptyDirs;
    Result := True;
    PostExecute;
  end;
end {Execute};

{--------------------------------------}
{-PROTECTED--------}

function TTntDelBoxDlg.SourceDirWriteable: Boolean;
begin
  Result := True;
end {SourceDirWriteable};

{-PUBLIC-----------}

constructor TTntDelBoxDlg.Create (AOwner: TComponent);
begin
  inherited;
  FSendToTrash := True;
end {Create};

function TTntDelBoxDlg.Execute: Boolean;
var
  FN: WideString;
  SizeTotal, SizeDeleted: Longint;
  RxFileOperator: TTntJvFileOperator;
  Deleted: Boolean;
begin
  if  not PreExecute (RS_CCopyDlg_ToDelete)
  then  Result := False
  else  begin
    if  FDataSet.RecordCount > 0  then  begin
      SizeTotal := 0;
      with FDataSet do  begin
        First;
        while not EOF do  begin
          Inc (SizeTotal, Fields[FNSize].AsInteger);
          Next;
        end;
      end;
      TntDelFilesProgressBox := TTntDelFilesProgressBox.Create(Application);
      TntDelFilesProgressBox.Show;
      if  FSendToTrash
      then  RxFileOperator := TTntJvFileOperator.Create (nil)
      else  RxFileOperator := nil; {for no Warning compiler messages}
      SizeDeleted := 0;
      with FDataSet do  begin
        First;
        while not EOF do  begin
          FN := GetCompletFN;
          WhenAskDelROF (FN, RS_CCopyDlg_DelReadOnlyFile);
          TntDelFilesProgressBox.L_SourceFileOrFileToDel.Caption := FN;
          Inc (SizeDeleted, Fields[FNSize].AsInteger);
          if NeedDel then  begin
            if FSendToTrash then  begin
              with RxFileOperator do  begin
                Source := FN;
                Operation := foDelete;
                Options := [flAllowUndo,flNoConfirmation];
                Deleted := Execute and (not FileExists (FN));
              end;
            end
            else
              Deleted := SysUtils.DeleteFile (FN);
          end
          else
            Deleted := False;
          if  Assigned (FOnNotifyDelMade)
          then  FOnNotifyDelMade (FN, Deleted);
          if Deleted
          then  Inc (FNFilesWithActionMade);
          if  SizeTotal > 0
          then  TntDelFilesProgressBox.GaugeTotal.Progress := Round (SizeDeleted/SizeTotal * 100);
          if  NeedDel and (not Deleted)  then  begin
            WideMessageBoxError (WideFormat (RS_CCopyDlg_NoCanDeleteFile, [FN]));
            Break;
          end;
          Application.ProcessMessages;
          if  TntDelFilesProgressBox.bCancel = True  then  begin
            if  WideUserSayYes (WideFormat (RS_CCopyDlg_TryIfBreak, [RS_CCopyDlg_OfDeletion]))
            then  Break
            else  TntDelFilesProgressBox.bCancel := False;
          end
          else
            TntDelFilesProgressBox.bCancel := False;
          Next;
        end;
      end;
      if  FSendToTrash
      then  RxFileOperator.Free;
      TntDelFilesProgressBox.Close;
      TntDelFilesProgressBox.Free;
    end;
    PerhapsDeleteEmptyDirs;
    Result := True;
    PostExecute;
  end;
end {Execute};

{--------------------------------------}
{-EVENTS-----------}

constructor TTntCCopyMoveBoxDlg.Create(AOwner: TComponent);
begin
  inherited Create (AOwner);
  FStrTargetDir := '';
  FOverwriteNewerPrompt := True;
end {Create};

{-PRIVATE----------}

function TTntCCopyMoveBoxDlg.GetDirsAdded: Boolean;
begin
  Result := FNDirsAdded > 0;
end {GetDirsAdded};

procedure TTntCCopyMoveBoxDlg.SetFileAction (const Value: TFileAction);
begin
  FFileAction := Value;
  if  (FFileAction = faMove) and (FStrSourceDir <> '')
  then  StrSourceDir := FStrSourceDir;
end {SetFileAction};

procedure TTntCCopyMoveBoxDlg.SetOverwritePrompt (V: Boolean);
begin
  FOverwritePrompt := V;
  if  FOverwritePrompt
  then  FOverwriteNewerPrompt := True;
end {SetOverwritePrompt};

procedure TTntCCopyMoveBoxDlg.SetOverwriteNewerPrompt (V: Boolean);
begin
  FOverwriteNewerPrompt := V;
  if  not FOverwriteNewerPrompt
  then  FOverwritePrompt := False;
end {SetOverwriteNewerPrompt};

procedure TTntCCopyMoveBoxDlg.SetStrTargetDir (const TD: WideString);
begin
  CheckDir (TD, FStrTargetDir, True);
end {SetStrTargetDir};

{-PROTECTED--------}

function TTntCCopyMoveBoxDlg.SourceDirWriteable: Boolean;
begin
  if  FFileAction = faCopy
  then  Result := False
  else  Result := True;
end;

{-PUBLIC-----------}

function TTntCCopyMoveBoxDlg.Execute: Boolean;

function GetFileInfo (const sFile: WideString): TFileInfo;
{routine returns file information - called in the case of overwrites}
var
  f: file;
  fInfo: TFileInfo;
begin
  if not FileExists(sFile) then Exit;
  {Set file access mode to readonly in case file is in use:}
  System.FileMode := fmOpenRead;
  {assign and open files:}
  AssignFile(f,sFile);
  {$I-}
  Reset(f,1);
  {$I+}
  {Set file access mode back to normal default for other processes:}
  System.Filemode := fmOpenReadWrite;
  if  IOResult <> 0  then  begin
    WideMessageBoxError (WideFormat (RS_CCopyDlg_NoCanOpen, [sFile]));
    fInfo.size := 0;
    fInfo.date := 0;
  end
  else  begin
    fInfo.size := FileSize(f);
    fInfo.date := FileGetDate(TFileRec(f).Handle);
  end;
  Result := fInfo;
  system.closeFile(f);
end {GetFileInfo};

function CustCopyFile (const sSrce, sDest: WideString): Boolean;

function IsSpace (const sDestination: WideString): Int64;
{return free space, plus size of existing file}
var
  c: Char;
  DiskByte: Byte;
  li: Int64;
  fExists: TFileInfo;
begin
  {get drive letter:}
  C := Char (sDestination[1]);
  {check that drive letter is valid:}
  if  not DiskValid (C, DiskByte)  then  begin
    Result := 0;
    Exit; {New}
  end;
  {get alphabet index of character - ie: A is 1.}
  li := DiskFree (DiskByte);
  if  li = -1  then  begin
    Result := 0;
    Exit; {New}
  end;
  {if the file exists,
   then add the existing file's size from value returned by diskFree:}
  if  FileExists (sDestination)  then  begin
    fExists := GetFileInfo (sDestination);
    li := li + fExists.size;
  end;
  Result := li;
end {IsSpace};

type
  iobufptr = ^iobufr; {allowate a LARGE buffer to speed up copies}
  iobufr   = array[0..32767] of Char; {MAX=65535}
var
  fSrce, fDest: file;
  wRead, wWritten: Integer;
  p: iobufptr;
  FDate, FSize, wSumWritten: Longint;
  Moved: Boolean;
begin {CustCopyFile}
  {initialise:}
  Result := False;
  wRead := 0;
  wWritten := 0;
  wSumWritten := 0;
  TntCopyFilesProgressBox.Gauge.Progress := 0;
  TntCopyFilesProgressBox.L_SourceFileOrFileToDel.Caption := sSrce;
  TntCopyFilesProgressBox.L_Target.Caption := sDest;

  Application.ProcessMessages;

  Moved := False;
  if  FFileAction = faMove  then  begin
    Moved := RenameFile (sSrce, sDest); { try just renaming }
  end;

  if  (FFileAction = faCopy) or ((FFileAction = faMove) and (not Moved))  then   begin

    {Set file access mode to readonly in case file is in use.}
    System.FileMode := fmOpenRead;
     {assign and open files}
    AssignFile(fSrce,sSrce);
     {$I-}
    Reset(fSrce,1);
     {$I+}
    {Set file access mode back to normal default for other processes}
    System.Filemode := fmOpenReadWrite;
    if IOResult <> 0  then  begin
      WideMessageBoxError (WideFormat (RS_CCopyDlg_NoCanOpen, [sSrce]));
      Exit;
    end;
    {Store file Date & Time for later use}
    FDate := FileGetDate(TFileRec(fSrce).Handle);

    {before creating new file, check that there is sufficient free space}
    if isSpace(sDest) > FileSize(fSrce) then  begin
      {Set file access mode to allow Exclusive Creation }
      System.Filemode := fmOpenWrite and fmShareExclusive;
      AssignFile(fDest,sDest);
      {$I-}
      Rewrite(fDest, 1);
      {$I+}
      {Set file access mode back to normal default for other processes}
      System.Filemode := fmOpenReadWrite;

      if IOResult <> 0  then  begin
        {Close the Source file we already have open.}
        System.CloseFile(fSrce);
        WideMessageBoxError (WideFormat (RS_CCopyDlg_NoCanCreate, [sDest]));
        Exit;
      end;
    end
    else  begin
      WideMessageBoxError (WideFormat (RS_CCopyDlg_NoHandleSpaceForCopy,[sSrce]));
      Exit;
    end;

    {allocate a file iobuffer on Heap to avoid stack overflow error}
    new(p);

    {copy loop}
    FSize := FileSize(fSrce);

    repeat
      BlockRead(fSrce, p^, SizeOf(p^), wRead);
      BlockWrite(fDest, p^, wRead, wWritten);
      wSumWritten := wSumWritten + wWritten;
      if  FSize > 0
      then  TntCopyFilesProgressBox.Gauge.Progress := Round(wSumWritten/FSize * 100);
    until (wRead = 0) or (wWritten <> wRead);

    {release heap space for iobuffer }
    Dispose(p);

    {restore Source file date & time to Destination file }
    Reset(fDest,1);
    FileSetDate(TFileRec(fDest).Handle,FDate);
    System.CloseFile(fDest);

    {clean up}
    System.CloseFile(fSrce);
  end;
  Result := True;
end {CustCopyFile};

function SetupFiles: Boolean;

var
  sSrce: WideString;
  sDest: WideString;
procedure ONAM (Copied: Boolean); {OnNotifyActionMade}
begin
  if  Assigned (FOnNotifyCopyMoveMade)
  then  FOnNotifyCopyMoveMade (sSrce, sDest, FFileAction, Copied);
  if Copied
  then  Inc (FNFilesWithActionMade);
end {ONAM};

var
  li: Int64;
procedure Mess (const S: WideString;  E: Int64);
begin
  WideMessageBoxError (WideFormat
   (Concat(S,' ',RS_CCopyDlg_SpaceForCopy), [IntToTSStr(E), IntToTSStr(li)]));
  SetupFiles := False;
end {Mess};

var
  iNum: Integer;
procedure SetsSDest;
var
  S: WideString;
begin
  if CopyMoveToSingleDir then  begin
    sDest := Concat (AddSlashW(FStrTargetDir), ExtractFileName(FList[iNum]));
  end
  else if  SeveralSourceDrivers  then  begin
    S := FList[iNum]; {contains, pex:  'C:|sss.rtf'}
    Delete (S, 1, 2); {S := '|sss.rtf'}
    sDest := Concat (AddSlashW(FStrTargetDir), WideUpCase(FList[iNum][1]), S);
  end
  else
    sDest := Concat (AddSlashW(FStrTargetDir), FList[iNum]);
end {SetsSDest};

var
  SLD, Dir: WideString;
  FSFNOF: Integer; {FileSizeFromNotOpenFile}
  liFree, SizeTotal, SizeCopyMoved: Int64;
  DriveByte: Byte;
  fSrce, fDest: TFileInfo;
  DS: Int64; {DiskSize}
  MustExit, NeedCopy: Boolean;
begin {SetupFiles}
  if  (not SeveralSourceDrivers) and
   (not isDir(FStrSourceDir, SourceDirWriteable))
  then  begin
    SetupFiles := False;
    Exit;
  end;
  if  not isDir (FStrTargetDir, True)  then  begin
    SetupFiles := False;
    Exit;
  end;
  {check that the user is not trying to copy over source files}
  if  WideCompareText (FStrSourceDir, FStrTargetDir) = 0  then  begin
    WideMessageBoxError (RS_CCopyDlg_NoCanOverwriteFiles);
    SetupFiles := False;
    Exit;
  end;

  SLD := GetSlashStrSourceDir;
  {check space on target}
  li := 0;
  liFree := 0;
  MustExit := False;
  try
    Screen.Cursor := crHourGlass;
    FList.Sort;
    {increment through file list, adding up file sizes}
    for  iNum := 0 to FList.Count-1  do  begin
      sSrce := SLD + FList[iNum];
      FSFNOF := FileSizeFromNotOpenFileW (sSrce);
      if  FSFNOF <> 0  then  begin
        Inc (li, FSFNOF);
        SetsSDest;
        case FFileAction of
        faCopy: Inc (liFree, FSFNOF);
        faMove:
          if  WideUpCase(sSrce[1]) = WideUpCase(sDest[1])
          then  Inc (liFree, FSFNOF-FileSizeFromNotOpenFileW(sDest))
          else  Inc (liFree, FSFNOF);
        end;
      end;
    end;
    SizeTotal := li;
    Dir := '';
    for  iNum := 0 to FList.Count-1  do  begin
      SetsSDest;
      sDest := WideExtractFileDir (sDest);
      if  Dir <> sDest  then  begin
        if  not DirectoryExists (sDest)  then  begin
          if  Pos(Dir, sDest) = 0
          then  Inc (li, 512);
          {else when (Dir='C:\hello') and (sDest = 'C:\hello\hello')}
        end;
        Dir := sDest;
      end;
    end;
    DriveByte := DriveByteFromDriveChar (Char(FStrTargetDir[1]));
    {find target disk size}
    DS := DiskSize(DriveByte);
    if  li > DS  then  begin
      Mess (RS_CCopyDlg_NoDiskSpace, DS);
      MustExit := True;
    end;
    if  not MustExit  then  begin
      {find target free - we add, to free space, the size of the existing files since the user
      is probably going to overwrite them}
      liFree := liFree + DiskFree(DriveByte);
      if  li > liFree  then  begin
        Mess (RS_CCopyDlg_NoDiskFreeSpace, liFree);
        MustExit := True;
      end;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
  if  MustExit  then  Exit;

  {init for loop}
  SizeCopyMoved := 0;
  FOkToAll := not (FOverwritePrompt or FOverwriteNewerPrompt);

  for  iNum := 0 to FList.Count-1  do  begin
    {get source file name}
    sSrce := Concat (SLD, FList[iNum]);
    {get destination file name}
    SetsSDest;
    Dir := WideExtractFileDir(sDest);
    if  not DirectoryExists(Dir)  then   begin
      if  not FileCtrl.ForceDirectories(Dir)  then  begin
        WideMessageBoxError (WideFormat (RS_CCopyDlg_NoMakeDir, [Dir]));
        SetupFiles := False;
        Exit;
      end
      else
        Inc (FNDirsAdded);
    end;

    Application.ProcessMessages;

    {break?}
    if  TntCopyFilesProgressBox.bCancel = True  then  begin
      if  WideUserSayYes (WideFormat (RS_CCopyDlg_TryIfBreak, [RS_CCopyDlg_OfCopy]))  then  begin
        SetupFiles := False;
        Exit;
      end
      else
        TntCopyFilesProgressBox.bCancel := False;
    end
    else
      TntCopyFilesProgressBox.bCancel := False;

    {check to see if file exists}
    NeedCopy := False;
    fSrce := GetFileInfo (sSrce);
    if  not FOkToAll  then  begin
      if  FileExists (sDest)  then  begin
        {since file exists, we must get info of both source and target files}
        fDest := GetFileInfo (sDest);
        if  fSrce.date = fDest.date  then  begin
          NeedCopy := False;
        end
        else if  (not FOverwritePrompt {=FOverwriteNewerPrompt})
          and (fSrce.date >= fDest.date)
        then  NeedCopy := True
        else  begin
          case MessageDlg(WideFormat (RS_CCopyDlg_TryIfOverwriteFile,
             [sDest, IntToTSStr(fSrce.size), DateTimeToStr(FileDateToDateTime(fSrce.date)),
              sSrce, IntToTSStr(fDest.size), DateTimeToStr(FileDateToDateTime(fDest.date))]),
            mtConfirmation,[mbYes,mbAll,mbNo],0)
          of
          mrYes:
            NeedCopy := True;
          mrAll:
            begin
              FOkToAll := True;
              NeedCopy := True;
            end;
          mrNo: {do nothing};
          end;
        end;
      end
      else
        {file doesn't already exist - so copy}
        NeedCopy := True;
    end
    else
      {file does already exist, but overwrite is True}
      NeedCopy := True;

    if NeedCopy then  begin
      if  FileExists (sDest)  then  begin
        WhenAskDelROF (sDest, RS_CCopyDlg_OverwriteReadOnlyFile);
        if NeedDel then  begin
          if  not SysUtils.DeleteFile (sDest)  then  begin
            WideMessageBoxError (WideFormat (RS_CCopyDlg_NoCanDeleteFile, [sDest]));
            SetupFiles := False;
            ONAM (False);
            Exit;
          end;
        end
        else
          NeedCopy := False; {not overwrite}
      end;
      if  NeedCopy and (not CustCopyFile (sSrce, sDest))  then  begin
        SetupFiles := False;
        ONAM (False);
        Exit;
      end;
    end;
    ONAM (NeedCopy);
    Inc (SizeCopyMoved, fSrce.Size);
    if  SizeTotal > 0
    then  TntCopyFilesProgressBox.GaugeTotal.Progress := Round (SizeCopyMoved/SizeTotal * 100);
    Application.ProcessMessages;
  end;
  SetupFiles := True;

end {SetupFiles};

procedure CreateDirs;
var
  L: Byte;
  I: Integer;
  Res, Dir, S: WideString;
begin
  try
    Screen.Cursor := crHourGlass;
    FindCommonDirForAllList (FDirList, False, Res);
    L := Length(Res);
    for  I := 0 to FDirList.Count-1  do  begin
      if  L = 0  then  begin
        S := FDirList[I];
        Delete (S, 2, 1); {extract DriveDelim}
        S := Concat (PathDelim, S);
      end
      else
        S := Copy (FDirList[I], L, MaxInt);
      Dir := Concat (FStrTargetDir, S);
      if  not DirectoryExists(Dir)  then
        if  not FileCtrl.ForceDirectories(Dir)  then  begin
          if  not WideUserSayYes (
            WideFormat (Concat (RS_CCopyDlg_NoMakeDir, RS_CCopyDlg_Continue), [Dir]))
          then  Break;
        end
        else  Inc (FNDirsAdded);
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end {CreateDirs};

{
type
  TTntSingleStr = class(TObject)
    S: ShortString;
  end;
  }
var
  Ok: Boolean;
  S, S1: WideString;
  iNum: Integer;
  SL, SLRes: TTntStringList;
  SS: TTntSingleStr;
begin {Execute}
  if  FFileAction = faCopy
  then  S := RS_CCopyDlg_ToCopy
  else  S := RS_CCopyDlg_ToMove;
  if  not PreExecute (S)
  then  Result := False
  else  begin
    FNDirsAdded := 0;
    if  FStrTargetDir = ''  then  begin
      WideMessageBoxError (RS_CCopyDlg_NoSetTargetDir);
      PostExecute;
      Result := False;
    end
    else  begin
      if  FList.Count > 0  then  begin
        if CopyMoveToSingleDir then  begin
          SLRes := TTntStringList.Create;
          SL := TTntStringList.Create;
          for  iNum := 0 to FList.Count-1  do  begin
            SS := TTntSingleStr.Create;
            SS.S := FList[iNum];
            SL.AddObject(WideUpperCase (ExtractFileName(FList[iNum])), SS);
          end;
          SL.Sort;
          S1 := '';
          Ok := True;
          for  iNum := 0 to SL.Count-1  do  begin
            if  SL[iNum] = S1  then  begin
              SLRes.Add (TTntSingleStr(SL.Objects[iNum-1]).S);
              SLRes.Add (TTntSingleStr(SL.Objects[iNum]).S);
            end
            else
              S1 := SL[iNum];
          end;
          for  iNum := 0 to SL.Count-1  do
            TTntSingleStr(SL.Objects[iNum]).Free;
          SL.Free;
          if  SLRes.Count > 0  then  begin
            S1 := '';
            for  iNum := 0 to SLRes.Count-1  do
              S1 := Concat (S1, sLineBreak, SLRes[iNum]);
            WideMessageBoxError (Concat (WideFormat (RS_CCopyDlg_DuplicateName,[S]), S1));
            Ok := False;
          end;
          SLRes.Free;

          Result := Ok;
          if  not Ok
          then  Exit;
        end;
        try
          { Create dialog in memory: }
          TntCopyFilesProgressBox := TTntCopyFilesProgressBox.Create(Application);
          if  FFileAction = faCopy
          then  TntCopyFilesProgressBox.Caption := RS_CCopyDlg_Copying
          else  TntCopyFilesProgressBox.Caption := RS_CCopyDlg_Moving;
          TntCopyFilesProgressBox.Show;
          TntCopyFilesProgressBox.Update;
          Ok := SetupFiles;
          if  Ok and (FFileAction = faMove)
          then  PerhapsDeleteEmptyDirs;
          Execute := Ok;
        finally
          TntCopyFilesProgressBox.Close;
          TntCopyFilesProgressBox.Free;
          PostExecute;
        end;
      end
      else  begin
        Result := True;
        {only copy tree structure}
        if  FPromptEmptyStructure and WideUserSayYes (RS_CCopyDlg_PromptCopyStructure)
        then  CreateDirs;
      end;
    end;
  end;
end {Execute};

function TTntCCopyMoveBoxDlg.ExistDirInTargetList (const Dir: WideString): Boolean;
{Dir must be with PathDelim}
var
  SL: TTntStringList;
  I: Integer;
  S: WideString;
begin
  if  FList.Count = 0  then  begin
    Result := False;
    Exit;
  end;
  SL := TTntStringList.Create;
  Result := False;
  for  I := 0 to FList.Count-1  do
    SL.Add (WideExtractFileDir (Concat (AddSlashW(FStrTargetDir),FList[I])));
  for  I := 0 to SL.Count-1  do  begin
    S := SL[I];
    if  S = Dir  then  begin
      Result := True;
      Break;
    end;
  end;
  SL.Free;
end {ExistDirInTargetList};

{--------------------------------------}
{-EVENTS-----------}

constructor TTntCopyMoveBoxDlg.Create(AOwner: TComponent);
begin
  inherited Create (AOwner);
  FStrTargetDir := '';
  FOverwriteNewerPrompt := True;
end {Create};

{-PRIVATE----------}

function TTntCopyMoveBoxDlg.GetDirsAdded: Boolean;
begin
  Result := FNDirsAdded > 0;
end {GetDirsAdded};

procedure TTntCopyMoveBoxDlg.SetFileAction (const Value: TFileAction);
begin
  FFileAction := Value;
  if  (FFileAction = faMove) and (FStrSourceDir <> '')
  then  StrSourceDir := FStrSourceDir;
end {SetFileAction};

procedure TTntCopyMoveBoxDlg.SetOverwritePrompt (V: Boolean);
begin
  FOverwritePrompt := V;
  if  FOverwritePrompt
  then  FOverwriteNewerPrompt := True;
end {SetOverwritePrompt};

procedure TTntCopyMoveBoxDlg.SetOverwriteNewerPrompt (V: Boolean);
begin
  FOverwriteNewerPrompt := V;
  if  not FOverwriteNewerPrompt
  then  FOverwritePrompt := False;
end {SetOverwriteNewerPrompt};

procedure TTntCopyMoveBoxDlg.SetStrTargetDir (const TD: WideString);
begin
  CheckDir (TD, FStrTargetDir, True);
end {SetStrTargetDir};

{-PROTECTED--------}

function TTntCopyMoveBoxDlg.SourceDirWriteable: Boolean;
begin
  if  FFileAction = faCopy
  then  Result := False
  else  Result := True;
end;

{-PUBLIC-----------}

function TTntCopyMoveBoxDlg.Execute: Boolean;

function GetFileInfo (const sFile: WideString): TFileInfo;
{routine returns file information - called in the case of overwrites}
var
  f: file;
  fInfo: TFileInfo;
begin
  if not FileExists(sFile) then Exit;
  {Set file access mode to readonly in case file is in use:}
  System.FileMode := fmOpenRead;
  {assign and open files:}
  AssignFile(f,sFile);
  {$I-}
  Reset(f,1);
  {$I+}
  {Set file access mode back to normal default for other processes:}
  System.Filemode := fmOpenReadWrite;
  if  IOResult <> 0  then  begin
    WideMessageBoxError (WideFormat (RS_CCopyDlg_NoCanOpen, [sFile]));
    fInfo.size := 0;
    fInfo.date := 0;
  end
  else  begin
    fInfo.size := FileSize(f);
    fInfo.date := FileGetDate(TFileRec(f).Handle);
  end;
  Result := fInfo;
  system.closeFile(f);
end {GetFileInfo};

function CustCopyFile (const sSrce, sDest: WideString): Boolean;

function IsSpace (const sDestination: WideString): Int64;
{return free space, plus size of existing file}
var
  c: Char;
  DiskByte: Byte;
  li: Int64;
  fExists: TFileInfo;
begin
  {get drive letter:}
  C := Char (sDestination[1]);
  {check that drive letter is valid:}
  if  not DiskValid (C, DiskByte)  then  begin
    Result := 0;
    Exit; {New}
  end;
  {get alphabet index of character - ie: A is 1.}
  li := DiskFree (DiskByte);
  if  li = -1  then  begin
    Result := 0;
    Exit; {New}
  end;
  {if the file exists,
   then add the existing file's size from value returned by diskFree:}
  if  FileExists (sDestination)  then  begin
    fExists := GetFileInfo (sDestination);
    li := li + fExists.size;
  end;
  Result := li;
end {IsSpace};

type
  iobufptr = ^iobufr; {allowate a LARGE buffer to speed up copies}
  iobufr   = array[0..32767] of Char; {MAX=65535}
var
  fSrce, fDest: file;
  wRead, wWritten: Integer;
  p: iobufptr;
  FDate, FSize, wSumWritten: Longint;
  Moved: Boolean;
begin {CustCopyFile}
  {initialise:}
  Result := False;
  wRead := 0;
  wWritten := 0;
  wSumWritten := 0;
  TntCopyFilesProgressBox.Gauge.Progress := 0;
  TntCopyFilesProgressBox.L_SourceFileOrFileToDel.Caption := sSrce;
  TntCopyFilesProgressBox.L_Target.Caption := sDest;

  Application.ProcessMessages;

  Moved := False;
  if  FFileAction = faMove  then  begin
    Moved := RenameFile (sSrce, sDest); { try just renaming }
  end;

  if  (FFileAction = faCopy) or ((FFileAction = faMove) and (not Moved))  then   begin

    {Set file access mode to readonly in case file is in use.}
    System.FileMode := fmOpenRead;
     {assign and open files}
    AssignFile(fSrce,sSrce);
     {$I-}
    Reset(fSrce,1);
     {$I+}
    {Set file access mode back to normal default for other processes}
    System.Filemode := fmOpenReadWrite;
    if IOResult <> 0  then  begin
      WideMessageBoxError (WideFormat (RS_CCopyDlg_NoCanOpen, [sSrce]));
      Exit;
    end;
    {Store file Date & Time for later use}
    FDate := FileGetDate(TFileRec(fSrce).Handle);

    {before creating new file, check that there is sufficient free space}
    if isSpace(sDest) > FileSize(fSrce) then  begin
      {Set file access mode to allow Exclusive Creation }
      System.Filemode := fmOpenWrite and fmShareExclusive;
      AssignFile(fDest,sDest);
      {$I-}
      Rewrite(fDest, 1);
      {$I+}
      {Set file access mode back to normal default for other processes}
      System.Filemode := fmOpenReadWrite;

      if IOResult <> 0  then  begin
        {Close the Source file we already have open.}
        System.CloseFile(fSrce);
        WideMessageBoxError (WideFormat (RS_CCopyDlg_NoCanCreate, [sDest]));
        Exit;
      end;
    end
    else  begin
      WideMessageBoxError (WideFormat (RS_CCopyDlg_NoHandleSpaceForCopy,[sSrce]));
      Exit;
    end;

    {allocate a file iobuffer on Heap to avoid stack overflow error}
    new(p);

    {copy loop}
    FSize := FileSize(fSrce);

    repeat
      BlockRead(fSrce, p^, SizeOf(p^), wRead);
      BlockWrite(fDest, p^, wRead, wWritten);
      wSumWritten := wSumWritten + wWritten;
      if  FSize > 0
      then  TntCopyFilesProgressBox.Gauge.Progress := Round(wSumWritten/FSize * 100);
    until (wRead = 0) or (wWritten <> wRead);

    {release heap space for iobuffer }
    Dispose(p);

    {restore Source file date & time to Destination file }
    Reset(fDest,1);
    FileSetDate(TFileRec(fDest).Handle,FDate);
    System.CloseFile(fDest);

    {clean up}
    System.CloseFile(fSrce);
  end;
  Result := True;
end {CustCopyFile};

function SetupFiles: Boolean;

var
  sSrce: WideString;
  sDest: WideString;
procedure ONAM (Copied: Boolean); {OnNotifyActionMade}
begin
  if  Assigned (FOnNotifyCopyMoveMade)
  then  FOnNotifyCopyMoveMade (sSrce, sDest, FFileAction, Copied);
  if Copied
  then  Inc (FNFilesWithActionMade);
end {ONAM};

var
  li: Int64;
procedure Mess (const S: WideString;  E: Int64);
begin
  WideMessageBoxError (WideFormat
   (Concat(S,RS_CCopyDlg_SpaceForCopy), [IntToTSStr(E), IntToTSStr(li)]));
  SetupFiles := False;
end {Mess};

procedure SetsSDest;
var
  S: WideString;
begin
  if CopyMoveToSingleDir then  begin
    sDest := Concat (AddSlashW(FStrTargetDir), ExtractFileName(sSrce));
  end
  else begin
    S := sSrce; {contains, pex:  'C:|sss.rtf'}
    if  SeveralSourceDrivers  then  begin
      Delete (S, 1, 2); {S := '|sss.rtf'}
      sDest := Concat (AddSlashW(FStrTargetDir), FDataSet.Fields[FNDir].Value[1], S);
    end
    else  begin
      Delete (S, 1, Length (AddSlashW(StrSourceDir)));
      sDest := Concat (AddSlashW(FStrTargetDir), S);
    end;
  end;
end {SetsSDest};

var
  SLD, Dir: WideString;
  FSFNOF: Integer; {FileSizeFromNotOpenFile}
  liFree, SizeTotal, SizeCopyMoved: Int64;
  DriveByte: Byte;
  fSrce, fDest: TFileInfo;
  DS: Int64; {DiskSize}
  MustExit, NeedCopy: Boolean;
begin {SetupFiles}
  if  (not SeveralSourceDrivers) and
   (not isDir(FStrSourceDir, SourceDirWriteable))
  then  begin
    SetupFiles := False;
    Exit;
  end;
  if  not isDir (FStrTargetDir, True)  then  begin
    SetupFiles := False;
    Exit;
  end;
  {check that the user is not trying to copy over source files}
  if  WideCompareText (FStrSourceDir, FStrTargetDir) = 0  then  begin
    WideMessageBoxError (RS_CCopyDlg_NoCanOverwriteFiles);
    SetupFiles := False;
    Exit;
  end;

  SLD := GetSlashStrSourceDir;
  {check space on target}



  li := 0;
  liFree := 0;
  MustExit := False;
  try
    Screen.Cursor := crHourGlass;
    //FList.Sort;
    {increment through file list, adding up file sizes}
    with FDataSet do  begin
      First;
      while not EOF do  begin
        sSrce := GetCompletFN;
        FSFNOF := Fields[FNSize].AsInteger;
        if  FSFNOF <> 0  then  begin
          Inc (li, FSFNOF);
          SetsSDest;
          case FFileAction of
          faCopy: Inc (liFree, FSFNOF);
          faMove:
            if  WideUpCase(sSrce[1]) = WideUpCase(sDest[1])
            then  Inc (liFree, FSFNOF-FileSizeFromNotOpenFileW(sDest))
            else  Inc (liFree, FSFNOF);
          end;
        end;
        Next;
      end;
    end;
    SizeTotal := li;
    Dir := '';
    with FDataSet do  begin
      First;
      while not EOF do  begin
        sSrce := GetCompletFN;
        SetsSDest;
        sDest := WideExtractFileDir (sDest);
        if  Dir <> sDest  then  begin
          if  not DirectoryExists (sDest)  then  begin
            if  Pos(Dir, sDest) = 0
            then  Inc (li, 512);
            {else when (Dir='C:\hello') and (sDest = 'C:\hello\hello')}
          end;
          Dir := sDest;
        end;
        Next;
      end;
    end;
    DriveByte := DriveByteFromDriveChar (Char(FStrTargetDir[1]));
    {find target disk size}
    DS := DiskSize(DriveByte);
    if  li > DS  then  begin
      Mess (RS_CCopyDlg_NoDiskSpace, DS);
      MustExit := True;
    end;
    if  not MustExit  then  begin
      {find target free - we add, to free space, the size of the existing files since the user
      is probably going to overwrite them}
      liFree := liFree + DiskFree(DriveByte);
      if  li > liFree  then  begin
        Mess (RS_CCopyDlg_NoDiskFreeSpace, liFree);
        MustExit := True;
      end;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
  if  MustExit  then  Exit;

  {init for loop}
  SizeCopyMoved := 0;
  FOkToAll := not (FOverwritePrompt or FOverwriteNewerPrompt);


  with FDataSet do  begin
    First;
    while not EOF do  begin
      sSrce := GetCompletFN;
      SetsSDest;
      Dir := WideExtractFileDir(sDest);
      if  not DirectoryExists(Dir)  then   begin
        if  not FileCtrl.ForceDirectories(Dir)  then  begin
          WideMessageBoxError (WideFormat (RS_CCopyDlg_NoMakeDir, [Dir]));
          SetupFiles := False;
          Exit;
        end
        else
          Inc (FNDirsAdded);
      end;

      Application.ProcessMessages;

      {break?}
      if  TntCopyFilesProgressBox.bCancel = True  then  begin
        if  WideUserSayYes (WideFormat (RS_CCopyDlg_TryIfBreak, [RS_CCopyDlg_OfCopy]))  then  begin
          SetupFiles := False;
          Exit;
        end
        else
          TntCopyFilesProgressBox.bCancel := False;
      end
      else
        TntCopyFilesProgressBox.bCancel := False;

      {check to see if file exists}
      NeedCopy := False;
      fSrce := GetFileInfo (sSrce);
      if  not FOkToAll  then  begin
        if  FileExists (sDest)  then  begin
          {since file exists, we must get info of both source and target files}
          fDest := GetFileInfo (sDest);
          if  (not FOverwritePrompt {=FOverwriteNewerPrompt})
            and (fSrce.date >= fDest.date)
          then  NeedCopy := True
          else  begin
            case MessageDlg(WideFormat (RS_CCopyDlg_TryIfOverwriteFile,
               [sDest, IntToTSStr(fSrce.size), DateTimeToStr(FileDateToDateTime(fSrce.date)),
                sSrce, IntToTSStr(fDest.size), DateTimeToStr(FileDateToDateTime(fDest.date))]),
              mtConfirmation,[mbYes,mbAll,mbNo],0)
            of
            mrYes:
              NeedCopy := True;
            mrAll:
              begin
                FOkToAll := True;
                NeedCopy := True;
              end;
            mrNo: {do nothing};
            end;
          end;
        end
        else
          {file doesn't already exist - so copy}
          NeedCopy := True;
      end
      else
        {file does already exist, but overwrite is True}
        NeedCopy := True;

      if NeedCopy then  begin
        if  FileExists (sDest)  then  begin
          WhenAskDelROF (sDest, RS_CCopyDlg_OverwriteReadOnlyFile);
          if NeedDel then  begin
            if  not SysUtils.DeleteFile (sDest)  then  begin
              WideMessageBoxError (WideFormat (RS_CCopyDlg_NoCanDeleteFile, [sDest]));
              SetupFiles := False;
              ONAM (False);
              Exit;
            end;
          end
          else
            NeedCopy := False; {not overwrite}
        end;
        if  NeedCopy and (not CustCopyFile (sSrce, sDest))  then  begin
          SetupFiles := False;
          ONAM (False);
          Exit;
        end;
      end;
      ONAM (NeedCopy);
      Inc (SizeCopyMoved, fSrce.Size);
      if  SizeTotal > 0
      then  TntCopyFilesProgressBox.GaugeTotal.Progress := Round (SizeCopyMoved/SizeTotal * 100);
      Application.ProcessMessages;
      Next;
    end;
  end;
  SetupFiles := True;

end {SetupFiles};

procedure CreateDirs;

function FindCommonDirForAllRecs (var Res: WideString): Boolean;
var
  FDir, NewDir: WideString;
  SL: TTntStringList;
begin
  Result := False;
  if  FDataSet.RecordCount = 0  then  begin
    {Message?}
    Exit;
  end;
  SL := TTntStringList.Create;
  FDir := '';
  with FDataSet do  begin
    //Sort! (ja sorted?)
    First;
    while not EOF do  begin
      NewDir := Fields[FNDir].Value;
      if  FDir <> NewDir  then  begin
        FDir := NewDir;
        SL.Add (NewDir);
      end;
      Next;
    end;
  end;
  TntFindCommonDirFromDirsSL (SL, Res);
  SL.Free;
  Result := True;
end {FindCommonDirForAllRecs};

var
  L: Byte;
  I: Integer;
  Res, Dir, S: WideString;
begin
  try
    Screen.Cursor := crHourGlass;
    FindCommonDirForAllRecs (Res);
    L := Length(Res);
    for  I := 0 to FDirList.Count-1  do  begin
      if  L = 0  then  begin
        S := FDirList[I];
        Delete (S, 2, 1); {extract DriveDelim}
        S := Concat (PathDelim, S);
      end
      else
        S := Copy (FDirList[I], L, MaxInt);
      Dir := Concat (FStrTargetDir, S);
      if  not DirectoryExists(Dir)  then
        if  not FileCtrl.ForceDirectories(Dir)  then  begin
          if  not WideUserSayYes (
            WideFormat (Concat (RS_CCopyDlg_NoMakeDir, RS_CCopyDlg_Continue), [Dir]))
          then  Break;
        end
        else  Inc (FNDirsAdded);
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end {CreateDirs};

var
  Ok: Boolean;
  S: WideString;
begin {Execute}
  if  FFileAction = faCopy
  then  S := RS_CCopyDlg_ToCopy
  else  S := RS_CCopyDlg_ToMove;
  if  not PreExecute (S)
  then  Result := False
  else  begin
    FNDirsAdded := 0;
    if  FStrTargetDir = ''  then  begin
      WideMessageBoxError (RS_CCopyDlg_NoSetTargetDir);
      PostExecute;
      Result := False;
    end
    else  begin
      if  FDataSet.RecordCount > 0  then  begin
        try
          { Create dialog in memory: }
          TntCopyFilesProgressBox := TTntCopyFilesProgressBox.Create(Application);
          if  FFileAction = faCopy
          then  TntCopyFilesProgressBox.Caption := RS_CCopyDlg_Copying
          else  TntCopyFilesProgressBox.Caption := RS_CCopyDlg_Moving;
          TntCopyFilesProgressBox.Show;
          TntCopyFilesProgressBox.Update;
          Ok := SetupFiles;
          if  Ok and (FFileAction = faMove)
          then  PerhapsDeleteEmptyDirs;
          Execute := Ok;
        finally
          TntCopyFilesProgressBox.Close;
          TntCopyFilesProgressBox.Free;
          PostExecute;
        end;
      end
      else  begin
        Result := True;
        {only copy tree structure}
        if  FPromptEmptyStructure and WideUserSayYes (RS_CCopyDlg_PromptCopyStructure)
        then  CreateDirs;
      end;
    end;
  end;
end {Execute};

function TTntCopyMoveBoxDlg.ExistDirInTargetList (const Dir: WideString): Boolean;
{Dir must be with PathDelim}
var
  SL: TTntStringList;
  I: Integer;
  S: WideString;
begin
  if  FDataSet.RecordCount = 0  then  begin
    Result := False;
    Exit;
  end;
  SL := TTntStringList.Create;
  Result := False;
  with FDataSet do  begin
    First;
    while not EOF do  begin
      SL.Add (WideExtractFileDir (Concat (AddSlashW(FStrTargetDir),Fields[FNDir].Value)));
      Next;
    end;
  end;
  for  I := 0 to SL.Count-1  do  begin
    S := SL[I];
    if  S = Dir  then  begin
      Result := True;
      Break;
    end;
  end;
  SL.Free;
end {ExistDirInTargetList};

{--------------------------------------}

end.
