{---------------------------------------------------------------------

 (c) Copyleft or copyright under terms of GNU General Public License
 2003  Jordi March i Nogu   jmarch@comg.es

----------------------------------------------------------------------}

unit TntCtrlPS;

interface

uses
  Controls, Classes, Forms,
  TntDbGrids, TntJvDbGridS,
  CtrlPS0;

type
  TPosSizeTntGridW = class(TPosSizeGridW0)
  public
    DBGrid: TTntDBGrid;
    procedure GetPosSize; override;
    function  SetPosSize: Boolean; override;
  end;

  TPosSizeTntJvGridW = class(TPosSizeGridW0)
  public
    DBGrid: TTntJvDBGridS;
    procedure GetPosSize; override;
    function  SetPosSize: Boolean; override;
  end;

implementation

uses
  Math;

{--------------------------------------}
{-PUBLIC-----------}

procedure TPosSizeTntGridW.GetPosSize;
var
  I: Byte;
  TW: TAliWidth;
begin
  inherited;
  FreeGridColsObjects;
  GridCols.Clear;
  for  I := 0 to DBGrid.Columns.Count-1  do  begin
    TW := TAliWidth.Create;
    TW.Width := Max (4, DBGrid.Columns[I].Width);
    TW.Alignment := DBGrid.Columns[I].Alignment;
    GridCols.AddObject (DBGrid.Columns[I].FieldName, TW);
  end;
end {GetPosSize};

function TPosSizeTntGridW.SetPosSize: Boolean;
var
  I: Byte;
  Ok: Boolean;
begin
  Ok := inherited SetPosSize;
  if Ok then
    if GridCols.Count > 0 then
      for  I := 0 to GridCols.Count-1  do  begin
        DBGrid.Columns[I].FieldName := GridCols[I];
        DBGrid.Columns[I].Alignment := TAliWidth(GridCols.Objects[I]).Alignment;
        DBGrid.Columns[I].Width := TAliWidth(GridCols.Objects[I]).Width;
      end;
  Result := Ok;
end {SetPosSize};

{--------------------------------------}
{-PUBLIC-----------}

procedure TPosSizeTntJvGridW.GetPosSize;
var
  I: Byte;
  TW: TAliWidth;
begin
  inherited;
  FreeGridColsObjects;
  GridCols.Clear;
  for  I := 0 to DBGrid.Columns.Count-1  do  begin
    TW := TAliWidth.Create;
    TW.Width := Max (4, DBGrid.Columns[I].Width);
    TW.Alignment := DBGrid.Columns[I].Alignment;
    GridCols.AddObject (DBGrid.Columns[I].FieldName, TW);
  end;
end {GetPosSize};

function TPosSizeTntJvGridW.SetPosSize: Boolean;
var
  I: Byte;
  Ok: Boolean;
begin
  Ok := inherited SetPosSize;
  if Ok then
    if GridCols.Count > 0 then
      for  I := 0 to GridCols.Count-1  do  begin
        DBGrid.Columns[I].FieldName := GridCols[I];
        DBGrid.Columns[I].Alignment := TAliWidth(GridCols.Objects[I]).Alignment;
        DBGrid.Columns[I].Width := TAliWidth(GridCols.Objects[I]).Width;
      end;
  Result := Ok;
end {SetPosSize};

{--------------------------------------}

end.
