{---------------------------------------------------------------------

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version

----------------------------------------------------------------------}

unit TntDataSetU;

interface

uses
  Classes, SysUtils, TntSysUtils, TntIniFiles, Variants,
  Db, TntDBCtrls,
  GrTypFun, TntMabSave;

resourcestring
  RS_CharYes = 'Y';
  RS_CharNo = 'N';
  RS_DataSetU_SaveRecCh = 'Do you want to keep the changes made this record?';
  RS_DataSetU_Ch = ', since it cannot be saved (will a message appear later with the reason)?';
  RS_DataSetU_CancelRec = 'Do you want to cancel the changes made this edited record of';
  RS_DataSetU_DSName = 'the name of the database: %s';
  RS_DataSetU_FewRecords = 'Low record number (%d, min %d, at %s)';
  RS_DataSetU_TableName = 'the table: %s';
  RS_DataSetU_ReadError = 'Error occurred when opening to read'#13#10'%s';
  RS_DataSetU_AppendError = 'Error occurred when opening to write'#13#10'%s';
  RS_DataSetU_WriteError = 'Error occurred on creating'#13#10'%s';
  RS_DataSetU_DataBaseNotActive = 'The database %s is not open';
  RS_DataSetU_Search = 'Search';
  RS_DataSetU_Terminate = 'Terminate';
  RS_DSU_TableNotOpen = 'Unable open'#13#10'%s'#13#10 +
   'Advisable thing is to close the program.'#13#10'Do it?';
  RS_SameTable = 'The two selected tables are the same one';
  RS_TableCreatedAndCopiedRec = '%s'#13#10'has been created and %d records have been copied';
  RS_DataSetU_NoAppend = 'to add';
  RS_DataSetU_NoUpdate = 'to update';
  RS_DataSetU_NoAppendUpdateRec = 'one is unable to %s, a record already exists with same:'#13#10'%s';
  RS_DataSetU_ActivatedFilter = 'Remember that there is an activated filter and maybe for this reason you doesn''t see this record';
  RS_DataSetU_DifferentFieldCount = 'The two data sets have different number of fields (%d and %d)';
  RS_DataSetU_DifferentFieldDataType = 'There is not concordance of field type, at least with %s and %s';
  RS_DataSetU_ConversionError1 = 'Conversion error in the field number %d: ''%s'', of content:'#13#10'%s'#13#10'from line %d';
  RS_DataSetU_NotField = 'Too many fields (%d), at line %d, of content:'#13#10'%s';
  RS_DataSetU_ConversionError2 = 'From:';
  RS_DataSetU_TooFewRecords = 'Too few records (%d, minim = %d)';

const
  eKeyViol = 9729;

var
  FieldsSepChar: WideChar = #9;
  TextFieldsDelimChar: WideChar = #0; //'"';

const
  IdentBetweenColumnsSep = 'BetweenColumnsSep';
  IdentTimeFormat = 'TimeFormat';

type
  TRRATFMode = (rratfReset, rratfRewrite, rratfAppend);
function ResRewAppTF00 (var T: TextFile;  const FileName: WideString;
  OnlyExt: Boolean;  Mode: TRRATFMode): Boolean;
function ResRewAppTF0 (var T: TextFile;  const FileName: WideString;
  Mode: TRRATFMode): Boolean;
function ResRewAppTF (D: TDataSet;  var T: TextFile;  const FileName: WideString;
  Mode: TRRATFMode): Boolean;

type
  TIndexWidthArr = array [Byte] of record
    Index, Width: Byte;
  end;
  PByteByteArr = ^TIndexWidthArr;
  Str8 = string[8];
  Str10 = string[10];

  TExportFieldFormats = class (TObject)
    FSection: WideString;
    BetweenColumnsSep: Str2;
    DateTimeAsNumber: Boolean;
    DateF: Str10;
    TimeF: Str8;
  public
    constructor Create (const Section: WideString);
    procedure LoadFromIniF (IniFile: TTntNewIniFile);
    procedure SaveToIniF (IniFile: TTntNewIniFile);
  end;

  TFieldsToExport = class (TObject)
  private
    FD: TDataSet;
    FExportFieldFormats: TExportFieldFormats;
  public
    MaxCount: Byte;
    Arr: PByteByteArr;
    constructor Create (D: TDataSet;  const FieldsSelected: string;
      const ExportFieldFormats: TExportFieldFormats);
    procedure CalculateWidth;
    destructor Destroy; override;
  end;

function StrFromFieldNames (D: TDataSet;
  IncCalcFields: Boolean): WideString;
function StrFromField (F: TField;  WithDelimChar: Boolean;
  const ExportFieldFormats: TExportFieldFormats): WideString;
function StrFromFields (D: TDataSet;
  const ExportFieldFormats: TExportFieldFormats): WideString;
function DelimitedStrFromSelectedFields (D: TDataSet;
  const ExportFieldFormats: TExportFieldFormats;
  FieldsToExport: TFieldsToExport): WideString;
function ColumnizedStrFromSelectedFieldNames (D: TDataSet;
  const ExportFieldFormats: TExportFieldFormats;
  FieldsToExport: TFieldsToExport): WideString;
function ColumnizedStrFromSelectedFields (D: TDataSet;
  const ExportFieldFormats: TExportFieldFormats;
  FieldsToExport: TFieldsToExport): WideString;
function ColumsStrFromFields (D: TDataSet;  FieldsColumnWidth: array of Byte): WideString;
function WidthFromField (F: TField;
  const ExportFieldFormats: TExportFieldFormats): Byte;

function PostDataSet (DS: TDataSet): Boolean;
function PostDataSetIsNeeded (DS: TDataSet): Boolean;
function PostedDataSetMinR (DS: TDataSet;  MinRecCount: Word;  const DataSetName: WideString): Boolean;
function DataSetPerhapsCancel (DS: TDataSet;  Ok: Boolean;  const DataSetName: WideString): Boolean;
function PostOrCancelCDataSetWhenNeeded (DS: TDataSet;  const DataSetName: WideString): Boolean;
function PostOrCancelDataSetWhenNeeded (DS: TDataSet): Boolean;
function PostCDataSetWhenNeeded (DS: TDataSet;  const DataSetName: WideString): Boolean;
function PostDataSetWhenNeeded (DS: TDataSet): Boolean;
function PostCDataSetWhenNeededAndClose (DS: TDataSet;  const DataSetName: WideString): Boolean;
function PostDataSetWhenNeededAndClose (DS: TDataSet): Boolean;
function DataSetClose(DS: TDataSet): Boolean;
function OnlyOpenDataSetWSCursor (DS: TDataSet): Boolean;
function OpenDataSetWLog (DS: TDataSet;  const TableName: WideString): Boolean;

type
  TDir = (tUp, TDown);
procedure RecordTowards (DS: TDataSet;  Dir: TDir);
procedure SetIntegerFieldMinMaxVFromField0DataSet (DS: TDataSet;  F: TIntegerField);
procedure SetFieldValidCharsFromField0DataSet (DS: TDataSet;  F: TField);
procedure AppendStructDescr (DSSource, DSWithStruct: TDataSet;  ForLink: Boolean);

function DataSetFromTxtF (D: TDataSet;  const FileName: WideString;
  IncCalcFields: Boolean): Boolean;
function DataSetFromClipboard (D: TDataSet; IncCalcFields: Boolean): Boolean;
function DataSetToTxtF (D: TDataSet;  const FileName: WideString;
  WithDelimChar, IncCalcFields, WithFieldNames: Boolean;  LastFieldN: Integer = -1): Boolean;
function DataSetToClipboard (D: TDataSet;
  WithDelimChar, IncCalcFields, WithFieldNames: Boolean): Boolean;
function DataSetColToTxtF (D: TDataSet;  const FileName: WideString;
  IncCalcFields: Boolean;  InterColSpacesNum: Byte;  WithFieldNames: Boolean): Boolean;
function DataSetColToClipboard (D: TDataSet;  IncCalcFields: Boolean;
  InterColSpacesNum: Byte;  WithFieldNames: Boolean): Boolean;

procedure CopyDataSetStructure (DSSource, DSTarget: TDataSet);
function SameDataSetStructure (DS1, DS2: TDataSet): Boolean;
function AddRecord (DSSource, DSTarget: TDataSet): Boolean;
function AddRecords (DSSource, DSTarget: TDataSet): Boolean;
var
  MaxDecimalPlaces: Byte = 6;
function PrepareDisplayDataSet (DS: TDataSet;  DecimalPlaces: Byte): Boolean;

function DataFieldsCount (D: TDataSet): Byte;
function FieldsCountFromRec (S: WideString): Byte;
function FieldsCountFromAscii (const FileName: WideString): Byte;
function StrToRec (D: TDataSet;  const FileName: WideString;  LineNum: Integer;
  IncCalcFields: Boolean;  const S: WideString): Boolean;
function StrFromFields2 (D: TDataSet;
  WithDelimChar, IncCalcFields: Boolean;
  const ExportFieldFormats: TExportFieldFormats;
  LastFieldN: Integer = -1): WideString;

function  BoolToCharsYesNoStr (B: Boolean): WideString;
function  BoolFromCharsYesNoStrFld (F: TStringField): Boolean;
procedure BoolToCharsYesNoStrFld (B: Boolean;  F: TStringField);
procedure CharsYesNoDBCheckBox (CB: TTntDBCheckBox);
procedure CharsYesNoDBRadioGroup (RG: TTntDBRadioGroup);
procedure WhenDSKeyViol (DS: TDataSet;  const Mess: WideString);

type
  TAsciiDSRestructure = class (TObject)
  protected
    S, STarget: WideString;
    procedure RestructureLine; virtual; abstract;
  public
    function Restructure (const FN: WideString): Boolean;
  end;

type
  TResFldToInc = (rftiOk, rftiConvertErr, rftiNotField);

implementation

uses
  Forms, Controls, TntClipBrd, Math, Windows,
  JvJCLUtils, TntJvJCLUtils,
  TntELog,
  TntFileUtil2, TntStrUtil0, TntStrAnal, TntMessUsual;

{--------------------------------------}
{-PUBLIC-----------}

constructor TExportFieldFormats.Create (const Section: WideString);
begin
  FSection := Section;
  BetweenColumnsSep := ' ';
  DateF := DefDateFormat(True);
  TimeF := ShortTimeFormat;
end {Create};

procedure TExportFieldFormats.LoadFromIniF (IniFile: TTntNewIniFile);
var
  S: Str3;
begin
  S := IniFile.ReadString
   (FSection, IdentBetweenColumnsSep, ' ;');
  Delete (S, Length(S), 1);
  if  S = ''
  then  S := #9;
  BetweenColumnsSep := S;
  TimeF := IniFile.ReadString
   (FSection, IdentTimeFormat, ShortTimeFormat);
end {LoadFromIniF};

procedure TExportFieldFormats.SaveToIniF (IniFile: TTntNewIniFile);
begin
  IniFile.WriteString
   (FSection, IdentBetweenColumnsSep, BetweenColumnsSep + ';');
  IniFile.WriteString
   (FSection, IdentTimeFormat, TimeF);
end {SaveToIniF};

{--------------------------------------}
{-PUBLIC-----------}

constructor TFieldsToExport.Create (D: TDataSet;  const FieldsSelected: string;
  const ExportFieldFormats: TExportFieldFormats);
var
  I, Count: Byte;
  FS, DL: WideString;
begin
  FD := D;
  FExportFieldFormats := ExportFieldFormats;
  MaxCount := CountOfChar (';', FieldsSelected) + 1;
  GetMem (Arr, MaxCount*2);
  FillChar (Arr^, MaxCount*2, 0);
  Count := 0;
  FS := FieldsSelected;
  while  FS <> ''  do  begin
    DL := StrUntilDelimiterW (FS, ';');
    with FD do
      for  I := 0 to FieldCount - 1  do
        if  DL = Fields[I].FieldName  then  begin
          Arr^[Count].Index := I;
          Break;
        end;
    Inc (Count);
  end;
end {Create};

procedure TFieldsToExport.CalculateWidth;
var
  I: Byte;
begin
  if  MaxCount = 0
  then  Exit
  else if  (MaxCount = 1) and (FD.Fields[Arr^[0].Index].DataType = ftString)
  then  Exit
  else
    for  I := 0 to MaxCount-1  do
      Arr^[I].Width := Max (
        Arr^[I].Width,
        WidthFromField (FD.Fields[Arr^[I].Index], FExportFieldFormats));
end {CalculateWidth};

destructor TFieldsToExport.Destroy;
begin
  FreeMem (Arr, MaxCount*2);
  inherited;
end {Destroy};

{--------------------------------------}

function PostDataSet (DS: TDataSet): Boolean;
begin
  if  PostDataSetIsNeeded (DS)  then  begin
    try
      DS.Post;
      Result := True;
    finally
    end;
  end
  else
    Result := True;
end {PostDataSet};

function PostDataSetIsNeeded (DS: TDataSet): Boolean;
begin
  Result := (DS.Modified) or (DS.State in [dsEdit, dsInsert]);
end {PostDataSetIsNeeded};

function PostedDataSetMinR (DS: TDataSet;  MinRecCount: Word;  const DataSetName: WideString): Boolean;
var
  Ok: Boolean;
begin
  Ok := PostDataSet (DS);
  if  Ok and (MinRecCount <> 0) and (DS.RecordCount < MinRecCount)  then  begin
    WideMessageBoxError (WideFormat (RS_DataSetU_FewRecords, [DS.RecordCount, MinRecCount, DataSetName]));
    Ok := False;
  end;
  Result := Ok;
end {PostedDataSetMinR};

function DataSetPerhapsCancel (DS: TDataSet;  Ok: Boolean;  const DataSetName: WideString): Boolean;
begin
  if  not Ok  then  begin
    if  WideUserSayYes (RS_DataSetU_CancelRec + DataSetName + RS_DataSetU_Ch)  then  begin
      DS.Cancel;
      Ok := True;
    end;
  end;
  Result := Ok;
end {DataSetPerhapsCancel};

function PostOrCancelCDataSetWhenNeeded (DS: TDataSet;  const DataSetName: WideString): Boolean;
var
  Ok: Boolean;
begin
  Result := True;
  if  PostDataSetIsNeeded (DS)  then  begin
    if  not WideUserSayYes(RS_DataSetU_SaveRecCh)
    then
      DS.Cancel
    else  begin
      Ok := False;
      try
        DS.Post;
        Ok := True;
      finally
        Result := DataSetPerhapsCancel (DS, Ok, DataSetName);
      end;
    end;
  end;
end {PostOrCancelCDataSetWhenNeeded};

function PostOrCancelDataSetWhenNeeded (DS: TDataSet): Boolean;
begin
  Result := PostOrCancelCDataSetWhenNeeded (DS, DS.Name);
end;

function PostCDataSetWhenNeeded (DS: TDataSet;  const DataSetName: WideString): Boolean;
var
  Ok: Boolean;
begin
  Result := True;
  if  PostDataSetIsNeeded (DS)  then  begin
    Ok := False;
    try
      DS.Post;
      Ok := True;
    finally
      Result := DataSetPerhapsCancel (DS, Ok, DataSetName);
    end;
  end;
end {PostCDataSetWhenNeeded};

function PostDataSetWhenNeeded (DS: TDataSet): Boolean;
begin
  Result := PostCDataSetWhenNeeded (DS, DS.Name);
end;

function PostCDataSetWhenNeededAndClose (DS: TDataSet;  const DataSetName: WideString): Boolean;
var
  Ok: Boolean;
begin
  Ok := PostCDataSetWhenNeeded (DS, DataSetName);
  if  Ok
  then  Ok := DataSetClose (DS);
  Result := Ok;
end {PostCDataSetWhenNeededAndClose};

function PostDataSetWhenNeededAndClose (DS: TDataSet): Boolean;
begin
  Result := PostCDataSetWhenNeededAndClose (DS, DS.Name);
end;

function DataSetClose (DS: TDataSet): Boolean;
begin
  try
    DS.Close;
    Result := True;
  finally
  end;
end {DataSetClose};

function OnlyOpenDataSetWSCursor (DS: TDataSet): Boolean;
begin
  with DS do
    try
      Screen.Cursor := crHourGlass;
      if not Active
      then  Open;
      Result := True;
    finally
      Screen.Cursor := crDefault;
    end;
end {OnlyOpenDataSetWSCursor};

function OpenDataSetWLog (DS: TDataSet;  const TableName: WideString): Boolean;
begin
  with DS do
    try
      if not Active
      then  Open;
      Result := True;
    finally
      if not Active then  begin
        if  WideUserSayYes (WideFormat (RS_DSU_TableNotOpen,[TableName]))
        then  Log.CriticalError := True; {Program break down}
      end;
    end;
end {OpenDataSetWLog};

procedure RecordTowards (DS: TDataSet;  Dir: TDir);
{only use if:
  not exists PrimaryKey and
  ((not exists SecundaryIndexes) or
   (exists SecundaryIndexes and (DS.IndexName = '')))
  and not contains blob fields}
var
  Arr: Variant;
  I: Byte;
  IsLast: Boolean;
begin
  with DS do  begin
    DS.DisableControls;
    if  Dir = tUp  then  begin
      Prior;
      if Bof then  begin
        DS.EnableControls;
        Exit;
      end;
      Next;
      if Eof then  begin
        IsLast := True;
      end
      else  begin
        Next;
        IsLast := Eof;
        if  not IsLast
        then  Prior;
      end;
    end
    else {if  Dir = TDown  then}  begin
      IsLast := False; {for not Warning compiler message}
      Next;
      if Eof then  begin
        DS.EnableControls;
        Exit;
      end;
      Prior;
    end;
    Arr := VarArrayCreate ([0, DS.FieldCount-1], varVariant);
    for  I := 0 to DS.FieldCount-1  do
      if  DS.Fields[I].FieldKind in [fkData, fkLookup]
      then  Arr[I] := DS.Fields[I].AsVariant;
    Delete;
    if  Dir = tUp  then  begin
      if  not IsLast
      then  Prior;
      Insert;
    end
    else {if  Dir = TDown  then}  begin
      Next;
      if  not Eof
      then  Prior;
      if Eof
      then
        Append
      else  begin
        Next;
        Insert;
      end;
    end;
    for  I := 0 to DS.FieldCount-1  do
      if  DS.Fields[I].FieldKind in [fkData, fkLookup]
      then  DS.Fields[I].AsVariant := Arr[I];
    DS.Post;
    DS.EnableControls;
  end;
end {RecordTowards};

procedure SetIntegerFieldMinMaxVFromField0DataSet (DS: TDataSet;  F: TIntegerField);
begin
  with DS do
    try
      First;
      F.MinValue := Fields[0].AsInteger;
      Last;
      F.MaxValue := Fields[0].AsInteger;
    finally
    end;
end {SetIntegerFieldMinMaxVFromField0DataSet};

procedure SetFieldValidCharsFromField0DataSet (DS: TDataSet;  F: TField);
var
  S: string;
  C: Char;
  FC: TFieldChars;
procedure SetCh;
var
  I: Byte;
begin
  for I := 1 to Length(S) do  begin
    C := S[I];
    FC := FC + [C];
  end;
end;
begin
  FC := [];
  with DS do  
    try
      First;
      while not EOF  do  begin
        S := Fields[0].AsString;
        SetCh;
        S := LowerCase (S);
        SetCh;
        Next;
      end;
    finally
    end;
  F.ValidChars := FC;
end {SetFieldValidCharsFromField0DataSet};

procedure AppendStructDescr (DSSource, DSWithStruct: TDataSet;  ForLink: Boolean);
var
  I: Integer;
  C: Str1;
  FNC: string;
begin
  with DSSource do
    for I := 0 to FieldCount - 1 do  begin
      if  Fields[I].FieldKind = fkData  then  begin
        if  ForLink and not (Fields[I].DataType in [ftString, ftSmallint, ftInteger, ftWord,
          ftBoolean, ftFloat, ftCurrency, ftBCD, ftDate, ftTime, ftDateTime,
          ftBytes, ftVarBytes, ftAutoInc])
        then  begin
        end
        else  begin
          case Fields[I].DataType of
          ftUnknown: C := '';
          ftString: C := 'A';
          ftSmallint, ftInteger, ftWord: C := 'S';
          ftBoolean: C := 'L';
          ftFloat: C := 'N';
          ftCurrency: C := '$';
          ftBCD: C := '#';
          ftDate: C := 'D';
          ftTime: C := 'T';
          ftDateTime: C := '@';
          ftBytes, ftVarBytes: C := 'Y';
          ftAutoInc: C := '+';
          ftBlob: C := 'B';
          ftMemo: C := 'M';
          ftGraphic: C := 'G';
          ftFmtMemo: C := 'F';
          ftParadoxOle, ftDBaseOle: C := 'O';
          ftTypedBinary: C := 'B';
          ftCursor: C := '';
          end;
          FNC := StrReplaceUnderscoreToSpaceCharW (Fields[I].FieldName);
          if  Fields[I].DataType = ftString
          then  DSWithStruct.AppendRecord ([FNC, I, C, Fields[I].DataSize-1])
          else  DSWithStruct.AppendRecord ([FNC, I, C]);
        end;
      end;
    end;
end {AppendStructDescr};

{--------------------------------------}

function FieldToInclude (const SAux: WideString;  D: TDataset;  Num: Byte;
  IncCalcFields: Boolean): TResFldToInc;
var
  F: TField;
  WS: WideString;
begin
  if  D.Fields.Count = Num  then  begin
    Result := rftiNotField;
    Exit;
  end;
  Result := rftiOk;
  F := D.Fields[Num];
  if
   (F.DataType in
    [ftString, ftWideString, ftBoolean, ftSmallint, ftInteger, ftWord, ftFloat, ftAutoInc,
     ftDate, ftDateTime, ftTime]) and
   (SAux <> '') and
   (IncCalcFields or
    ((not IncCalcFields) and not(F.Calculated)))
  then  begin
    if  F.DataType = ftBoolean  then  begin
      if  SAux = '1'
      then  TBooleanField(F).AsBoolean := True
      else if  SAux = '0'
      then  TBooleanField(F).AsBoolean := False
      else  begin
        Result := rftiConvertErr;
        Exit;
      end;
    end
    else if  F.DataType = ftWideString  then  begin
      WS := UTF8Decode (SAux);
      TWideStringField(F).AsVariant := WS;
      Result := rftiOk;
    end
    else  begin
      try
        F.AsString := SAux;
        Result := rftiOk;
      except
        Result := rftiConvertErr;
      end;
    end;
  end;
end {FieldToInclude};

function ResRewAppTF00 (var T: TextFile;  const FileName: WideString;
  OnlyExt: Boolean;  Mode: TRRATFMode): Boolean;
var
  S: WideString;
begin
  if  FileName = ''  then  begin
    Result := False;
    Exit;
  end;
  if  (Mode = rratfReset) or
    (((Mode = rratfRewrite) or (Mode = rratfAppend)) and FileExistsSetNotReadOnlyMessW (FileName))
  then  begin
    System.Assign (T, FileName);
    {$I-}
    case Mode of
    rratfReset: Reset (T);
    rratfRewrite: Rewrite (T);
    rratfAppend: Append (T);
    end;
    {$I+}
    if  IOResult <> 0  then  begin
      case Mode of
      rratfReset:   S := RS_DataSetU_ReadError;
      rratfRewrite: S := RS_DataSetU_WriteError;
      rratfAppend:  S := RS_DataSetU_AppendError;
      end;
      if OnlyExt
      then  WideMessageBoxError (WideFormat (S, ['*'+WideExtractFileExt(FileName)])) {hides filename}
      else  WideMessageBoxError (WideFormat (S, [FileName]));
      Result := False;
    end
    else
      Result := True;
  end
  else
    Result := False;
end {ResRewAppTF00};

function ResRewAppTF0 (var T: TextFile;  const FileName: WideString;
  Mode: TRRATFMode): Boolean;
begin
  Result := ResRewAppTF00 (T, FileName, False, Mode);
end {ResRewAppTF0};

function ResRewAppTF (D: TDataSet;  var T: TextFile;  const FileName: WideString;
  Mode: TRRATFMode): Boolean;
begin
  if  not D.Active  then  begin
    WideMessageBoxError (WideFormat(RS_DataSetU_DataBaseNotActive, [D.Name]));
    Result := False;
    Exit;
  end;
  Result := ResRewAppTF0 (T, FileName, Mode);
end {ResRewAppTF};

function DataFieldsCount (D: TDataSet): Byte;
var
  I, Res: Byte;
begin
  Res := 0;
  for  I := 0 to D.FieldCount-1  do
    if  D.Fields[I].FieldKind <> fkCalculated
    then  Inc (Res);
  Result := Res;
end {DataFieldsCount};

function FieldsCountFromRec (S: WideString): Byte;
begin
  Result := CountOfCharW (FieldsSepChar, S) + 1;
end {FieldsCountFromRec};

function FieldsCountFromAscii (const FileName: WideString): Byte;
var
  S: WideString;
  T: TextFile;
begin
  Result := 0;
  if  not ResRewAppTF0 (T, FileName, rratfReset)
  then  Exit;
  try
    if  not System.EOF(T)  then  begin
      ReadLn (T, S);
      Result := FieldsCountFromRec (S);
    end;
  finally
    CloseFile (T);
  end;
end {FieldsCountFromAscii};

function StrToRec (D: TDataSet;  const FileName: WideString;  LineNum: Integer;
  IncCalcFields: Boolean;  const S: WideString): Boolean;
var
  NField, Posic: Integer;
  SS, SAux: WideString;
  RTFI: TResFldToInc;
begin
  SS := S;
  with D do  begin
    NField := 0;
    while  SS <> ''  do  begin
      if  SS[1] = TextFieldsDelimChar  then  begin
        System.Delete (SS, 1, 1);
        Posic := Pos (TextFieldsDelimChar, SS);
        SAux := Copy (SS, 1, Posic-1);
        SS := Copy (SS, Posic+2, Length(SS)-Posic);
      end
      else  begin
        Posic := Pos (FieldsSepChar, SS);
        if  Posic <> 0  then  begin
          SAux := Copy (SS, 1, Posic-1);
          SS := Copy (SS, Posic+1, Length(SS)-Posic);
        end
        else  begin
          SAux := SS;
          SS := '';
        end;
      end;
      if  NField = 0  then  begin
        try
          D.Append;
        finally
        end
      end;
      RTFI := FieldToInclude (SAux, D, NField, IncCalcFields);
      if  RTFI = rftiOk   then  begin
        Inc (NField);
      end
      else  begin
        if  RTFI = rftiConvertErr
        then  SS := WideFormat (RS_DataSetU_ConversionError1, [NField+1, SAux, LineNum])
        else  SS := WideFormat (RS_DataSetU_NotField, [NField+1, LineNum, S]);
        if  FileName <> ''
        then  SS := Concat (SS, WideFormat (Concat (sLineBreak, RS_DataSetU_ConversionError2, sLineBreak, '%s'), [FileName]));
        WideMessageBoxError (SS);
        Result := False;
        Exit;
      end;
    end;
    try
      if  State = dsBrowse  then  begin
        {Append a record with only 1 data field and its contain is null}
        try
          D.Append;
        finally
        end
      end;
      Post;
      Result := True;
    finally
    end;
  end;
end {StrToRec};

function DataSetFromTxtF (D: TDataSet;  const FileName: WideString;
  IncCalcFields: Boolean): Boolean;
var
  S: WideString;
  T: TextFile;
  Ok: Boolean;
  LineNum: Integer;
begin
  Result := False;
  if  not ResRewAppTF (D, T, FileName, rratfReset)
  then  Exit;
  with D do  begin
    Screen.Cursor := crHourGlass;
    DisableControls;
    Ok := True;
    LineNum := 0;
    try
      while  not System.EOF(T)  do  begin
        Ok := False;
        ReadLn (T, S);
        Inc (LineNum);
        Ok := StrToRec (D, FileName, LineNum, IncCalcFields, S);
        if not Ok
        then  Break;
      end;
      if Ok
      then  First;
    finally
      Result := Ok;
      EnableControls;
      CloseFile (T);
      Screen.Cursor := crDefault;
    end;
  end;
end {DataSetFromTxtF};

function DataSetFromClipboard (D: TDataSet;  IncCalcFields: Boolean): Boolean;
var
  S, SAux: WideString;
  Posic: Integer;
  Ok: Boolean;
  LineNum: Integer;
begin
  S := TntClipboard.AsText;
  with D do  begin
    Screen.Cursor := crHourGlass;
    DisableControls;
    try
      Ok := False;
      LineNum := 0;
      while  S <> ''  do  begin
        Posic := Pos (sLineBreak, S);
        if  Posic <> 0  then  begin
          SAux := Copy (S, 1, Posic-1);
          Inc (LineNum);
          S := Copy (S, Posic+2, Length(S)-(Posic+1));
        end
        else  begin
          SAux := S;
          S := '';
        end;
        Ok := StrToRec (D, '', LineNum, IncCalcFields, SAux);
        if not Ok
        then  Break;
      end;
      Result := Ok;
    finally
      EnableControls;
      Screen.Cursor := crDefault;
    end;
  end;
end {DataSetFromClipboard};

function StrFromField (F: TField;  WithDelimChar: Boolean;
  const ExportFieldFormats: TExportFieldFormats): WideString;
var
  S: string;
  S1: WideString;
  WS: WideString;
  DT: TDateTime;
begin
  if  F.IsNull
  then  S1 := ''
  else begin
    if  F.DataType = ftString  then  begin
      S1 := F.AsString;
      if WithDelimChar
      then  S1 := Concat (TextFieldsDelimChar, S1, TextFieldsDelimChar);
    end
    else if  F.DataType = ftWideString  then  begin
      WS := F.AsVariant;
      S1 := UTF8Encode (WS);
      if WithDelimChar
      then  S1 := Concat (TextFieldsDelimChar, S1, TextFieldsDelimChar);
    end
    else if  F.DataType in [ftSmallint, ftInteger, ftWord, ftAutoInc]
    then  S1 := F.AsString
    else if  F.DataType = ftFloat
    then  S1 := FormatFloat (TFloatField(F).DisplayFormat, F.AsFloat)
    else if  F.DataType = ftDate
    then  S1 := FormatDateTime (ExportFieldFormats.DateF, F.AsDateTime)
    else if  F.DataType = ftDateTime  then  begin
      DT := F.AsDateTime;
      if  DT <= 1
      then  S1 := FormatDateTime (ExportFieldFormats.TimeF, DT)
      else  S1 := FormatDateTime (Concat (ExportFieldFormats.DateF, ' ', ExportFieldFormats.TimeF), DT);
    end
    else if  F.DataType = ftTime  then  begin
      DateTimeToString (S, LongTimeFormat, F.AsDateTime);
      S1 := S;
    end
    else if  F.DataType = ftBoolean  then  begin
      {or S1 := F.AsString}
      if  TBooleanField(F).AsBoolean
      then  S1 := '1'
      else  S1 := '0';
    end
    else  S1 := '';
  end;
  Result := S1;
end {StrFromField};

function StrFromFields (D: TDataSet;
  const ExportFieldFormats: TExportFieldFormats): WideString;
var
  I: Integer;
  S1, S2: WideString;
begin
  S1 := '';
  for  I := 0 to D.FieldCount-1  do  begin
    S2 := StrFromField (D.Fields[I], True, ExportFieldFormats);
    if  I = 0
    then  S1 := S2
    else  S1 := Concat (S1, FieldsSepChar, S2);
  end;
  Result := S1;
end {StrFromFields};

function DelimitedStrFromSelectedFields (D: TDataSet;
  const ExportFieldFormats: TExportFieldFormats;
  FieldsToExport: TFieldsToExport): WideString;
var
  I: Byte;
  S1, S2: WideString;
begin
  S1 := '';
  for  I := 0 to FieldsToExport.MaxCount-1  do  begin
    S2 := StrFromField (D.Fields[FieldsToExport.Arr^[I].Index], True, ExportFieldFormats);
    if  I = 0
    then  S1 := S2
    else  S1 := Concat (S1, FieldsSepChar, S2);
  end;
  Result := S1;
end {DelimitedStrFromSelectedFields};

function ColumnizedStrFromSelectedFieldNames (D: TDataSet;
  const ExportFieldFormats: TExportFieldFormats;
  FieldsToExport: TFieldsToExport): WideString;
var
  I: Byte;
  S1, S2: string;
  Field: TField;
begin
  S1 := '';
  for  I := 0 to FieldsToExport.MaxCount-1  do
    if  FieldsToExport.Arr^[I].Width <> 0  then  begin
      Field := D.Fields[FieldsToExport.Arr^[I].Index];
      S2 := Field.FieldName;
      if  ExportFieldFormats.BetweenColumnsSep <> #9  then  begin
        S2 := WideRightStr (S2, FieldsToExport.Arr^[I].Width);
      end;
      S1 := ConcatWithStrW (S1, S2, ExportFieldFormats.BetweenColumnsSep);
    end;
  Result := S1;
end {ColumnizedStrFromSelectedFieldNames};

function StrFromFieldNames (D: TDataSet;
  IncCalcFields: Boolean): WideString;
var
  I: Integer;
  S1: string;
begin
  S1 := '';
  with D do
    for  I := 0 to FieldCount-1  do  begin
      if  IncCalcFields or ((not IncCalcFields) and not(Fields[I].Calculated))  then  begin
        S1 := ConcatWithStrW (S1, D.Fields[I].FieldName, FieldsSepChar);
      end;
    end;
  Result := S1;
end {StrFromFieldNames};

function StrFromFields2 (D: TDataSet;
  WithDelimChar, IncCalcFields: Boolean;
  const ExportFieldFormats: TExportFieldFormats;
  LastFieldN: Integer = -1): WideString;
var
  SL: WideString;
  LFN: Byte;
  I: Integer;
  S: WideString;
begin
  SL := '';
  if  LastFieldN = -1
  then  LFN := D.FieldCount-1
  else  LFN := LastFieldN;
  with D do
    for  I := 0 to LFN  do  begin
      if  IncCalcFields or ((not IncCalcFields) and not(Fields[I].Calculated))  then  begin
        S := StrFromField (Fields[I], WithDelimChar, ExportFieldFormats);
        if  I = 0
        then  SL := S
        else  SL := Concat (SL, FieldsSepChar, S);
      end;
    end;
  Result := SL;
end {StrFromFields2};

function ColumnizedStrFromSelectedFields (D: TDataSet;
  const ExportFieldFormats: TExportFieldFormats;
  FieldsToExport: TFieldsToExport): WideString;
var
  I: Byte;
  S1, S2: WideString;
  Field: TField;
begin
  S1 := '';
  for  I := 0 to FieldsToExport.MaxCount-1  do
    if  FieldsToExport.Arr^[I].Width <> 0  then  begin
      Field := D.Fields[FieldsToExport.Arr^[I].Index];
      S2 := StrFromField (Field, False, ExportFieldFormats);
      if  ExportFieldFormats.BetweenColumnsSep <> #9  then  begin
        if  Field.DataType = ftString  then  begin
          if  I <> FieldsToExport.MaxCount-1
          then  S2 := WideLeftStr (S2, FieldsToExport.Arr^[I].Width)
        end
        else
          S2 := WideRightStr (S2, FieldsToExport.Arr^[I].Width);
      end;
      S1 := ConcatWithStrW (S1, S2, ExportFieldFormats.BetweenColumnsSep);
    end;
  Result := S1;
end {ColumnizedStrFromSelectedFields};

function ColumsStrFromFields (D: TDataSet;  FieldsColumnWidth: array of Byte): WideString;
var
  I: Integer;
  S1, S2: WideString;
begin
  S1 := '';
  for  I := 0 to D.FieldCount-1  do
    if  FieldsColumnWidth[I] <> 0  then  begin
      S2 := D.Fields[I].AsString;
      if  D.Fields[I].DataType = ftString
      then  S2 := WideLeftStr (S2, FieldsColumnWidth[I])
      else  S2 := WideRightStr (S2, FieldsColumnWidth[I]);
      if  I = 0
      then  S1 := S2
      else  S1 := Concat (S1, ' ', S2);
    end;
  Result := S1;
end {ColumsStrFromFields};

function WidthFromField (F: TField;
  const ExportFieldFormats: TExportFieldFormats): Byte;
var
  DT: TDateTime;
begin
  if  F.IsNull
  then  Result := 0
  else begin
    if  F.DataType in [ftString, ftSmallint, ftInteger, ftWord, ftAutoInc]
    then  Result := Length (F.AsString)
    else if  F.DataType = ftFloat
    then  Result := Length (FormatFloat (TFloatField(F).DisplayFormat, F.AsFloat))
    else if  F.DataType = ftDate
    then  Result := Length (TDateField(F).DisplayFormat)
    else if  F.DataType = ftDate
    then  Result := Length (FormatDateTime (ExportFieldFormats.DateF, F.AsDateTime))
    else if  F.DataType = ftDateTime  then  begin
      DT := F.AsDateTime;
      if  DT <= 1
      then  Result := Length (FormatDateTime (ExportFieldFormats.TimeF, DT))
      else  Result := Length (FormatDateTime (Concat (ExportFieldFormats.DateF, ' ', ExportFieldFormats.TimeF), DT));
    end
    else if  F.DataType = ftBoolean
    then  Result := 1
    else  Result := 0;
  end;
end {WidthFromField};

function DataSetToTxtF (D: TDataSet;  const FileName: WideString;
  WithDelimChar, IncCalcFields, WithFieldNames: Boolean;  LastFieldN: Integer = -1): Boolean;
var
  BM: TBookmark;
  T: TextFile;
  ExportFieldFormats: TExportFieldFormats;
begin
  Result := False;
  if  not ResRewAppTF (D, T, FileName, rratfRewrite)
  then  Exit;
  ExportFieldFormats := TExportFieldFormats.Create ('');
  with D do  begin
    Screen.Cursor := crHourGlass;
    DisableControls;
    BM := GetBookmark;
    if  WithFieldNames
    then  WriteLn (T, StrFromFieldNames(D, IncCalcFields));
    try
      First;
      while not EOF  do  begin
        WriteLn (T, StrFromFields2 (D, WithDelimChar, IncCalcFields, ExportFieldFormats, LastFieldN));
        Next;
      end;
      GotoBookmark (BM);
      Result := True;
    finally
      EnableControls;
      FreeBookmark (BM);
      CloseFile (T);
      Screen.Cursor := crDefault;
      ExportFieldFormats.Free;
    end;
  end;
end {DataSetToTxtF};

function DataSetToClipboard (D: TDataSet;
  WithDelimChar, IncCalcFields, WithFieldNames: Boolean): Boolean;
var
  S: WideString;
  BM: TBookmark;
  ExportFieldFormats: TExportFieldFormats;
begin
  S := '';
  ExportFieldFormats := TExportFieldFormats.Create ('');
  with D do  begin
    Screen.Cursor := crHourGlass;
    DisableControls;
    BM := GetBookmark;
    if  WithFieldNames
    then  S := Concat (StrFromFieldNames(D, IncCalcFields), sLineBreak);
    try
      First;
      while not EOF  do  begin
        S := Concat (S, StrFromFields2 (D, WithDelimChar, IncCalcFields, ExportFieldFormats), sLineBreak);
        Next;
      end;
      GotoBookmark (BM);
      Result := True;
    finally
      EnableControls;
      FreeBookmark (BM);
      TntClipboard.AsText := S;
      Screen.Cursor := crDefault;
      ExportFieldFormats.Free;
    end;
  end;
end {DataSetToClipboard};

function AllExportFieldsStr (D: TDataSet): WideString;
var
  I: Byte;
begin
  Result := '';
  for  I := 0 to D.FieldCount-1  do  begin
    Result := Concat (Result, D.Fields[I].FieldName);
    if  I < D.FieldCount-1
    then  Result := Concat (Result, ';');
  end;
end {AllExportFieldsStr};

procedure SetBetweenColumnsSep (ExportFieldFormats: TExportFieldFormats;
 InterColSpacesNum: Byte);
begin
  if  InterColSpacesNum = 1
  then  ExportFieldFormats.BetweenColumnsSep := ' '
  else  ExportFieldFormats.BetweenColumnsSep := '  ';
end {SetBetweenColumnsSep};

function DataSetColToTxtF (D: TDataSet;  const FileName: WideString;
  IncCalcFields: Boolean;  InterColSpacesNum: Byte;  WithFieldNames: Boolean): Boolean;
var
  T: TextFile;
  BM: TBookmark;
  FieldsToExport: TFieldsToExport;
  ExportFieldFormats: TExportFieldFormats;
begin
  Result := False;
  if  not ResRewAppTF (D, T, FileName, rratfRewrite)
  then  Exit;
  ExportFieldFormats := TExportFieldFormats.Create ('');
  SetBetweenColumnsSep (ExportFieldFormats, InterColSpacesNum);
  FieldsToExport := TFieldsToExport.Create (D, AllExportFieldsStr(D), ExportFieldFormats);
  with D do  begin
    Screen.Cursor := crHourGlass;
    DisableControls;
    BM := GetBookmark;
    try
      with D do  begin
        First;
        while not EOF  do  begin
          FieldsToExport.CalculateWidth;
          Next;
        end;
        if  WithFieldNames
        then  WriteLn (T, ColumnizedStrFromSelectedFieldNames(D, ExportFieldFormats, FieldsToExport));
        First;
        while not EOF  do  begin
          WriteLn (T, ColumnizedStrFromSelectedFields(D, ExportFieldFormats, FieldsToExport));
          Next;
        end;
        GotoBookmark (BM);
        Result := True;
      end;
    finally
      EnableControls;
      FreeBookmark (BM);
      Screen.Cursor := crDefault;
      FieldsToExport.Free;
      CloseFile (T);
      ExportFieldFormats.Free;
    end;
  end;
end {DataSetColToTxtF};

function DataSetColToClipboard (D: TDataSet;  IncCalcFields: Boolean;
  InterColSpacesNum: Byte;  WithFieldNames: Boolean): Boolean;
var
  S: WideString;
  BM: TBookmark;
  FieldsToExport: TFieldsToExport;
  ExportFieldFormats: TExportFieldFormats;
begin
  S := '';
  ExportFieldFormats := TExportFieldFormats.Create ('');
  SetBetweenColumnsSep (ExportFieldFormats, InterColSpacesNum);
  FieldsToExport := TFieldsToExport.Create (D, AllExportFieldsStr(D), ExportFieldFormats);
  with D do  begin
    Screen.Cursor := crHourGlass;
    DisableControls;
    BM := GetBookmark;
    try
      Result := False;
      with D do  begin
        First;
        while not EOF  do  begin
          FieldsToExport.CalculateWidth;
          Next;
        end;
        if  WithFieldNames
        then  S := Concat (S, ColumnizedStrFromSelectedFieldNames(D, ExportFieldFormats, FieldsToExport), sLineBreak);
        First;
        while not EOF  do  begin
          S := Concat (S, ColumnizedStrFromSelectedFields(D, ExportFieldFormats, FieldsToExport), sLineBreak);
          Next;
        end;
        GotoBookmark (BM);
      end;
      Result := True;
    finally
      EnableControls;
      FreeBookmark (BM);
      Screen.Cursor := crDefault;
      FieldsToExport.Free;
      TntClipboard.AsText := S;
      ExportFieldFormats.Free;
    end;
  end;
end {DataSetColToClipboard};

procedure CopyDataSetStructure (DSSource, DSTarget: TDataSet);
var
  I: Byte;
begin
  with DSTarget do
    with FieldDefs do begin
      Clear;
      for  I := 0 to DSSource.FieldCount-1  do
        with AddFieldDef do begin
          Name := DSSource.Fields[I].FieldName;
          DataType := DSSource.Fields[I].DataType;
          if  (DataType = ftString) or (DataType = ftWideString) 
          then  Size := DSSource.Fields[I].Size;
        end;
    end;
end {CopyDataSetStructure};

function SameDataSetStructure (DS1, DS2: TDataSet): Boolean;
var
  I: Byte;
begin
  Result := True;
  if  DS1.FieldCount <> DS2.FieldCount  then  begin
    WideMessageBoxWarning (WideFormat (RS_DataSetU_DifferentFieldCount, [DS1.FieldCount, DS2.FieldCount]));
    Result := False;
  end
  else  begin
    for  I := 0 to DS1.FieldCount-1  do  begin
      if  DS1.Fields[I].DataType <> DS2.Fields[I].DataType  then  begin
        WideMessageBoxWarning (WideFormat (RS_DataSetU_DifferentFieldDataType, [DS1.Fields[I].FieldName, DS2.Fields[I].FieldName]));
        Result := False;
        Break;
      end;
    end;
  end;
end {SameDataSetStructure};

function AddRecord (DSSource, DSTarget: TDataSet): Boolean;
var
  I: Byte;
begin
  try
    with DSSource do  begin
      DSTarget.Append;
      for  I := 0 to DSSource.FieldCount-1  do
        if  not DSSource.Fields[I].IsNull
        then  DSTarget.Fields[I].AsVariant := DSSource.Fields[I].AsVariant;
      DSTarget.Post;
    end;
    Result := True;
  finally
  end;                      
end {AddRecord};

function AddRecords (DSSource, DSTarget: TDataSet): Boolean;
begin
  Result := False;
  try
    with DSSource do  begin
      First;
      while not Eof do  begin
        if  not AddRecord (DSSource, DSTarget)
        then  Exit;
        Next;
      end;
    end;
    Result := True;
  finally
  end;
end {AddRecords};

function PrepareDisplayDataSet (DS: TDataSet;  DecimalPlaces: Byte): Boolean;
const
  MaxRealSpaces = 12;
var
  BM: TBookmark;
  I: Integer;
  N: Integer;
  D: Double;
  E, Decim: SmallInt;
  S: WideString;
begin
  if  DS.RecordCount = 0  then  begin
    for  I := 0 to DS.FieldCount-1  do
      DS.Fields[I].DisplayWidth := 1;
    Result := True;
  end
  else  begin
    Screen.Cursor := crHourGlass;
    with DS do  begin
      DisableControls;
      BM := GetBookmark;
    end;
    try
      with DS do  begin
        for  I := 0 to DS.FieldCount-1  do  begin
          First;
          while  not EOF  do  begin
            N := 0;
            D := 0;
            while  not DS.EOF  do  begin
              if  not Fields[I].IsNull  then
                case  Fields[I].DataType  of
                ftSmallint, ftInteger, ftWord, ftAutoInc:
                    N := Max (N, Fields[I].AsInteger);
                ftFloat, ftCurrency:
                    D := Max (D, Fields[I].AsFloat);
                ftString:
                    N := Max (N, Length (Fields[I].AsString));
                end;
              DS.Next;
            end;
            E := 0;  Decim := 0;
            case  Fields[I].DataType  of
            ftSmallint, ftInteger, ftWord, ftAutoInc:
                E := StrLenNum (N);
            ftFloat, ftCurrency:
              begin
                if  DecimalPlaces <> MaxDecimalPlaces  then  begin
                  Decim := 1;
                  E := StrLenReal (D, Decim);
                  if  E = 3  then  begin
                    E := 4;
                    Decim := 2;
                  end;
                  if  E > MaxRealSpaces  then  begin
                    Decim := 0;
                    Dec (E, 2);
                    if  E > MaxRealSpaces  then  begin
                      E := MaxRealSpaces;
                    end;
                  end;
                end;
                if  Decim = 0
                then  S := #0
                else  S := Concat ('#0.', MakeStr('0',Decim));
                TFloatField(Fields[I]).DisplayFormat := S;
              end;
            ftString:
                E := N;
            ftDate:
                E := 8;
            else
                E := 1;
            end;
            if  E = 0
            then  E := 1;
            Fields[I].DisplayWidth := E;
            Next;
          end;
        end;
      end;
      Result := True;
    finally
      with DS do  begin
        GotoBookmark (BM);
        EnableControls;
        FreeBookmark (BM);
      end;
    end;
    Screen.Cursor := crDefault;
  end;
end {PrepareDisplayDataSet};

function BoolToCharsYesNoStr (B: Boolean): WideString;
begin
  if  B
  then  Result := RS_CharYes
  else  Result := RS_CharNo;
end {BoolToCharsYesNoStr};

function BoolFromCharsYesNoStrFld (F: TStringField): Boolean;
begin
  if  F.AsString = RS_CharYes
  then  Result := True
  else  Result := False;
end {BoolFromCharsYesNoStrFld};

procedure BoolToCharsYesNoStrFld (B: Boolean;
  F: TStringField);
begin
  F.AsString := BoolToCharsYesNoStr (B);
end {BoolToCharsYesNoStrFld};

procedure CharsYesNoDBCheckBox (CB: TTntDBCheckBox);
begin
  CB.ValueChecked := RS_CharYes;
  CB.ValueUnchecked := RS_CharNo;
end {CharsYesNoDBCheckBox};

procedure CharsYesNoDBRadioGroup (RG: TTntDBRadioGroup);
begin
  with RG.Values do  begin
    Add (RS_CharYes);
    Add (RS_CharNo);
  end;
end {CharsYesNoDBRadioGroup};

procedure WhenDSKeyViol (DS: TDataSet;  const Mess: WideString);
var
  S1, S3: WideString;
begin
  if  DS.State = dsEdit
  then  S1 := RS_DataSetU_NoUpdate
  else  S1 := RS_DataSetU_NoAppend;
  if  DS.Filtered
  then  S3 := Concat ('.', sLineBreak, RS_DataSetU_ActivatedFilter)
  else  S3 := '';
  WideMessageBoxError (Concat (WideFormat (RS_DataSetU_NoAppendUpdateRec, [S1, Mess]), S3));
end {WhenDSKeyViol};

{--------------------------------------}
{-PUBLIC-----------}

function TAsciiDSRestructure.Restructure (const FN: WideString): Boolean;
var
  T, TT: TextFile;
  FNBak: WideString;
begin
  Result := False;
  FNBak := WideChangeFileExt (FN,'.bak');
  if  ResRewAppTF0 (T, FN, rratfReset) and ResRewAppTF0 (TT, FNBak, rratfRewrite)  then  begin
    while  not System.EOF(T)  do  begin
      ReadLn (T, S);
      STarget := '';
      RestructureLine;
      WriteLn (TT, STarget);
    end;
    CloseFile (T);
    CloseFile (TT);
    EraseFileW (FN);
    WideRenameFile (FNBak, FN);
    Result := True;
  end;
end {Restructure};

{--------------------------------------}

end.
