{---------------------------------------------------------------------

 Date and Time consts and functions  for exact date

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version

----------------------------------------------------------------------}

unit TntDateTime0;

interface

uses
  SysUtils, DateTimeA0, DateTime00;

resourcestring
  RS_DT_TimeItemsChars = 'ymwdh'; {year, month, week, day, hour}
  RS_Of = 'from';

function StrToAbsTimeW (const AbsVTimeStr: WideString;  out Res: Real): Boolean;
function  StrToAbsTimeAndMinATGW (const AbsVTimeStr: WideString;
  out MinATG: TAbsTimeGroup;  out Res: Real): Boolean;

implementation

uses
  TntJvJCLUtils,
  TntStrUtil0, TntStrAnal;

function StrToAbsTimeW (const AbsVTimeStr: WideString;  out Res: Real): Boolean;
{string To Absolute Time,
 converts '1y ' (1 year) to 365.25
 keeping in mind RS_DT_TimeItemsChars}
var
  MinATG: TAbsTimeGroup;
begin
  Result := StrToAbsTimeAndMinATGW (AbsVTimeStr, MinATG, Res);
end {StrToAbsTimeW};

function StrToAbsTimeAndMinATGW (const AbsVTimeStr: WideString;
  out MinATG: TAbsTimeGroup;  out Res: Real): Boolean;
{string To Absolute Time,
 converts '1y 1d' (1 year 1 day) to Res=366.25 and MinATG=atgDay}
var
  InStr: WideString;
  IsNeg: Boolean;
  I, J: Byte;
  N: Real;
  NumStr, TempStr, WS: WideString;
  Found: Boolean;
const
  SetOfNum = '0123456789';
begin
  MinATG := atgYear;
  Res := 0;
  if  AbsVTimeStr = ''  then  begin
    Result := False;
    Exit;
  end;
  InStr := AbsVTimeStr;
  Result := True;
  InStr := LowerCase (InStr);
  if  (Length (InStr) > 2) and (InStr[1] = '-')  then  begin
    if  InStr[2] = ' '  then  begin
      IsNeg := True;
      Delete (InStr, 1, 2);
    end
    else  begin
      Result := False;
      Exit;
    end;
  end
  else
    IsNeg := False;
  while  InStr <> ''  do  begin
    StrUntilDelimitersW (InStr, SetOfNum+DecimalSeparator);
    NumStr := StrUntilNoDelimitersW (InStr, SetOfNum+DecimalSeparator);
    TempStr := StrUntilDelimiterW (InStr, ' ');
    if  Length(TempStr) = 1  then  begin
      try
        N := StrToFloat (NumStr);
      except
        on EConvertError do begin
          Result := False;
          Exit;
        end;
      end;
      Found := False;
      J := TimeGroupNumber-1; {for no compiler Warning message}
      for  I := 0 to TimeGroupNumber-1  do  begin
        WS := RS_DT_TimeItemsChars;
        if  TempStr[1] = WS[I+1]  then  begin
          J := I;
          case I of
          0: MinATG := atgYear;
          1: MinATG := atgMonth;
          2: MinATG := atgWeek;
          3: MinATG := atgDay;
          end;
          Found := True;
          Break;
        end;
      end;
      if  not Found  then  begin
        Result := False;
        Exit;
      end;
      Res := Res + (N * TGCFArrToDays[J]);
    end
    else begin
      Result := False;
      Exit;
    end;
    InStr := WideDelBSpace (InStr);
  end;
  if IsNeg
  then  Res := Res * -1;
  if  Pos (DecimalSeparator, NumStr) <> 0  then  begin
    case MinATG of
    atgYear:  MinATG := atgMonth;
    atgMonth: MinATG := atgWeek;
    atgWeek:  MinATG := atgDay;
    end;
  end;
end {StrToAbsTimeAndMinATGW};

end.
