{---------------------------------------------------------------------

 Copyright (c) 1995 by Maggie Owens.

 Please send bug reports, suggestions & comments to mmowens@panix.com.
 Updates (if any) will also be avialable for download from:
   http://www.panix.com/~mmowens/

 Revision history:
   This is version 1.1, finished 7/25/96.
   Corrects the Vertical Orientation bug.
   Version 1.0 first released to the public June 10, 1996.

 If you would like to included on the update notification mailing list,
 please send email to mmowens@panix.com with "subscribe navigator" as
 the subject.
 I would also appreciate it if you send me your name if you use this
 navigator, so I can maintain a usage count.

 Revision history:
 This component was originally developed in early '95 by modifying a copy of
 Delphi 1.0's DBNavigator to correct the resource leak and add functionality:
 lookuphep, locate and locatenext buttons; direct access to the enabled /
 disabled state of the buttons, and the ability to override the state of any
 given button. This version of the navigator is in use in numerous production
 applications.
 The set bookmark, goto bookmark and clear bookmark buttons were added in
 early '96 for my Borland conference paper. The newer version navigator has
 been thoroughly tested and debugged, but has not yet been included in any
 production applications.

 Code that differs from the Delphi 1.0 DBNavigator has been marked with the
 comment "New".

 Special thanks to:
   Ed Jordan, for helping me solve the problem of more than 16 elements in
     the set of published properties, by providing sample code for the
     TmoNavBtnSwitches object.
   Bill Morgenthein, for the set bookmark, goto bookmark and clear bookmark
     bitmaps (My drawing abilities rate -1 on a scale of 1 to 10).
   Everyone at the Burgiss group, for using the navigator.
   My mother, Terry Winter Owens (http://www.panix.com/~twowens/)
     for her tireless help in editing my conference papers.
   Lizards, in general, for eating the bugs.

 DISCLAIMER: I have provided these components and source code to the public
 free of charge. You accept these components AS IS without any representation
 or warranty of any kind, including but not limited to the warranty of
 merchantability or fitness for a particular purpose. You may not sell these
 components
 
 Modified by
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version

----------------------------------------------------------------------}

unit TntDbNavNew0;
{$D+,L+}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, TntClasses, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, TntExtCtrls, Menus, TntStdCtrls, DB, Mask, Buttons, TntButtons,
  JvSpeedButton,
  TntJvComponent, TntJvSpeedButton, TntJvBitBtn,
  {JMNNew:} DbGrids, TntDbGrids, Dialogs0;

resourcestring
  RS_mnb_First = 'Goto first record';
  RS_mnb_Prior = 'Goto previous record';
  RS_mnb_Next = 'Goto next record';
  RS_mnb_Last = 'Goto last record';
  RS_mnb_AddInsert = 'Add a record, before current';
  RS_mnb_AddAppend = 'Add a record, at end';
  RS_mnb_Insert = 'Add a record';
  RS_mnb_Delete = 'Delete a record';
  RS_mnb_Edit = 'Edit the data';
  RS_mnb_Post = 'Accept the record modification';
  RS_mnb_Cancel = 'Cancel the record edition';
  RS_mnb_Refresh = 'Refresh the data visualization';
  RS_mnb_PriorSet = 'Goto current record -%d records';
  RS_mnb_NextSet = 'Goto current record +%d records';
  RS_mnb_LookupHelp = '';
  RS_mnb_Locate = 'Look for first record according to condition';
  RS_mnb_LocateNext = 'Look for the next one';
  RS_mnb_BkSet = 'Set a location point to this record';

  RS_CancelChangesQuestion = 'Cancel record changes?';
  RS_mnb_BkGoto = 'Goto point of previous assigned location';
  {RS_mnb_BkClear = 'Delete the localitation point';}
  RS_mnb_GotoLastRecMod = 'To the last modified record';
  RS_DefaultBookmarkMessage =
    'The point that it is trying to reach belongs to a database different from the current one';
   {Message to display if ShowBookmarkMessage is true and BookmarkMessage is blank.}
  RS_DbNavNew_RecordNotFound = 'Marked record not found, '+
    'it has been deleted or there is an(other) activated filter';
  RS_DbNavNew_NotFound = 'Not found';
  RS_DbNavNew_NotFilter = 'There is not any filter';
  RS_DbNavNew_NoOtherRecordFound = 'Another record not found';
  RS_DbNavNew_MaxSetMoveTooLow = 'MaxSetMove must be bigger than 2';
  RS_DbNavNew_SetMoveMarginError = 'SetMove has to be between 0 and %d';
   {Now is possible 0 for make nothing}
  RS_DbNavNew_Append = 'Add';

  {SLookupHelp = 50000;
  SLocate = 50001;
  SLocateNext = 50002;
  SBookmarkSet = 50003;
  SBookmarkClear = 50004;
  SBookmarkGoto = 50005;
  SPriorSet = 50006;
  SNextSet = 50007;}

const
  InitRepeatPause = 400;  { pause before repeat timer (ms) }
  RepeatPause     = 100;  { pause before hint window displays (ms)}
  SpaceSize       =  5;   { size of space between special buttons }

type
  TTntmoNavBtn = class;
  TTntNavDataLink = class;

  TNavGlyph = (ngEnabled, ngDisabled);
  {Note the new buttons below:
  mnbLookupHelp (Lookup Help),
  mnbLocate (Locate record),
  mnbLocateNext (Locate next record),
  mnbBkSet (Set Bookmark),
  mnbBkGoto (Go to bookmark),
  mnbBkClear (Clear Bookmark),
  mnbPriorSet (move back 10 record) and mnbNextSet (move forward 10 records).
  mnbLookupHelp, mnbLocate and mnbLocateNext are initially disabled.
  These three buttons require event-handling procedures in order to do anything.}
  TmoNavBtns = (
    mnbFirst, mnbPriorSet, mnbPrior, mnbNext, mnbNextSet, mnbLast,
    mnbLookupHelp, mnbLocate, mnbLocateNext,
    mnbBkSet, mnbBkGoto, {mnbBkClear,}
    mnbBkSetAcc, mnbBkGotoAcc, {New}
    mnbGotoLastRecMod,
    mnbAddInsert, mnbAddAppend, {New}
    mnbInsert, mnbDelete, mnbEdit, mnbPost, mnbCancel, mnbRefresh);
  TmoBtnSet = set of TmoNavBtns;
  TmoNavButtonStyle = set of (nsAllowTimer, nsFocusRect);
  ENavClick = procedure (Sender: TObject; Button: TmoNavBtns) of object;
  EReplaceNavClick = procedure (Sender: TObject; Button: TmoNavBtns; var Replaced: Boolean) of object; {New JMN}
  TmoNavOrientation = (noHorizontal, noVertical); {New}

  TmoGetBtn = function: TmoBtnSet of object; {New}
  TmoSetBtn = procedure(Value: TmoBtnSet) of object; {New}

  TmoNavBtnSwitches = class(TPersistent) {New}
  private
    GetBtn: TmoGetBtn;
    SetBtn: TmoSetBtn;
    function GetSwitch(Index: Integer): Boolean;
    procedure SetSwitch(Index: Integer; Value: Boolean);
  public
    constructor Create(AGetFunc: TmoGetBtn; ASetProc: TmoSetBtn);
  published
    property mnbFirst: Boolean index 0 read GetSwitch write SetSwitch default True;
    property mnbPriorSet: Boolean index 1 read GetSwitch write SetSwitch default True;
    property mnbPrior: Boolean index 2 read GetSwitch write SetSwitch default True;
    property mnbNext: Boolean index 3 read GetSwitch write SetSwitch default True;
    property mnbNextSet: Boolean index 4 read GetSwitch write SetSwitch default True;
    property mnbLast: Boolean index 5 read GetSwitch write SetSwitch default True;
    property mnbLookupHelp: Boolean index 6 read GetSwitch write SetSwitch default False;
    property mnbLocate: Boolean index 7 read GetSwitch write SetSwitch default False;
    property mnbLocateNext: Boolean index 8 read GetSwitch write SetSwitch default False;
    property mnbBkSet: Boolean index 9 read GetSwitch write SetSwitch default True;
    property mnbBkGoto: Boolean index 10 read GetSwitch write SetSwitch default True;
    property mnbBkSetAcc: Boolean index 11 read GetSwitch write SetSwitch default False;
    property mnbBkGotoAcc: Boolean index 12 read GetSwitch write SetSwitch default False;
    property {mnbBkClear}mnbGotoLastRecMod: Boolean index 13 read GetSwitch write SetSwitch default True;
    property mnbAddInsert: Boolean index 14 read GetSwitch write SetSwitch default False;
    property mnbAddAppend: Boolean index 15 read GetSwitch write SetSwitch default False;
    property mnbInsert: Boolean index 16 read GetSwitch write SetSwitch default True;
    property mnbDelete: Boolean index 17 read GetSwitch write SetSwitch default True;
    property mnbEdit: Boolean index 18 read GetSwitch write SetSwitch default True;
    property mnbPost: Boolean index 19 read GetSwitch write SetSwitch default True;
    property mnbCancel: Boolean index 20 read GetSwitch write SetSwitch default True;
    property mnbRefresh: Boolean index 21 read GetSwitch write SetSwitch default True;
  end; {TmoNavBtnSwitches}

  TFuncByte = function: Byte of object; {JMNNew}
  TTntCustomMoDBNav0 = class(TTntJvCustomPanel)
  private
    FVisibleSwitches: TmoNavBtnSwitches; {New - Used to set the visiblebtns
      property at design time. This is necessary because you can't publish a set
      property that has more than 16 elements.}
    FOrientation: TmoNavOrientation; {New - horizontal or vertical. Extra code
      is in the procedure AdjustSize.}
    FBookmark, FBookmarkAcc: TBookmark; {New}
    FBmLastRec: TBookmark; {JMNNew}
    FShowBookmarkMessage: Boolean; {New - indicates whether or not a message
      should be displayed when the user clicks Goto Bookmark while on a dataset
      other than that on which the bookmark was set.}
    FBookmarkDs: TDataSet; {New - the dataset for which the bookmark was set.}
    FBookmarkDsAcc: TDataSet; {New}
    FEnabledButtons: TmoBtnSet; {New - specifies which of the visible buttons
      are enabled.}
    FMaxSetMove: Integer; {New - max # of records to move on NextSet/PriorSet.
      Checked in SetMoveByAmount.}
    FSetMove: Integer; {# of records to move on NextSet/PriorSet}
    FVisibleButtons: TmoBtnSet;
    FHints: TTntStrings;
    ButtonWidth: Integer;
    ButtonHeight: Integer;
    MinBtnSize: TPoint;
    FOnNavClick: ENavClick;
    FOnReplaceNavClick: EReplaceNavClick; {New JMN}
    FOnLookupHelp: ENavClick; {New - procedure to be executed when the
      lookuphelp button is clicked. Nothing will happen if there is no procedure
      for this event.}
    FOnLocate: TFuncByte{ENavClick}; {New - procedure to be executed when the
      locate button is clicked. Nothing will happen if there is no procedure
      for this event.}
    FOnLocateNext: TFuncByte{ENavClick}; {New - procedure to be executed when the
      locatenext button is clicked. Nothing will happen if there is no procedure
      for this event.}
    FOnDataChanged: TNotifyEvent; {New - procedure to be executed when the

      DataChanged event of the navigator occurs.}
    FOnEditingChanged: TNotifyEvent; {New - procedure to be executed when the
      EditingChanged event of the navigator occurs.}
    FocusedButton: TmoNavBtns;
    FConfirmCancel: Boolean; {New - displays a confirmation dialog when the user
      tries to cancel a record, much like ConfirmDelete.}
    FConfirmDelete: Boolean;
    {begin JMNNew}
    FAppInsteadIns: Boolean; {Append instead Insert}
    FBeforeAction: ENavClick;
    FOnBtnInsert: TNotifyEvent;
      {for automatic Hints preparation, in design time}
    {end JMNNew}
    procedure SetMaxSetMove(Value: Integer); {New - used to set FMaxSetMove.}
    procedure SetMoveByAmount(Value: Integer); {New - used to set SetMove.}
    function  GetVisibleButtons: TmoBtnSet; {New - Function to be called by
      TmoNavBtnSwitches to determine which buttons are enabled.}
    procedure SetVisibleButtons(Value: TmoBtnSet); {New - function called by
      TmoNavBtnSwitches to change the set of visible buttons.}
    function  GetDataSource: TDataSource;
    procedure SetDataSource(Value: TDataSource);
    procedure Click(Sender: TObject);
    procedure BtnMouseDown (Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AdjustSize (var W: Integer; var H: Integer);
    procedure SetHints(Value: TTntStrings);
    procedure SetOrientation(Value: TmoNavOrientation); {New - used to change
      the orientation from horizontal to vertical or vice-versa.}
    procedure WMSize(var Message: TWMSize);  message WM_SIZE;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
    procedure UpdateEnabled; {New - used to update the set of enabled buttons
      when they are enabled or disabled.}
    {JMNNew}
    procedure BkSetHere0 (ds: TDataSet;  var bm: TBookmark;
      var bmDs: TDataSet;  nb: TmoNavBtns);
    procedure BkSetHere (ds: TDataSet); {New here}
    procedure BkSetHereAcc (ds: TDataSet); {New here}
    procedure FreeBookmarks;
    procedure NewEnabled;
    procedure SetBm (var Bm: TBookmark;  nb: TmoNavBtns;  var bmDs: TDataSet);
  protected
    Buttons: array[TmoNavBtns] of TTntmoNavBtn;
    FDataLink: TTntNavDataLink; {Now here}
    FUserEnabledButtons: TmoBtnSet; {Specifies which of the buttons have been
      explicitly enabled by the user.} {Now here}
    procedure ActiveChanged;
    procedure DataChanged;
    function  GetSetMove: Integer; virtual; abstract; {JMNNew}
    procedure EditingChanged;
    procedure EditingChangedRefresh; virtual; {JMNNew}
    procedure Loaded; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure BtnClick(Index: TmoNavBtns);
    procedure InitButtons; {Now here}
    procedure InitHints; {Now here}
    property  EnabledButtons : TmoBtnSet read FEnabledButtons; {New - runtime
      readonly property that returns the set of enabled buttons.}
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    function  GetButtonState(Index: TmoNavBtns): Boolean; {New JMN}
    procedure SetButtonState(Index: TmoNavBtns; bEnable: Boolean); {New - used
      to explicitly enable or disable a particular button, overriding its
      default state.}
    property  VisibleButtons: TmoBtnSet read GetVisibleButtons write SetVisibleButtons;
   {begin JMNNew}
    procedure BkGoto;
    procedure BkSet;
    procedure ClearBookmarks;
    procedure ClickInsert(Sender: TObject); virtual;
    procedure GotoRecMark (ds: TDataSet;  bm: TBookmark;  bmDs: TDataSet);
    function  ExecPersCDS (PD: TPersComDialSimple): Boolean;
    procedure SetLastRecModi;
    procedure UpdateHints;
   {end JMNNew}
  published
    property VisibleBtns: TmoNavBtnSwitches read FVisibleSwitches write FVisibleSwitches;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property ShowBookmarkMessage: Boolean read FShowBookmarkMessage
      write FShowBookmarkMessage default True; {New}
    property Align;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Ctl3D;
    property Hints: TTntStrings read FHints write SetHints;
    property ParentCtl3D;
    property ParentShowHint;
    property PopupMenu;
    property ConfirmCancel: Boolean read FConfirmCancel write FConfirmCancel default False; {New}
    property ConfirmDelete: Boolean read FConfirmDelete write FConfirmDelete default True; {New}
    property Orientation: TmoNavOrientation read FOrientation write SetOrientation default noHorizontal; {New}
    property MaxSetMove: Integer read FMaxSetMove write SetMaxSetMove default 100; {New}
    property SetMove: Integer read FSetMove write SetMoveByAmount default 10; {New}
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick: ENavClick read FOnNavClick write FOnNavClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnResize;
    {New - proc to execute when LookupHelp is clicked.}
    property OnLookupHelp: ENavClick read FOnLookupHelp write FOnLookupHelp;
    {New - proc to execute when locate is clicked.}
    property OnLocate: TFuncByte{ENavClick} read FOnLocate write FOnLocate;
    {New - proc to execute when LocateNext is clicked.}
    property OnLocateNext: TFuncByte{ENavClick} read FOnLocateNext write FOnLocateNext;
    {New - proc to execute when OnDataChanged occurs.}
    property OnDataChanged: TNotifyEvent read FOnDataChanged write FOnDataChanged;
    {New - proc to execute when OnEditingChanged occurs.}
    property OnEditingChanged: TNotifyEvent read FOnEditingChanged write
      FOnEditingChanged;
   {begin JMNNew}
    property AppInsteadIns: Boolean read FAppInsteadIns write FAppInsteadIns;
    property BeforeAction: ENavClick read FBeforeAction write FBeforeAction;
    property OnReplaceClick: EReplaceNavClick read FOnReplaceNavClick write FOnReplaceNavClick;
    property OnBtnInsert: TNotifyEvent read FOnBtnInsert write FOnBtnInsert;
   {end JMNNew}
  end; {TTntCustomMoDBNav0}

  TTntmoDBNav0 = class(TTntCustomMoDBNav0)
  protected {for no compiler Hint message}
    function  GetSetMove: Integer; override;
  end;

  TTntDBGridRow = class(TTntDBGrid)
  published
    property RowCount;
  end;

  TTntmoDBNavRow0 = class(TTntCustomMoDBNav0)
  private
    FDBGridRow: TTntDBGridRow;
  protected {for no compiler Hint message}
    function  GetSetMove: Integer; override;
  published
    property DBGridRow: TTntDBGridRow read FDBGridRow write FDBGridRow;
  end;

  TTntmoNavBtn = class(TTntJvSpeedButton)
  private
    FIndex: TmoNavBtns;
    FNavStyle: TmoNavButtonStyle;
    FRepeatTimer: TTimer;
    procedure TimerExpired(Sender: TObject);
  protected
    procedure Paint; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
  public
    destructor Destroy; override;
    property NavStyle: TmoNavButtonStyle read FNavStyle write FNavStyle;
    property Index : TmoNavBtns read FIndex write FIndex;
  end; {TTntmoNavBtn}

  TTntNavDataLink = class(TDataLink)
  private
    FNavigator: TTntCustomMoDBNav0;
  protected
    procedure EditingChanged; override;
    procedure DataSetChanged; override;
    procedure ActiveChanged; override;
  public
    constructor Create(ANav: TTntCustomMoDBNav0);
    destructor Destroy; override;
  end; {TTntNavDataLink}


  TTntNavIDataLink = class;
  TTntmoDBInsert = class (TTntJvBitBtn)
  private
    FAppInsteadIns: Boolean;
    FDataLink: TTntNavIDataLink;
    FOnBtnInsert: TNotifyEvent;
    function  GetDataSource: TDataSource;
    procedure SetDataSource(Value: TDataSource);
  protected
    procedure ActiveChanged;
  public
    procedure ClickInsert(Sender: TObject); virtual;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property AppInsteadIns: Boolean read FAppInsteadIns write FAppInsteadIns;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property OnBtnInsert: TNotifyEvent read FOnBtnInsert write FOnBtnInsert;
  end;

  TTntNavIDataLink = class(TDataLink)
  private
    FNavigator: TTntmoDBInsert;
  protected
    procedure ActiveChanged; override;
  public
    constructor Create(ANav: TTntmoDBInsert);
    destructor Destroy; override;
  end; {TTntNavDataLink}

implementation

{$R *.res}

uses
  DBConsts, TntSystem,
  TntMessUsual;

const
  {New: constants for hint identifiers for the new buttons.}
  //BtnStateName: array[TNavGlyph] of PChar = ('EN', 'DI');
  BtnTypeNameLToR: array[mnbFirst..mnbLast] of PChar = (
    'FIRST', 'PRIORSET', 'PRIOR', 'NEXT', 'NEXTSET', 'LAST');
  BtnTypeNameRToL: array[mnbFirst..mnbLast] of PChar = (
    'LAST', 'NEXTSET', 'NEXT', 'PRIOR', 'PRIORSET', 'FIRST');
  BtnTypeName: array[mnbLookupHelp..mnbRefresh] of PChar = (
    'LOOKUPHELP', 'LOCATE', 'LOCATENEXT',
    'BKSET', 'BKGOTO', {'BKCLEAR',}'BKSETACC', 'BKGOTOACC', 'GOTOLASTRECMOD',
    'ADDINSERT', 'ADDAPPEND',
    'INSERT', 'DELETE', 'EDIT', 'POST', 'CANCEL', 'REFRESH'); {New}
  BtnHintId: array [TmoNavBtns] of Pointer =
   (@RS_mnb_First,
    @RS_mnb_PriorSet,
    @RS_mnb_Prior,
    @RS_mnb_Next,
    @RS_mnb_NextSet,
    @RS_mnb_Last,
    @RS_mnb_LookupHelp,
    @RS_mnb_Locate,
    @RS_mnb_LocateNext,
    @RS_mnb_BkSet,
    @RS_mnb_BkGoto,
    @RS_mnb_BkSet,
    @RS_mnb_BkGoto,
    @RS_mnb_GotoLastRecMod,
    @RS_mnb_AddInsert,
    @RS_mnb_AddAppend,
    @RS_mnb_Insert,
    @RS_mnb_Delete,
    @RS_mnb_Edit,
    @RS_mnb_Post,
    @RS_mnb_Cancel,
    @RS_mnb_Refresh);

{--------------------------------------}

constructor TmoNavBtnSwitches.Create(AGetFunc: TmoGetBtn; ASetProc: TmoSetBtn);
begin
  inherited Create;
  GetBtn := AGetFunc;
  SetBtn := ASetProc;
  mnbLookupHelp := False;
  mnbLocate := False;
  mnbLocateNext := False;
  mnbBkSetAcc := False;
  mnbBkGotoAcc := False;
  mnbAddInsert := False; {New}
  mnbAddAppend := False; {New}
  mnbBkSet := True;
  mnbBkGoto := True;
 {mnbBkClear := False;}
  mnbGotoLastRecMod := True;
  mnbFirst := True;
  mnbPriorSet := True;
  mnbPrior := True;
  mnbNext := True;
  mnbNextSet := True;
  mnbLast := True;
  mnbInsert := True;
  mnbDelete := True;
  mnbEdit := True;
  mnbPost := True;
  mnbCancel := True;
  mnbRefresh := True;
end; {Create}

function TmoNavBtnSwitches.GetSwitch(Index: Integer): Boolean;
begin
  Result := TmoNavBtns(Index) in GetBtn;
end; {GetSwitch}

procedure TmoNavBtnSwitches.SetSwitch(Index: Integer; Value: Boolean);
begin
  if Value then
    SetBtn(GetBtn + [TmoNavBtns(Index)])
  else
    SetBtn(GetBtn - [TmoNavBtns(Index)]);
end; {SetSwitch}

{--------------------------------------}

constructor TTntCustomMoDBNav0.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle - [csAcceptsControls, csSetCaption] +
    [csFramed, csOpaque];
  FDataLink := TTntNavDataLink.Create(Self);
  FVisibleButtons := [
    mnbFirst, mnbPriorSet, mnbPrior, mnbNext, mnbNextSet, mnbLast,
    mnbLocate, mnbLocateNext,
    mnbBkSet, mnbBkGoto, {mnbBkClear,}
    mnbBkSetAcc, mnbBkGotoAcc,
    mnbGotoLastRecMod, mnbAddInsert, mnbAddAppend, {New}
    mnbInsert, mnbDelete, mnbEdit, mnbPost, mnbCancel, mnbRefresh]; {New}
  FEnabledButtons := FVisibleButtons; {New}
  FUserEnabledButtons := FVisibleButtons; {New}
  FShowBookmarkMessage := True; {New}
  FHints := TTntStringList.Create;
  InitButtons;
  BevelOuter := bvNone;
  BevelInner := bvNone;
  Width := 22*15; {New}
  Height := 25;
  ButtonWidth := 0;
  ButtonHeight := 0;
  FocusedButton := mnbBkSet; {New}
  FConfirmCancel := False; {New}
  FConfirmDelete := True;
  FOrientation := noHorizontal; {New}
  FBookmark := nil; {New}
  FBookmarkAcc := nil; {New}
  FBmLastRec := nil; {JMNNew}
  FBookmarkDs := nil; {New}
  FBookmarkDsAcc := nil; {New}
  FVisibleSwitches := TmoNavBtnSwitches.Create(GetVisibleButtons, SetVisibleButtons); {New}
  FMaxSetMove := 100; {New}
  FSetMove := 10; {New}
end; {Create}

destructor TTntCustomMoDBNav0.Destroy;
begin
  {New - free the bookmark and its dataset if necessary.}
  FreeBookmarks;
  if  FBookmarkDs <> nil then  FBookmarkDs := nil;
  FDataLink.Free;
  FDataLink := nil;
  {New - the code below is missing from the native Delphi 1.0 TDBNavigator, and
  is responsible for resource leakage.}
  FHints.Free;
  FVisibleSwitches.Free; {New}
  inherited Destroy;
end; {Destroy}

procedure TTntCustomMoDBNav0.SetMaxSetMove(Value: Integer);
begin
  if Value <= 2 then
    raise ERangeError.create(RS_DbNavNew_MaxSetMoveTooLow);
  if Value < FSetMove then
    {Reduce FSetMove so that it doesn't violate the new boundary.}
    FSetMove := Value;
  FMaxSetMove := Value;
end; {SetMaxSetMove}

procedure TTntCustomMoDBNav0.SetMoveByAmount(Value: Integer);
begin
  if (Value < 0) or (Value > FMaxSetMove) then
    {Value may not be <0 or greater than specified amount.}
    raise ERangeError.Create(WideFormat (RS_DbNavNew_SetMoveMarginError, [FMaxSetMove]));
  FSetMove := Value;
end; {SetMoveByAmount}

function TTntCustomMoDBNav0.GetVisibleButtons: TmoBtnSet; {New}
begin
  Result := FVisibleButtons;
end; {GetVisibleButtons}

procedure TTntCustomMoDBNav0.SetVisibleButtons(Value: TmoBtnSet); {New}
var
  I: TmoNavBtns;
  W, H: Integer;
begin
  W := Width;
  H := Height;
  FVisibleButtons := Value;
  for I := Low(Buttons) to High(Buttons) do
    Buttons[I].Visible := I in FVisibleButtons;
  AdjustSize (W, H);
  if (W <> Width) or (H <> Height) then
    inherited SetBounds (Left, Top, W, H);
  Invalidate;
end; {SetVisibleButtons}

procedure TTntCustomMoDBNav0.SetOrientation(Value: TmoNavOrientation); {New}
var
  W, H: Integer;
begin
  if FOrientation <> Value then begin
    FOrientation := Value;
    W := Width;
    H := Height;
    {Height & width are reversed in the call below to make the size switch with
    the orientation. Otherwise the buttons would be tall & skinny or short and
    fat when switching the orientation.}
    {If statement added below 7/25 to fix vertical orientation bug.}
    if ((W >= H) and (Value = noVertical)) or ((W <= H) and
      (Value = noHorizontal)) then
      inherited SetBounds(Left, Top, H, W);
  end
end; {SetOrientation}

procedure TTntCustomMoDBNav0.InitButtons;
var
  I: TmoNavBtns;
  X: Integer;

procedure ForButton;
var
  Btn: TTntmoNavBtn;
  ResName: array[0..40] of Char;
  PCh: PChar;
begin
  Btn := TTntmoNavBtn.Create (Self);
  Btn.Index := I;
  Btn.Visible := I in FVisibleButtons;
  Btn.Enabled := (I in FEnabledButtons) and (I in FVisibleButtons) and
    (I in FUserEnabledButtons); {New}
  Btn.SetBounds (X, 0, MinBtnSize.X, MinBtnSize.Y);

  if  I in [mnbFirst..mnbLast]  then  begin
    if UseRightToLeftAlignment
    then  PCh := BtnTypeNameRToL[I]
    else  PCh := BtnTypeNameLToR[I];
  end
  else  begin
    PCh := BtnTypeName[I];
  end;
  Btn.Glyph.Handle := LoadBitmap(HInstance,
    StrFmt(ResName, 'MODBN_%s', [PCh])); {New}

  Btn.NumGlyphs := 2;
  Btn.OnClick := Click;
  Btn.OnMouseDown := BtnMouseDown;
  Btn.Parent := Self;
  Buttons[I] := Btn;
  Inc (X, MinBtnSize.X);
end {ForButton};

var
  W: Integer;
  H: Integer;
begin
  if UseRightToLeftAlignment then  begin
    for I := Low(Buttons) to High(Buttons) do begin
      RemoveControl (Buttons[I]);
      Buttons[I].Free;
    end;
  end;
  MinBtnSize := Point(20, 18);
  X := 0;
  if UseRightToLeftAlignment then  begin
    for I := High(Buttons) downto Low(Buttons) do begin
      ForButton;
    end;
  end
  else  begin
    for I := Low(Buttons) to High(Buttons) do begin
      ForButton;
    end;
  end;
  InitHints;
  Buttons[mnbPrior].NavStyle    := Buttons[mnbPrior].NavStyle + [nsAllowTimer];
  Buttons[mnbNext].NavStyle     := Buttons[mnbNext].NavStyle + [nsAllowTimer];
  Buttons[mnbPriorSet].NavStyle := Buttons[mnbPriorSet].NavStyle + [nsAllowTimer]; {New}
  Buttons[mnbNextSet].NavStyle  := Buttons[mnbNextSet].NavStyle + [nsAllowTimer]; {New}
  Buttons[mnbInsert].OnClick := ClickInsert;
  W := Width;
  H := Height;
  AdjustSize (W, H);
end; {InitButtons}

procedure TTntCustomMoDBNav0.InitHints;
var
  I: Integer;
  J: TmoNavBtns;
  S: WideString;
begin
  for J := Low(Buttons) to High(Buttons) do  begin
    S := WideLoadResString(BtnHintId[J]);
    if  J in [mnbPriorSet, mnbNextSet]
    then  S := WideFormat (S, [SetMove]);
    Buttons[J].Hint := S;
  end;
  J := Low(Buttons);
  for I := 0 to (FHints.Count - 1) do begin
    if FHints.Strings[I] <> '' then Buttons[J].Hint := FHints.Strings[I];
    if J = High(Buttons) then Exit;
    Inc(J)
  end
end; {InitHints}

procedure TTntCustomMoDBNav0.SetHints(Value: TTntStrings);
begin
  FHints.Assign(Value);
  InitHints;
end; {SetHints}

procedure TTntCustomMoDBNav0.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (FDataLink <> nil) and
    (AComponent = DataSource) then DataSource := nil;
end; {Notification}

procedure TTntCustomMoDBNav0.AdjustSize (var W: Integer; var H: Integer);
var
  Count: Integer;
  I: TmoNavBtns;
  Space, Temp, Remain: Integer;
  X: Integer;

procedure SituateH;
begin
  if Buttons[I].Visible then begin
    Space := 0;
    if Remain <> 0 then begin
      Dec (Temp, Remain);
      if Temp < 0 then begin
        Inc (Temp, Count);
        Space := 1
      end
    end;
    Buttons[I].SetBounds (X, 0, ButtonWidth + Space, Height);
    Inc (X, ButtonWidth - 1 + Space);
  end
  else
    Buttons[I].SetBounds (Width + 1, 0, ButtonWidth, Height);
end {SituateH};

var
  MinW, MinH: Integer;
  Y: Integer;
begin
  if (csLoading in ComponentState) then Exit;
  if Buttons[mnbLookuphelp] = nil then Exit;


  Count := 0;
  for I := Low(Buttons) to High(Buttons) do begin
    if Buttons[I].Visible then begin
      Inc(Count);
    end
  end;
  if Count = 0 then Inc(Count);

  if FOrientation = noHorizontal then begin
    MinW := Count * (MinBtnSize.X - 1) + 1;
    if W < MinW then
      W := MinW;
    if H < MinBtnSize.Y then
      H := MinBtnSize.Y;
    ButtonWidth := ((W - 1) div Count) + 1;
    Temp := Count * (ButtonWidth - 1) + 1;
    if Align = alNone then
      W := Temp;
    X := 0;
    Remain := W - Temp;
    Temp := Count div 2;
    if UseRightToLeftAlignment then  begin
      for I := High(Buttons) downto Low(Buttons)  do
        SituateH;
    end
    else  begin
      for I := Low(Buttons) to High(Buttons) do
        SituateH;
    end;
  end
  else begin {New - Vertical}
    MinH := Count * (MinBtnSize.Y - 1) + 1;
    if H < MinH then
      H := MinH;
    if W < MinBtnSize.X then
      W := MinBtnSize.X;
    ButtonHeight := ((H - 1) div Count) + 1;
    Temp := Count * (ButtonHeight - 1) + 1;
    if Align = alNone then
      H := Temp;
    Y := 0;
    Remain := H - Temp;
    Temp := Count div 2;
    for I := Low(Buttons) to High(Buttons) do begin
      if Buttons[I].Visible then begin
        Space := 0;
        if Remain <> 0 then begin
          Dec (Temp, Remain);
          if Temp < 0 then begin
            Inc (Temp, Count);
            Space := 1
          end
        end;
        Buttons[I].SetBounds (0, Y, Width, ButtonHeight + Space);
        Inc (Y, ButtonHeight - 1 + Space);
      end
      else
        Buttons[I].SetBounds (0, Height + 1, ButtonHeight, Width)
    end
  end {Vertical};
end; {AdjustSize}

procedure TTntCustomMoDBNav0.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
var
  W, H: Integer;
begin
  W := AWidth;
  H := AHeight;
  AdjustSize (W, H);
  inherited SetBounds (ALeft, ATop, W, H);
end; {SetBounds}

procedure TTntCustomMoDBNav0.WMSize(var Message: TWMSize);
var
  W, H: Integer;
begin
  inherited;

  { check for minimum size }
  W := Width;
  H := Height;
  AdjustSize (W, H);
  if (W <> Width) or (H <> Height) then
    inherited SetBounds(Left, Top, W, H);
  Message.Result := 0;
end; {WMSize}

procedure TTntCustomMoDBNav0.Click(Sender: TObject);
begin
  BtnClick (TTntmoNavBtn (Sender).Index);
end; {Click}

procedure TTntCustomMoDBNav0.BtnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  OldFocus: TmoNavBtns;
begin
  OldFocus := FocusedButton;
  FocusedButton := TTntmoNavBtn (Sender).Index;
  if TabStop and (GetFocus <> Handle) and CanFocus then begin
    SetFocus;
    if (GetFocus <> Handle) then
      Exit
  end
  else if TabStop and (GetFocus = Handle) and (OldFocus <> FocusedButton) then begin
    Buttons[OldFocus].Invalidate;
    Buttons[FocusedButton].Invalidate;
  end;
end; {BtnMouseDown}

procedure TTntCustomMoDBNav0.BtnClick(Index: TmoNavBtns);
var
  ds: TDataSet;
  R: Byte;
  Replaced: Boolean;
begin
  if (DataSource <> nil) and (DataSource.State <> dsInactive) then begin
    ds := DataSource.DataSet;
    with DataSource.DataSet do begin
      {begin JMNNew}
      if not (csDesigning in ComponentState) and Assigned (FBeforeAction) then
        FBeforeAction (Self, Index);
      if not (csDesigning in ComponentState) and Assigned (FOnReplaceNavClick)  then  begin
        FOnReplaceNavClick (Self, Index, Replaced);
        if  Replaced
        then  Exit;
      end;
      {end JMNNew}
      case Index of
        mnbLookupHelp: if not (csDesigning in ComponentState) and
          Assigned(FOnLookupHelp) then FOnLookupHelp(Self, Index);
        mnbLocate: if not (csDesigning in ComponentState) then  begin
            if  Assigned(FOnLocate) then  begin
              R := FOnLocate{(Self, Index)};
            end
            else  begin
              if  Filter = ''
              then  R := 2
              else
                if  FindFirst
                then  R := 0
                else  R := 1;
            end;
            case R of
            1: WideMessageBoxInfo (RS_DbNavNew_NotFound);
            2: WideMessageBoxError (RS_DbNavNew_NotFilter);
            else;
            end;
          end;
        mnbLocateNext: if not (csDesigning in ComponentState) then  begin
            if  Assigned(FOnLocateNext) then  begin
              R := FOnLocateNext{(Self, Index)};
            end
            else  begin
              if  Filter = ''
              then  R := 2
              else
                if  FindNext
                then  R := 0
                else  R := 1;
            end;
            case R of
            1: WideMessageBoxInfo (RS_DbNavNew_NoOtherRecordFound);
            2: WideMessageBoxError (RS_DbNavNew_NotFilter);
            else;
            end;
          end;
        mnbPriorSet: MoveBy(0-GetSetMove);
        mnbPrior: Prior;
        mnbNext: Next;
        mnbNextSet: MoveBy(GetSetMove);
        mnbFirst: First;
        mnbLast: Last;
        mnbAddInsert: Insert;
        mnbAddAppend: Append;
        mnbInsert: {begin JMNNew} if FAppInsteadIns
          then Append
          else {end JMNNew} Insert;
        mnbEdit: Edit;
        mnbCancel:
          if not FConfirmCancel or (MessageDlg (RS_CancelChangesQuestion,
            mtConfirmation, mbOkCancel, 0) <> idCancel) then
            Cancel;
        mnbPost: Post;
        mnbRefresh: Refresh;
        mnbDelete:
          if not FConfirmDelete or
            (MessageDlg(SDeleteRecordQuestion, mtConfirmation,
            mbOKCancel, 0) <> idCancel) then Delete;
        mnbBkSet: BkSetHere (ds);
        mnbBkSetAcc: BkSetHereAcc (ds);
        mnbBkGoto: GotoRecMark (ds, FBookmark, FBookmarkDs);
        mnbBkGotoAcc: GotoRecMark (ds, FBookmarkAcc, FBookmarkDsAcc);
        mnbGotoLastRecMod: GotoRecMark (ds, FBmLastRec, FBookmarkDs);
       {mnbBkClear:
          begin
            if (FBookmark <> nil) and (FBookmarkDs <> nil) then begin
              FBookmarkDs.FreeBookmark(FBookmark);
              FBookmarkDs := nil
            end;
            Buttons[mnbBkGoto].Enabled := False;
            Buttons[mnbBkClear].Enabled := False
          end;}
      end
    end
  end;
  if not (csDesigning in ComponentState) and Assigned(FOnNavClick) then
    FOnNavClick(Self, Index);
end; {BtnNavClick}

function TTntCustomMoDBNav0.GetButtonState(Index: TmoNavBtns): Boolean; {New JMN}
begin
  Result := Buttons[Index].Enabled;
end; {GetButtonState}

procedure TTntCustomMoDBNav0.SetButtonState(Index: TmoNavBtns; bEnable: Boolean);
begin
  Buttons[Index].Enabled := bEnable;
  if bEnable then begin
    Include(FUserEnabledButtons, Index);
    Include(FEnabledButtons, Index)
  end else begin
    Exclude(FUserEnabledButtons, Index);
    Exclude(FEnabledButtons, Index);
  end
end; {SetButtonState}

procedure TTntCustomMoDBNav0.WMSetFocus(var Message: TWMSetFocus);
begin
  Buttons[FocusedButton].Invalidate;
end; {WMSetFocus}

procedure TTntCustomMoDBNav0.WMKillFocus(var Message: TWMKillFocus);
begin
  Buttons[FocusedButton].Invalidate;
end; {WMKillFocus}

procedure TTntCustomMoDBNav0.KeyDown(var Key: Word; Shift: TShiftState);
var
  NewFocus: TmoNavBtns;
  OldFocus: TmoNavBtns;
begin
  OldFocus := FocusedButton;
  case Key of
    VK_RIGHT:
      begin
        NewFocus := FocusedButton;
        repeat
          if NewFocus < High(Buttons) then
            NewFocus := Succ(NewFocus);
        until (NewFocus = High(Buttons)) or (Buttons[NewFocus].Visible);
        if NewFocus <> FocusedButton then begin
          FocusedButton := NewFocus;
          Buttons[OldFocus].Invalidate;
          Buttons[FocusedButton].Invalidate;
        end
      end;
    VK_LEFT:
      begin
        NewFocus := FocusedButton;
        repeat
          if NewFocus > Low(Buttons) then
            NewFocus := Pred(NewFocus);
        until (NewFocus = Low(Buttons)) or (Buttons[NewFocus].Visible);
        if NewFocus <> FocusedButton then begin
          FocusedButton := NewFocus;
          Buttons[OldFocus].Invalidate;
          Buttons[FocusedButton].Invalidate;
        end;
      end;
    VK_SPACE:
      begin
        if Buttons[FocusedButton].Enabled then
          Buttons[FocusedButton].Click;
      end
  end
end; {KeyDown}

procedure TTntCustomMoDBNav0.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTARROWS;
end; {WMGetDlgCode}

procedure TTntCustomMoDBNav0.DataChanged;
var
  UpEnable, DnEnable: Boolean;
begin
  UpEnable := Enabled and FDataLink.Active and not FDataLink.DataSet.BOF;
  DnEnable := Enabled and FDataLink.Active and not FDataLink.DataSet.EOF;
  Buttons[mnbBkSet].Enabled := mnbBkSet in FUserEnabledButtons;
  Buttons[mnbBkSetAcc].Enabled := mnbBkSetAcc in FUserEnabledButtons;
  Buttons[mnbBkGoto].Enabled := (FBookmark <> nil) and (mnbBkGoto in FUserEnabledButtons);
  Buttons[mnbBkGotoAcc].Enabled := (FBookmarkAcc <> nil) and (mnbBkGotoAcc in FUserEnabledButtons);
 {Buttons[mnbBkClear].Enabled := (FBookmark <> nil) and (mnbBkClear in FUserEnabledButtons);}
  Buttons[mnbGotoLastRecMod].Enabled := (FBmLastRec <> nil) and (mnbGotoLastRecMod in FUserEnabledButtons);
  Buttons[mnbFirst].Enabled := UpEnable and (mnbFirst in FUserEnabledButtons);
  Buttons[mnbPriorSet].Enabled := UpEnable and (mnbPriorSet in FUserEnabledButtons);
  Buttons[mnbPrior].Enabled := UpEnable and (mnbPrior in FUserEnabledButtons);
  Buttons[mnbNext].Enabled := DnEnable and (mnbNext in FUserEnabledButtons);
  Buttons[mnbNextSet].Enabled := DnEnable and (mnbNextSet in FUserEnabledButtons);
  Buttons[mnbLast].Enabled := DnEnable and (mnbLast in FUserEnabledButtons);
  Buttons[mnbDelete].Enabled := Enabled and FDataLink.Active and
    FDataLink.DataSet.CanModify and
    not (FDataLink.DataSet.BOF and FDataLink.DataSet.EOF) and
    (mnbDelete in FUserEnabledButtons);
  Buttons[mnbLocate].Enabled := (not (FDataLink.DataSet.BOF) or
    not (FDataLink.DataSet.EOF)) and (mnbLocate in FUserEnabledButtons);
  Buttons[mnbLocateNext].Enabled := Buttons[mnbLocate].Enabled;
  UpdateEnabled;
  if not (csDesigning in ComponentState) and Assigned(FOnDataChanged) then
    FOnDataChanged(Self);
end; {DataChanged}

procedure TTntCustomMoDBNav0.UpdateEnabled;
var
  I : TmoNavBtns;
begin
  for I := Low(Buttons) to High(Buttons) do
    if Buttons[I].Enabled then
      Include(FEnabledButtons, I)
    else
      Exclude(FEnabledButtons, I);
end; {UpdateEnabled}

procedure TTntCustomMoDBNav0.EditingChanged;
var
  CanModify: Boolean;
begin
  CanModify := Enabled and FDataLink.Active and FDataLink.DataSet.CanModify;
  Buttons[mnbAddInsert].Enabled := CanModify and (mnbAddInsert in FUserEnabledButtons); {New}
  Buttons[mnbAddAppend].Enabled := CanModify and (mnbAddAppend in FUserEnabledButtons); {New}
  Buttons[mnbInsert].Enabled := CanModify and (mnbInsert in FUserEnabledButtons);
  Buttons[mnbEdit].Enabled := CanModify and not FDataLink.Editing and (mnbEdit in
    FUserEnabledButtons);
  Buttons[mnbPost].Enabled := CanModify and FDataLink.Editing and (mnbPost in
    FUserEnabledButtons);
  Buttons[mnbCancel].Enabled := CanModify and FDataLink.Editing and (mnbCancel in
    FUserEnabledButtons);
  EditingChangedRefresh;
  Buttons[mnbLookupHelp].Enabled := CanModify and
    (mnbLookupHelp in FUserEnabledButtons);
  UpdateEnabled;
  if not (csDesigning in ComponentState) and Assigned(FOnEditingChanged) then
    FOnEditingChanged(Self);
end; {EditingChanged}

procedure TTntCustomMoDBNav0.EditingChangedRefresh;
begin
  Buttons[mnbRefresh].Enabled := mnbRefresh in FUserEnabledButtons;
end;

procedure TTntCustomMoDBNav0.ActiveChanged;
var
  I: TmoNavBtns;
begin
  if not (Enabled and FDataLink.Active) then
    for I := Low(Buttons) to High(Buttons) do
      Buttons[I].Enabled := False
  else begin
    DataChanged;
    EditingChanged;
  end;
end; {ActiveChanged}

procedure TTntCustomMoDBNav0.CMEnabledChanged(var Message: TMessage);
begin
  inherited;
  if not (csLoading in ComponentState) then
    ActiveChanged;
end; {CMEnabledChanged}

procedure TTntCustomMoDBNav0.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource := Value;
  if not (csLoading in ComponentState) then
    ActiveChanged;
end; {SetDataSource}

function TTntCustomMoDBNav0.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end; {GetDataSource}

procedure TTntCustomMoDBNav0.Loaded;
var
  W, H: Integer;
begin
  inherited Loaded;
  W := Width;
  H := Height;
  AdjustSize (W, H);
  if (W <> Width) or (H <> Height) then
    inherited SetBounds (Left, Top, W, H);
  InitHints;
  ActiveChanged;
end; {Loaded}

{------------------}

procedure TTntCustomMoDBNav0.ClickInsert(Sender: TObject);
begin
  if (DataSource <> nil) and (DataSource.State <> dsInactive) then
  begin
    {begin JMNNew}
    if FAppInsteadIns
    then DataSource.DataSet.Append
    else {end JMNNew} DataSource.DataSet.Insert;
    if  Assigned(FOnBtnInsert)
    then  FOnBtnInsert(Self);
  end;
end {ClickInsert};

procedure TTntCustomMoDBNav0.BkGoto;
begin
  if (DataSource <> nil) and (DataSource.State <> dsInactive)
  then  GotoRecMark (DataSource.DataSet, FBookmark, FBookmarkDs);
end {BkGoto};

procedure TTntCustomMoDBNav0.BkSet;
begin
  if (DataSource <> nil) and (DataSource.State <> dsInactive)
  then  BkSetHere (DataSource.DataSet);
end {BkSet};

procedure TTntCustomMoDBNav0.ClearBookmarks; {New}
begin
  FreeBookmarks;
  FBookmark := nil;
  FBmLastRec := nil;
  Buttons[mnbBkGoto].Enabled := False;
 {Buttons[mnbBkClear].Enabled := False;}
  Buttons[mnbGotoLastRecMod].Enabled := False;
  NewEnabled;
end {ClearBookmarks};

procedure TTntCustomMoDBNav0.GotoRecMark (ds: TDataSet;  bm: TBookmark;
  bmDs: TDataSet);
begin
  {NewHere}
  if (bm <> nil) and (bmDs <> nil) then begin
    if (bmDs <> ds) and FShowBookmarkMessage then begin
      WideMessageBoxError (RS_DefaultBookmarkMessage)
    end else {Either we're on the same dataset or FShowBookmarkMessage
              is false}
      try
        bmDs.GotoBookmark(bm)
      except
        raise EDatabaseError.create(RS_DbNavNew_RecordNotFound);
      end;
  end;
end {GotoRecMark};

function TTntCustomMoDBNav0.ExecPersCDS (PD: TPersComDialSimple): Boolean;
var
  Added: Boolean;
begin
  with PD do
    Added := ShowModal = mrOK;
    Result := Added;
    if  Added
    then  DataSource.DataSet.Refresh
    else  DataSource.DataSet.Delete;
end {ExecPersCDS};

procedure TTntCustomMoDBNav0.SetLastRecModi;
begin
  SetBm (FBmLastRec, mnbGotoLastRecMod, FBookmarkDs);
end {SetLastRecModi};

procedure TTntCustomMoDBNav0.UpdateHints;
begin
  InitHints;
end;

{-PRIVATE----------}

procedure TTntCustomMoDBNav0.BkSetHere0 (ds: TDataSet;  var bm: TBookmark;
  var bmDs: TDataSet;  nb: TmoNavBtns);
begin
  SetBm (bm, nb, bmDs);
  if (bm <> nil) and (bmDs <> nil) then
    {Free existing bookmark first}
    bmDs.FreeBookmark(bm);
  bmDs := ds;
  bm := DataSource.DataSet.GetBookmark;
  Buttons[nb].Enabled := (nb in FUserEnabledButtons);
 {Buttons[mnbBkClear].Enabled := (mnbBkClear in FUserEnabledButtons)}
  NewEnabled; {New}
end {BkSetHere};

procedure TTntCustomMoDBNav0.BkSetHere (ds: TDataSet); {New here}
begin
  BkSetHere0 (ds, FBookmark, FBookmarkDs, mnbBkGoto);
end {BkSetHere};

procedure TTntCustomMoDBNav0.BkSetHereAcc (ds: TDataSet); {New here}
begin
  BkSetHere0 (ds, FBookmarkAcc, FBookmarkDsAcc, mnbBkGotoAcc);
end {BkSetHere};

procedure TTntCustomMoDBNav0.FreeBookmarks;
begin
  if  (FBookmarkDs <> nil) or (FBookmarkDsAcc <> nil)  then  begin
    if  FBookmark <> nil
    then  FBookmarkDs.FreeBookmark(FBookmark);
    if  FBookmarkAcc <> nil
    then  FBookmarkDsAcc.FreeBookmark(FBookmarkAcc);
    if  FBmLastRec <> nil
    then  FBookmarkDs.FreeBookmark(FBmLastRec);
  end;
end {FreeBookmarks};

procedure TTntCustomMoDBNav0.NewEnabled;
begin
  UpdateEnabled;
  if not (csDesigning in ComponentState) and Assigned(FOnDataChanged) then
    FOnDataChanged(Self);
end {NewEnabled};

procedure TTntCustomMoDBNav0.SetBm (var Bm: TBookmark;  nb: TmoNavBtns;
  var bmDs: TDataSet);
begin
  if (Bm <> nil) and (FBookmarkDs <> nil) then
    {Free existing bookmark first}
    FBookmarkDs.FreeBookmark(Bm);
  bmDs := DataSource.DataSet;
  Bm := DataSource.DataSet.GetBookmark;
  Buttons[nb].Enabled := (nb in FUserEnabledButtons);
end {SetBm};

{--------------------------------------}
{-PROTECTED----------}

function TTntmoDBNav0.GetSetMove: Integer;
begin
  Result := SetMove;
end {GetSetMove};

{--------------------------------------}
{-PRROTECTED----------}

function TTntmoDBNavRow0.GetSetMove: Integer;
begin
  if  Assigned (FDBGridRow)
  then  Result := FDBGridRow.RowCount-1
  else  Result := 0;
end {GetSetMove};

{--------------------------------------}

destructor TTntmoNavBtn.Destroy;
begin
  if FRepeatTimer <> nil then
    FRepeatTimer.Free;
  inherited Destroy;
end; {Destroy}

procedure TTntmoNavBtn.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseDown (Button, Shift, X, Y);
  if nsAllowTimer in FNavStyle then begin
    if FRepeatTimer = nil then
      FRepeatTimer := TTimer.Create(Self);

    FRepeatTimer.OnTimer := TimerExpired;
    FRepeatTimer.Interval := InitRepeatPause;
    FRepeatTimer.Enabled  := True;
  end;
end; {MouseDown}

procedure TTntmoNavBtn.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseUp (Button, Shift, X, Y);
  if FRepeatTimer <> nil then
    FRepeatTimer.Enabled  := False;
end; {MouseUp}

procedure TTntmoNavBtn.TimerExpired(Sender: TObject);
begin
  FRepeatTimer.Interval := RepeatPause;
  if (FState = rbsDown) and MouseCapture then begin
    try
      Click;
    except
      FRepeatTimer.Enabled := False;
      raise;
    end;
  end;
end; {TimerExpired}

procedure TTntmoNavBtn.Paint;
var
  R: TRect;
begin
  inherited Paint;
  if (GetFocus = Parent.Handle) and
    (FIndex = TTntCustomMoDBNav0 (Parent).FocusedButton) then begin
    R := Bounds(0, 0, Width, Height);
    InflateRect(R, -3, -3);
    if FState = rbsDown then
      OffsetRect(R, 1, 1);
    DrawFocusRect(Canvas.Handle, R);
  end;
end; {Paint}

{--------------------------------------}

constructor TTntNavDataLink.Create(ANav: TTntCustomMoDBNav0);
begin
  inherited Create;
  FNavigator := ANav;
end; {Create}

destructor TTntNavDataLink.Destroy;
begin
  FNavigator := nil;
  inherited Destroy;
end; {Destroy}

procedure TTntNavDataLink.EditingChanged;
begin
  if FNavigator <> nil then FNavigator.EditingChanged;
end; {EditingChanged}

procedure TTntNavDataLink.DataSetChanged;
begin
  if FNavigator <> nil then FNavigator.DataChanged;
end; {DataSetChanged}

procedure TTntNavDataLink.ActiveChanged;
begin
  if FNavigator <> nil then FNavigator.ActiveChanged;
end; {ActiveChanged}

{--------------------------------------}
{-PRIVATE----------}

function TTntmoDBInsert.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end {GetDataSource};

procedure TTntmoDBInsert.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource := Value;
  if not (csLoading in ComponentState) then
    ActiveChanged;
end; {SetDataSource}

{-PROTECTED--------}

procedure TTntmoDBInsert.ActiveChanged;
begin
  Enabled := FDataLink.Active and FDataLink.DataSet.CanModify;
end {ActiveChanged};

{-PUBLIC-----------}

procedure TTntmoDBInsert.ClickInsert(Sender: TObject);
begin
  if (DataSource <> nil) and (DataSource.State <> dsInactive) then
  begin
    if FAppInsteadIns
    then  DataSource.DataSet.Append
    else  DataSource.DataSet.Insert;
    if  Assigned(FOnBtnInsert)
    then  FOnBtnInsert(Self);
  end;
end {ClickInsert};

constructor TTntmoDBInsert.Create (AOwner: TComponent);
var
  ResName: array[0..40] of Char;
begin
  inherited Create (AOwner);
  FDataLink := TTntNavIDataLink.Create(Self);
  Glyph.Handle := LoadBitmap(HInstance,
    StrFmt(ResName, 'MODBN_%s', [BtnTypeName[mnbInsert]]));
  Width := 22;
  Height := 25;
  Caption := '';
  Enabled := False;
  NumGlyphs := 2;
  ShowHint := True;
  Hint := RS_DbNavNew_Append;
  OnClick := ClickInsert;
end {Create};

destructor TTntmoDBInsert.Destroy;
begin
  FDataLink.Free;
  FDataLink := nil;
  inherited;
end {Destroy};

{--------------------------------------}

constructor TTntNavIDataLink.Create(ANav: TTntmoDBInsert);
begin
  inherited Create;
  FNavigator := ANav;
end; {Create}

destructor TTntNavIDataLink.Destroy;
begin
  FNavigator := nil;
  inherited Destroy;
end; {Destroy}

procedure TTntNavIDataLink.ActiveChanged;
begin
  if FNavigator <> nil then FNavigator.ActiveChanged;
end; {ActiveChanged}

{--------------------------------------}

end.
