{---------------------------------------------------------------------

 Several File Utils

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 05/19/2006 version

----------------------------------------------------------------------}

unit TntFileUtil2;

interface

uses
  Classes,
 {$IFDEF MSWINDOWS}
  Windows, TntWindows,
 {$ENDIF MSWINDOWS}
  Dialogs, Graphics,
  GrTypFun;

resourcestring
  RS_FF_FileNotFound = 'File'#13#10'%s'#13#10'not found';
  RS_FF_DirNotFound = 'Directory'#13#10'%s'#13#10'not found';
  RS_FF_OnToNotReadOnlyInCD = 'File'#13#10'%s'#13#10'is into CD: it can''t change only-read attribute';
  RS_FF_OnToNotReadOnly = 'It can''t change only-read attribute of file:'#13#10'%s';
  RS_FF_PromptIfReadOnlyToNoReadOnly = 'File'#13#10'%s'#13#10'has only-read attribute. Change the protection?';
  RS_FF_NotCreateDir = 'Error on creation'#13#10'%s';
  RS_FF_CantSelCD = 'Can''t select a CD';
  SFileNotExec = 'Specified file is not an executable file, dynamic-link library, or icon file';

const
  ExtExe = '.exe';

{ functions that returns WideString: }
{$IFDEF MSWINDOWS}
procedure ApplicationPathAndNameW (var Path, Name: WideString);
function ApplicationNameW: WideString; {Case sensitive}
function ApplicationPathW: WideString; {Case sensitive}
function ApplicationPathNameW: WideString; {without extension, case sensitives}
{$ENDIF MSWINDOWS}
function ExtractFileOnlyNameW (FileName: WideString): WideString;
   {X:\Path\Name.ext -> Name}
function ExtractFilePathAndOnlyNameW (FileName: WideString): WideString;
   {X:\Path\Name.ext -> X:\Path\Name}
function ExtractFileExtWithoutPointW (const FileName: WideString): WideString;
function FileNameStrFromOnlyNameChangedW (FileName: WideString;
  const NewName: WideString): WideString;  {X:\Path\OldName.ext -> X:\Path\NewName.ext}
function FileNameStrWithTildeW (const FileName: WideString): WideString;
  {X:\Path\N.ext -> X:\Path\~N.ext}
{$IFDEF MSWINDOWS}
function DriveByteFromDriveChar (Drive: Char): Byte;
{$ENDIF MSWINDOWS}

  {from LsFileExplorer27.pas Leo D. Shih's:}
function AddSlashW (Path: WideString): WideString;
function DelExistEndCharW (Path: WideString;  EndChar: WideChar): WideString;
function DelSlashW (Path: WideString): WideString;
{$IFDEF MSWINDOWS}
function GetNormalIconW (const Path: WideString): Integer;
function GetSelectedIconW (const Path: WideString): Integer;
{$ENDIF MSWINDOWS}

{$IFDEF MSWINDOWS}
function ValidRootDirectoryW: WideString; {Result = 'C:', if C is valid drive}
{$ENDIF MSWINDOWS}
function DownBranchW (var Path: WideString): Boolean;
  {if  Path = 'c:\aa\bb\' or 'c:\aa\bb' returns 'c:\aa'}
function ValidDirectoryW (InvalidDir: WideString): WideString;
  {InvalidDir not exist, then try obtain the first valid down branch,
   if InvalidDir drive is'nt valid call GetValidRootDirectory}
{$IFDEF MSWINDOWS}
function ValidDirectory2W (Dir: WideString): WideString;

{ functions, over files, that returns the last I/O operation performed: }
function CreateDirMessW (const Dir: WideString): Boolean;
function EraseEmptyDirW (const Dir: WideString;  var Count: Word): Boolean;
{$ENDIF MSWINDOWS}
function EraseFileW (const FileName: WideString): Integer;
{$IFDEF MSWINDOWS}
function FileIsReadOnlyW (const FileName: WideString): Boolean;
function FileSetNotReadOnlyW (const FileName: WideString): Boolean;
function FileSetReadOnlyW (const FileName: WideString): Boolean;
function FileExistsSetNotReadOnlyMessW (const FileName: WideString): Boolean;
{$ENDIF MSWINDOWS}
function RenameOnlyExtFileW (const FileName: WideString;
  const Ext: WideString): Integer;
function RenameFileToBakFileW (const FileName: WideString): Integer;
{$IFDEF MSWINDOWS}
function RenameFileIncROFW (const OldName, NewName: WideString;
  IncROF: Boolean): Boolean;
function FileSetDateIncROFW (const FileName: WideString;  Age: Integer;
  IncROF: Boolean): Boolean;
{$ENDIF MSWINDOWS}

{ other functions: }
{$IFDEF MSWINDOWS}
function FileExistsMessMDTW (const FileName: WideString;
  MDT: TMsgDlgType): Boolean;
function FileExistsMessW (const FileName: WideString): Boolean;
function DirectoryExistsMessW (const Dir: WideString): Boolean;
function FileTimeToDateTime (FTime: TFileTime): TDateTime; {from LsFileExplorer27.pas Leo D. Shih's:}
function FileSizeFromNotOpenFileW (const FileName: WideString): LongInt;
function DriveIsCDW (const Path: WideString): Boolean;
function DriveIsCDMessInvalSelectW (const Path: WideString): Boolean;
function FileContainsTextW (const NVF: WideString;  TextToFind: WideString;
  CaseSensitive: Boolean;  var IOError: Integer): Boolean;
{$ENDIF MSWINDOWS}
function ExtIsSameW (FileName, Ext: WideString): Boolean;

function IconExtractW(const FileName: WideString; Id: Integer): TIcon; //from RhShell

implementation

uses
  SysUtils, TntSysUtils, FileCtrl, ShellApi, Controls,
  JvConsts,
  TntMessUsual, TntWideStrUtils;

{$IFDEF MSWINDOWS}
procedure ApplicationPathAndNameW (var Path, Name: WideString);
var
  SearchRec: TSearchRecW;
begin
  if  WideFindFirst (ExpandFileName(ParamStr(0)), faAnyFile, SearchRec) = 0  then  begin
    { if use: Path := WideExtractFilePath (ExpandFileName(ParamStr(0))
      then: all characters are upcase!}
    Path := WideExtractFilePath (WideExpandFileName(ParamStr(0)));
    Name := WideChangeFileExt (SearchRec.Name, '');
  end
  else  begin
    Path := '';
    Name := '';
  end;
  WideFindClose (SearchRec);
end {ApplicationPathAndNameW};

function ApplicationNameW: WideString;
var
  Path: WideString;
begin
  ApplicationPathAndNameW (Path, Result);
end {ApplicationNameW};

function ApplicationPathW: WideString;
var
  NameExt: WideString;
begin
  ApplicationPathAndNameW (Result, NameExt);
end {ApplicationPathW};

function ApplicationPathNameW: WideString;
var
  Path, Name: WideString;
begin
  ApplicationPathAndNameW (Path, Name);
  if  Name = ''
  then
    Result := ''
  else  begin
    Name := Copy (Name, 1, Length(Name)-4);
    Result := Concat (Path, Name);
  end;
end {ApplicationPathNameW};
{$ENDIF MSWINDOWS}

function ExtractFileOnlyNameW (FileName: WideString): WideString;
var
  S: WideString;
  I: Byte;
begin
  S := WideExtractFileName (FileName);
  for  I := Length(S) downto 1  do
    if  S[I] = '.'
    then  Break;
  if  I = 1
  then  S := ''
  else  Delete (S, I, 255);
  Result := S;
end {ExtractFileOnlyNameW};

function ExtractFilePathAndOnlyNameW (FileName: WideString): WideString;
begin
  Result := Concat (WideExtractFilePath(FileName), ExtractFileOnlyNameW (FileName));
end {ExtractFilePathAndOnlyNameW};

function ExtractFileExtWithoutPointW (const FileName: WideString): WideString;
var
  S: TFileName;
begin
  S := WideExtractFileExt (FileName);
  if  S <> ''
  then  Delete (S, 1, 1);
  Result := S;
end {ExtractFileExtWithoutPointW};

function FileNameStrFromOnlyNameChangedW (FileName: WideString;
  const NewName: WideString): WideString;
var
  I, J: Integer;
begin
  I := WideLastDelimiter (PathDelim+DriveDelim, FileName);
  J := WideLastDelimiter (PathDelim+DriveDelim+'.', FileName);
  Delete (FileName, I+1, J-(I+1));
  Insert (NewName, FileName, I+1);
  Result := FileName;
end {FileNameStrFromOnlyNameChangedW};

function FileNameStrWithTildeW (const FileName: WideString): WideString;
begin
  Result := Concat (WideExtractFileDir(FileName), PathDelim+'~', WideExtractFileName(FileName));
end {FileNameStrWithTildeW};

{$IFDEF MSWINDOWS}
function DriveByteFromDriveChar (Drive: Char): Byte;
begin
  if  Drive in ['a'..'z']
  then  Dec (Drive,($20));
  Result :=  Ord(Drive) - $40;
end {DriveByteFromDriveChar};
{$ENDIF MSWINDOWS}

function AddSlashW (Path: WideString): WideString;
begin
  Result := WideIncludeTrailingBackslash (Path);
end {AddSlashW};

function DelExistEndCharW (Path: WideString;  EndChar: WideChar): WideString;
begin
  Result := Path;
  if  Path <> ''  then
    if  Path[Length(Path)] = EndChar  then
      Delete (Result, Length(Path), 1);
end {DelExistEndCharW};

function DelSlashW (Path: WideString): WideString;
begin
  Result := WideExcludeTrailingBackslash (Path);
end {DelSlashW};

{$IFDEF MSWINDOWS}
function GetNormalIconW (const Path: WideString): Integer;
var
  sfi: TShFileInfoW;
begin
  SHGetFileInfoW(PChar(Path), 0, sfi, SizeOf(TSHFileInfo),
    SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  Result := sfi.iIcon;
end; {GetNormalIcon}

function GetSelectedIconW (const Path: WideString): Integer;
var
  sfi: TShFileInfoW;
begin
  SHGetFileInfoW(PChar(Path), 0, sfi, SizeOf(TSHFileInfo),
    SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_OPENICON);
  Result := sfi.iIcon;
end; {GetSelectedIcon}
{$ENDIF MSWINDOWS}


{$IFDEF MSWINDOWS}
function ValidRootDirectoryW: WideString;
var
  WinDir : array[0..MAX_PATH] of WideChar;
  WC: WideChar;
  WS: WideString;
begin
  GetWindowsDirectoryW (WinDir, MAX_PATH);
  WC := WinDir[0];
  WS := ':';
  Result := WC + WS;
end {ValidRootDirectoryW};
{$ENDIF MSWINDOWS}

function DownBranchW (var Path: WideString): Boolean;
var
  I: Integer;
  Found: Boolean;
begin
  Found := False;
  Path := DelSlashW (Path);
  for  I := Length(Path) downto 1  do
    if  Path[I] = PathDelim  then  begin
      Found := True;
      Path := Copy (Path, 1, I-1);
      Break;
    end;
  Result := Found;
end {DownBranchW};

function ValidDirectoryW (InvalidDir: WideString): WideString;
var
  Valid: Boolean;
begin
  Valid := False;
  Result := ''; {for no warning compiler message}
 {$IFDEF MSWINDOWS}
  if  (Length (InvalidDir) >= 2) and (InvalidDir[2] <> DriveDelim)  then  begin
    Result := ValidRootDirectoryW;
    Exit;
  end;
 {$ENDIF MSWINDOWS}
  while  (Length (InvalidDir) > 2) and (not Valid)  do  begin
    Valid := DownBranchW (InvalidDir);
    if Valid then  begin
      Valid := WideDirectoryExists (InvalidDir);
      if Valid then  begin
        Result := InvalidDir;
        Exit;
      end;
    end;
  end;
  Result := ValidRootDirectoryW;
end {ValidDirectoryW};

{$IFDEF MSWINDOWS}
function ValidDirectory2W (Dir: WideString): WideString;
begin
  if  WideDirectoryExists (Dir)
  then  Result := Dir
  else  Result := ValidDirectoryW (Dir);
end;

function CreateDirMessW (const Dir: WideString): Boolean;
var
  Ok: Boolean;
begin
  Ok := WideCreateDir (Dir);
  if  not Ok
  then  WideMessageBoxError (WideFormat (RS_FF_NotCreateDir, [Dir]));
  Result := Ok;
end {CreateDirMessW};

function EraseEmptyDirW (const Dir: WideString;  var Count: Word): Boolean;
var
  Ok: Boolean;
  Found: Integer;
  SearchRec: TSearchRecW;
begin
  Ok := WideRemoveDir (Dir);
  if  not Ok  then  begin
    Found := WideFindFirst (Dir+PathDelim+AllFilePattern, faDirectory, SearchRec);
    while  Found = 0  do  begin
      if  SearchRec.Attr = faDirectory  then  begin
        if  not ((SearchRec.Name='.') or (SearchRec.Name='..'))  then  begin
          EraseEmptyDirW (Concat (Dir,PathDelim,SearchRec.Name), Count);
         {Recursive}
        end;
      end
      else  begin
        Break;
      end;
      Found := WideFindNext (SearchRec);
    end;
    WideFindClose (SearchRec);
    Result := WideRemoveDir (Dir);
  end
  else begin
    Result := Ok;
    Inc (Count);
  end;
end {EraseEmptyDirW};
{$ENDIF MSWINDOWS}

function EraseFileW (const FileName: WideString): Integer;
var
  AFile: file;
  Error: Integer;
begin
  AssignFile (AFile, FileName);
  {$I-}
  Reset (AFile);
  Error := IOResult;
  if  Error = 0  then  begin
    CloseFile (AFile);
    Erase (AFile);
    Result := IOResult;
  end
  else
    Result := Error;
  {$I+}
end {EraseFileW};

{$IFDEF MSWINDOWS}
function FileIsReadOnlyW (const FileName: WideString): Boolean;
var
  Attr: Integer;
begin
  Attr := WideFileGetAttr(FileName);
  Result := Attr and faReadOnly <> 0;
end {FileIsReadOnlyW};

function FileSetNotReadOnlyW (const FileName: WideString): Boolean;
var
  Attr: Integer;
begin
  Attr := WideFileGetAttr(FileName);
  if  (Attr <> -1) and (Attr and faReadOnly <> 0)  then  begin
    Attr := Attr and not faReadOnly;
    Result := WideFileSetAttr (FileName, Attr);
  end
  else
    Result := True;
end {FileSetNotReadOnlyW};

function FileSetReadOnlyW (const FileName: WideString): Boolean;
var
  Attr: Integer;
begin
  Attr := WideFileGetAttr(FileName);
  if  (Attr <> -1) and (Attr and faReadOnly = 0)  then  begin
    Attr := Attr or faReadOnly;
    Result := WideFileSetAttr (FileName, Attr);
  end
  else
    Result := True;
end {FileSetReadOnlyW};

function FileExistsSetNotReadOnlyMessW (const FileName: WideString): Boolean;
var
  Attr: Integer;
begin
  Attr := WideFileGetAttr(FileName);
  if  Attr = -1 {notExists}
  then  Result := True
  else if  Attr and faReadOnly <> 0  then  begin
    if  DriveIsCDW (FileName)  then  begin
      WideMessageBoxWarning (WideFormat (RS_FF_OnToNotReadOnlyInCD, [FileName]));
      Result := False;
    end
    else  begin
      if  WideUserSayYes (WideFormat (RS_FF_PromptIfReadOnlyToNoReadOnly, [FileName]))
      then  Result := FileSetNotReadOnlyW (FileName)
      else  Result := False;
    end;
  end
  else
    Result := True;
end {FileExistsSetNotReadOnlyMessW};
{$ENDIF MSWINDOWS}

function RenameOnlyExtFileW (const FileName: WideString;
  const Ext: WideString): Integer;
var
  NVFBak: WideString;
  AFile, FBak: file;
  Error: Integer;
begin
  NVFBak := WideChangeFileExt (FileName, Ext);
  AssignFile (AFile, FileName);
  {$I-}
  Rename (AFile, NVFBak);
  Error := IOResult;
  if  Error = 0  then  begin
    AssignFile (FBak, NVFBak);
    Erase (FBak);
    Rename (AFile, NVFBak);
    Result := IOResult;
  end
  else
    Result := Error;
  {$I+}
end {RenameOnlyExtFileW};

function RenameFileToBakFileW (const FileName: WideString): Integer;
begin
  Result := RenameOnlyExtFileW (FileName, '.bak');
end {RenameFileToBakFileW};

{$IFDEF MSWINDOWS}
function RenameFileIncROFW (const OldName, NewName: WideString;
  IncROF: Boolean): Boolean;
var
  IsReadOnly, Ok: Boolean;
begin
  IsReadOnly := FileIsReadOnlyW (OldName);
  if IsReadOnly then  begin
    if IncROF
    then  Ok := FileSetNotReadOnlyW (OldName)
    else  Ok := False;
  end
  else
    Ok := True;
  if Ok then  begin
    Ok := RenameFile (OldName, NewName);
    if Ok and IsReadOnly
    then  FileSetReadOnlyW (NewName);
  end;
  Result := Ok;
end {RenameFileIncROFW};

function FileSetDateIncROFW (const FileName: WideString;  Age: Integer;
  IncROF: Boolean): Boolean;
var
  IsReadOnly, Ok: Boolean;
begin
  IsReadOnly := FileIsReadOnlyW (FileName);
  if IsReadOnly then  begin
    if IncROF
    then  Ok := FileSetNotReadOnlyW (FileName)
    else  Ok := False;
  end
  else
    Ok := True;
  if Ok then  begin
    Ok := FileSetDate (FileName, Age) = 0;
    if Ok and IsReadOnly
    then  FileSetReadOnlyW (FileName);
  end;
  Result := Ok;
end {FileSetDateIncROFW};
{$ENDIF MSWINDOWS}


{$IFDEF MSWINDOWS}
function FileExistsMessMDTW (const FileName: WideString;  MDT: TMsgDlgType): Boolean;
var
  Exists: Boolean;
begin
  Exists := WideFileExists (FileName);
  if  not Exists
  then  WideMessageBoxMDT (WideFormat (RS_FF_FileNotFound, [FileName]), MDT);
  Result := Exists;
end {FileExistsMessMDTW};

function FileExistsMessW (const FileName: WideString): Boolean;
begin
  Result := FileExistsMessMDTW (FileName, mtError);
end {FileExistsMessW};

function DirectoryExistsMessW (const Dir: WideString): Boolean;
var
  Exists: Boolean;
begin
  Exists := WideDirectoryExists (Dir);
  if  not Exists
  then  WideMessageBoxError (WideFormat (RS_FF_DirNotFound, [Dir]));
  Result := Exists;
end {DirectoryExistsMessW};

function FileTimeToDateTime (FTime: TFileTime): TDateTime;  {New}
var
  SysTime       : TSystemTime;
  LocalFileTime : TFileTime;
begin
  FileTimeToLocalFileTime(Ftime, LocalFileTime);
  FileTimeToSystemTime(LocalFileTime, SysTime);
  Result := SystemTimeToDateTime(SysTime);
end; {FileTimeToDateTimeStr}

function FileSizeFromNotOpenFileW (const FileName: WideString): LongInt;
var
  win32FD: TWin32FindDataW;
  hFindFile: THandle;
begin
  hFindFile := Tnt_FindFirstFileW(PWideChar(FileName), win32FD);
  if  hFindFile = INVALID_HANDLE_VALUE
  then  Result := 0
  else  Result := ((win32FD.nFileSizeHigh * MAXDWORD) + win32FD.nFileSizeLow);
  Windows.FindClose(hFindFile);
end {FileSizeFromNotOpenFileW};

function FileSizeFromNotOpenFileAnErrorW (const FileName: WideString;  var IOError: Integer): LongInt;
var
  win32FD: TWin32FindDataW;
  hFindFile: THandle;
begin
  hFindFile := Tnt_FindFirstFileW(PWideChar(FileName), win32FD);
  if  hFindFile = INVALID_HANDLE_VALUE  then  begin
    Result := 0;
    IOError := -1;
  end
  else  begin
    Result := ((win32FD.nFileSizeHigh * MAXDWORD) + win32FD.nFileSizeLow);
    IOError := 0;
  end;
  Windows.FindClose(hFindFile);
end {FileSizeFromNotOpenFileW};

function DriveIsCDW (const Path: WideString): Boolean;
var
  A: array [0..2] of Char;
begin
  StrPCopy (A, Copy (Path, 1, 2));
  Result := GetDriveType(A) = DRIVE_CDROM;
end {DriveIsCDW};

function DriveIsCDMessInvalSelectW (const Path: WideString): Boolean;
var
  Ok: Boolean;
begin
  Ok := DriveIsCDW (Path);
  if  Ok
  then  WideMessageBoxError (RS_FF_CantSelCD);
  Result := Ok;
end {DriveIsCDMessInvalSelectW};

function FileContainsTextW (const NVF: WideString;  TextToFind: WideString;
  CaseSensitive: Boolean;  var IOError: Integer): Boolean;
var
  F: file;
  I, J, Size: Integer;
  K: Byte;
  Stop, Found: Boolean;
  Buffer: PWideChar;
function CharToFind (Z: Integer): WideChar;
begin
  Result := Buffer[Z];
  if  not CaseSensitive
  then  CharToFind := WideChar(Tnt_CharUpperW (PWideChar(Result)));
end {CharToFind};
begin
  Result := False;
  Size := FileSizeFromNotOpenFileAnErrorW (NVF, IOError);
  if  Size <> 0  then  begin
    if  not CaseSensitive
    then  TextToFind := Tnt_WideUpperCase (TextToFind);
    AssignFile (F, NVF);
    {$I-}
    Reset(F, 1);
    {$I+}
    IOError := IOResult;
    if  IOError = 0  then   begin
      try
        GetMem (Buffer, Size);
        try
          BlockRead (F, Buffer^, Size);
          for  I := 0 to Size  do  begin
            if  CharToFind(I) = TextToFind [1]  then  begin
              J := I;
              K :=  1;
              Stop := False;
              Found := False;
              while  (not Stop) and (J < Size) and (K < Length(TextToFind))  do  begin
                Inc (J);
                Inc (K);
                if  CharToFind(J) <> TextToFind [K]
                then  Stop := True;
                if  (not Stop) and (K = Length(TextToFind))
                then  Found := True;
              end;
              if  Found  then  begin
                Result := True;
                Break;
              end;
            end;
          end;
        finally
          FreeMem (Buffer);
        end;
      finally
        CloseFile(F);
      end;
    end;
  end;
end {FileContainsTextW};
{$ENDIF MSWINDOWS}

function ExtIsSameW (FileName, Ext: WideString): Boolean;
begin
  FileName := WideLowerCase (WideExtractFileExt (FileName));
  Ext := WideLowerCase (Ext);
  if  Ext[1] <> '.'
  then  Ext := '.' + Ext;
  Result := FileName = Ext;
end {ExtIsSameW};

function IconExtractW(const FileName: WideString; Id: Integer): TIcon;
var
  S: array[0..255] of WideChar;
  IconHandle: HIcon;
  Index: Word;
begin
  Result := TIcon.Create;
  try
   {$IFDEF COMPILER_7_UP}
    StrPLCopyW(S, FileName, SizeOf(S) - 1);
   {$ELSE}
    WStrPLCopy(S, FileName, SizeOf(S) - 1);
   {$ENDIF}
    IconHandle := ExtractIconW(hInstance, S, Id);
    if IconHandle < 2 then begin
      Index := Id;
      IconHandle := ExtractAssociatedIconW(hInstance, S, Index);
    end;
    if IconHandle < 2 then begin
      if IconHandle = 1 then
        raise EResNotFound.Create(SFileNotExec)
      else begin
        Result.Free;
        Result := nil;
      end;
    end else Result.Handle := IconHandle;
  except
    Result.Free;
    raise;
  end;
end {IconExtractW};

{--------------------------------------}

end {TntFileUtil2}.
