{---------------------------------------------------------------------

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version

----------------------------------------------------------------------}

unit TntJvSpinR;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, TntJvSpin;

type
  TTntJvSpinEditR = class(TTntJvSpinEdit)
  private
    FRequired: Boolean;
    FWinCtrlTitle: WideString;
    function GetValueInt: Integer;
    procedure SetValueInt(const NewValue: Integer);
  public
    constructor Create(AOwner : TComponent); override;
    procedure CreateWindowHandle(const Params: TCreateParams); override;
    function Valid: Boolean; virtual;
    function ValidNoMess: Boolean; virtual;
    property ValueInt: Integer read GetValueInt write SetValueInt;
  published
    property Required: Boolean read FRequired write FRequired default True;
    property WinCtrlTitle: WideString read FWinCtrlTitle write FWinCtrlTitle;
  end;

implementation

uses
  TntEdiTAmp, TntMessUsual;

{--------------------------------------}
{-PRIVATE----------}

function TTntJvSpinEditR.GetValueInt: Integer;
begin
  Result := Round (Value);
end;

procedure TTntJvSpinEditR.SetValueInt (const NewValue: Integer);
begin
  Value := NewValue;
end;

{-PUBLIC-----------}

constructor TTntJvSpinEditR.Create (AOwner : TComponent);
begin
  inherited Create(AOwner);
  FRequired := True;
  CheckOptions := [coCheckOnExit, coCropBeyondLimit];
  Text := '';
  Width := 69;
end {Create};

procedure TTntJvSpinEditR.CreateWindowHandle(const Params: TCreateParams);
begin
  inherited;
  if (csDesigning in ComponentState)
  then  Text := '';
end {CreateWindowHandle};

function TTntJvSpinEditR.Valid: Boolean;
begin
  Result := True;
  if FRequired then  begin
    if  Text = ''  then  begin
      if  WinCtrlTitle <> ''
      then
        WideMessageBoxError (Format (RS_EdiTAmp_EmptyDefinedEdit, [FWinCtrlTitle]))
      else
        WideMessageBoxError (RS_EdiTAmp_EmptyEdit);
      SetFocus;
      Result := False;
    end;
  end;
end {Valid};

function TTntJvSpinEditR.ValidNoMess: Boolean;
begin
  Result := True;
  if  FRequired and (Text = '')  then  begin
    Result := False;
  end;
end;

{--------------------------------------}

end.
