{---------------------------------------------------------------------

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-5  Jordi March i Nogu   jmarch@comg.es
 05/19/2006 version
 Includes WideString show messages and changeable Font

----------------------------------------------------------------------}

unit TntMessFont;

interface

uses
  Consts, Forms, TntForms, Graphics, Dialogs;

resourcestring
  SMsgDlgWarning = 'Warning';
  SMsgDlgError = 'Error';
  SMsgDlgInformation = 'Information';
  SMsgDlgConfirm = 'Confirm';
  SMsgDlgYes = '&Yes';
  SMsgDlgNo = '&No';
  SMsgDlgOK = 'OK';
  SMsgDlgCancel = 'Cancel';
  SMsgDlgHelp = '&Help';
  SMsgDlgHelpNone = 'No help available';
  SMsgDlgHelpHelp = 'Help';
  SMsgDlgAbort = '&Abort';
  SMsgDlgRetry = '&Retry';
  SMsgDlgIgnore = '&Ignore';
  SMsgDlgAll = '&All';
  SMsgDlgNoToAll = 'N&o to All';
  SMsgDlgYesToAll = 'Yes to &All';

function WideCreateMessageFDialog (const Msg: WideString;  F: TFont;
  WithIcon: Boolean;  DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons): TTntForm;

function WideMessageFDlg (const Msg: WideString;  F: TFont;
  WithIcon: Boolean;  DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons;  HelpCtx: Longint): Integer;
function WideMessageFDlgPos (const Msg: WideString;  F: TFont;
  WithIcon: Boolean;  DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons;  HelpCtx: Longint;  X, Y: Integer): Integer;
function WideMessageFDlgPosHelp (const Msg: WideString;  F: TFont;
  WithIcon: Boolean;  DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons;  HelpCtx: Longint;  X, Y: Integer;
  const HelpFileName: WideString): Integer;

procedure WideMessageFBoxWarning (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
procedure WideMessageFBoxError (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
procedure WideMessageFBoxInfo (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
procedure WideMessageFBox (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);

function WideMessageFCompletPrompt (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True): Integer;
function WideUserFSayYes (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True): Boolean;
function WideUserFSayYesWarning (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True): Boolean;

procedure WideMessageFBoxMDTTimer (const Msg: WideString;  MDT: TMsgDlgType;
  F: TFont;  WithIcon: Boolean = True);
procedure WideMessageFBoxWarningTimer (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
procedure WideMessageFBoxErrorTimer (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
procedure WideMessageFBoxInfoTimer (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
function  WideMessageFCompletPromptTimer (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True): Integer;

implementation

uses
  Classes, Windows, TntWindows, Controls, StdCtrls, ExtCtrls, Math, SysUtils,
  JvJVCLUtils,
  TntSysUtils, TntStdCtrls, TntSystem,
  VCtrls, TntMessUsual;

function GetAveCharSize(Canvas: TCanvas): TPoint;
var
  I: Integer;
  Buffer: array[0..51] of Char;
begin
  for I := 0 to 25 do Buffer[I] := Chr(I + Ord('A'));
  for I := 0 to 25 do Buffer[I + 26] := Chr(I + Ord('a'));
  GetTextExtentPoint(Canvas.Handle, Buffer, 52, TSize(Result));
  Result.X := Result.X div 52;
end;

type
  TWideMessageFForm = class(TTntForm)
  private
    procedure HelpButtonClick(Sender: TObject);
  public
    constructor CreateNew(AOwner: TComponent); reintroduce;
  end;

constructor TWideMessageFForm.CreateNew(AOwner: TComponent);
var
  NonClientMetrics: TNonClientMetrics;
begin
  inherited CreateNew(AOwner);
  NonClientMetrics.cbSize := sizeof(NonClientMetrics);
  if SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, @NonClientMetrics, 0) then
    Font.Handle := CreateFontIndirect(NonClientMetrics.lfMessageFont);
end;

procedure TWideMessageFForm.HelpButtonClick(Sender: TObject);
begin
  Application.HelpContext(HelpContext);
end;

var
  Captions: array[TMsgDlgType] of Pointer = (@SMsgDlgWarning, @SMsgDlgError,
    @SMsgDlgInformation, @SMsgDlgConfirm, nil);
  IconIDs: array[TMsgDlgType] of PChar = (IDI_EXCLAMATION, IDI_HAND,
    IDI_ASTERISK, IDI_QUESTION, nil);
  ButtonNames: array[TMsgDlgBtn] of string = (
    'Yes', 'No', 'OK', 'Cancel', 'Abort', 'Retry', 'Ignore', 'All', 'NoToAll',
    'YesToAll', 'Help');
  ButtonCaptions: array[TMsgDlgBtn] of Pointer = (
    @SMsgDlgYes, @SMsgDlgNo, @SMsgDlgOK, @SMsgDlgCancel, @SMsgDlgAbort,
    @SMsgDlgRetry, @SMsgDlgIgnore, @SMsgDlgAll, @SMsgDlgNoToAll, @SMsgDlgYesToAll,
    @SMsgDlgHelp);
  ModalResults: array[TMsgDlgBtn] of Integer = (
    mrYes, mrNo, mrOk, mrCancel, mrAbort, mrRetry, mrIgnore, mrAll, mrNoToAll,
    mrYesToAll, 0);
var
  ButtonWidths : array[TMsgDlgBtn] of integer;  // initialized to zero

function WideCreateMessageFDialog (const Msg: WideString;  F: TFont;
  WithIcon: Boolean;
  DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons): TTntForm;
const
  mcHorzMargin = 8;
  mcVertMargin = 8;
  mcHorzSpacing = 10;
  mcVertSpacing = 10;
  mcButtonWidth = 50;
  mcButtonHeight = 14;
  mcButtonSpacing = 4;
var
  DialogUnits: TPoint;
  HorzMargin, VertMargin, HorzSpacing, VertSpacing, ButtonWidth,
  ButtonHeight, ButtonSpacing, ButtonCount, ButtonGroupWidth,
  IconTextWidth, IconTextHeight, X, ALeft: Integer;
  B, DefaultButton, CancelButton: TMsgDlgBtn;
  IconID: PChar;
  TextRect: TRect;
  DefaultFont: TFont;
  Bitmap2: Graphics.TBitmap;
begin
  Result := TWideMessageFForm.CreateNew(Application);
  with Result do
  begin
    BiDiMode := Application.BiDiMode;
    BorderStyle := bsDialog;
    DefaultFont := TFont.Create;
    DefaultFont.Assign (Font);
    DefaultFont.Name := F.Name;
    DialogUnits := GetAveCharSize(Canvas);
    HorzMargin := MulDiv(mcHorzMargin, DialogUnits.X, 4);
    VertMargin := MulDiv(mcVertMargin, DialogUnits.Y, 8);
    HorzSpacing := MulDiv(mcHorzSpacing, DialogUnits.X, 4);
    VertSpacing := MulDiv(mcVertSpacing, DialogUnits.Y, 8);
    ButtonWidth := MulDiv(mcButtonWidth, DialogUnits.X, 4);
    for B := Low(TMsgDlgBtn) to High(TMsgDlgBtn) do
    begin
      if B in Buttons then
      begin
        if ButtonWidths[B] = 0 then
        begin
          TextRect := Rect(0,0,0,0);
          Tnt_DrawTextW(Canvas.Handle,
            PWideChar(WideLoadResString(ButtonCaptions[B])), -1,
            TextRect, DT_CALCRECT or DT_LEFT or DT_SINGLELINE or
            DrawTextBiDiModeFlagsReadingOnly);
          with TextRect do ButtonWidths[B] := Right - Left + 8;
        end;
        if ButtonWidths[B] > ButtonWidth then
          ButtonWidth := ButtonWidths[B];
      end;
    end;
    ButtonHeight := MulDiv(mcButtonHeight, DialogUnits.Y, 8);
    ButtonSpacing := MulDiv(mcButtonSpacing, DialogUnits.X, 4);
    SetRect(TextRect, 0, 0, Screen.Width div 2, 0);
    Font.Assign (F);
    Canvas.Font := Font;
    Tnt_DrawTextW(Canvas.Handle, PWideChar(Msg), Length(Msg)+1, TextRect,
      DT_EXPANDTABS or DT_CALCRECT or DT_WORDBREAK or
      DrawTextBiDiModeFlagsReadingOnly);
    if WithIcon
    then  IconID := IconIDs[DlgType]
    else  IconID := nil;
    IconTextWidth := TextRect.Right;
    IconTextHeight := TextRect.Bottom;
    if IconID <> nil then
    begin
      Inc(IconTextWidth, 32 + HorzSpacing);
      if IconTextHeight < 32 then IconTextHeight := 32;
    end;
    ButtonCount := 0;
    for B := Low(TMsgDlgBtn) to High(TMsgDlgBtn) do
      if B in Buttons then Inc(ButtonCount);
    ButtonGroupWidth := 0;
    if ButtonCount <> 0 then
      ButtonGroupWidth := ButtonWidth * ButtonCount +
        ButtonSpacing * (ButtonCount - 1);
    ClientWidth := Max(IconTextWidth, ButtonGroupWidth) + HorzMargin * 2;
    ClientHeight := IconTextHeight + ButtonHeight + VertSpacing +
      VertMargin * 2;
    Left := (Screen.Width div 2) - (Width div 2);
    Top := (Screen.Height div 2) - (Height div 2);
    if DlgType <> mtCustom then
      Caption := WideLoadResString(Captions[DlgType]) else
      Caption := Application.Title;
    if IconID <> nil then
      with TImage.Create(Result) do
      begin
        Name := 'Image';
        Parent := Result;
        Picture.Icon.Handle := LoadIcon(0, IconID);
        if  Application.UseRightToLeftAlignment  then  begin
          Bitmap2 := IconToBitmap2 (Picture.Icon.Handle, 32, clBtnFace);
          MirrorBitmapHorz (Bitmap2);
          Picture.Assign (Bitmap2);
          Bitmap2.Free;
        end;
        SetBounds(HorzMargin, VertMargin, 32, 32);
      end;
    with TTntLabel.Create(Result) do
    begin
      Name := 'Message';
      Parent := Result;
      WordWrap := True;
      Caption := Msg;
      BoundsRect := TextRect;
      BiDiMode := Result.BiDiMode;
      ALeft := IconTextWidth - TextRect.Right + HorzMargin;
      SetBounds(ALeft, VertMargin,
        TextRect.Right, TextRect.Bottom);
    end;
    if mbOk in Buttons then DefaultButton := mbOk else
      if mbYes in Buttons then DefaultButton := mbYes else
        DefaultButton := mbRetry;
    if mbCancel in Buttons then CancelButton := mbCancel else
      if mbNo in Buttons then CancelButton := mbNo else
        CancelButton := mbOk;
    X := (ClientWidth - ButtonGroupWidth) div 2;
    for B := Low(TMsgDlgBtn) to High(TMsgDlgBtn) do
      if B in Buttons then
        with TTntButton.Create(Result) do
        begin
          Font.Assign (DefaultFont);
          Name := ButtonNames[B];
          Parent := Result;
          Caption := WideLoadResString(ButtonCaptions[B]);
          ModalResult := ModalResults[B];
          if B = DefaultButton then Default := True;
          if B = CancelButton then Cancel := True;
          SetBounds(X, IconTextHeight + VertMargin + VertSpacing,
            ButtonWidth, ButtonHeight);
          Inc(X, ButtonWidth + ButtonSpacing);
          if B = mbHelp then
            OnClick := TWideMessageFForm(Result).HelpButtonClick;
        end;
    DefaultFont.Free;
    if  Application.UseRightToLeftAlignment  then  begin
      FlipChildren (True);
    end;
  end;
end {WideCreateMessageFDialog};

function WideMessageFDlg(const Msg: WideString;  F: TFont;
  WithIcon: Boolean;  DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons;  HelpCtx: Longint): Integer;
begin
  Result := WideMessageFDlgPosHelp (Msg, F, WithIcon, DlgType, Buttons, HelpCtx, -1, -1, '');
end;

function WideMessageFDlgPos(const Msg: WideString;  F: TFont;
  WithIcon: Boolean;  DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons;  HelpCtx: Longint;  X, Y: Integer): Integer;
begin
  Result := WideMessageFDlgPosHelp(Msg, F, WithIcon, DlgType, Buttons, HelpCtx, X, Y, '');
end;

function WideMessageFDlgPosHelp(const Msg: WideString;  F: TFont;
  WithIcon: Boolean;  DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons;  HelpCtx: Longint;  X, Y: Integer;
  const HelpFileName: WideString): Integer;
begin
  with WideCreateMessageFDialog (Msg, F, WithIcon, DlgType, Buttons) do
    try
      HelpContext := HelpCtx;
      HelpFile := HelpFileName;
      if X >= 0 then Left := X;
      if Y >= 0 then Top := Y;
      if (Y < 0) and (X < 0) then Position := poScreenCenter;
      Result := ShowModal;
    finally
      Free;
    end;
end {WideMessageFDlgPosHelp};

procedure WideMessageFBoxWarning (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
begin
  WideMessageFDlg (Msg, F, WithIcon, mtWarning, [mbOk], 0);
end;

procedure WideMessageFBoxError (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
begin
  WideMessageFDlg (Msg, F, WithIcon, mtError, [mbOk], 0);
end;

procedure WideMessageFBoxInfo (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
begin
  WideMessageFDlg (Msg, F, WithIcon, mtInformation, [mbOk], 0);
end;

procedure WideMessageFBox (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
begin
  WideMessageFDlg (Msg, F, WithIcon, mtInformation, [mbOk], 0);
end;


function WideMessageFCompletPrompt (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True): Integer;
begin
  Result := WideMessageFDlg (
    Msg, F, WithIcon, mtConfirmation, [mbYes, mbNo, mbCancel], 0);
end;

function WideUserFSayYes (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True): Boolean;
begin
  Result := WideMessageFDlg (
    Msg, F, WithIcon, mtConfirmation, [mbYes, mbNo], 0) = mrYes;
end;

function WideUserFSayYesWarning (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True): Boolean;
begin
  Result := WideMessageFDlg (
    Msg, F, WithIcon, mtWarning, [mbYes, mbNo], 0) = mrYes;
end;

{------------------}

function WideCreateMessageDialogTimer (const Msg: WideString;  F: TFont;
  WithIcon: Boolean;  DlgType: TMsgDlgType;  Buttons: TMsgDlgButtons): TTntForm;
var
  Form: TTntForm;
  T: TTimerH;
begin
  Form := WideCreateMessageFDialog (Msg, F, WithIcon, DlgType, Buttons);
  T := TTimerH.Create (Form);
  T.Interval := (Length (Msg) * TimeForChar) + 800;
  T.Enabled := True;
  Result := Form;
end {WideCreateMessageDialogTimer};

function WideMessageDlgPosHelpTimer (const Msg: WideString;  F: TFont;
  WithIcon: Boolean;  DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons;  HelpCtx: Longint;  X, Y: Integer;
  const HelpFileName: WideString): Integer;
begin
  with WideCreateMessageDialogTimer(Msg, F, WithIcon, DlgType, Buttons) do
    try
      HelpContext := HelpCtx;
      HelpFile := HelpFileName;
      if X >= 0 then Left := X;
      if Y >= 0 then Top := Y;
      if (Y < 0) and (X < 0) then Position := poScreenCenter;
      Result := ShowModal;
    finally
      Free;
    end;
end {WideMessageDlgPosHelpTimer};

function MessageFDlgTimer(const Msg: WideString;  F: TFont;
  WithIcon: Boolean;  DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons;  HelpCtx: Longint): Integer;
begin
  Result := WideMessageDlgPosHelpTimer (
    Msg, F, WithIcon, DlgType, Buttons, HelpCtx, -1, -1, '');
end;

procedure WideMessageFBoxMDTTimer (const Msg: WideString;  MDT: TMsgDlgType;
  F: TFont;  WithIcon: Boolean = True);
begin
  MessageFDlgTimer (Msg, F, WithIcon, MDT, [mbOk], 0);
end;

procedure WideMessageFBoxWarningTimer (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
begin
  WideMessageFBoxMDTTimer (Msg, mtWarning, F, WithIcon);
end;

procedure WideMessageFBoxErrorTimer (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
begin
  WideMessageFBoxMDTTimer (Msg, mtError, F, WithIcon);
end;

procedure WideMessageFBoxInfoTimer (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True);
begin
  WideMessageFBoxMDTTimer (Msg, mtInformation, F, WithIcon);
end;

function  WideMessageFCompletPromptTimer (const Msg: WideString;  F: TFont;
  WithIcon: Boolean = True): Integer;
begin
  Result := MessageFDlgTimer (Msg, F, WithIcon, mtConfirmation, [mbYes, mbNo, mbCancel], 0);
end;


end.
 
