{---------------------------------------------------------------------

 It's a copy from several Dialogs unit functions,
 that allow to set another Standard buttons captions.
 Example: ...
 SButtons = ['Yes Always!', 'No Never!', 'Cancel Sometimes...']
 where the first letters are one of ButtonNames

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version

 Portions created by Borland Software Corporation are
 Copyright (c) 1995-2005 Borland Software Corporation

----------------------------------------------------------------------}

unit TntMessOther; {Other Messages}

interface

uses
  Dialogs, Graphics;

{$DEFINE WithResize}
var
   mcButtonWidth: Integer = 50;

function WideMessageXFDlgPosHelp (const Msg: WideString;  F: TFont;
  DlgType: TMsgDlgType;
  const SButtons: array of WideString;  HelpCtx: Longint;  X, Y: Integer;
  const HelpFileName: WideString): Integer;
function WideMessageXFDlg (const Msg: WideString;  F: TFont;
  DlgType: TMsgDlgType;
  const SButtons: array of WideString;  HelpCtx: Longint): Integer;

function WideMessageXDlgPosHelp (const Msg: WideString;  DlgType: TMsgDlgType;
  const SButtons: array of WideString;  HelpCtx: Longint;  X, Y: Integer;
  const HelpFileName: WideString): Integer;
function WideMessageXDlg (const Msg: WideString;  DlgType: TMsgDlgType;
  const SButtons: array of WideString;  HelpCtx: Longint): Integer;

implementation

uses
  Windows, TntWindows, Forms, TntForms, Classes, SysUtils, Controls, TntSystem,
  StdCtrls, ExtCtrls, Consts, Math,
  JvJVCLUtils,
  TntStdCtrls, TntWideStrUtils,
  VCtrls;

function GetAveCharSize(Canvas: TCanvas): TPoint;
var
  I: Integer;
  Buffer: array[0..51] of Char;
begin
  for I := 0 to 25 do Buffer[I] := Chr(I + Ord('A'));
  for I := 0 to 25 do Buffer[I + 26] := Chr(I + Ord('a'));
  GetTextExtentPoint(Canvas.Handle, Buffer, 52, TSize(Result));
  Result.X := Result.X div 52;
end;

type
  TTntMessageForm = class(TTntForm)
  private
    procedure HelpButtonClick(Sender: TObject);
  public
    constructor CreateNew(AOwner: TComponent); reintroduce;
  end;

var
  ButtonWidths : array[TMsgDlgBtn] of integer;  // initialized to zero

constructor TTntMessageForm.CreateNew(AOwner: TComponent);
var
  NonClientMetrics: TNonClientMetrics;
begin
  inherited CreateNew(AOwner);
  NonClientMetrics.cbSize := sizeof(NonClientMetrics);
  if SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, @NonClientMetrics, 0) then
    Font.Handle := CreateFontIndirect(NonClientMetrics.lfMessageFont);
end;

procedure TTntMessageForm.HelpButtonClick(Sender: TObject);
begin
  Application.HelpContext(HelpContext);
end;

var
  Captions: array[TMsgDlgType] of Pointer
   { = (@SMsgDlgWarning, @SMsgDlgError, @SMsgDlgInformation, @SMsgDlgConfirm,
    nil)};
  IconIDs: array[TMsgDlgType] of PChar = (IDI_EXCLAMATION, IDI_HAND,
    IDI_ASTERISK, IDI_QUESTION, nil);
  ButtonNames: array[TMsgDlgBtn] of String[8] = (
    'Yes', 'No', 'OK', 'Cancel', 'Abort', 'Retry', 'Ignore', 'All', 'NoToAll',
    'YesToAll', 'Help');
  ButtonCaptions: array[TMsgDlgBtn] of Pointer
   { = (
    @SMsgDlgYes, @SMsgDlgNo, @SMsgDlgOK, @SMsgDlgCancel, @SMsgDlgAbort,
    @SMsgDlgRetry, @SMsgDlgIgnore, @SMsgDlgAll, @SMsgDlgNoToAll,
    @SMsgDlgYesToAll, @SMsgDlgHelp)};
  ModalResults: array[TMsgDlgBtn] of Integer = (
    mrYes, mrNo, mrOk, mrCancel, mrAbort, mrRetry, mrIgnore, mrAll, mrNoToAll,
    mrYesToAll, 0);

function WideCreateMessageXDialog (const Msg: WideString;  F: TFont;
  DlgType: TMsgDlgType;  const SButtons: array of WideString): TTntForm;
type
  TButtonSCaptions = array[TMsgDlgBtn] of PWideChar;
const
  mcHorzMargin = 8;
  mcVertMargin = 8;
  mcHorzSpacing = 10;
  mcVertSpacing = 10;
  mcButtonHeight = 14;
  mcButtonSpacing = 4;
var
  Buttons: TMsgDlgButtons;
  ButtonSCaptions: TButtonSCaptions;
  DialogUnits: TPoint;
  HorzMargin, VertMargin, HorzSpacing, VertSpacing, ButtonWidth,
  ButtonHeight, ButtonSpacing, ButtonCount, ButtonGroupWidth,
  IconTextWidth, IconTextHeight, X, ALeft: Integer;
  B, DefaultButton, CancelButton: TMsgDlgBtn;
  IconID: PChar;
  TextRect: TRect;
  P: Byte;
  I: Integer;
  Bitmap2: Graphics.TBitmap;
begin
  Buttons := [];
  for  B := mbYes to mbHelp  do
    ButtonSCaptions[B] := nil;
  for  I := 0 to High(SButtons)  do
    for  B := mbYes to mbHelp  do  begin
      P := Pos (ButtonNames[B]+' ', SButtons[I]);
      if  (SButtons[I] = ButtonNames[B]) or (P = 1)  then  begin
        Buttons := Buttons + [B];
        if  P = 1  then  begin
          ButtonSCaptions[B] :=
            WStrNew(PWideChar(Copy (SButtons[I], Pos(' ',SButtons[I])+1, MaxInt)));
        end;
        Break;
      end;
    end;
  Result := TTntMessageForm.CreateNew(Application);
  with Result do
  begin
    BiDiMode := Application.BiDiMode;
    BorderStyle := bsDialog;
    Scaled := False;
    DialogUnits := GetAveCharSize(Canvas);
    HorzMargin := MulDiv(mcHorzMargin, DialogUnits.X, 4);
    VertMargin := MulDiv(mcVertMargin, DialogUnits.Y, 8);
    HorzSpacing := MulDiv(mcHorzSpacing, DialogUnits.X, 4);
    VertSpacing := MulDiv(mcVertSpacing, DialogUnits.Y, 8);
    ButtonWidth := MulDiv(mcButtonWidth, DialogUnits.X, 4);
    for B := Low(TMsgDlgBtn) to High(TMsgDlgBtn) do
    begin
      if B in Buttons then
      begin
        if ButtonWidths[B] = 0 then
        begin
          TextRect := Rect(0,0,0,0);
          Tnt_DrawTextW(Canvas.Handle,
            PWideChar(WideLoadResString(ButtonCaptions[B])), -1,
            TextRect, DT_CALCRECT or DT_LEFT or DT_SINGLELINE or
            DrawTextBiDiModeFlagsReadingOnly);
          with TextRect do ButtonWidths[B] := Right - Left + 8;
        end;
        if ButtonWidths[B] > ButtonWidth then
          ButtonWidth := ButtonWidths[B];
      end;
    end;
    ButtonHeight := MulDiv(mcButtonHeight, DialogUnits.Y, 8);
    ButtonSpacing := MulDiv(mcButtonSpacing, DialogUnits.X, 4);
    SetRect(TextRect, 0, 0, Screen.Width div 2, 0);
    Font.Assign (F);
    Canvas.Font := Font;
    Tnt_DrawTextW(Canvas.Handle, PWideChar(Msg), Length(Msg)+1, TextRect,
      DT_EXPANDTABS or DT_CALCRECT or DT_WORDBREAK or
      DrawTextBiDiModeFlagsReadingOnly);
    IconID := IconIDs[DlgType];
    IconTextWidth := TextRect.Right;
    IconTextHeight := TextRect.Bottom;
    if IconID <> nil then
    begin
      Inc(IconTextWidth, 32 + HorzSpacing);
      if IconTextHeight < 32 then IconTextHeight := 32;
    end;
    ButtonCount := 0;
    for B := Low(TMsgDlgBtn) to High(TMsgDlgBtn) do
      if B in Buttons then Inc(ButtonCount);
    ButtonGroupWidth := 0;
    if ButtonCount <> 0 then
      ButtonGroupWidth := ButtonWidth * ButtonCount +
        ButtonSpacing * (ButtonCount - 1);
    ClientWidth := Max(IconTextWidth, ButtonGroupWidth) + HorzMargin * 2;
    ClientHeight := IconTextHeight + ButtonHeight + VertSpacing +
      VertMargin * 2;
    Left := (Screen.Width div 2) - (Width div 2);
    Top := (Screen.Height div 2) - (Height div 2);
    if DlgType <> mtCustom then
      Caption := WideLoadResString(Captions[DlgType]) else
      Caption := Application.Title;
    if IconID <> nil then
      with TImage.Create(Result) do
      begin
        Name := 'Image';
        Parent := Result;
        Picture.Icon.Handle := LoadIcon(0, IconID);
        if  Application.UseRightToLeftAlignment  then  begin
          Bitmap2 := IconToBitmap2 (Picture.Icon.Handle, 32, clBtnFace);
          MirrorBitmapHorz (Bitmap2);
          Picture.Assign (Bitmap2);
          Bitmap2.Free;
        end;
        SetBounds(HorzMargin, VertMargin, 32, 32);
      end;
    with TTntLabel.Create(Result) do
    begin
      Name := 'Message';
      Parent := Result;
      WordWrap := True;
      Caption := Msg;
      BoundsRect := TextRect;
      BiDiMode := Result.BiDiMode;
      ALeft := IconTextWidth - TextRect.Right + HorzMargin;
      SetBounds(ALeft, VertMargin,
        TextRect.Right, TextRect.Bottom);
    end;
    if mbOk in Buttons then DefaultButton := mbOk else
      if mbYes in Buttons then DefaultButton := mbYes else
        DefaultButton := mbRetry;
    if mbCancel in Buttons then CancelButton := mbCancel else
      if mbNo in Buttons then CancelButton := mbNo else
        CancelButton := mbOk;
    X := (ClientWidth - ButtonGroupWidth) div 2;
    for B := Low(TMsgDlgBtn) to High(TMsgDlgBtn) do
      if B in Buttons then
        with TTntButton.Create(Result) do
        begin
          Name := ButtonNames[B];
          Font.Name := F.Name;
          Parent := Result;
          if  ButtonSCaptions[B] <> nil  then  begin
            Caption := ButtonSCaptions[B];
            WStrDispose(ButtonSCaptions[B]);
          end
          else
            Caption := WideLoadResString(ButtonCaptions[B]);
          ModalResult := ModalResults[B];
          if B = DefaultButton then Default := True;
          if B = CancelButton then Cancel := True;
          SetBounds(X, IconTextHeight + VertMargin + VertSpacing,
            ButtonWidth, ButtonHeight);
          Inc(X, ButtonWidth + ButtonSpacing);
          if B = mbHelp then
            OnClick := TTntMessageForm(Result).HelpButtonClick;
        end;
    if  Application.UseRightToLeftAlignment  then  begin
      FlipChildren (True);
    end;
  end;
end {WideCreateMessageXDialog};


function WideMessageXFDlgPosHelp (const Msg: WideString;  F: TFont;
  DlgType: TMsgDlgType;
  const SButtons: array of WideString;  HelpCtx: Longint;  X, Y: Integer;
  const HelpFileName: WideString): Integer;
begin
  with WideCreateMessageXDialog (Msg, F, DlgType, SButtons) do
    try
      HelpContext := HelpCtx;
      HelpFile := HelpFileName;
      if X >= 0 then Left := X;
      if Y >= 0 then Top := Y;
      if (Y < 0) and (X < 0) then Position := poScreenCenter;
      Result := ShowModal;
    finally
      Free;
    end;
end {WideMessageXFDlgPosHelp};

function WideMessageXFDlg (const Msg: WideString;  F: TFont;
  DlgType: TMsgDlgType;
  const SButtons: array of WideString;  HelpCtx: Longint): Integer;
begin
  Result := WideMessageXFDlgPosHelp (Msg, F, DlgType, SButtons, HelpCtx, -1, -1, '');
end;

function WideMessageXDlgPosHelp (const Msg: WideString;  DlgType: TMsgDlgType;
  const SButtons: array of WideString;  HelpCtx: Longint;  X, Y: Integer;
  const HelpFileName: WideString): Integer;
var
  L: TLabel;
begin
  L := TLabel.Create(Application);
  Result := WideMessageXFDlgPosHelp (Msg, L.Font, DlgType, SButtons, HelpCtx, X, Y, HelpFileName);
  L.Free;
end;

function WideMessageXDlg (const Msg: WideString;  DlgType: TMsgDlgType;
  const SButtons: array of WideString;  HelpCtx: Longint): Integer;
begin
  Result := WideMessageXDlgPosHelp (Msg, DlgType, SButtons, HelpCtx, -1, -1, '');
end;


begin
  {Declared here for no
  "Need imported data reference ($G) compiler error"
   when MessOther is in a Package}
  Captions[mtWarning]      := @SMsgDlgWarning;
  Captions[mtError]        := @SMsgDlgError;
  Captions[mtInformation]  := @SMsgDlgInformation;
  Captions[mtConfirmation] := @SMsgDlgConfirm;
  Captions[mtCustom]       := nil;
  ButtonCaptions[mbYes]      := @SMsgDlgYes;
  ButtonCaptions[mbNo]       := @SMsgDlgNo;
  ButtonCaptions[mbOK]       := @SMsgDlgOK;
  ButtonCaptions[mbCancel]   := @SMsgDlgCancel;
  ButtonCaptions[mbAbort]    := @SMsgDlgAbort;
  ButtonCaptions[mbRetry]    := @SMsgDlgRetry;
  ButtonCaptions[mbIgnore]   := @SMsgDlgIgnore;
  ButtonCaptions[mbAll]      := @SMsgDlgAll;
  ButtonCaptions[mbNoToAll]  := @SMsgDlgNoToAll;
  ButtonCaptions[mbYesToAll] := @SMsgDlgYesToAll;
  ButtonCaptions[mbHelp]     := @SMsgDlgHelp;
end.
