unit TntNewAbout;

interface

{$INCLUDE JVCL.inc}

uses
  {$IFDEF DELPHI_6_UP} RTLConsts, DesignIntf, DesignEditors, VCLEditors
    {$ELSE} DsgnIntf {$ENDIF}, TntAbout, TntJvAbout;

type
  TAboutTntNew = class(TAboutTntJv00)
  protected
    function DialogTitle: string; override;
    function PropertyTitle: string; override;
  end;

  TAboutH0 = class(TAboutTntNew)
  protected
    function DialogMess: string; override;
  end;

  TAboutH1 = class(TAboutTntNew)
  protected
    function DialogMess: string; override;
  end;

  TAboutH2 = class(TAboutTntNew)
  protected
    function AuthorMess: string; virtual; abstract;
    function DialogMess: string; override;
  end;

  TAboutH3 = class(TAboutTntNew)
  protected
    function AuthorMess: string; virtual; abstract;
    function DialogMess: string; override;
  end;

implementation

uses
  SysUtils;

{--------------------------------------}
{-PROTECTED--------}

function TAboutTntNew.DialogTitle: string;
begin
  Result := 'Tnt-New';
end;

function TAboutTntNew.PropertyTitle: string;
begin
  Result := Concat ('Tnt-New, Version ', '3.1');
end;

{--------------------------------------}
{-PROTECTED--------}

function TAboutH0.DialogMess: string;
const
  MainMess = 'Adapted by'#13#10'%s'#13#10#13#10+
    'Used:'#13#10'%s';
begin
  Result := Format (MainMess, [JMNMess, TntWareStr]);
end;

{--------------------------------------}
{-PROTECTED--------}

function TAboutH1.DialogMess: string;
const
  MainMess = 'Adapted by'#13#10'%s'#13#10#13#10+
    'Used:'#13#10'%s'#13#10'and'#13#10'%s';
begin
  Result := Format (MainMess, [JMNMess, TntWareStr, JVCLStr]);
end;

{--------------------------------------}
{-PROTECTED--------}

function TAboutH2.DialogMess: string;
const
  MainMess = 'Adapted by'#13#10'%s'#13#10'from'#13#10'%s'#13#10#13#10+
    'Used:'#13#10'%s'#13#10'and'#13#10'%s';
begin
  Result := Format (MainMess, [JMNMess, AuthorMess, TntWareStr, JVCLStr]);
end;

{--------------------------------------}
{-PROTECTED--------}

function TAboutH3.DialogMess: string;
const
  MainMess = 'Adapted by'#13#10'%s'#13#10'from'#13#10'%s'#13#10#13#10+
    'Used:'#13#10'%s';
begin
  Result := Format (MainMess, [JMNMess, AuthorMess, TntWareStr]);
end;

{--------------------------------------}

end.
