 {---------------------------------------------------------------------

 Implementation of a TEdit component with ValidChars string filter

 (c) Copyleft or copyright under terms of GNU General Public License
 2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version

----------------------------------------------------------------------}


unit TntRfEdit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, TntEdiTAmp;

type
  TTntRFilterEdit = class (TTntEditR)
  private
    FValidCharsStr: WideString;
    procedure SetValidCharsStr (const Value: WideString);
    procedure WMChar(var Message: TWMChar); message WM_CHAR;
  protected
    function DoKeyPressW(var Message: TWMKey): Boolean;
  published
    property ValidCharsStr: WideString read FValidCharsStr write SetValidCharsStr;
  end;

implementation

uses
  TntStrUtil0;

{--------------------------------------}
{-PRIVATE----------}

procedure TTntRFilterEdit.SetValidCharsStr (const Value: WideString);
var
  S: WideString;
  I: Byte;
begin
  if  Value = ''
  then  FValidCharsStr := ''
  else  begin
    S := '';
    for  I := 1 to length (Value)  do
      if  Pos (Value[I], S) = 0
      then  S := S + Value[I];
    FValidCharsStr := S;
  end;
end {SetValidCharsStr};

procedure TTntRFilterEdit.WMChar(var Message: TWMChar);
begin
  if  not DoKeyPressW (Message)  then  inherited;
end;

{-PROTECTED--------}

function TTntRFilterEdit.DoKeyPressW(var Message: TWMKey): Boolean;
var
  Ch: WideChar;
begin
  Result := True;
  if not (csNoStdEvents in ControlStyle) then
    with Message do
    begin
      if  Unused = 0
      then  Ch := WideChar (CharCode)
      else  Ch := WideChar (Unused);
      if  FValidCharsStr <> ''  then  begin
        case CharCase of
        ecUpperCase: Ch := WideUpCase (Ch);
        ecLowerCase: Ch := WideLoCase (Ch);
        end;
        if (Pos (Ch,FValidCharsStr) = 0)
        then  Exit;
      end;
    end;
  Result := False;
end {DoKeyPressW};

{--------------------------------------}

end.
