{---------------------------------------------------------------------

 Modified from several Libraries

 (c) Copyleft or copyright under terms of GNU General Public License
 2003-2006  Jordi March i Nogu   jmarch@comg.es
 03/01/2006 version

 03/08/2006:
Analyse composed WideChar (for example:  -> A+`.)
Find compatible WideChar (for example: =$00A8 == ' '=$0020 + $0308)
Find Block of WideChar ('Basic Latin', 'Cyrillic', 'Armenian', etc.)

----------------------------------------------------------------------}

unit TntStrUtil0;

{$F+,O+,X+,S-,D+,L+}

interface

uses
  GrTypFun;

function WCharToStr1 (Ch: WideChar): WideString;
function WideUpCase (Ch: WideChar): WideChar;
function WideLoCase (Ch: WideChar): WideChar;
function WCharIsLetter (Ch: WideChar): Boolean;
function WCharIsLetterUppercase (Ch: WideChar): Boolean;
function WCharIsLetterLowercase (Ch: WideChar): Boolean;
function WCharIsLetterTitlecase (Ch: WideChar): Boolean;
function WCharIsLetterOther (Ch: WideChar): Boolean;
function WCharIsLeftToRight (Ch: WideChar): Boolean;
function WCharIsRightToLeft (Ch: WideChar): Boolean;
function WCharIsCharSpace (Ch: WideChar): Boolean;
function WCharHasModi (Ch: WideChar;  out ChWithoutModi, ChModi: WideChar): Boolean;
function WCharFromSingles (ChWithoutModi, ChModi: WideChar;  out Ch: WideChar): Boolean;
function WCharHasCompat (Ch: WideChar;  out Ch1, Ch2: WideChar): Boolean;
function WStrWithThisModifier (Modifier: WideChar;
  out Composed, Single: WideString): Boolean;
function WCharToWithoutModifierWChar (Ch: WideChar): WideChar;
function WCharToWithoutModifierWCharModi (Ch: WideChar;
  out Modified: Boolean): WideChar;
function WStrToWithoutModifierWStr (const S: WideString): WideString;
function WStrToWithoutModifierWStrModi (const S: WideString;
  out Modified: Boolean): WideString;

function WideDelBChar (const S: WideString;  Ch: WideChar): WideString;
function WideDelEChar (const S: WideString;  Ch: WideChar): WideString;
function WideAddChar (C: WideChar;  const S: WideString;  N: Integer): WideString;
function WideAddCharR (C: WideChar;  const S: WideString;  N: Integer): WideString;
function WideLeftStr (const S: WideString;  N: Integer): WideString;
function WideRightStr (const S: WideString;  N: Integer): WideString;
function DelAmpersandW (const S: WideString): WideString;
function StrReplaceCharW (const S: WideString;  {from JCL strings}
  const Source, Replace: WideChar): WideString;
function StrReplaceSpaceToUnderscoreCharW (const S: WideString): WideString;
function StrReplaceUnderscoreToSpaceCharW (const S: WideString): WideString;
function StrCapitalizedW (const S: WideString;
  AllWords, ReplaceUnderscore: Boolean): WideString;
function StrQuotedW (S: WideString): WideString;
function ConcatWithStrW (const SBegin, SEnd, Sep: WideString): WideString;
function ConcatWithStrXW (const SBegin, SEnd, Sep: WideString): WideString;
function ConcatSpacedW (const SBegin, SEnd: WideString): WideString;
function RemoveCharsW (const S, InvalidChars: WideString): WideString;
function RemoveDuplicatedCharsW (const S: WideString): WideString;

type
  TwoIntegers = array [1..2] of Integer;
  ThreeIntegers = array [1..3] of Integer;
const
  ComposedChrArrN = 989;
  {(, A,`),...}
  ComposedChrArr: array [0..ComposedChrArrN-1] of ThreeIntegers = (
   ($00C0, $0041, $0300), ($00C1, $0041, $0301), ($00C2, $0041, $0302), ($00C3, $0041, $0303), ($00C4, $0041, $0308),
   ($00C5, $0041, $030A), ($00C7, $0043, $0327), ($00C8, $0045, $0300), ($00C9, $0045, $0301), ($00CA, $0045, $0302),
   ($00CB, $0045, $0308), ($00CC, $0049, $0300), ($00CD, $0049, $0301), ($00CE, $0049, $0302), ($00CF, $0049, $0308),
   ($00D1, $004E, $0303), ($00D2, $004F, $0300), ($00D3, $004F, $0301), ($00D4, $004F, $0302), ($00D5, $004F, $0303),
   ($00D6, $004F, $0308), ($00D9, $0055, $0300), ($00DA, $0055, $0301), ($00DB, $0055, $0302), ($00DC, $0055, $0308),
   ($00DD, $0059, $0301), ($00E0, $0061, $0300), ($00E1, $0061, $0301), ($00E2, $0061, $0302), ($00E3, $0061, $0303),
   ($00E4, $0061, $0308), ($00E5, $0061, $030A), ($00E7, $0063, $0327), ($00E8, $0065, $0300), ($00E9, $0065, $0301),
   ($00EA, $0065, $0302), ($00EB, $0065, $0308), ($00EC, $0069, $0300), ($00ED, $0069, $0301), ($00EE, $0069, $0302),
   ($00EF, $0069, $0308), ($00F1, $006E, $0303), ($00F2, $006F, $0300), ($00F3, $006F, $0301), ($00F4, $006F, $0302),
   ($00F5, $006F, $0303), ($00F6, $006F, $0308), ($00F9, $0075, $0300), ($00FA, $0075, $0301), ($00FB, $0075, $0302),
   ($00FC, $0075, $0308), ($00FD, $0079, $0301), ($00FF, $0079, $0308), ($0100, $0041, $0304), ($0101, $0061, $0304),
   ($0102, $0041, $0306), ($0103, $0061, $0306), ($0104, $0041, $0328), ($0105, $0061, $0328), ($0106, $0043, $0301),
   ($0107, $0063, $0301), ($0108, $0043, $0302), ($0109, $0063, $0302), ($010A, $0043, $0307), ($010B, $0063, $0307),
   ($010C, $0043, $030C), ($010D, $0063, $030C), ($010E, $0044, $030C), ($010F, $0064, $030C), ($0112, $0045, $0304),
   ($0113, $0065, $0304), ($0114, $0045, $0306), ($0115, $0065, $0306), ($0116, $0045, $0307), ($0117, $0065, $0307),
   ($0118, $0045, $0328), ($0119, $0065, $0328), ($011A, $0045, $030C), ($011B, $0065, $030C), ($011C, $0047, $0302),
   ($011D, $0067, $0302), ($011E, $0047, $0306), ($011F, $0067, $0306), ($0120, $0047, $0307), ($0121, $0067, $0307),
   ($0122, $0047, $0327), ($0123, $0067, $0327), ($0124, $0048, $0302), ($0125, $0068, $0302), ($0128, $0049, $0303),
   ($0129, $0069, $0303), ($012A, $0049, $0304), ($012B, $0069, $0304), ($012C, $0049, $0306), ($012D, $0069, $0306),
   ($012E, $0049, $0328), ($012F, $0069, $0328), ($0130, $0049, $0307), ($0134, $004A, $0302), ($0135, $006A, $0302),
   ($0136, $004B, $0327), ($0137, $006B, $0327), ($0139, $004C, $0301), ($013A, $006C, $0301), ($013B, $004C, $0327),
   ($013C, $006C, $0327), ($013D, $004C, $030C), ($013E, $006C, $030C), ($0143, $004E, $0301), ($0144, $006E, $0301),
   ($0145, $004E, $0327), ($0146, $006E, $0327), ($0147, $004E, $030C), ($0148, $006E, $030C), ($014C, $004F, $0304),
   ($014D, $006F, $0304), ($014E, $004F, $0306), ($014F, $006F, $0306), ($0150, $004F, $030B), ($0151, $006F, $030B),
   ($0154, $0052, $0301), ($0155, $0072, $0301), ($0156, $0052, $0327), ($0157, $0072, $0327), ($0158, $0052, $030C),
   ($0159, $0072, $030C), ($015A, $0053, $0301), ($015B, $0073, $0301), ($015C, $0053, $0302), ($015D, $0073, $0302),
   ($015E, $0053, $0327), ($015F, $0073, $0327), ($0160, $0053, $030C), ($0161, $0073, $030C), ($0162, $0054, $0327),
   ($0163, $0074, $0327), ($0164, $0054, $030C), ($0165, $0074, $030C), ($0168, $0055, $0303), ($0169, $0075, $0303),
   ($016A, $0055, $0304), ($016B, $0075, $0304), ($016C, $0055, $0306), ($016D, $0075, $0306), ($016E, $0055, $030A),
   ($016F, $0075, $030A), ($0170, $0055, $030B), ($0171, $0075, $030B), ($0172, $0055, $0328), ($0173, $0075, $0328),
   ($0174, $0057, $0302), ($0175, $0077, $0302), ($0176, $0059, $0302), ($0177, $0079, $0302), ($0178, $0059, $0308),
   ($0179, $005A, $0301), ($017A, $007A, $0301), ($017B, $005A, $0307), ($017C, $007A, $0307), ($017D, $005A, $030C),
   ($017E, $007A, $030C), ($01A0, $004F, $031B), ($01A1, $006F, $031B), ($01AF, $0055, $031B), ($01B0, $0075, $031B),
   ($01CD, $0041, $030C), ($01CE, $0061, $030C), ($01CF, $0049, $030C), ($01D0, $0069, $030C), ($01D1, $004F, $030C),
   ($01D2, $006F, $030C), ($01D3, $0055, $030C), ($01D4, $0075, $030C), ($01D5, $00DC, $0304), ($01D6, $00FC, $0304),
   ($01D7, $00DC, $0301), ($01D8, $00FC, $0301), ($01D9, $00DC, $030C), ($01DA, $00FC, $030C), ($01DB, $00DC, $0300),
   ($01DC, $00FC, $0300), ($01DE, $00C4, $0304), ($01DF, $00E4, $0304), ($01E0, $0226, $0304), ($01E1, $0227, $0304),
   ($01E2, $00C6, $0304), ($01E3, $00E6, $0304), ($01E6, $0047, $030C), ($01E7, $0067, $030C), ($01E8, $004B, $030C),
   ($01E9, $006B, $030C), ($01EA, $004F, $0328), ($01EB, $006F, $0328), ($01EC, $01EA, $0304), ($01ED, $01EB, $0304),
   ($01EE, $01B7, $030C), ($01EF, $0292, $030C), ($01F0, $006A, $030C), ($01F4, $0047, $0301), ($01F5, $0067, $0301),
   ($01F8, $004E, $0300), ($01F9, $006E, $0300), ($01FA, $00C5, $0301), ($01FB, $00E5, $0301), ($01FC, $00C6, $0301),
   ($01FD, $00E6, $0301), ($01FE, $00D8, $0301), ($01FF, $00F8, $0301), ($0200, $0041, $030F), ($0201, $0061, $030F),
   ($0202, $0041, $0311), ($0203, $0061, $0311), ($0204, $0045, $030F), ($0205, $0065, $030F), ($0206, $0045, $0311),
   ($0207, $0065, $0311), ($0208, $0049, $030F), ($0209, $0069, $030F), ($020A, $0049, $0311), ($020B, $0069, $0311),
   ($020C, $004F, $030F), ($020D, $006F, $030F), ($020E, $004F, $0311), ($020F, $006F, $0311), ($0210, $0052, $030F),
   ($0211, $0072, $030F), ($0212, $0052, $0311), ($0213, $0072, $0311), ($0214, $0055, $030F), ($0215, $0075, $030F),
   ($0216, $0055, $0311), ($0217, $0075, $0311), ($0218, $0053, $0326), ($0219, $0073, $0326), ($021A, $0054, $0326),
   ($021B, $0074, $0326), ($021E, $0048, $030C), ($021F, $0068, $030C), ($0226, $0041, $0307), ($0227, $0061, $0307),
   ($0228, $0045, $0327), ($0229, $0065, $0327), ($022A, $00D6, $0304), ($022B, $00F6, $0304), ($022C, $00D5, $0304),
   ($022D, $00F5, $0304), ($022E, $004F, $0307), ($022F, $006F, $0307), ($0230, $022E, $0304), ($0231, $022F, $0304),
   ($0232, $0059, $0304), ($0233, $0079, $0304), ($0344, $0308, $0301), ($0385, $00A8, $0301), ($0386, $0391, $0301),
   ($0388, $0395, $0301), ($0389, $0397, $0301), ($038A, $0399, $0301), ($038C, $039F, $0301), ($038E, $03A5, $0301),
   ($038F, $03A9, $0301), ($0390, $03CA, $0301), ($03AA, $0399, $0308), ($03AB, $03A5, $0308), ($03AC, $03B1, $0301),
   ($03AD, $03B5, $0301), ($03AE, $03B7, $0301), ($03AF, $03B9, $0301), ($03B0, $03CB, $0301), ($03CA, $03B9, $0308),
   ($03CB, $03C5, $0308), ($03CC, $03BF, $0301), ($03CD, $03C5, $0301), ($03CE, $03C9, $0301), ($03D3, $03D2, $0301),
   ($03D4, $03D2, $0308), ($0400, $0415, $0300), ($0401, $0415, $0308), ($0403, $0413, $0301), ($0407, $0406, $0308),
   ($040C, $041A, $0301), ($040D, $0418, $0300), ($040E, $0423, $0306), ($0419, $0418, $0306), ($0439, $0438, $0306),
   ($0450, $0435, $0300), ($0451, $0435, $0308), ($0453, $0433, $0301), ($0457, $0456, $0308), ($045C, $043A, $0301),
   ($045D, $0438, $0300), ($045E, $0443, $0306), ($0476, $0474, $030F), ($0477, $0475, $030F), ($04C1, $0416, $0306),
   ($04C2, $0436, $0306), ($04D0, $0410, $0306), ($04D1, $0430, $0306), ($04D2, $0410, $0308), ($04D3, $0430, $0308),
   ($04D6, $0415, $0306), ($04D7, $0435, $0306), ($04DA, $04D8, $0308), ($04DB, $04D9, $0308), ($04DC, $0416, $0308),
   ($04DD, $0436, $0308), ($04DE, $0417, $0308), ($04DF, $0437, $0308), ($04E2, $0418, $0304), ($04E3, $0438, $0304),
   ($04E4, $0418, $0308), ($04E5, $0438, $0308), ($04E6, $041E, $0308), ($04E7, $043E, $0308), ($04EA, $04E8, $0308),
   ($04EB, $04E9, $0308), ($04EC, $042D, $0308), ($04ED, $044D, $0308), ($04EE, $0423, $0304), ($04EF, $0443, $0304),
   ($04F0, $0423, $0308), ($04F1, $0443, $0308), ($04F2, $0423, $030B), ($04F3, $0443, $030B), ($04F4, $0427, $0308),
   ($04F5, $0447, $0308), ($04F8, $042B, $0308), ($04F9, $044B, $0308), ($0622, $0627, $0653), ($0623, $0627, $0654),
   ($0624, $0648, $0654), ($0625, $0627, $0655), ($0626, $064A, $0654), ($06C0, $06D5, $0654), ($06C2, $06C1, $0654),
   ($06D3, $06D2, $0654), ($0929, $0928, $093C), ($0931, $0930, $093C), ($0934, $0933, $093C), ($0958, $0915, $093C),
   ($0959, $0916, $093C), ($095A, $0917, $093C), ($095B, $091C, $093C), ($095C, $0921, $093C), ($095D, $0922, $093C),
   ($095E, $092B, $093C), ($095F, $092F, $093C), ($09CB, $09C7, $09BE), ($09CC, $09C7, $09D7), ($09DC, $09A1, $09BC),
   ($09DD, $09A2, $09BC), ($09DF, $09AF, $09BC), ($0A33, $0A32, $0A3C), ($0A36, $0A38, $0A3C), ($0A59, $0A16, $0A3C),
   ($0A5A, $0A17, $0A3C), ($0A5B, $0A1C, $0A3C), ($0A5E, $0A2B, $0A3C), ($0B48, $0B47, $0B56), ($0B4B, $0B47, $0B3E),
   ($0B4C, $0B47, $0B57), ($0B5C, $0B21, $0B3C), ($0B5D, $0B22, $0B3C), ($0B94, $0B92, $0BD7), ($0BCA, $0BC6, $0BBE),
   ($0BCB, $0BC7, $0BBE), ($0BCC, $0BC6, $0BD7), ($0C48, $0C46, $0C56), ($0CC0, $0CBF, $0CD5), ($0CC7, $0CC6, $0CD5),
   ($0CC8, $0CC6, $0CD6), ($0CCA, $0CC6, $0CC2), ($0CCB, $0CCA, $0CD5), ($0D4A, $0D46, $0D3E), ($0D4B, $0D47, $0D3E),
   ($0D4C, $0D46, $0D57), ($0DDA, $0DD9, $0DCA), ($0DDC, $0DD9, $0DCF), ($0DDD, $0DDC, $0DCA), ($0DDE, $0DD9, $0DDF),
   ($0F43, $0F42, $0FB7), ($0F4D, $0F4C, $0FB7), ($0F52, $0F51, $0FB7), ($0F57, $0F56, $0FB7), ($0F5C, $0F5B, $0FB7),
   ($0F69, $0F40, $0FB5), ($0F73, $0F71, $0F72), ($0F75, $0F71, $0F74), ($0F76, $0FB2, $0F80), ($0F78, $0FB3, $0F80),
   ($0F81, $0F71, $0F80), ($0F93, $0F92, $0FB7), ($0F9D, $0F9C, $0FB7), ($0FA2, $0FA1, $0FB7), ($0FA7, $0FA6, $0FB7),
   ($0FAC, $0FAB, $0FB7), ($0FB9, $0F90, $0FB5), ($1026, $1025, $102E), ($1E00, $0041, $0325), ($1E01, $0061, $0325),
   ($1E02, $0042, $0307), ($1E03, $0062, $0307), ($1E04, $0042, $0323), ($1E05, $0062, $0323), ($1E06, $0042, $0331),
   ($1E07, $0062, $0331), ($1E08, $00C7, $0301), ($1E09, $00E7, $0301), ($1E0A, $0044, $0307), ($1E0B, $0064, $0307),
   ($1E0C, $0044, $0323), ($1E0D, $0064, $0323), ($1E0E, $0044, $0331), ($1E0F, $0064, $0331), ($1E10, $0044, $0327),
   ($1E11, $0064, $0327), ($1E12, $0044, $032D), ($1E13, $0064, $032D), ($1E14, $0112, $0300), ($1E15, $0113, $0300),
   ($1E16, $0112, $0301), ($1E17, $0113, $0301), ($1E18, $0045, $032D), ($1E19, $0065, $032D), ($1E1A, $0045, $0330),
   ($1E1B, $0065, $0330), ($1E1C, $0228, $0306), ($1E1D, $0229, $0306), ($1E1E, $0046, $0307), ($1E1F, $0066, $0307),
   ($1E20, $0047, $0304), ($1E21, $0067, $0304), ($1E22, $0048, $0307), ($1E23, $0068, $0307), ($1E24, $0048, $0323),
   ($1E25, $0068, $0323), ($1E26, $0048, $0308), ($1E27, $0068, $0308), ($1E28, $0048, $0327), ($1E29, $0068, $0327),
   ($1E2A, $0048, $032E), ($1E2B, $0068, $032E), ($1E2C, $0049, $0330), ($1E2D, $0069, $0330), ($1E2E, $00CF, $0301),
   ($1E2F, $00EF, $0301), ($1E30, $004B, $0301), ($1E31, $006B, $0301), ($1E32, $004B, $0323), ($1E33, $006B, $0323),
   ($1E34, $004B, $0331), ($1E35, $006B, $0331), ($1E36, $004C, $0323), ($1E37, $006C, $0323), ($1E38, $1E36, $0304),
   ($1E39, $1E37, $0304), ($1E3A, $004C, $0331), ($1E3B, $006C, $0331), ($1E3C, $004C, $032D), ($1E3D, $006C, $032D),
   ($1E3E, $004D, $0301), ($1E3F, $006D, $0301), ($1E40, $004D, $0307), ($1E41, $006D, $0307), ($1E42, $004D, $0323),
   ($1E43, $006D, $0323), ($1E44, $004E, $0307), ($1E45, $006E, $0307), ($1E46, $004E, $0323), ($1E47, $006E, $0323),
   ($1E48, $004E, $0331), ($1E49, $006E, $0331), ($1E4A, $004E, $032D), ($1E4B, $006E, $032D), ($1E4C, $00D5, $0301),
   ($1E4D, $00F5, $0301), ($1E4E, $00D5, $0308), ($1E4F, $00F5, $0308), ($1E50, $014C, $0300), ($1E51, $014D, $0300),
   ($1E52, $014C, $0301), ($1E53, $014D, $0301), ($1E54, $0050, $0301), ($1E55, $0070, $0301), ($1E56, $0050, $0307),
   ($1E57, $0070, $0307), ($1E58, $0052, $0307), ($1E59, $0072, $0307), ($1E5A, $0052, $0323), ($1E5B, $0072, $0323),
   ($1E5C, $1E5A, $0304), ($1E5D, $1E5B, $0304), ($1E5E, $0052, $0331), ($1E5F, $0072, $0331), ($1E60, $0053, $0307),
   ($1E61, $0073, $0307), ($1E62, $0053, $0323), ($1E63, $0073, $0323), ($1E64, $015A, $0307), ($1E65, $015B, $0307),
   ($1E66, $0160, $0307), ($1E67, $0161, $0307), ($1E68, $1E62, $0307), ($1E69, $1E63, $0307), ($1E6A, $0054, $0307),
   ($1E6B, $0074, $0307), ($1E6C, $0054, $0323), ($1E6D, $0074, $0323), ($1E6E, $0054, $0331), ($1E6F, $0074, $0331),
   ($1E70, $0054, $032D), ($1E71, $0074, $032D), ($1E72, $0055, $0324), ($1E73, $0075, $0324), ($1E74, $0055, $0330),
   ($1E75, $0075, $0330), ($1E76, $0055, $032D), ($1E77, $0075, $032D), ($1E78, $0168, $0301), ($1E79, $0169, $0301),
   ($1E7A, $016A, $0308), ($1E7B, $016B, $0308), ($1E7C, $0056, $0303), ($1E7D, $0076, $0303), ($1E7E, $0056, $0323),
   ($1E7F, $0076, $0323), ($1E80, $0057, $0300), ($1E81, $0077, $0300), ($1E82, $0057, $0301), ($1E83, $0077, $0301),
   ($1E84, $0057, $0308), ($1E85, $0077, $0308), ($1E86, $0057, $0307), ($1E87, $0077, $0307), ($1E88, $0057, $0323),
   ($1E89, $0077, $0323), ($1E8A, $0058, $0307), ($1E8B, $0078, $0307), ($1E8C, $0058, $0308), ($1E8D, $0078, $0308),
   ($1E8E, $0059, $0307), ($1E8F, $0079, $0307), ($1E90, $005A, $0302), ($1E91, $007A, $0302), ($1E92, $005A, $0323),
   ($1E93, $007A, $0323), ($1E94, $005A, $0331), ($1E95, $007A, $0331), ($1E96, $0068, $0331), ($1E97, $0074, $0308),
   ($1E98, $0077, $030A), ($1E99, $0079, $030A), ($1E9B, $017F, $0307), ($1EA0, $0041, $0323), ($1EA1, $0061, $0323),
   ($1EA2, $0041, $0309), ($1EA3, $0061, $0309), ($1EA4, $00C2, $0301), ($1EA5, $00E2, $0301), ($1EA6, $00C2, $0300),
   ($1EA7, $00E2, $0300), ($1EA8, $00C2, $0309), ($1EA9, $00E2, $0309), ($1EAA, $00C2, $0303), ($1EAB, $00E2, $0303),
   ($1EAC, $1EA0, $0302), ($1EAD, $1EA1, $0302), ($1EAE, $0102, $0301), ($1EAF, $0103, $0301), ($1EB0, $0102, $0300),
   ($1EB1, $0103, $0300), ($1EB2, $0102, $0309), ($1EB3, $0103, $0309), ($1EB4, $0102, $0303), ($1EB5, $0103, $0303),
   ($1EB6, $1EA0, $0306), ($1EB7, $1EA1, $0306), ($1EB8, $0045, $0323), ($1EB9, $0065, $0323), ($1EBA, $0045, $0309),
   ($1EBB, $0065, $0309), ($1EBC, $0045, $0303), ($1EBD, $0065, $0303), ($1EBE, $00CA, $0301), ($1EBF, $00EA, $0301),
   ($1EC0, $00CA, $0300), ($1EC1, $00EA, $0300), ($1EC2, $00CA, $0309), ($1EC3, $00EA, $0309), ($1EC4, $00CA, $0303),
   ($1EC5, $00EA, $0303), ($1EC6, $1EB8, $0302), ($1EC7, $1EB9, $0302), ($1EC8, $0049, $0309), ($1EC9, $0069, $0309),
   ($1ECA, $0049, $0323), ($1ECB, $0069, $0323), ($1ECC, $004F, $0323), ($1ECD, $006F, $0323), ($1ECE, $004F, $0309),
   ($1ECF, $006F, $0309), ($1ED0, $00D4, $0301), ($1ED1, $00F4, $0301), ($1ED2, $00D4, $0300), ($1ED3, $00F4, $0300),
   ($1ED4, $00D4, $0309), ($1ED5, $00F4, $0309), ($1ED6, $00D4, $0303), ($1ED7, $00F4, $0303), ($1ED8, $1ECC, $0302),
   ($1ED9, $1ECD, $0302), ($1EDA, $01A0, $0301), ($1EDB, $01A1, $0301), ($1EDC, $01A0, $0300), ($1EDD, $01A1, $0300),
   ($1EDE, $01A0, $0309), ($1EDF, $01A1, $0309), ($1EE0, $01A0, $0303), ($1EE1, $01A1, $0303), ($1EE2, $01A0, $0323),
   ($1EE3, $01A1, $0323), ($1EE4, $0055, $0323), ($1EE5, $0075, $0323), ($1EE6, $0055, $0309), ($1EE7, $0075, $0309),
   ($1EE8, $01AF, $0301), ($1EE9, $01B0, $0301), ($1EEA, $01AF, $0300), ($1EEB, $01B0, $0300), ($1EEC, $01AF, $0309),
   ($1EED, $01B0, $0309), ($1EEE, $01AF, $0303), ($1EEF, $01B0, $0303), ($1EF0, $01AF, $0323), ($1EF1, $01B0, $0323),
   ($1EF2, $0059, $0300), ($1EF3, $0079, $0300), ($1EF4, $0059, $0323), ($1EF5, $0079, $0323), ($1EF6, $0059, $0309),
   ($1EF7, $0079, $0309), ($1EF8, $0059, $0303), ($1EF9, $0079, $0303), ($1F00, $03B1, $0313), ($1F01, $03B1, $0314),
   ($1F02, $1F00, $0300), ($1F03, $1F01, $0300), ($1F04, $1F00, $0301), ($1F05, $1F01, $0301), ($1F06, $1F00, $0342),
   ($1F07, $1F01, $0342), ($1F08, $0391, $0313), ($1F09, $0391, $0314), ($1F0A, $1F08, $0300), ($1F0B, $1F09, $0300),
   ($1F0C, $1F08, $0301), ($1F0D, $1F09, $0301), ($1F0E, $1F08, $0342), ($1F0F, $1F09, $0342), ($1F10, $03B5, $0313),
   ($1F11, $03B5, $0314), ($1F12, $1F10, $0300), ($1F13, $1F11, $0300), ($1F14, $1F10, $0301), ($1F15, $1F11, $0301),
   ($1F18, $0395, $0313), ($1F19, $0395, $0314), ($1F1A, $1F18, $0300), ($1F1B, $1F19, $0300), ($1F1C, $1F18, $0301),
   ($1F1D, $1F19, $0301), ($1F20, $03B7, $0313), ($1F21, $03B7, $0314), ($1F22, $1F20, $0300), ($1F23, $1F21, $0300),
   ($1F24, $1F20, $0301), ($1F25, $1F21, $0301), ($1F26, $1F20, $0342), ($1F27, $1F21, $0342), ($1F28, $0397, $0313),
   ($1F29, $0397, $0314), ($1F2A, $1F28, $0300), ($1F2B, $1F29, $0300), ($1F2C, $1F28, $0301), ($1F2D, $1F29, $0301),
   ($1F2E, $1F28, $0342), ($1F2F, $1F29, $0342), ($1F30, $03B9, $0313), ($1F31, $03B9, $0314), ($1F32, $1F30, $0300),
   ($1F33, $1F31, $0300), ($1F34, $1F30, $0301), ($1F35, $1F31, $0301), ($1F36, $1F30, $0342), ($1F37, $1F31, $0342),
   ($1F38, $0399, $0313), ($1F39, $0399, $0314), ($1F3A, $1F38, $0300), ($1F3B, $1F39, $0300), ($1F3C, $1F38, $0301),
   ($1F3D, $1F39, $0301), ($1F3E, $1F38, $0342), ($1F3F, $1F39, $0342), ($1F40, $03BF, $0313), ($1F41, $03BF, $0314),
   ($1F42, $1F40, $0300), ($1F43, $1F41, $0300), ($1F44, $1F40, $0301), ($1F45, $1F41, $0301), ($1F48, $039F, $0313),
   ($1F49, $039F, $0314), ($1F4A, $1F48, $0300), ($1F4B, $1F49, $0300), ($1F4C, $1F48, $0301), ($1F4D, $1F49, $0301),
   ($1F50, $03C5, $0313), ($1F51, $03C5, $0314), ($1F52, $1F50, $0300), ($1F53, $1F51, $0300), ($1F54, $1F50, $0301),
   ($1F55, $1F51, $0301), ($1F56, $1F50, $0342), ($1F57, $1F51, $0342), ($1F59, $03A5, $0314), ($1F5B, $1F59, $0300),
   ($1F5D, $1F59, $0301), ($1F5F, $1F59, $0342), ($1F60, $03C9, $0313), ($1F61, $03C9, $0314), ($1F62, $1F60, $0300),
   ($1F63, $1F61, $0300), ($1F64, $1F60, $0301), ($1F65, $1F61, $0301), ($1F66, $1F60, $0342), ($1F67, $1F61, $0342),
   ($1F68, $03A9, $0313), ($1F69, $03A9, $0314), ($1F6A, $1F68, $0300), ($1F6B, $1F69, $0300), ($1F6C, $1F68, $0301),
   ($1F6D, $1F69, $0301), ($1F6E, $1F68, $0342), ($1F6F, $1F69, $0342), ($1F70, $03B1, $0300), ($1F72, $03B5, $0300),
   ($1F74, $03B7, $0300), ($1F76, $03B9, $0300), ($1F78, $03BF, $0300), ($1F7A, $03C5, $0300), ($1F7C, $03C9, $0300),
   ($1F80, $1F00, $0345), ($1F81, $1F01, $0345), ($1F82, $1F02, $0345), ($1F83, $1F03, $0345), ($1F84, $1F04, $0345),
   ($1F85, $1F05, $0345), ($1F86, $1F06, $0345), ($1F87, $1F07, $0345), ($1F88, $1F08, $0345), ($1F89, $1F09, $0345),
   ($1F8A, $1F0A, $0345), ($1F8B, $1F0B, $0345), ($1F8C, $1F0C, $0345), ($1F8D, $1F0D, $0345), ($1F8E, $1F0E, $0345),
   ($1F8F, $1F0F, $0345), ($1F90, $1F20, $0345), ($1F91, $1F21, $0345), ($1F92, $1F22, $0345), ($1F93, $1F23, $0345),
   ($1F94, $1F24, $0345), ($1F95, $1F25, $0345), ($1F96, $1F26, $0345), ($1F97, $1F27, $0345), ($1F98, $1F28, $0345),
   ($1F99, $1F29, $0345), ($1F9A, $1F2A, $0345), ($1F9B, $1F2B, $0345), ($1F9C, $1F2C, $0345), ($1F9D, $1F2D, $0345),
   ($1F9E, $1F2E, $0345), ($1F9F, $1F2F, $0345), ($1FA0, $1F60, $0345), ($1FA1, $1F61, $0345), ($1FA2, $1F62, $0345),
   ($1FA3, $1F63, $0345), ($1FA4, $1F64, $0345), ($1FA5, $1F65, $0345), ($1FA6, $1F66, $0345), ($1FA7, $1F67, $0345),
   ($1FA8, $1F68, $0345), ($1FA9, $1F69, $0345), ($1FAA, $1F6A, $0345), ($1FAB, $1F6B, $0345), ($1FAC, $1F6C, $0345),
   ($1FAD, $1F6D, $0345), ($1FAE, $1F6E, $0345), ($1FAF, $1F6F, $0345), ($1FB0, $03B1, $0306), ($1FB1, $03B1, $0304),
   ($1FB2, $1F70, $0345), ($1FB3, $03B1, $0345), ($1FB4, $03AC, $0345), ($1FB6, $03B1, $0342), ($1FB7, $1FB6, $0345),
   ($1FB8, $0391, $0306), ($1FB9, $0391, $0304), ($1FBA, $0391, $0300), ($1FBC, $0391, $0345), ($1FC1, $00A8, $0342),
   ($1FC2, $1F74, $0345), ($1FC3, $03B7, $0345), ($1FC4, $03AE, $0345), ($1FC6, $03B7, $0342), ($1FC7, $1FC6, $0345),
   ($1FC8, $0395, $0300), ($1FCA, $0397, $0300), ($1FCC, $0397, $0345), ($1FCD, $1FBF, $0300), ($1FCE, $1FBF, $0301),
   ($1FCF, $1FBF, $0342), ($1FD0, $03B9, $0306), ($1FD1, $03B9, $0304), ($1FD2, $03CA, $0300), ($1FD6, $03B9, $0342),
   ($1FD7, $03CA, $0342), ($1FD8, $0399, $0306), ($1FD9, $0399, $0304), ($1FDA, $0399, $0300), ($1FDD, $1FFE, $0300),
   ($1FDE, $1FFE, $0301), ($1FDF, $1FFE, $0342), ($1FE0, $03C5, $0306), ($1FE1, $03C5, $0304), ($1FE2, $03CB, $0300),
   ($1FE4, $03C1, $0313), ($1FE5, $03C1, $0314), ($1FE6, $03C5, $0342), ($1FE7, $03CB, $0342), ($1FE8, $03A5, $0306),
   ($1FE9, $03A5, $0304), ($1FEA, $03A5, $0300), ($1FEC, $03A1, $0314), ($1FED, $00A8, $0300), ($1FF2, $1F7C, $0345),
   ($1FF3, $03C9, $0345), ($1FF4, $03CE, $0345), ($1FF6, $03C9, $0342), ($1FF7, $1FF6, $0345), ($1FF8, $039F, $0300),
   ($1FFA, $03A9, $0300), ($1FFC, $03A9, $0345), ($219A, $2190, $0338), ($219B, $2192, $0338), ($21AE, $2194, $0338),
   ($21CD, $21D0, $0338), ($21CE, $21D4, $0338), ($21CF, $21D2, $0338), ($2204, $2203, $0338), ($2209, $2208, $0338),
   ($220C, $220B, $0338), ($2224, $2223, $0338), ($2226, $2225, $0338), ($2241, $223C, $0338), ($2244, $2243, $0338),
   ($2247, $2245, $0338), ($2249, $2248, $0338), ($2260, $003D, $0338), ($2262, $2261, $0338), ($226D, $224D, $0338),
   ($226E, $003C, $0338), ($226F, $003E, $0338), ($2270, $2264, $0338), ($2271, $2265, $0338), ($2274, $2272, $0338),
   ($2275, $2273, $0338), ($2278, $2276, $0338), ($2279, $2277, $0338), ($2280, $227A, $0338), ($2281, $227B, $0338),
   ($2284, $2282, $0338), ($2285, $2283, $0338), ($2288, $2286, $0338), ($2289, $2287, $0338), ($22AC, $22A2, $0338),
   ($22AD, $22A8, $0338), ($22AE, $22A9, $0338), ($22AF, $22AB, $0338), ($22E0, $227C, $0338), ($22E1, $227D, $0338),
   ($22E2, $2291, $0338), ($22E3, $2292, $0338), ($22EA, $22B2, $0338), ($22EB, $22B3, $0338), ($22EC, $22B4, $0338),
   ($22ED, $22B5, $0338), ($2ADC, $2ADD, $0338), ($304C, $304B, $3099), ($304E, $304D, $3099), ($3050, $304F, $3099),
   ($3052, $3051, $3099), ($3054, $3053, $3099), ($3056, $3055, $3099), ($3058, $3057, $3099), ($305A, $3059, $3099),
   ($305C, $305B, $3099), ($305E, $305D, $3099), ($3060, $305F, $3099), ($3062, $3061, $3099), ($3065, $3064, $3099),
   ($3067, $3066, $3099), ($3069, $3068, $3099), ($3070, $306F, $3099), ($3071, $306F, $309A), ($3073, $3072, $3099),
   ($3074, $3072, $309A), ($3076, $3075, $3099), ($3077, $3075, $309A), ($3079, $3078, $3099), ($307A, $3078, $309A),
   ($307C, $307B, $3099), ($307D, $307B, $309A), ($3094, $3046, $3099), ($309E, $309D, $3099), ($30AC, $30AB, $3099),
   ($30AE, $30AD, $3099), ($30B0, $30AF, $3099), ($30B2, $30B1, $3099), ($30B4, $30B3, $3099), ($30B6, $30B5, $3099),
   ($30B8, $30B7, $3099), ($30BA, $30B9, $3099), ($30BC, $30BB, $3099), ($30BE, $30BD, $3099), ($30C0, $30BF, $3099),
   ($30C2, $30C1, $3099), ($30C5, $30C4, $3099), ($30C7, $30C6, $3099), ($30C9, $30C8, $3099), ($30D0, $30CF, $3099),
   ($30D1, $30CF, $309A), ($30D3, $30D2, $3099), ($30D4, $30D2, $309A), ($30D6, $30D5, $3099), ($30D7, $30D5, $309A),
   ($30D9, $30D8, $3099), ($30DA, $30D8, $309A), ($30DC, $30DB, $3099), ($30DD, $30DB, $309A), ($30F4, $30A6, $3099),
   ($30F7, $30EF, $3099), ($30F8, $30F0, $3099), ($30F9, $30F1, $3099), ($30FA, $30F2, $3099), ($30FE, $30FD, $3099),
   ($FB1D, $05D9, $05B4), ($FB1F, $05F2, $05B7), ($FB2A, $05E9, $05C1), ($FB2B, $05E9, $05C2), ($FB2C, $FB49, $05C1),
   ($FB2D, $FB49, $05C2), ($FB2E, $05D0, $05B7), ($FB2F, $05D0, $05B8), ($FB30, $05D0, $05BC), ($FB31, $05D1, $05BC),
   ($FB32, $05D2, $05BC), ($FB33, $05D3, $05BC), ($FB34, $05D4, $05BC), ($FB35, $05D5, $05BC), ($FB36, $05D6, $05BC),
   ($FB38, $05D8, $05BC), ($FB39, $05D9, $05BC), ($FB3A, $05DA, $05BC), ($FB3B, $05DB, $05BC), ($FB3C, $05DC, $05BC),
   ($FB3E, $05DE, $05BC), ($FB40, $05E0, $05BC), ($FB41, $05E1, $05BC), ($FB43, $05E3, $05BC), ($FB44, $05E4, $05BC),
   ($FB46, $05E6, $05BC), ($FB47, $05E7, $05BC), ($FB48, $05E8, $05BC), ($FB49, $05E9, $05BC), ($FB4A, $05EA, $05BC),
   ($FB4B, $05D5, $05B9), ($FB4C, $05D1, $05BF), ($FB4D, $05DB, $05BF), ($FB4E, $05E4, $05BF));

const
  Compat2ChrArrN = 124;
   {(=$00A8 == ' '=$0020 + $0308), ....}
  Compat2ChrArr: array [0..Compat2ChrArrN-1] of ThreeIntegers = (
   ($005E, $0020, $0302), ($0060, $0020, $0300), ($007E, $0020, $0303),
   ($00A8, $0020, $0308), ($00AF, $0020, $0304), ($00B4, $0020, $0301), ($00B8, $0020, $0327), ($0132, $0049, $004A),
   ($0133, $0069, $006A), ($013F, $004C, $00B7), ($0140, $006C, $00B7), ($0149, $02BC, $006E), ($01C4, $0044, $017D),
   ($01C5, $0044, $017E), ($01C6, $0064, $017E), ($01C7, $004C, $004A), ($01C8, $004C, $006A), ($01C9, $006C, $006A),
   ($01CA, $004E, $004A), ($01CB, $004E, $006A), ($01CC, $006E, $006A), ($01F1, $0044, $005A), ($01F2, $0044, $007A),
   ($01F3, $0064, $007A), ($02D8, $0020, $0306), ($02D9, $0020, $0307), ($02DA, $0020, $030A), ($02DB, $0020, $0328),
   ($02DC, $0020, $0303), ($02DD, $0020, $030B), ($037A, $0020, $0345), ($0384, $0020, $0301), ($0587, $0565, $0582),
   ($0675, $0627, $0674), ($0676, $0648, $0674), ($0677, $06C7, $0674), ($0678, $064A, $0674), ($0E33, $0E4D, $0E32),
   ($0EB3, $0ECD, $0EB2), ($0EDC, $0EAB, $0E99), ($0EDD, $0EAB, $0EA1), ($0F77, $0FB2, $0F81), ($0F79, $0FB3, $0F81),
   ($1E9A, $0061, $02BE), ($1FBD, $0020, $0313), ($1FBF, $0020, $0313), ($1FC0, $0020, $0342), ($1FFE, $0020, $0314),
   ($2017, $0020, $0333), ($2025, $002E, $002E), ($2033, $2032, $2032), ($2036, $2035, $2035), ($203C, $0021, $0021),
   ($203E, $0020, $0305), ($2047, $003F, $003F), ($2048, $003F, $0021), ($2049, $0021, $003F), ($20A8, $0052, $0073),
   ($2103, $00B0, $0043), ($2109, $00B0, $0046), ($2116, $004E, $006F), ($2161, $0049, $0049), ($2163, $0049, $0056),
   ($2165, $0056, $0049), ($2168, $0049, $0058), ($216A, $0058, $0049), ($2171, $0069, $0069), ($2173, $0069, $0076),
   ($2175, $0076, $0069), ($2178, $0069, $0078), ($217A, $0078, $0069), ($222C, $222B, $222B), ($222F, $222E, $222E),
   ($2488, $0031, $002E), ($2489, $0032, $002E), ($248A, $0033, $002E), ($248B, $0034, $002E), ($248C, $0035, $002E),
   ($248D, $0036, $002E), ($248E, $0037, $002E), ($248F, $0038, $002E), ($2490, $0039, $002E), ($2A75, $003D, $003D),
   ($309B, $0020, $3099), ($309C, $0020, $309A), ($32C0, $0031, $6708), ($32C1, $0032, $6708), ($32C2, $0033, $6708),
   ($32C3, $0034, $6708), ($32C4, $0035, $6708), ($32C5, $0036, $6708), ($32C6, $0037, $6708), ($32C7, $0038, $6708),
   ($32C8, $0039, $6708), ($3358, $0030, $70B9), ($3359, $0031, $70B9), ($335A, $0032, $70B9), ($335B, $0033, $70B9),
   ($335C, $0034, $70B9), ($335D, $0035, $70B9), ($335E, $0036, $70B9), ($335F, $0037, $70B9), ($3360, $0038, $70B9),
   ($3361, $0039, $70B9), ($33E0, $0031, $65E5), ($33E1, $0032, $65E5), ($33E2, $0033, $65E5), ($33E3, $0034, $65E5),
   ($33E4, $0035, $65E5), ($33E5, $0036, $65E5), ($33E6, $0037, $65E5), ($33E7, $0038, $65E5), ($33E8, $0039, $65E5),
   ($FB00, $0066, $0066), ($FB01, $0066, $0069), ($FB02, $0066, $006C), ($FB05, $017F, $0074), ($FB06, $0073, $0074),
   ($FB13, $0574, $0576), ($FB14, $0574, $0565), ($FB15, $0574, $056B), ($FB16, $057E, $0576), ($FB17, $0574, $056D),
   ($FB4F, $05D0, $05DC));

  Compat1ChrArrN = 363;
  Compat1ChrArr: array [0..Compat1ChrArrN-1] of TwoIntegers = (
   ($00B5, $03BC), ($017F, $0073), ($03D0, $03B2), ($03D1, $03B8), ($03D2, $03A5),
   ($03D5, $03C6), ($03D6, $03C0), ($03F0, $03BA), ($03F1, $03C1), ($03F2, $03C2),
   ($03F4, $0398), ($03F5, $03B5), ($03F9, $03A3), ($2002, $0020), ($2003, $0020),
   ($2004, $0020), ($2005, $0020), ($2006, $0020), ($2008, $0020), ($2009, $0020),
   ($200A, $0020), ($2024, $002E), ($205F, $0020), ($2107, $0190), ($2135, $05D0),
   ($2136, $05D1), ($2137, $05D2), ($2138, $05D3), ($2160, $0049), ($2164, $0056),
   ($2169, $0058), ($216C, $004C), ($216D, $0043), ($216E, $0044), ($216F, $004D),
   ($2170, $0069), ($2174, $0076), ($2179, $0078), ($217C, $006C), ($217D, $0063),
   ($217E, $0064), ($217F, $006D), ($2E9F, $6BCD), ($2EF3, $9F9F), ($2F00, $4E00),
   ($2F01, $4E28), ($2F02, $4E36), ($2F03, $4E3F), ($2F04, $4E59), ($2F05, $4E85),
   ($2F06, $4E8C), ($2F07, $4EA0), ($2F08, $4EBA), ($2F09, $513F), ($2F0A, $5165),
   ($2F0B, $516B), ($2F0C, $5182), ($2F0D, $5196), ($2F0E, $51AB), ($2F0F, $51E0),
   ($2F10, $51F5), ($2F11, $5200), ($2F12, $529B), ($2F13, $52F9), ($2F14, $5315),
   ($2F15, $531A), ($2F16, $5338), ($2F17, $5341), ($2F18, $535C), ($2F19, $5369),
   ($2F1A, $5382), ($2F1B, $53B6), ($2F1C, $53C8), ($2F1D, $53E3), ($2F1E, $56D7),
   ($2F1F, $571F), ($2F20, $58EB), ($2F21, $5902), ($2F22, $590A), ($2F23, $5915),
   ($2F24, $5927), ($2F25, $5973), ($2F26, $5B50), ($2F27, $5B80), ($2F28, $5BF8),
   ($2F29, $5C0F), ($2F2A, $5C22), ($2F2B, $5C38), ($2F2C, $5C6E), ($2F2D, $5C71),
   ($2F2E, $5DDB), ($2F2F, $5DE5), ($2F30, $5DF1), ($2F31, $5DFE), ($2F32, $5E72),
   ($2F33, $5E7A), ($2F34, $5E7F), ($2F35, $5EF4), ($2F36, $5EFE), ($2F37, $5F0B),
   ($2F38, $5F13), ($2F39, $5F50), ($2F3A, $5F61), ($2F3B, $5F73), ($2F3C, $5FC3),
   ($2F3D, $6208), ($2F3E, $6236), ($2F3F, $624B), ($2F40, $652F), ($2F41, $6534),
   ($2F42, $6587), ($2F43, $6597), ($2F44, $65A4), ($2F45, $65B9), ($2F46, $65E0),
   ($2F47, $65E5), ($2F48, $66F0), ($2F49, $6708), ($2F4A, $6728), ($2F4B, $6B20),
   ($2F4C, $6B62), ($2F4D, $6B79), ($2F4E, $6BB3), ($2F4F, $6BCB), ($2F50, $6BD4),
   ($2F51, $6BDB), ($2F52, $6C0F), ($2F53, $6C14), ($2F54, $6C34), ($2F55, $706B),
   ($2F56, $722A), ($2F57, $7236), ($2F58, $723B), ($2F59, $723F), ($2F5A, $7247),
   ($2F5B, $7259), ($2F5C, $725B), ($2F5D, $72AC), ($2F5E, $7384), ($2F5F, $7389),
   ($2F60, $74DC), ($2F61, $74E6), ($2F62, $7518), ($2F63, $751F), ($2F64, $7528),
   ($2F65, $7530), ($2F66, $758B), ($2F67, $7592), ($2F68, $7676), ($2F69, $767D),
   ($2F6A, $76AE), ($2F6B, $76BF), ($2F6C, $76EE), ($2F6D, $77DB), ($2F6E, $77E2),
   ($2F6F, $77F3), ($2F70, $793A), ($2F71, $79B8), ($2F72, $79BE), ($2F73, $7A74),
   ($2F74, $7ACB), ($2F75, $7AF9), ($2F76, $7C73), ($2F77, $7CF8), ($2F78, $7F36),
   ($2F79, $7F51), ($2F7A, $7F8A), ($2F7B, $7FBD), ($2F7C, $8001), ($2F7D, $800C),
   ($2F7E, $8012), ($2F7F, $8033), ($2F80, $807F), ($2F81, $8089), ($2F82, $81E3),
   ($2F83, $81EA), ($2F84, $81F3), ($2F85, $81FC), ($2F86, $820C), ($2F87, $821B),
   ($2F88, $821F), ($2F89, $826E), ($2F8A, $8272), ($2F8B, $8278), ($2F8C, $864D),
   ($2F8D, $866B), ($2F8E, $8840), ($2F8F, $884C), ($2F90, $8863), ($2F91, $897E),
   ($2F92, $898B), ($2F93, $89D2), ($2F94, $8A00), ($2F95, $8C37), ($2F96, $8C46),
   ($2F97, $8C55), ($2F98, $8C78), ($2F99, $8C9D), ($2F9A, $8D64), ($2F9B, $8D70),
   ($2F9C, $8DB3), ($2F9D, $8EAB), ($2F9E, $8ECA), ($2F9F, $8F9B), ($2FA0, $8FB0),
   ($2FA1, $8FB5), ($2FA2, $9091), ($2FA3, $9149), ($2FA4, $91C6), ($2FA5, $91CC),
   ($2FA6, $91D1), ($2FA7, $9577), ($2FA8, $9580), ($2FA9, $961C), ($2FAA, $96B6),
   ($2FAB, $96B9), ($2FAC, $96E8), ($2FAD, $9751), ($2FAE, $975E), ($2FAF, $9762),
   ($2FB0, $9769), ($2FB1, $97CB), ($2FB2, $97ED), ($2FB3, $97F3), ($2FB4, $9801),
   ($2FB5, $98A8), ($2FB6, $98DB), ($2FB7, $98DF), ($2FB8, $9996), ($2FB9, $9999),
   ($2FBA, $99AC), ($2FBB, $9AA8), ($2FBC, $9AD8), ($2FBD, $9ADF), ($2FBE, $9B25),
   ($2FBF, $9B2F), ($2FC0, $9B32), ($2FC1, $9B3C), ($2FC2, $9B5A), ($2FC3, $9CE5),
   ($2FC4, $9E75), ($2FC5, $9E7F), ($2FC6, $9EA5), ($2FC7, $9EBB), ($2FC8, $9EC3),
   ($2FC9, $9ECD), ($2FCA, $9ED1), ($2FCB, $9EF9), ($2FCC, $9EFD), ($2FCD, $9F0E),
   ($2FCE, $9F13), ($2FCF, $9F20), ($2FD0, $9F3B), ($2FD1, $9F4A), ($2FD2, $9F52),
   ($2FD3, $9F8D), ($2FD4, $9F9C), ($2FD5, $9FA0), ($3036, $3012), ($3038, $5341),
   ($3039, $5344), ($303A, $5345), ($3131, $1100), ($3132, $1101), ($3133, $11AA),
   ($3134, $1102), ($3135, $11AC), ($3136, $11AD), ($3137, $1103), ($3138, $1104),
   ($3139, $1105), ($313A, $11B0), ($313B, $11B1), ($313C, $11B2), ($313D, $11B3),
   ($313E, $11B4), ($313F, $11B5), ($3140, $111A), ($3141, $1106), ($3142, $1107),
   ($3143, $1108), ($3144, $1121), ($3145, $1109), ($3146, $110A), ($3147, $110B),
   ($3148, $110C), ($3149, $110D), ($314A, $110E), ($314B, $110F), ($314C, $1110),
   ($314D, $1111), ($314E, $1112), ($314F, $1161), ($3150, $1162), ($3151, $1163),
   ($3152, $1164), ($3153, $1165), ($3154, $1166), ($3155, $1167), ($3156, $1168),
   ($3157, $1169), ($3158, $116A), ($3159, $116B), ($315A, $116C), ($315B, $116D),
   ($315C, $116E), ($315D, $116F), ($315E, $1170), ($315F, $1171), ($3160, $1172),
   ($3161, $1173), ($3162, $1174), ($3163, $1175), ($3164, $1160), ($3165, $1114),
   ($3166, $1115), ($3167, $11C7), ($3168, $11C8), ($3169, $11CC), ($316A, $11CE),
   ($316B, $11D3), ($316C, $11D7), ($316D, $11D9), ($316E, $111C), ($316F, $11DD),
   ($3170, $11DF), ($3171, $111D), ($3172, $111E), ($3173, $1120), ($3174, $1122),
   ($3175, $1123), ($3176, $1127), ($3177, $1129), ($3178, $112B), ($3179, $112C),
   ($317A, $112D), ($317B, $112E), ($317C, $112F), ($317D, $1132), ($317E, $1136),
   ($317F, $1140), ($3180, $1147), ($3181, $114C), ($3182, $11F1), ($3183, $11F2),
   ($3184, $1157), ($3185, $1158), ($3186, $1159), ($3187, $1184), ($3188, $1185),
   ($3189, $1188), ($318A, $1191), ($318B, $1192), ($318C, $1194), ($318D, $119E),
   ($318E, $11A1), ($FE49, $203E), ($FE4A, $203E), ($FE4B, $203E), ($FE4C, $203E),
   ($FE4D, $005F), ($FE4E, $005F), ($FE4F, $005F));

const
  CharsSpaceArrN = 20;
  CharsSpaceArr: array [0..CharsSpaceArrN-1] of Integer = (
    32, 133, 160, 5760, 8192, 8193, 8194, 8195, 8196, 8197,
    8198, 8199, 8200, 8201, 8202, 8203, 8232, 8233, 8239, 12288);

type
  TCharBlock = (
    chb_Basic_Latin,
    chb_Latin_Supp,
    chb_Latin_Ext_A,
    chb_Latin_Ext_B,
    chb_IPA_Ext,
    chb_Spacing_Modi_Lett,
    chb_Combin_Diacr_Marks,
    chb_Greek_Coptic,
    chb_Cyrillic,
    chb_Cyrillic_Supp,
    chb_Armenian,
    chb_Hebrew,
    chb_Arabic,
    chb_Syriac,
    chb_Arabic_Supp,
    chb_Thaana,
    chb_Devanagari,
    chb_Bengali,
    chb_Gurmukhi,
    chb_Gujarati,
    chb_Oriya,
    chb_Tamil,
    chb_Telugu,
    chb_Kannada,
    chb_Malayalam,
    chb_Sinhala,
    chb_Thai,
    chb_Lao,
    chb_Tibetan,
    chb_Myanmar,
    chb_Georgian,
    chb_Hangul_Jamo,
    chb_Ethiopic,
    chb_Ethiopic_Supp,
    chb_Cherokee,
    chb_Unif_Canadian_Aborig_Syl,
    chb_Ogham,
    chb_Runic,
    chb_Tagalog,
    chb_Hanunoo,
    chb_Buhid,
    chb_Tagbanwa,
    chb_Khmer,
    chb_Mongolian,
    chb_Limbu,
    chb_Tai_Le,
    chb_New_Tai_Lue,
    chb_Khmer_Symbols,
    chb_Buginese,
    chb_Phonetic_Ext,
    chb_Phonetic_Ext_Supp,
    chb_Combining_Diacr_Marks_Supp,
    chb_Latin_Ext_Additional,
    chb_Greek_Ext,
    chb_General_Punctuation,
    chb_Superscripts_and_Subscripts,
    chb_Currency_Symbols,
    chb_Combin_Diacr_Marks_for_Symbols,
    chb_Letterlike_Symbols,
    chb_Number_Forms,
    chb_Arrows,
    chb_Mathematical_Operators,
    chb_Miscellaneous_Technical,
    chb_Control_Pictures,
    chb_Optical_Char_Recognition,
    chb_Enclosed_Alphanum,
    chb_Box_Drawing,
    chb_Block_Elements,
    chb_Geometric_Shapes,
    chb_Miscell_Symbols,
    chb_Dingbats,
    chb_Miscell_Math_Symbols_A,
    chb_Supp_Arrows_A,
    chb_Braille_Patterns,
    chb_Supp_Arrows_B,
    chb_Miscell_Math_Symbols_B,
    chb_Supp_Math_Operators,
    chb_Miscell_Symbols_Arrows,
    chb_Glagolitic,
    chb_Coptic,
    chb_Georgian_Suppl,
    chb_Tifinagh,
    chb_Ethiopic_Ext,
    chb_Supp_Punctuation,
    chb_CJK_Radicals_Suppl,
    chb_Kangxi_Radicals,
    chb_Ideographic_Descrip_Char,
    chb_CJK_Symbols_and_Punct,
    chb_Hiragana,
    chb_Katakana,
    chb_Bopomofo,
    chb_Hangul_Compatib_Jamo,
    chb_Kanbun,
    chb_Bopomofo_Ext,
    chb_CJK_Strokes,
    chb_Katakana_Phonetic_Ext,
    chb_Enclosed_CJK_Lett_Months,
    chb_CJK_Compatib,
    chb_CJK_Unified_Ideogr_Ext_A,
    chb_Yijing_Hexagram_Symbols,
    chb_CJK_Unified_Ideogr,
    chb_Yi_Syllables,
    chb_Yi_Radicals,
    chb_Modifier_Tone_Lett,
    chb_Syloti_Nagri,
    chb_Hangul_Syllables,
    chb_High_Surrog,
    chb_High_Private_Use_Surrog,
    chb_Low_Surrog,
    chb_Private_Use_Area,
    chb_CJK_Compatib_Ideographs,
    chb_Alphabetic_Present_Forms,
    chb_Arabic_Present_Forms_A,
    chb_Variation_Selectors,
    chb_Vertical_Forms,
    chb_Combin_Half_Marks,
    chb_CJK_Compatib_Forms,
    chb_Small_Form_Variants,
    chb_Arabic_Present_Forms_B,
    chb_Halfwidth_Fullwidth_Forms,
    chb_Specials);

resourcestring
  RS_chb_Basic_Latin = 'Basic Latin';
  RS_chb_Latin_Sup = 'Latin-1 Supplement';
  RS_chb_Latin_Ext_A = 'Latin Extended-A';
  RS_chb_Latin_Ext_B = 'Latin Extended-B';
  RS_chb_IPA_Ext = 'IPA Extensions';
  RS_chb_Spacing_Modi_Lett = 'Spacing Modifier Letters';
  RS_chb_Combin_Diacr_Marks = 'Combining Diacritical Marks';
  RS_chb_Greek_Coptic = 'Greek and Coptic';
  RS_chb_Cyrillic = 'Cyrillic';
  RS_chb_Cyrillic_Supp = 'Cyrillic Supplement';
  RS_chb_Armenian = 'Armenian';
  RS_chb_Hebrew = 'Hebrew';
  RS_chb_Arabic = 'Arabic';
  RS_chb_Syriac = 'Syriac';
  RS_chb_Arabic_Supp = 'Arabic Supplement';
  RS_chb_Thaana = 'Thaana';
  RS_chb_Devanagari = 'Devanagari';
  RS_chb_Bengali = 'Bengali';
  RS_chb_Gurmukhi = 'Gurmukhi';
  RS_chb_Gujarati = 'Gujarati';
  RS_chb_Oriya = 'Oriya';
  RS_chb_Tamil = 'Tamil';
  RS_chb_Telugu = 'Telugu';
  RS_chb_Kannada = 'Kannada';
  RS_chb_Malayalam = 'Malayalam';
  RS_chb_Sinhala = 'Sinhala';
  RS_chb_Thai = 'Thai';
  RS_chb_Lao = 'Lao';
  RS_chb_Tibetan = 'Tibetan';
  RS_chb_Myanmar = 'Myanmar';
  RS_chb_Georgian = 'Georgian';
  RS_chb_Hangul_Jamo = 'Hangul Jamo';
  RS_chb_Ethiopic = 'Ethiopic';
  RS_chb_Ethiopic_Supp = 'Ethiopic Supplement';
  RS_chb_Cherokee = 'Cherokee';
  RS_chb_Unif_Canadian_Aborig_Syl = 'Unified Canadian Aboriginal Syllabics';
  RS_chb_Ogham = 'Ogham';
  RS_chb_Runic = 'Runic';
  RS_chb_Tagalog = 'Tagalog';
  RS_chb_Hanunoo = 'Hanunoo';
  RS_chb_Buhid = 'Buhid';
  RS_chb_Tagbanwa = 'Tagbanwa';
  RS_chb_Khmer = 'Khmer';
  RS_chb_Mongolian = 'Mongolian';
  RS_chb_Limbu = 'Limbu';
  RS_chb_Tai_Le = 'Tai Le';
  RS_chb_New_Tai_Lue = 'New Tai Lue';
  RS_chb_Khmer_Symbols = 'Khmer Symbols';
  RS_chb_Buginese = 'Buginese';
  RS_chb_Phonetic_Ext = 'Phonetic Extensions';
  RS_chb_Phonetic_Ext_Supp = 'Phonetic Extensions Supplement';
  RS_chb_Combining_Diacr_Marks_Supp = 'Combining Diacritical Marks Supplement';
  RS_chb_Latin_Ext_Additional = 'Latin Extended Additional';
  RS_chb_Greek_Ext = 'Greek Extended';
  RS_chb_General_Punctuation = 'General Punctuation';
  RS_chb_Superscripts_and_Subscripts = 'Superscripts and Subscripts';
  RS_chb_Currency_Symbols = 'Currency Symbols';
  RS_chb_Combin_Diacr_Marks_for_Symbols = 'Combining Diacritical Marks for Symbols';
  RS_chb_Letterlike_Symbols = 'Letterlike Symbols';
  RS_chb_Number_Forms = 'Number Forms';
  RS_chb_Arrows = 'Arrows';
  RS_chb_Mathematical_Operators = 'Mathematical Operators';
  RS_chb_Miscellaneous_Technical = 'Miscellaneous Technical';
  RS_chb_Control_Pictures = 'Control Pictures';
  RS_chb_Optical_Char_Recognition = 'Optical Character Recognition';
  RS_chb_Enclosed_Alphanum = 'Enclosed Alphanumerics';
  RS_chb_Box_Drawing = 'Box Drawing';
  RS_chb_Block_Elements = 'Block Elements';
  RS_chb_Geometric_Shapes = 'Geometric Shapes';
  RS_chb_Miscell_Symbols = 'Miscellaneous Symbols';
  RS_chb_Dingbats = 'Dingbats';
  RS_chb_Miscell_Math_Symbols_A = 'Miscellaneous Mathematical Symbols-A';
  RS_chb_Supp_Arrows_A = 'Supplemental Arrows-A';
  RS_chb_Braille_Patterns = 'Braille Patterns';
  RS_chb_Supp_Arrows_B = 'Supplemental Arrows-B';
  RS_chb_Miscell_Math_Symbols_B = 'Miscellaneous Mathematical Symbols-B';
  RS_chb_Supp_Math_Operators = 'Supplemental Mathematical Operators';
  RS_chb_Miscell_Symbols_Arrows = 'Miscellaneous Symbols and Arrows';
  RS_chb_Glagolitic = 'Glagolitic';
  RS_chb_Coptic = 'Coptic';
  RS_chb_Georgian_Suppl = 'Georgian Supplement';
  RS_chb_Tifinagh = 'Tifinagh';
  RS_chb_Ethiopic_Ext = 'Ethiopic Extended';
  RS_chb_Supp_Punctuation = 'Supplemental Punctuation';
  RS_chb_CJK_Radicals_Suppl = 'CJK Radicals Supplement';
  RS_chb_Kangxi_Radicals = 'Kangxi Radicals';
  RS_chb_Ideographic_Descrip_Char = 'Ideographic Description Characters';
  RS_chb_CJK_Symbols_and_Punct = 'CJK Symbols and Punctuation';
  RS_chb_Hiragana = 'Hiragana';
  RS_chb_Katakana = 'Katakana';
  RS_chb_Bopomofo = 'Bopomofo';
  RS_chb_Hangul_Compatib_Jamo = 'Hangul Compatibility Jamo';
  RS_chb_Kanbun = 'Kanbun';
  RS_chb_Bopomofo_Ext = 'Bopomofo Extended';
  RS_chb_CJK_Strokes = 'CJK Strokes';
  RS_chb_Katakana_Phonetic_Ext = 'Katakana Phonetic Extensions';
  RS_chb_Enclosed_CJK_Lett_Months = 'Enclosed CJK Letters and Months';
  RS_chb_CJK_Compatib = 'CJK Compatibility';
  RS_chb_CJK_Unified_Ideogr_Ext_A = 'CJK Unified Ideographs Extension A';
  RS_chb_Yijing_Hexagram_Symbols = 'Yijing Hexagram Symbols';
  RS_chb_CJK_Unified_Ideogr = 'CJK Unified Ideographs';
  RS_chb_Yi_Syllables = 'Yi Syllables';
  RS_chb_Yi_Radicals = 'Yi Radicals';
  RS_chb_Modifier_Tone_Lett = 'Modifier Tone Letters';
  RS_chb_Syloti_Nagri = 'Syloti Nagri';
  RS_chb_Hangul_Syllables = 'Hangul Syllables';
  RS_chb_High_Surrog = 'High Surrogates';
  RS_chb_High_Private_Use_Surrog = 'High Private Use Surrogates';
  RS_chb_Low_Surrog = 'Low Surrogates';
  RS_chb_Private_Use_Area = 'Private Use Area';
  RS_chb_CJK_Compatib_Ideographs = 'CJK Compatibility Ideographs';
  RS_chb_Alphabetic_Present_Forms = 'Alphabetic Presentation Forms';
  RS_chb_Arabic_Present_Forms_A = 'Arabic Presentation Forms-A';
  RS_chb_Variation_Selectors = 'Variation Selectors';
  RS_chb_Vertical_Forms = 'Vertical Forms';
  RS_chb_Combin_Half_Marks = 'Combining Half Marks';
  RS_chb_CJK_Compatib_Forms = 'CJK Compatibility Forms';
  RS_chb_Small_Form_Variants = 'Small Form Variants';
  RS_chb_Arabic_Present_Forms_B = 'Arabic Presentation Forms-B';
  RS_chb_Halfwidth_Fullwidth_Forms = 'Halfwidth and Fullwidth Forms';
  RS_chb_Specials = 'Specials';

const
  CharBlocksArr: array [TCharBlock] of TwoIntegers = (
   (0, 127), (128, 255), (256, 383), (384, 591), (592, 687),
   (688, 767), (768, 879), (880, 1023), (1024, 1279), (1280, 1327),
   (1328, 1423), (1424, 1535), (1536, 1791), (1792, 1871), (1872, 1919),
   (1920, 1983), (2304, 2431), (2432, 2559), (2560, 2687), (2688, 2815),
   (2816, 2943), (2944, 3071), (3072, 3199), (3200, 3327), (3328, 3455),
   (3456, 3583), (3584, 3711), (3712, 3839), (3840, 4095), (4096, 4255),
   (4256, 4351), (4352, 4607), (4608, 4991), (4992, 5023), (5024, 5119),
   (5120, 5759), (5760, 5791), (5792, 5887), (5888, 5919), (5920, 5951),
   (5952, 5983), (5984, 6015), (6016, 6143), (6144, 6319), (6400, 6479),
   (6480, 6527), (6528, 6623), (6624, 6655), (6656, 6687), (7424, 7551),
   (7552, 7615), (7616, 7679), (7680, 7935), (7936, 8191), (8192, 8303),
   (8304, 8351), (8352, 8399), (8400, 8447), (8448, 8527), (8528, 8591),
   (8592, 8703), (8704, 8959), (8960, 9215), (9216, 9279), (9280, 9311),
   (9312, 9471), (9472, 9599), (9600, 9631), (9632, 9727), (9728, 9983),
   (9984, 10175), (10176, 10223), (10224, 10239), (10240, 10495), (10496, 10623),
   (10624, 10751), (10752, 11007), (11008, 11263), (11264, 11359), (11392, 11519),
   (11520, 11567), (11568, 11647), (11648, 11743), (11776, 11903), (11904, 12031),
   (12032, 12255), (12272, 12287), (12288, 12351), (12352, 12447), (12448, 12543),
   (12544, 12591), (12592, 12687), (12688, 12703), (12704, 12735), (12736, 12783),
   (12784, 12799), (12800, 13055), (13056, 13311), (13312, 19903), (19904, 19967),
   (19968, 40959), (40960, 42127), (42128, 42191), (42752, 42783), (43008, 43055),
   (44032, 55215), (55296, 56191), (56192, 56319), (56320, 57343), (57344, 63743),
   (63744, 64255), (64256, 64335), (64336, 65023), (65024, 65039), (65040, 65055),
   (65056, 65071), (65072, 65103), (65104, 65135), (65136, 65279), (65280, 65519),
   (65520, 65535));

  RS_CharBlocksArr: array [TCharBlock] of Pointer = (
    @RS_chb_Basic_Latin,
    @RS_chb_Latin_Sup,
    @RS_chb_Latin_Ext_A,
    @RS_chb_Latin_Ext_B,
    @RS_chb_IPA_Ext,
    @RS_chb_Spacing_Modi_Lett,
    @RS_chb_Combin_Diacr_Marks,
    @RS_chb_Greek_Coptic,
    @RS_chb_Cyrillic,
    @RS_chb_Cyrillic_Supp,
    @RS_chb_Armenian,
    @RS_chb_Hebrew,
    @RS_chb_Arabic,
    @RS_chb_Syriac,
    @RS_chb_Arabic_Supp,
    @RS_chb_Thaana,
    @RS_chb_Devanagari,
    @RS_chb_Bengali,
    @RS_chb_Gurmukhi,
    @RS_chb_Gujarati,
    @RS_chb_Oriya,
    @RS_chb_Tamil,
    @RS_chb_Telugu,
    @RS_chb_Kannada,
    @RS_chb_Malayalam,
    @RS_chb_Sinhala,
    @RS_chb_Thai,
    @RS_chb_Lao,
    @RS_chb_Tibetan,
    @RS_chb_Myanmar,
    @RS_chb_Georgian,
    @RS_chb_Hangul_Jamo,
    @RS_chb_Ethiopic,
    @RS_chb_Ethiopic_Supp,
    @RS_chb_Cherokee,
    @RS_chb_Unif_Canadian_Aborig_Syl,
    @RS_chb_Ogham,
    @RS_chb_Runic,
    @RS_chb_Tagalog,
    @RS_chb_Hanunoo,
    @RS_chb_Buhid,
    @RS_chb_Tagbanwa,
    @RS_chb_Khmer,
    @RS_chb_Mongolian,
    @RS_chb_Limbu,
    @RS_chb_Tai_Le,
    @RS_chb_New_Tai_Lue,
    @RS_chb_Khmer_Symbols,
    @RS_chb_Buginese,
    @RS_chb_Phonetic_Ext,
    @RS_chb_Phonetic_Ext_Supp,
    @RS_chb_Combining_Diacr_Marks_Supp,
    @RS_chb_Latin_Ext_Additional,
    @RS_chb_Greek_Ext,
    @RS_chb_General_Punctuation,
    @RS_chb_Superscripts_and_Subscripts,
    @RS_chb_Currency_Symbols,
    @RS_chb_Combin_Diacr_Marks_for_Symbols,
    @RS_chb_Letterlike_Symbols,
    @RS_chb_Number_Forms,
    @RS_chb_Arrows,
    @RS_chb_Mathematical_Operators,
    @RS_chb_Miscellaneous_Technical,
    @RS_chb_Control_Pictures,
    @RS_chb_Optical_Char_Recognition,
    @RS_chb_Enclosed_Alphanum,
    @RS_chb_Box_Drawing,
    @RS_chb_Block_Elements,
    @RS_chb_Geometric_Shapes,
    @RS_chb_Miscell_Symbols,
    @RS_chb_Dingbats,
    @RS_chb_Miscell_Math_Symbols_A,
    @RS_chb_Supp_Arrows_A,
    @RS_chb_Braille_Patterns,
    @RS_chb_Supp_Arrows_B,
    @RS_chb_Miscell_Math_Symbols_B,
    @RS_chb_Supp_Math_Operators,
    @RS_chb_Miscell_Symbols_Arrows,
    @RS_chb_Glagolitic,
    @RS_chb_Coptic,
    @RS_chb_Georgian_Suppl,
    @RS_chb_Tifinagh,
    @RS_chb_Ethiopic_Ext,
    @RS_chb_Supp_Punctuation,
    @RS_chb_CJK_Radicals_Suppl,
    @RS_chb_Kangxi_Radicals,
    @RS_chb_Ideographic_Descrip_Char,
    @RS_chb_CJK_Symbols_and_Punct,
    @RS_chb_Hiragana,
    @RS_chb_Katakana,
    @RS_chb_Bopomofo,
    @RS_chb_Hangul_Compatib_Jamo,
    @RS_chb_Kanbun,
    @RS_chb_Bopomofo_Ext,
    @RS_chb_CJK_Strokes,
    @RS_chb_Katakana_Phonetic_Ext,
    @RS_chb_Enclosed_CJK_Lett_Months,
    @RS_chb_CJK_Compatib,
    @RS_chb_CJK_Unified_Ideogr_Ext_A,
    @RS_chb_Yijing_Hexagram_Symbols,
    @RS_chb_CJK_Unified_Ideogr,
    @RS_chb_Yi_Syllables,
    @RS_chb_Yi_Radicals,
    @RS_chb_Modifier_Tone_Lett,
    @RS_chb_Syloti_Nagri,
    @RS_chb_Hangul_Syllables,
    @RS_chb_High_Surrog,
    @RS_chb_High_Private_Use_Surrog,
    @RS_chb_Low_Surrog,
    @RS_chb_Private_Use_Area,
    @RS_chb_CJK_Compatib_Ideographs,
    @RS_chb_Alphabetic_Present_Forms,
    @RS_chb_Arabic_Present_Forms_A,
    @RS_chb_Variation_Selectors,
    @RS_chb_Vertical_Forms,
    @RS_chb_Combin_Half_Marks,
    @RS_chb_CJK_Compatib_Forms,
    @RS_chb_Small_Form_Variants,
    @RS_chb_Arabic_Present_Forms_B,
    @RS_chb_Halfwidth_Fullwidth_Forms,
    @RS_chb_Specials);

function CharBlockFromChar (Ch: WideChar): TCharBlock;

implementation

uses
  SysUtils, Windows, JvJCLUtils, TntJvJCLUtils;

function WCharToStr1 (Ch: WideChar): WideString;
begin
  SetLength (Result, 1);
  Result[1] := Ch;
end {WCharToStr1};

function WideUpCase (Ch: WideChar): WideChar;
{ converts a character to uppercase }
var
  S: Str1;
begin
  S := WCharToStr1 (Ch);
  Result := WideUpperCase(S)[1];
end {WideUpCase};

function FoundInTwoIntArray (I: Integer;  Arr: array of TwoIntegers): Boolean;
var
  J: Integer;
begin
  Result := False;
  for  J := 0 to High(Arr)  do
    if  (I >= Arr[J,1]) and (I <= Arr[J,2])  then  begin
      Result := True;
      Exit;
    end;
end {FoundInTwoIntArray};

function FoundInIntArray (I: Integer;  Arr: array of Integer): Boolean;
var
  J: Integer;
begin
  Result := False;
  for  J := 0 to High(Arr)  do
    if  I = Arr[J]  then  begin
      Result := True;
      Exit;
    end;
end {FoundInIntArray};

function WideLoCase (Ch: WideChar): WideChar;
{ converts a character to lowercase }
var
  S: Str1;
begin
  S := WCharToStr1 (Ch);
  Result := WideLowerCase(S)[1];
end {WideLoCase};

  {from http://www.unicode.org/Public/UNIDATA/UCD.html#UnicodeData.txt
        http://www.unicode.org/Public/UNIDATA/UnicodeData.txt
  where
  Abbr. Description
  Lu    Letter, Uppercase
  Ll    Letter, Lowercase
  Lt    Letter, Titlecase
  Lo  	Letter, Other
  }

function WCharIsLetter (Ch: WideChar): Boolean;
const
  Chars2: array [0..127] of TwoIntegers = (
   ($0041,$005A), ($0061,$007A), ($00C0,$00D6), ($00D8,$00F6), ($00F8,$02AF),
   ($0388,$03F5), ($03F7,$0481), ($048A,$0556), ($0561,$0587), ($05D0,$05F2),
   ($0621,$063A), ($0641,$064A), ($066E,$066F), ($0671,$06D3), ($06EE,$06EF),
   ($06FA,$06FC), ($0712,$072F), ($074D,$07A5), ($0904,$0939), ($0958,$0961),
   ($0985,$09B9), ($09DC,$09E1), ($09F0,$09F1), ($0A05,$0A39), ($0A59,$0A5E),
   ($0A72,$0A74), ($0A85,$0AB9), ($0AD0,$0AE1), ($0B05,$0B39), ($0B5C,$0B61),
   ($0B83,$0BB9), ($0C05,$0C39), ($0C60,$0C61), ($0C85,$0CB9), ($0CDE,$0CE1),
   ($0D05,$0D39), ($0D60,$0D61), ($0D85,$0DC6), ($0E01,$0E30), ($0E32,$0E33),
   ($0E40,$0E45), ($0E81,$0EB0), ($0EB2,$0EB3), ($0EBD,$0EC4), ($0EDC,$0F00),
   ($0F40,$0F6A), ($0F88,$0F8B), ($1000,$102A), ($1050,$1055), ($10A0,$10FA),
   ($1100,$135A), ($1380,$138F), ($13A0,$166C), ($166F,$1676), ($1681,$169A),
   ($16A0,$16EA), ($1700,$1711), ($1720,$1731), ($1740,$1751), ($1760,$1770),
   ($1780,$17B3), ($1820,$1842), ($1844,$18A8), ($1900,$191C), ($1950,$19A9),
   ($19C1,$19C7), ($1A00,$1A16), ($1D00,$1D2B), ($1D62,$1D77), ($1D79,$1D9A),
   ($1E00,$1FBC), ($1FC2,$1FCC), ($1FD0,$1FDB), ($1FE0,$1FEC), ($1FF2,$1FFC),
   ($210A,$2113), ($2119,$211D), ($212A,$212D), ($212F,$2131), ($2133,$2139),
   ($213C,$213F), ($2145,$2149), ($2C00,$2CE4), ($2D00,$2D65), ($2D80,$2DDE),
   ($3041,$3096), ($30A1,$30FA), ($30FF,$318E), ($31A0,$31B7), ($31F0,$31FF),
   ($3400,$4DB5), ($4E00,$A014), ($A016,$A48C), ($A800,$A801), ($A803,$A805),
   ($A807,$A80A), ($A80C,$A822), ($AC00,$D7A3), ($F900,$FB1D), ($FB1F,$FB28),
   ($FB2A,$FD3D), ($FD50,$FDFB), ($FE70,$FEFC), ($FF21,$FF3A), ($FF41,$FF5A),
   ($FF66,$FF6F), ($FF71,$FF9D), ($FFA0,$FFDC), ($10000,$100FA), ($10300,$1031E),
   ($10330,$10349), ($10380,$1039D), ($103A0,$103CF), ($10400,$1049D), ($10800,$10A00),
   ($10A10,$10A33), ($1D400,$1D6C0), ($1D6C2,$1D6DA), ($1D6DC,$1D6FA), ($1D6FC,$1D714),
   ($1D716,$1D734), ($1D736,$1D74E), ($1D750,$1D76E), ($1D770,$1D788), ($1D78A,$1D7A8),
   ($1D7AA,$1D7C2), ($1D7C4,$1D7C9), ($20000,$2FA1D));
  Chars1: array [0..29] of Integer = (
    $00AA, $00B5, $00BA, $0386, $06D5, $06FF, $0710, $07B1, $093D, $0950,
    $097D, $09BD, $09CE, $0ABD, $0B3D, $0B71, $0CBD, $17DC, $1FBE, $2071,
    $207F, $2102, $2107, $2115, $2124, $2126, $2128, $3006, $303C, $309F);
var
  J: Integer;
begin
  J := Integer (Ch);
  Result := FoundInTwoIntArray (J,Chars2) or FoundInIntArray (J, Chars1);
end {WCharIsLetter};

function WCharIsLetterUppercase (Ch: WideChar): Boolean;
const
  Chars2: array [0..65] of TwoIntegers = (
   ($0041,$005A), ($00C0,$00D6), ($00D8,$00DE), ($0178,$0179), ($0181,$0182),
   ($0186,$0187), ($0189,$018B), ($018E,$0191), ($0193,$0194), ($0196,$0198),
   ($019C,$019D), ($019F,$01A0), ($01A6,$01A7), ($01AE,$01AF), ($01B1,$01B3),
   ($01B7,$01B8), ($01F6,$01F8), ($023A,$023B), ($023D,$023E), ($0388,$038F),
   ($0391,$03AB), ($03D2,$03D4), ($03F9,$03FA), ($03FD,$042F), ($04C0,$04C1),
   ($0531,$0556), ($10A0,$10C5), ($1F08,$1F0F), ($1F18,$1F1D), ($1F28,$1F2F),
   ($1F38,$1F3F), ($1F48,$1F4D), ($1F59,$1F5F), ($1F68,$1F6F), ($1FB8,$1FBB),
   ($1FC8,$1FCB), ($1FD8,$1FDB), ($1FE8,$1FEC), ($1FF8,$1FFB), ($210B,$210D),
   ($2110,$2112), ($2119,$211D), ($212A,$212D), ($2130,$2131), ($213E,$213F),
   ($2C00,$2C2E), ($FF21,$FF3A), ($10400,$10427), ($1D400,$1D419), ($1D434,$1D44D),
   ($1D468,$1D481), ($1D49C,$1D4B5), ($1D4D0,$1D4E9), ($1D504,$1D51C), ($1D538,$1D550),
   ($1D56C,$1D585), ($1D5A0,$1D5B9), ($1D5D4,$1D5ED), ($1D608,$1D621), ($1D63C,$1D655),
   ($1D670,$1D689), ($1D6A8,$1D6C0), ($1D6E2,$1D6FA), ($1D71C,$1D734), ($1D756,$1D76E),
   ($1D790,$1D7A8));
  Chars1: array [0..391] of Integer = (
    $0100, $0102, $0104, $0106, $0108, $010A, $010C, $010E, $0110, $0112,
    $0114, $0116, $0118, $011A, $011C, $011E, $0120, $0122, $0124, $0126,
    $0128, $012A, $012C, $012E, $0130, $0132, $0134, $0136, $0139, $013B,
    $013D, $013F, $0141, $0143, $0145, $0147, $014A, $014C, $014E, $0150,
    $0152, $0154, $0156, $0158, $015A, $015C, $015E, $0160, $0162, $0164,
    $0166, $0168, $016A, $016C, $016E, $0170, $0172, $0174, $0176, $017B,
    $017D, $0184, $01A2, $01A4, $01A9, $01AC, $01B5, $01BC, $01C4, $01C7,
    $01CA, $01CD, $01CF, $01D1, $01D3, $01D5, $01D7, $01D9, $01DB, $01DE,
    $01E0, $01E2, $01E4, $01E6, $01E8, $01EA, $01EC, $01EE, $01F1, $01F4,
    $01FA, $01FC, $01FE, $0200, $0202, $0204, $0206, $0208, $020A, $020C,
    $020E, $0210, $0212, $0214, $0216, $0218, $021A, $021C, $021E, $0220,
    $0222, $0224, $0226, $0228, $022A, $022C, $022E, $0230, $0232, $0241,
    $0386, $03D8, $03DA, $03DC, $03DE, $03E0, $03E2, $03E4, $03E6, $03E8,
    $03EA, $03EC, $03EE, $03F4, $03F7, $0460, $0462, $0464, $0466, $0468,
    $046A, $046C, $046E, $0470, $0472, $0474, $0476, $0478, $047A, $047C,
    $047E, $0480, $048A, $048C, $048E, $0490, $0492, $0494, $0496, $0498,
    $049A, $049C, $049E, $04A0, $04A2, $04A4, $04A6, $04A8, $04AA, $04AC,
    $04AE, $04B0, $04B2, $04B4, $04B6, $04B8, $04BA, $04BC, $04BE, $04C3,
    $04C5, $04C7, $04C9, $04CB, $04CD, $04D0, $04D2, $04D4, $04D6, $04D8,
    $04DA, $04DC, $04DE, $04E0, $04E2, $04E4, $04E6, $04E8, $04EA, $04EC,
    $04EE, $04F0, $04F2, $04F4, $04F6, $04F8, $0500, $0502, $0504, $0506,
    $0508, $050A, $050C, $050E, $1E00, $1E02, $1E04, $1E06, $1E08, $1E0A,
    $1E0C, $1E0E, $1E10, $1E12, $1E14, $1E16, $1E18, $1E1A, $1E1C, $1E1E,
    $1E20, $1E22, $1E24, $1E26, $1E28, $1E2A, $1E2C, $1E2E, $1E30, $1E32,
    $1E34, $1E36, $1E38, $1E3A, $1E3C, $1E3E, $1E40, $1E42, $1E44, $1E46,
    $1E48, $1E4A, $1E4C, $1E4E, $1E50, $1E52, $1E54, $1E56, $1E58, $1E5A,
    $1E5C, $1E5E, $1E60, $1E62, $1E64, $1E66, $1E68, $1E6A, $1E6C, $1E6E,
    $1E70, $1E72, $1E74, $1E76, $1E78, $1E7A, $1E7C, $1E7E, $1E80, $1E82,
    $1E84, $1E86, $1E88, $1E8A, $1E8C, $1E8E, $1E90, $1E92, $1E94, $1EA0,
    $1EA2, $1EA4, $1EA6, $1EA8, $1EAA, $1EAC, $1EAE, $1EB0, $1EB2, $1EB4,
    $1EB6, $1EB8, $1EBA, $1EBC, $1EBE, $1EC0, $1EC2, $1EC4, $1EC6, $1EC8,
    $1ECA, $1ECC, $1ECE, $1ED0, $1ED2, $1ED4, $1ED6, $1ED8, $1EDA, $1EDC,
    $1EDE, $1EE0, $1EE2, $1EE4, $1EE6, $1EE8, $1EEA, $1EEC, $1EEE, $1EF0,
    $1EF2, $1EF4, $1EF6, $1EF8, $2102, $2107, $2115, $2124, $2126, $2128,
    $2133, $2145, $2C80, $2C82, $2C84, $2C86, $2C88, $2C8A, $2C8C, $2C8E,
    $2C90, $2C92, $2C94, $2C96, $2C98, $2C9A, $2C9C, $2C9E, $2CA0, $2CA2,
    $2CA4, $2CA6, $2CA8, $2CAA, $2CAC, $2CAE, $2CB0, $2CB2, $2CB4, $2CB6,
    $2CB8, $2CBA, $2CBC, $2CBE, $2CC0, $2CC2, $2CC4, $2CC6, $2CC8, $2CCA,
    $2CCC, $2CCE, $2CD0, $2CD2, $2CD4, $2CD6, $2CD8, $2CDA, $2CDC, $2CDE,
    $2CE0, $2CE2);
var
  J: Integer;
begin
  J := Integer (Ch);
  Result := FoundInTwoIntArray (J,Chars2) or FoundInIntArray (J, Chars1);
end {WCharIsLetterUppercase};

function WCharIsLetterLowercase (Ch: WideChar): Boolean;
const
  Chars2: array [0..48] of TwoIntegers = (
   ($0061,$007A), ($00DF,$00F6), ($00F8,$00FF), ($0137,$0138), ($0148,$0149),
   ($017E,$0180), ($018C,$018D), ($0199,$019B), ($01AA,$01AB), ($01B9,$01BA),
   ($01BD,$01BF), ($01DC,$01DD), ($01EF,$01F0), ($0233,$0239), ($023F,$0240),
   ($0250,$02AF), ($03AC,$03D1), ($03D5,$03D7), ($03EF,$03F3), ($03FB,$03FC),
   ($0430,$045F), ($0561,$0587), ($1D00,$1D2B), ($1D62,$1D77), ($1D79,$1D9A),
   ($1E95,$1E9B), ($1EF9,$1F07), ($1F10,$1F15), ($1F20,$1F27), ($1F30,$1F37),
   ($1F40,$1F45), ($1F50,$1F57), ($1F60,$1F67), ($1F70,$1F87), ($1F90,$1F97),
   ($1FA0,$1FA7), ($1FB0,$1FB7), ($1FC2,$1FC7), ($1FD0,$1FD7), ($1FE0,$1FE7),
   ($1FF2,$1FF7), ($210E,$210F), ($213C,$213D), ($2146,$2149), ($2C30,$2C5E),
   ($2CE3,$2CE4), ($2D00,$2D25), ($FB00,$FB17), ($FF41,$FF5A));
  Chars1: array [0..394] of Integer = (
    $00AA, $00B, $00BA, $0101, $0103, $0105, $0107, $0109, $010B, $010D,
    $010F, $011, $0113, $0115, $0117, $0119, $011B, $011D, $011F, $0121,
    $0123, $012, $0127, $0129, $012B, $012D, $012F, $0131, $0133, $0135,
    $013A, $013, $013E, $0140, $0142, $0144, $0146, $014B, $014D, $014F,
    $0151, $015, $0155, $0157, $0159, $015B, $015D, $015F, $0161, $0163,
    $0165, $016, $0169, $016B, $016D, $016F, $0171, $0173, $0175, $0177,
    $017A, $017, $0183, $0185, $0188, $0192, $0195, $019E, $01A1, $01A3,
    $01A5, $01A, $01AD, $01B0, $01B4, $01B6, $01C6, $01C9, $01CC, $01CE,
    $01D0, $01D, $01D4, $01D6, $01D8, $01DA, $01DF, $01E1, $01E3, $01E5,
    $01E7, $01E, $01EB, $01ED, $01F3, $01F5, $01F9, $01FB, $01FD, $01FF,
    $0201, $020, $0205, $0207, $0209, $020B, $020D, $020F, $0211, $0213,
    $0215, $021, $0219, $021B, $021D, $021F, $0221, $0223, $0225, $0227,
    $0229, $022, $022D, $022F, $0231, $023C, $0390, $03D9, $03DB, $03DD,
    $03DF, $03E, $03E3, $03E5, $03E7, $03E9, $03EB, $03ED, $03F5, $03F8,
    $0461, $046, $0465, $0467, $0469, $046B, $046D, $046F, $0471, $0473,
    $0475, $047, $0479, $047B, $047D, $047F, $0481, $048B, $048D, $048F,
    $0491, $049, $0495, $0497, $0499, $049B, $049D, $049F, $04A1, $04A3,
    $04A5, $04A, $04A9, $04AB, $04AD, $04AF, $04B1, $04B3, $04B5, $04B7,
    $04B9, $04B, $04BD, $04BF, $04C2, $04C4, $04C6, $04C8, $04CA, $04CC,
    $04CE, $04D, $04D3, $04D5, $04D7, $04D9, $04DB, $04DD, $04DF, $04E1,
    $04E3, $04E, $04E7, $04E9, $04EB, $04ED, $04EF, $04F1, $04F3, $04F5,
    $04F7, $04F, $0501, $0503, $0505, $0507, $0509, $050B, $050D, $050F,
    $1E01, $1E0, $1E05, $1E07, $1E09, $1E0B, $1E0D, $1E0F, $1E11, $1E13,
    $1E15, $1E1, $1E19, $1E1B, $1E1D, $1E1F, $1E21, $1E23, $1E25, $1E27,
    $1E29, $1E2, $1E2D, $1E2F, $1E31, $1E33, $1E35, $1E37, $1E39, $1E3B,
    $1E3D, $1E3, $1E41, $1E43, $1E45, $1E47, $1E49, $1E4B, $1E4D, $1E4F,
    $1E51, $1E5, $1E55, $1E57, $1E59, $1E5B, $1E5D, $1E5F, $1E61, $1E63,
    $1E65, $1E6, $1E69, $1E6B, $1E6D, $1E6F, $1E71, $1E73, $1E75, $1E77,
    $1E79, $1E7, $1E7D, $1E7F, $1E81, $1E83, $1E85, $1E87, $1E89, $1E8B,
    $1E8D, $1E8, $1E91, $1E93, $1EA1, $1EA3, $1EA5, $1EA7, $1EA9, $1EAB,
    $1EAD, $1EA, $1EB1, $1EB3, $1EB5, $1EB7, $1EB9, $1EBB, $1EBD, $1EBF,
    $1EC1, $1EC, $1EC5, $1EC7, $1EC9, $1ECB, $1ECD, $1ECF, $1ED1, $1ED3,
    $1ED5, $1ED, $1ED9, $1EDB, $1EDD, $1EDF, $1EE1, $1EE3, $1EE5, $1EE7,
    $1EE9, $1EE, $1EED, $1EEF, $1EF1, $1EF3, $1EF5, $1EF7, $1FBE, $2071,
    $207F, $210, $2113, $212F, $2134, $2139, $2C81, $2C83, $2C85, $2C87,
    $2C89, $2C8, $2C8D, $2C8F, $2C91, $2C93, $2C95, $2C97, $2C99, $2C9B,
    $2C9D, $2C9, $2CA1, $2CA3, $2CA5, $2CA7, $2CA9, $2CAB, $2CAD, $2CAF,
    $2CB1, $2CB, $2CB5, $2CB7, $2CB9, $2CBB, $2CBD, $2CBF, $2CC1, $2CC3,
    $2CC5, $2CC, $2CC9, $2CCB, $2CCD, $2CCF, $2CD1, $2CD3, $2CD5, $2CD7,
    $2CD9, $2CDB, $2CDD, $2CDF, $2CE1);
var
  J: Integer;
begin
  J := Integer (Ch);
  Result := FoundInTwoIntArray (J,Chars2) or FoundInIntArray (J, Chars1);
end {WCharIsLetterLowercase};

function WCharIsLetterTitlecase (Ch: WideChar): Boolean;
const
  Chars2: array [0..2] of TwoIntegers = (
   ($1F88,$1F8F), ($1F98,$1F9F), ($1FA8,$1FAF));
  Chars1: array [0..6] of Integer = (
    $01C5, $01C8, $01CB, $01F2, $1FBC, $1FCC, $1FFC);
var
  J: Integer;
begin
  J := Integer (Ch);
  Result := FoundInTwoIntArray (J,Chars2) or FoundInIntArray (J, Chars1);
end {WCharIsLetterTitlecase};

function WCharIsLetterOther (Ch: WideChar): Boolean;
const
  Chars2: array [0..82] of TwoIntegers = (
   ($01C0,$01C3), ($05D0,$05F2), ($0621,$063A), ($0641,$064A), ($066E,$066F),
   ($0671,$06D3), ($06EE,$06EF), ($06FA,$06FC), ($0712,$072F), ($074D,$07A5),
   ($0904,$0939), ($0958,$0961), ($0985,$09B9), ($09DC,$09E1), ($09F0,$09F1),
   ($0A05,$0A39), ($0A59,$0A5E), ($0A72,$0A74), ($0A85,$0AB9), ($0AD0,$0AE1),
   ($0B05,$0B39), ($0B5C,$0B61), ($0B83,$0BB9), ($0C05,$0C39), ($0C60,$0C61),
   ($0C85,$0CB9), ($0CDE,$0CE1), ($0D05,$0D39), ($0D60,$0D61), ($0D85,$0DC6),
   ($0E01,$0E30), ($0E32,$0E33), ($0E40,$0E45), ($0E81,$0EB0), ($0EB2,$0EB3),
   ($0EBD,$0EC4), ($0EDC,$0F00), ($0F40,$0F6A), ($0F88,$0F8B), ($1000,$102A),
   ($1050,$1055), ($10D0,$10FA), ($1100,$135A), ($1380,$138F), ($13A0,$166C),
   ($166F,$1676), ($1681,$169A), ($16A0,$16EA), ($1700,$1711), ($1720,$1731),
   ($1740,$1751), ($1760,$1770), ($1780,$17B3), ($1820,$1842), ($1844,$18A8),
   ($1900,$191C), ($1950,$19A9), ($19C1,$19C7), ($1A00,$1A16), ($2135,$2138),
   ($2D30,$2D65), ($2D80,$2DDE), ($3041,$3096), ($30A1,$30FA), ($30FF,$318E),
   ($31A0,$31B7), ($31F0,$31FF), ($3400,$4DB5), ($4E00,$A014), ($A016,$A48C),
   ($A800,$A801), ($A803,$A805), ($A807,$A80A), ($A80C,$A822), ($AC00,$D7A3),
   ($F900,$FAD9), ($FB1F,$FB28), ($FB2A,$FD3D), ($FD50,$FDFB), ($FE70,$FEFC),
   ($FF66,$FF6F), ($FF71,$FF9D), ($FFA0,$FFDC));
  Chars1: array [0..18] of Integer = (
    $01BB, $06D5, $06FF, $0710, $07B1, $093D, $0950, $097D, $09BD, $09CE,
    $0ABD, $0B3D, $0B71, $0CBD, $17DC, $3006, $303C, $309F, $FB1D);
var
  J: Integer;
begin
  J := Integer (Ch);
  Result := FoundInTwoIntArray (J,Chars2) or FoundInIntArray (J, Chars1);
end {WCharIsLetterOther};

function WCharIsLeftToRight (Ch: WideChar): Boolean;
const
  Chars2: array [0..124] of TwoIntegers = (
   ($0041, $005A), ($0061, $007A), ($00C0, $00D6), ($00D8, $00F6), ($00F8, $02B8),
   ($02BB, $02C1), ($02D0, $02D1), ($02E0, $02E4), ($0388, $03F5), ($03F7, $0482),
   ($048A, $0589), ($0903, $0939), ($093D, $0940), ($0949, $094C), ($0958, $0961),
   ($0964, $097D), ($0982, $09B9), ($09BD, $09C0), ($09C7, $09CC), ($09CE, $09E1),
   ($09E6, $09F1), ($09F4, $09FA), ($0A03, $0A39), ($0A3E, $0A40), ($0A59, $0A6F),
   ($0A72, $0A74), ($0A83, $0AB9), ($0ABD, $0AC0), ($0AC9, $0ACC), ($0AD0, $0AE1),
   ($0AE6, $0AEF), ($0B02, $0B39), ($0B3D, $0B3E), ($0B47, $0B4C), ($0B57, $0B71),
   ($0B83, $0BBF), ($0BC1, $0BCC), ($0BD7, $0BF2), ($0C01, $0C39), ($0C41, $0C44),
   ($0C60, $0CB9), ($0CBD, $0CCB), ($0CD5, $0D40), ($0D46, $0D4C), ($0D57, $0DC6),
   ($0DCF, $0DD1), ($0DD8, $0E30), ($0E32, $0E33), ($0E40, $0E46), ($0E4F, $0EB0),
   ($0EB2, $0EB3), ($0EBD, $0EC6), ($0ED0, $0F17), ($0F1A, $0F34), ($0F3E, $0F6A),
   ($0F88, $0F8B), ($0FBE, $0FC5), ($0FC7, $102C), ($1040, $1057), ($10A0, $135A),
   ($1360, $138F), ($13A0, $1676), ($1681, $169A), ($16A0, $1711), ($1720, $1731),
   ($1735, $1751), ($1760, $1770), ($1780, $17B6), ($17BE, $17C5), ($17C7, $17C8),
   ($17D4, $17DA), ($17E0, $17E9), ($1810, $18A8), ($1900, $191C), ($1923, $1926),
   ($1930, $1931), ($1933, $1938), ($1946, $19D9), ($1A00, $1A16), ($1A19, $1DBF),
   ($1E00, $1FBC), ($1FC2, $1FCC), ($1FD0, $1FDB), ($1FE0, $1FEC), ($1FF2, $1FFC),
   ($2090, $2094), ($210A, $2113), ($2119, $211D), ($212A, $212D), ($212F, $2131),
   ($2133, $2139), ($213C, $213F), ($2145, $2149), ($2160, $2183), ($2336, $237A),
   ($249C, $24E9), ($2800, $28FF), ($2C00, $2CE4), ($2D00, $2DDE), ($3005, $3007),
   ($3021, $3029), ($3031, $3035), ($3038, $303C), ($3041, $3096), ($309D, $309F),
   ($30A1, $30FA), ($30FC, $31B7), ($31F0, $321C), ($3220, $3243), ($3260, $327B),
   ($327F, $32B0), ($32C0, $32CB), ($32D0, $3376), ($337B, $33DD), ($33E0, $33FE),
   ($3400, $4DB5), ($4E00, $A48C), ($A800, $A801), ($A803, $A805), ($A807, $A80A),
   ($A80C, $A824), ($AC00, $FB17), ($FF21, $FF3A), ($FF41, $FF5A), ($FF66, $FFDC));
  Chars1: array [0..29] of Integer = (
    $00AA, $00B5, $00BA, $02EE, $037A, $0386, $0950, $0B40, $0F36, $0F38,
    $0F7F, $0F85, $1031, $1038, $17DC, $1FBE, $200E, $202A, $202D, $2071,
    $207F, $2102, $2107, $2115, $2124, $2126, $2128, $2395, $26AC, $A827);
var
  J: Integer;
begin
  J := Integer (Ch);
  Result := FoundInTwoIntArray (J,Chars2) or FoundInIntArray (J, Chars1);
end {WCharIsLeftToRight};

function WCharIsRightToLeft (Ch: WideChar): Boolean;
const
  Chars2: array [0..12] of TwoIntegers = (
   ($05D0, $060B), ($061B, $064A), ($066D, $066F), ($0671, $06D5), ($06E5, $06E6),
   ($06EE, $06EF), ($06FA, $070D), ($0712, $072F), ($074D, $07A5), ($FB1F, $FB28),
   ($FB2A, $FD3D), ($FD50, $FDFC), ($FE70, $FEFC));
  Chars1: array [0..11] of Integer = (
    $05BE, $05C0, $05C3, $05C6, $060D, $06DD, $0710, $07B1, $200F, $202B,
    $202E, $FB1D);
var
  J: Integer;
begin
  J := Integer (Ch);
  Result := FoundInTwoIntArray (J,Chars2) or FoundInIntArray (J, Chars1);
end {WCharIsRightToLeft};

function WCharIsCharSpace (Ch: WideChar): Boolean;
var
  J: Integer;
begin
  J := Integer (Ch);
  Result := FoundInIntArray (J, CharsSpaceArr);
end {WCharIsRightToLeft};

function WCharHasModi (Ch: WideChar;  out ChWithoutModi, ChModi: WideChar): Boolean;
{'' => 'a' + '`'}
var
  J, K, L: Integer;
begin
  J := Integer (Ch);
  ChWithoutModi := #0;
  ChModi := #0;
  Result := False;
  for  K := 0 to ComposedChrArrN-1  do  begin
    L := K;
    if  J = ComposedChrArr[L,1]  then  begin
      ChWithoutModi := WideChar (ComposedChrArr[L,2]);
      ChModi := WideChar (ComposedChrArr[L,3]);
      Result := True;
      Break;
    end
    else if  J < ComposedChrArr[L,1]
    then  Break;
  end;
end {WCharHasModi};

function WCharFromSingles (ChWithoutModi, ChModi: WideChar;  out Ch: WideChar): Boolean;
{'a' + '`' => ''}
var
  WithoutModiNum, ChModiNum: Word;
  Ch1, Ch2: WideChar;
procedure TryH;
var
  L, K: Integer;
begin
  ChModiNum := Integer (ChModi);
  for  K := 0 to ComposedChrArrN-1  do  begin
    L := K;
    if  (WithoutModiNum = ComposedChrArr[L,2]) and
        (ChModiNum = ComposedChrArr[L,3])
    then  begin
      Ch := WideChar (ComposedChrArr[L,1]);
      Result := True;
      Break;
    end;
  end;
end {TryH};
begin
  WithoutModiNum := Integer (ChWithoutModi);
  Ch := #0;
  Result := False;
  TryH;
  if  (not Result) and WCharHasCompat (ChModi, Ch1, Ch2)  then  begin
    ChModi := Ch2;
    TryH;
  end;
end {WCharFromSingles};

function WCharHasCompat (Ch: WideChar;  out Ch1, Ch2: WideChar): Boolean;
var
  J, K, L: Integer;
begin
  J := Integer (Ch);
  Ch1 := #0;
  Ch2 := #0;
  Result := False;
  for  K := 0 to Compat2ChrArrN-1  do  begin
    L := K;
    if  J = Compat2ChrArr[L,1]  then  begin
      Ch1 := WideChar (Compat2ChrArr[L,2]);
      Ch2 := WideChar (Compat2ChrArr[L,3]);
      Result := True;
      Exit;
    end
    else if  J < Compat2ChrArr[L,1]
    then  Break;
  end;
  for  K := 0 to Compat1ChrArrN-1  do  begin
    L := K;
    if  J = Compat1ChrArr[L,1]  then  begin
      Ch1 := WideChar (Compat1ChrArr[L,2]);
      Result := True;
      Exit;
    end
    else if  J < Compat1ChrArr[L,1]
    then  Exit;
  end;
end {WCharHasCompat};

function WStrWithThisModifier (Modifier: WideChar;
  out Composed, Single: WideString): Boolean;
var
  J, K, L: Integer;
begin
  J := Integer (Modifier);
  Composed := '';
  Single := '';
  for  K := 0 to 988  do  begin
    L := K;
    if  J = ComposedChrArr[L,3]  then  begin
      Composed := Concat (Composed, WideChar(ComposedChrArr[L,1]));
      Single := Concat (Single, WideChar(ComposedChrArr[L,2]));
    end;
  end;
  Result := Composed <> '';
end {WStrWithThisModifier};

function WCharToWithoutModifierWChar (Ch: WideChar): WideChar;
var
  Ch1, Ch2: WideChar;
begin
  if  WCharHasModi (Ch, Ch1, Ch2)
  then  Result := Ch1
  else  Result := Ch;
end {WCharToWithoutModifierWChar};

function WCharToWithoutModifierWCharModi (Ch: WideChar;
  out Modified: Boolean): WideChar;
begin
  Result := WCharToWithoutModifierWChar (Ch);
  Modified := Result <> Ch;
end {WCharToWithoutModifierWCharModi};

function WStrToWithoutModifierWStr (const S: WideString): WideString;
var
  I, J: Byte;
begin
  if  S = ''  then  begin
    Result := '';
    Exit;
  end;
  J := Length (S);
  SetLength (Result, J);
  for  I := 1 to J  do
    Result[I] := WCharToWithoutModifierWChar (S[I]);
end {WStrToWithoutModifierWStr};

function WStrToWithoutModifierWStrModi (const S: WideString;
  out Modified: Boolean): WideString;
begin
  Result := WStrToWithoutModifierWStr (S);
  Modified := S <> Result;
end {WStrToWithoutModifierWStrModi};

function WideDelBChar (const S: WideString;  Ch: WideChar): WideString;
{ Deletes begin char Ch from WideString }
var
  I, L: Word;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] = Ch)
  do  Inc(I);
  Result := Copy(S, I, MaxInt);
end {WideDelBChar};

function WideDelEChar (const S: WideString;  Ch: WideChar): WideString;
{ Deletes end char Ch from WideString }
var
  I: Word;
begin
  I := Length (S);
  while  (I >= 1) and (S[I] = Ch)
  do  Dec (I);
  Result := Copy (S, 1, I);
end {WideDelEChar};

function WideAddChar (C: WideChar;  const S: WideString;  N: Integer): WideString;
{ WideAddChar return a string left-padded to length N with characters C. }
begin
  if Length(S) < N then
    Result := MakeStr (C, N - Length(S)) + S
  else Result := S;
end;

function WideAddCharR (C: WideChar;  const S: WideString;  N: Integer): WideString;
{ WideAddCharR return a string right-padded to length N with characters C. }
begin
  if Length(S) < N then
    Result := S + MakeStr (C, N - Length(S))
  else Result := S;
end;

function WideLeftStr (const S: WideString;  N: Integer): WideString;
{ WideLeftStr return a string right-padded to length N with blanks. }
begin
  Result := WideAddCharR (' ', S, N);
end;

function WideRightStr (const S: WideString;  N: Integer): WideString;
{ WideRightStr return a string left-padded to length N with blanks. }
begin
  Result := WideAddChar (' ', S, N);
end;

function DelAmpersandW (const S: WideString): WideString;
begin
  Result := WideDelChars (S, '&');
end {DelAmpersandW};

function StrReplaceCharW (const S: WideString;
  const Source, Replace: WideChar): WideString;
var
  I: Integer;
begin
  Result := S;
  for  I := 1 to Length(S)  do
    if  Result[I] = Source
    then  Result[I] := Replace;
end {StrReplaceCharW};

function StrReplaceCharsW (const S: WideString;
  const Source, Replace: WideString): WideString;
var
  I: Integer;
  P: Integer;
begin
  Result := S;
  for  I := 1 to Length(S)  do  begin
    P := Pos (Result[I], Source);
    if  P <> 0
    then  Result[I] := Replace[P];
  end;
end {StrReplaceCharsW};

function StrReplaceSpaceToUnderscoreCharW (const S: WideString): WideString;
begin
  Result := StrReplaceCharW (S, ' ', '_');
end;

function StrReplaceUnderscoreToSpaceCharW (const S: WideString): WideString;
begin
  Result := StrReplaceCharW (S, '_', ' ');
end;

function StrCapitalizedW (const S: WideString;
  AllWords, ReplaceUnderscore: Boolean): WideString;
var
  I: Word;
begin
  Result := S;
  if  S <> ''  then  begin
    Result := WideLowerCase (S);
    Result[1] := WideUpCase (Result[1]);
    if AllWords and (Length(Result)>1) then  begin
      for  I := 2 to Length(Result)  do
        if  (Result[I-1] = '_') or (Result[I-1] = ' ')
        then  Result[I] := WideUpCase (Result[I]);
    end;
    if ReplaceUnderscore
    then  Result := StrReplaceUnderscoreToSpaceCharW (Result);
  end;
end {StrCapitalizedW};

function StrQuotedW (S: WideString): WideString;
// Replaces " for ' at WideString begin and end
const
  Quote = '''';
procedure ChangeH (W: Integer);
begin
  if  S[W] = '"'
  then  S[W] := Quote;
end {ChangeH};
begin
  if  S <> ''  then  begin
    ChangeH (1);
    ChangeH (Length(S));
    if  S[1] <> Quote
    then  S := Concat (Quote, S, Quote);
  end;
  Result := S;
end {StrQuotedW};

function ConcatWithStrW (const SBegin, SEnd, Sep: WideString): WideString;
begin
  if  SBegin <> ''
  then  Result := Concat (SBegin, Sep, SEnd)
  else  Result := SEnd;
end {ConcatWithStrW};

function ConcatWithStrXW (const SBegin, SEnd, Sep: WideString): WideString;
begin
  if  SBegin <> '' then  begin
    if  SEnd <> ''
    then  Result := Concat (SBegin, Sep, SEnd)
    else  Result := SBegin;
  end
  else
    Result := SEnd;
end {ConcatWithStrXW};

function ConcatSpacedW (const SBegin, SEnd: WideString): WideString;
begin
  Result := ConcatWithStrW (SBegin, SEnd, ' ');
end {ConcatSpacedW};

function RemoveCharsW (const S, InvalidChars: WideString): WideString;
var
  I: Word;
begin
  Result := '';
  for  I := 1 to Length(S)  do
    if  Pos (S[I],InvalidChars) = 0
    then  Result := Concat (Result, S[I]);
end {RemoveCharsW};

function RemoveDuplicatedCharsW (const S: WideString): WideString;
var
  I: Word;
begin
  Result := '';
  for  I := 1 to Length (S)  do  begin
    if  Pos (S[I], Result) = 0
    then  Result := Concat (Result, S[I]);
  end;
end {RemoveDuplicatedCharsW};

function CharBlockFromChar (Ch: WideChar): TCharBlock;
var
  I: Integer;
  J: TCharBlock;
begin
  I := Integer(Ch);
  for  J := chb_Basic_Latin to chb_Specials  do
    if  (I >= CharBlocksArr[J,1]) and (I <= CharBlocksArr[J,2])  then  begin
      Result := J;
      Exit;
    end;
  Result := chb_Basic_Latin;
end {CharBlockFromChar};

end.
